#!/bin/sh

# used by the libload command in hoc to find an instance of a procedure,
#	function, or template

if [ $TEMP ] ; then
	tmpdir=$TEMP
else
	tmpdir="/tmp"
fi
curdir=`pwd`
names=$tmpdir/oc"$3".hl

if [ ! -f $names ] ; then

paths=". $HOC_LIBRARY_PATH $NEURONHOME/lib/hoc"

for p in $paths
do
	cd $p
	for f in *.oc *.hoc
	do
	# damn the 128 char command line limit in dos
	echo "Z $p/$f" >> $names
sed -n "
/^begintemplate/,/^endtem/ {
/^begintemplate/p
d
}
/^proc /p
/^func /p
" $f >> $names 2>/dev/null
	done
done	

fi

cd $curdir

file=`sed -n "
/^Z/h
/$1 $2/ {
g
s/Z //p
q
}
" $names`

if [ -z "$file" ] ; then
	exit 1
fi
echo $file
exit 0
