/* Copyright 1987,1988- Michael Hines, Neurobiology Dept., DUMC, NC
*
* REVISION HISTORY:
*
* 11-88 This file was fixed so that the memacs editor would work with
the editing keys. Made use of dos function call 7 which returns the
extended ASCII codes for the editing keys.
*
*/
/*mlh /7/20/87
==================================================
ibm.c
==================================================
*/
/*
 * The routines in this file provide support for PC compatible terminals
 * The serial I/O services are provided by routines in
 * "termio.c". It compiles into nothing if not an IBM device.
 */

#define		termdef		1
#include	<stdio.h>
#include	"estruct.h"
#include	"edef.h"

#if	MSDOS
#include	<dos.h>	/* works with microsoft c */
#if __GO32__
#include	<gppconio.h>
#else
#include	<conio.h>
#endif

#define NROW	25			/* Screen size. 		*/
#define NCOL	80			/* Edit if you want to. 	*/
#define MARGIN	8
#define	SCRSIZ	64
#define BEL	0x07			/* BEL character.		*/
#define ESC	0x1B			/* ESC character.		*/

extern	int	ttopen();		/* Forward references.		*/
static	int	ibmgetc();
static	int	ibmputc();
static	int	ibmflush();
extern	int	ttclose();
static	int	ibmmove();
static	int	ibmeeol();
static	int	ibmeeop();
static	int	ibmbeep();
static	int	ibmrev();
static	int	ibmopen();


/*
 * Standard terminal interface dispatch table. Most of the fields point into
 * "termio" code.
 */
TERM	term	= {
	NROW-1,
	NCOL,
	MARGIN,
	SCRSIZ,
	ibmopen,
	ttclose,
	ibmgetc,
	ibmputc,
	ibmflush,
	ibmmove,
	ibmeeol,
	ibmeeop,
	ibmbeep,
	ibmrev
};


static ibmmove(row, col)
{
	union REGS regs;
	regs.h.ah = 0x02;
	regs.h.bh = 0;
	regs.h.dh = row;
	regs.h.dl = col;
	int86(0x10, &regs, &regs);
}

static ibmeeol()
{
	union REGS regs;
	regs.h.ah = 0x03;
	regs.h.bh = 0;
	int86(0x10, &regs, &regs);

	regs.h.ah = 6;
	regs.h.al = 0;
	regs.h.bh = 7;
	regs.h.ch = regs.h.dh;
	regs.h.cl = regs.h.dl;
	regs.h.dl = NCOL - 1;
	int86(0x10, &regs, &regs);
}

static ibmeeop()
{
	union REGS regs;
	regs.h.ah = 6;
	regs.h.al = 0;
	regs.h.bh = 7;
	regs.h.ch = 0;
	regs.h.cl = 0;
	regs.h.dh = NROW - 1;
	regs.h.dl = NCOL - 1;
	int86(0x10, &regs, &regs);
	ibmmove(0, 0);
}

static ibmgetc()
{
	union REGS regs;
	regs.h.ah = 7;
	intdos(&regs,&regs);
	return (int)regs.h.al;
}

static ibmputc(c)
{
#if 1
	cprintf("%c",c);
#else
	union REGS regs;
	regs.h.ah = 14;
	regs.h.bl = 7;
	regs.h.al = c;
	int86(0x10, &regs, &regs);
#endif
}	

static ibmflush()
{
}

static ibmbeep()
{
	ttputc(BEL);
	ttflush();
}

static ibmparm(n)
register int	n;
{

	register int	q;

	q = n/10;
	if (q != 0)
		ibmparm(q);
	ttputc((n%10) + '0');
}

#endif

ibmopen()
{
	textmode(3);
	textcolor(2);

	ttopen();
}

static ibmrev(state)		/* change reverse video state */

int state;	/* TRUE = reverse, FALSE = normal */

{
/*ANSI	ttputc(ESC);
	ttputc('[');
	ttputc(state ? '7': '0');
	ttputc('m');
*/
}


