# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO Fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/* $Header: /timshel2g/src/master/nrn/src/modlunit/lex.c,v 1.2 1994/10/12 20:55:04 hines Exp $ */

#undef output
#undef unput
#undef input
#include "model.h"
#include "ytab.h"

static char linebuf[512], *cp;
int lexcontext;

#define debug(arg1,arg2) /*printf("lex:arg1|%s|\n", arg2);*/
# define O 2
# define to_eocom 4
# define to_par 6
# define to_eoverb 8
# define to_eol 10
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{ /*PRIME possibly high order*/
	yylval.qp = putintoken(yytext, PRIME, 0);
	return PRIME;
}
break;
case 2:
{ /*NAME*/
	Symbol *s;

	yylval.qp = putintoken(yytext, NAME, 0);
	s = SYM(yylval.qp);
	switch (s->type) {
		case TITLE:
			BEGIN to_eol;
			cp = linebuf;
			break;
		case COMMENT:
			BEGIN to_eocom;
			cp = linebuf;
			break;
		case VERBATIM:
			BEGIN to_eoverb;
			cp = linebuf;
			break;
	}
	return s->type;
}
break;
case 3:
{ /*INTEGER*/
	yylval.qp = putintoken(yytext, INTEGER, INTEGER); /* Numbers are not looked for */
	return INTEGER;
}
break;
case 4:
case 5:
case 6:
{ /*REAL*/
	yylval.qp = putintoken(yytext, REAL, REAL); /* Numbers are not looked for */
	return REAL;
}
break;
case 7:
{ /* STRING */
	yylval.qp = putintoken(yytext, STRING, STRING);
	return STRING;
		/* can't quote \" */
}
break;
case 8:
{ yylval.qp = putintoken(yytext, 0, GT); return GT;}
break;
case 9:
{ yylval.qp = putintoken(yytext, 0, GE); return GE;}
break;
case 10:
{ yylval.qp = putintoken(yytext, 0, LT); return LT;}
break;
case 11:
{ yylval.qp = putintoken(yytext, 0, LE); return LE;}
break;
case 12:
{ yylval.qp = putintoken(yytext, 0, EQ); return EQ;}
break;
case 13:
{ yylval.qp = putintoken(yytext, 0, NE); return NE;}
break;
case 14:
{ yylval.qp = putintoken(yytext, 0, NOT); return NOT;}
break;
case 15:
{ yylval.qp = putintoken(yytext, 0, AND); return AND;}
break;
case 16:
{ yylval.qp = putintoken(yytext, 0, OR); return OR;}
break;
case 17:
{ yylval.qp = putintoken(yytext, 0, REACT1); return REACT1;}
break;
case 18:
{ /* syntactic sugar for equation addition */
	yylval.qp = putintoken(yytext, 0, NONLIN1);
	if (lexcontext == NONLINEAR) return NONLIN1;
	if (lexcontext == LINEAR){yylval.qp->itemsubtype = LINEAR; return LIN1;}
	diag("equation addition can't occur in this type of block", (char *)0);
	}
break;
case 19:
{ /* syntactic sugar for equations */
	yylval.qp = putintoken(yytext, 0, 0);
	if (lexcontext == PARTIAL) {
		yylval.qp->itemsubtype = PARTEQN;
		 return PARTEQN;
	}else if (lexcontext == KINETIC) {
		yylval.qp->itemsubtype = REACTION;
		 return REACTION;
	}else{
		yylval.qp->itemsubtype = yytext[0];
		return yytext[0];
	}
	}
break;
case 20:
{ putintoken(yytext, SPACE, SPACE);}
break;
case 21:
{ putintoken(yytext, NEWLINE, 0);}
break;
case 22:
{ putintoken(yytext, STRING, STUFF);}
break;
case 23:
{ yylval.qp = putintoken("{", 0, '{'); return yytext[0]; }
break;
case 24:
{ yylval.qp = putintoken("}", 0, '}'); return yytext[0]; }
break;
case 25:
{ yylval.qp = putintoken(yytext, 0, yytext[0]); return yytext[0]; }
break;
case 26:
{
	if (cp != linebuf) {
		*cp = '\0';
		putintoken(linebuf, STRING, STUFF);
	}
	cp = linebuf;
	BEGIN O;
	yylval.qp = putintoken(yytext, NAME, 0);
	return SYM(yylval.qp)->type;
}
break;
case 27:
{
	if (cp != linebuf) {
		*cp = '\0';
		putintoken(linebuf, STRING, STUFF);
	}
	cp = linebuf;
	BEGIN O;
	yylval.qp = putintoken(yytext, NAME, 0);
	return SYM(yylval.qp)->type;
}
break;
case 28:
{
	*cp = '\0';
	yylval.qp = putintoken(linebuf, STRING, UNITS);
	cp = linebuf;
	unput(')');
	BEGIN O;
	return UNITS;
	}
break;
case 29:
{
	diag("Units not terminated by ')'", (char *)0);
}
break;
case 30:
{
	if (cp != linebuf) {
		*cp = '\0';
		putintoken(linebuf, STRING, STUFF);
	}
	cp = linebuf;
	putintoken(yytext, NEWLINE, 0);
	}
break;
case 31:
{
	*cp = '\0';
	yylval.qp = putintoken(linebuf, STRING, TO_EOL);
	cp = linebuf;
	BEGIN O;
	putintoken(yytext, NEWLINE, 0);
	return TO_EOL;
	}
break;
case 32:
{ *cp++ = yytext[0];}
break;
case -1:
break;
default:
Fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

lex_start() {
	BEGIN O;
}

lex_units() {
	cp = linebuf;
	BEGIN to_par;
}

int input() {
	int c;
	c = Getc();
	if (c == EOF) {
		c = 0;
	}
	return c;
}

int unput(c) int c; {
	unGetc(c);
}

int output(c) int c; {
#if LINT
	IGNORE(c);
#endif
	diag("internal error: ", "called output");
}

int yywrap() {
	if (YYSTATE == to_eoverb) {
		diag("End of file while in VERBATIM mode.\n",
			"Missing ENDVERBATIM?");
	}
	if (YYSTATE == to_eocom) {
		diag("End of file while in COMMENT mode.\n",
			"Missing ENDCOMMENT?");
	}
	return 1;
}

/* $Log: lex.c,v $
 * Revision 1.2  1994/10/12  20:55:04  hines
 * first pass at neuron under cvs control
 *
 * Revision 1.1.1.1  1994/10/12  17:22:52  hines
 * NEURON 3.0 distribution
 *
 * Revision 1.3  1994/03/17  15:21:11  hines
 * ? token same as comment : token
 *
 * Revision 1.2  1990/11/13  16:14:06  hines
 * prototype units checking
 *
 * Revision 1.1  90/07/02  09:01:47  hines
 * Initial revision
 *  */

int yyvstop[] = {
0,

25,
0,

20,
25,
0,

21,
0,

14,
25,
0,

25,
0,

25,
0,

25,
0,

3,
25,
0,

22,
25,
0,

10,
25,
0,

25,
0,

8,
25,
0,

2,
25,
0,

23,
25,
0,

25,
0,

24,
25,
0,

19,
25,
0,

32,
0,

30,
0,

32,
0,

29,
0,

28,
32,
0,

32,
0,

31,
0,

20,
0,

13,
0,

7,
0,

15,
0,

5,
0,

4,
0,

3,
0,

22,
0,

11,
0,

12,
0,

9,
0,

1,
0,

2,
0,

16,
0,

18,
0,

4,
5,
0,

6,
0,

17,
0,

5,
0,

4,
0,

4,
5,
0,

26,
0,

27,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	3,13,	0,0,	
0,0,	0,0,	0,0,	0,0,	
5,30,	0,0,	3,14,	3,15,	
0,0,	14,37,	0,0,	0,0,	
5,30,	5,31,	46,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3,16,	3,17,	
14,37,	0,0,	0,0,	3,18,	
4,16,	5,30,	8,34,	18,41,	
3,13,	4,18,	51,51,	3,19,	
7,30,	3,20,	5,30,	29,54,	
0,0,	4,19,	0,0,	5,30,	
7,30,	7,33,	0,0,	3,21,	
0,0,	3,22,	3,23,	3,24,	
16,38,	5,30,	3,25,	4,22,	
4,23,	4,24,	3,25,	11,30,	
5,30,	22,47,	9,35,	10,35,	
5,32,	23,49,	24,50,	11,30,	
11,36,	7,30,	42,57,	47,62,	
55,63,	32,55,	35,56,	56,64,	
7,34,	22,48,	7,30,	58,67,	
63,70,	64,71,	70,74,	7,30,	
3,13,	71,75,	74,76,	75,77,	
76,78,	77,79,	5,30,	6,30,	
11,30,	7,30,	9,30,	10,30,	
5,30,	78,80,	79,81,	17,39,	
7,30,	11,30,	42,57,	80,82,	
7,30,	81,83,	11,30,	17,39,	
17,39,	82,84,	83,85,	58,67,	
3,26,	3,27,	3,28,	3,29,	
11,30,	27,53,	4,26,	4,27,	
4,28,	4,29,	85,86,	11,30,	
0,0,	0,0,	0,0,	11,30,	
0,0,	0,0,	7,30,	0,0,	
17,40,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	17,39,	0,0,	0,0,	
0,0,	0,0,	17,39,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	11,30,	0,0,	0,0,	
17,39,	21,46,	0,0,	0,0,	
0,0,	0,0,	0,0,	17,39,	
0,0,	21,46,	21,0,	17,39,	
19,42,	19,42,	19,42,	19,42,	
19,42,	19,42,	19,42,	19,42,	
19,42,	19,42,	20,43,	0,0,	
20,44,	20,44,	20,44,	20,44,	
20,44,	20,44,	20,44,	20,44,	
20,44,	20,44,	21,46,	0,0,	
0,0,	17,39,	0,0,	0,0,	
0,0,	0,0,	0,0,	21,46,	
0,0,	20,45,	0,0,	0,0,	
21,46,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	21,46,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	21,46,	0,0,	0,0,	
0,0,	21,46,	25,51,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	20,45,	0,0,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	21,46,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	0,0,	0,0,	
0,0,	0,0,	25,52,	0,0,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	25,52,	25,52,	
25,52,	25,52,	43,58,	43,58,	
43,58,	43,58,	43,58,	43,58,	
43,58,	43,58,	43,58,	43,58,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	45,60,	
0,0,	45,60,	0,0,	43,59,	
45,61,	45,61,	45,61,	45,61,	
45,61,	45,61,	45,61,	45,61,	
45,61,	45,61,	57,65,	0,0,	
57,65,	0,0,	0,0,	57,66,	
57,66,	57,66,	57,66,	57,66,	
57,66,	57,66,	57,66,	57,66,	
57,66,	0,0,	0,0,	59,68,	
0,0,	59,68,	0,0,	43,59,	
59,69,	59,69,	59,69,	59,69,	
59,69,	59,69,	59,69,	59,69,	
59,69,	59,69,	60,61,	60,61,	
60,61,	60,61,	60,61,	60,61,	
60,61,	60,61,	60,61,	60,61,	
65,66,	65,66,	65,66,	65,66,	
65,66,	65,66,	65,66,	65,66,	
65,66,	65,66,	67,72,	0,0,	
67,72,	0,0,	0,0,	67,73,	
67,73,	67,73,	67,73,	67,73,	
67,73,	67,73,	67,73,	67,73,	
67,73,	68,69,	68,69,	68,69,	
68,69,	68,69,	68,69,	68,69,	
68,69,	68,69,	68,69,	72,73,	
72,73,	72,73,	72,73,	72,73,	
72,73,	72,73,	72,73,	72,73,	
72,73,	0,0,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+0,	0,		0,	
yycrank+0,	0,		0,	
yycrank+-1,	0,		0,	
yycrank+-7,	yysvec+3,	0,	
yycrank+-7,	0,		0,	
yycrank+-2,	yysvec+5,	0,	
yycrank+-47,	0,		0,	
yycrank+-1,	yysvec+7,	0,	
yycrank+-5,	yysvec+5,	0,	
yycrank+-6,	yysvec+5,	0,	
yycrank+-70,	0,		0,	
yycrank+0,	yysvec+11,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+4,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+3,	0,		yyvstop+8,
yycrank+-110,	0,		yyvstop+11,
yycrank+5,	0,		yyvstop+13,
yycrank+132,	0,		yyvstop+15,
yycrank+144,	0,		yyvstop+17,
yycrank+-168,	0,		yyvstop+20,
yycrank+28,	0,		yyvstop+23,
yycrank+16,	0,		yyvstop+26,
yycrank+17,	0,		yyvstop+28,
yycrank+199,	0,		yyvstop+31,
yycrank+0,	0,		yyvstop+34,
yycrank+5,	0,		yyvstop+37,
yycrank+0,	0,		yyvstop+39,
yycrank+8,	0,		yyvstop+42,
yycrank+0,	0,		yyvstop+45,
yycrank+0,	0,		yyvstop+47,
yycrank+7,	0,		yyvstop+49,
yycrank+0,	0,		yyvstop+51,
yycrank+0,	0,		yyvstop+53,
yycrank+8,	0,		yyvstop+56,
yycrank+0,	0,		yyvstop+58,
yycrank+0,	yysvec+14,	yyvstop+60,
yycrank+0,	0,		yyvstop+62,
yycrank+0,	yysvec+17,	0,	
yycrank+0,	0,		yyvstop+64,
yycrank+0,	0,		yyvstop+66,
yycrank+13,	yysvec+19,	yyvstop+68,
yycrank+274,	0,		yyvstop+70,
yycrank+0,	yysvec+20,	yyvstop+72,
yycrank+296,	0,		0,	
yycrank+-8,	yysvec+21,	yyvstop+74,
yycrank+21,	0,		0,	
yycrank+0,	0,		yyvstop+76,
yycrank+0,	0,		yyvstop+78,
yycrank+0,	0,		yyvstop+80,
yycrank+7,	0,		yyvstop+82,
yycrank+0,	yysvec+25,	yyvstop+84,
yycrank+0,	0,		yyvstop+86,
yycrank+0,	0,		yyvstop+88,
yycrank+16,	0,		0,	
yycrank+19,	0,		0,	
yycrank+311,	0,		0,	
yycrank+22,	yysvec+43,	yyvstop+90,
yycrank+328,	0,		0,	
yycrank+338,	0,		0,	
yycrank+0,	yysvec+60,	yyvstop+93,
yycrank+0,	0,		yyvstop+95,
yycrank+25,	0,		0,	
yycrank+7,	0,		0,	
yycrank+348,	0,		0,	
yycrank+0,	yysvec+65,	yyvstop+97,
yycrank+363,	0,		0,	
yycrank+373,	0,		0,	
yycrank+0,	yysvec+68,	yyvstop+99,
yycrank+15,	0,		0,	
yycrank+28,	0,		0,	
yycrank+383,	0,		0,	
yycrank+0,	yysvec+72,	yyvstop+101,
yycrank+21,	0,		0,	
yycrank+17,	0,		0,	
yycrank+23,	0,		0,	
yycrank+35,	0,		0,	
yycrank+40,	0,		0,	
yycrank+45,	0,		0,	
yycrank+37,	0,		0,	
yycrank+33,	0,		0,	
yycrank+37,	0,		0,	
yycrank+49,	0,		0,	
yycrank+0,	0,		yyvstop+104,
yycrank+57,	0,		0,	
yycrank+0,	0,		yyvstop+106,
0,	0,	0};
struct yywork *yytop = yycrank+440;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,'+' ,01  ,'+' ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,':' ,01  ,01  ,01  ,01  ,':' ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,'_' ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)Fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				Fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)Fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					Fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)Fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				Fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			Fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					Fprintf(yyout,"\nmatch ");
					sprint(yytext);
					Fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
