#if defined(__TURBOC__) || NeXT 
extern void *malloc(), *calloc(), *realloc();
#else
extern char *malloc(), *calloc(), *realloc();
#endif


# line 2 "parse1.y"
/* $Header: /timshel2g/src/master/nrn/src/modlunit/ytab.c,v 1.2 1994/10/12 20:55:12 hines Exp $ */

#include "model.h"

/* Constructs a parse tree. No translation is done, ie. on exit printing
the intoken list will make an exact copy of the input file.
All tokens and productions are of Item type and consist of STRING, SYMBOL,
and LIST.
SPACE and NEWLINE are in the intoken list but are not yacc tokens.

All explicitly declared names are given their subtype
and a pointer to their declaration. All "used" names are marked with
their usage for later error checking.
*/

extern Symbol *checklocal();
extern Item *title;
extern int declare_level;
extern int parse_pass, restart_pass;
extern List *solvelist;

#define IFP(n)	if (parse_pass == n)
#define IFR(n)	if (restart_pass == n)
#define P1	IFP(1)
#define P2	IFP(2)
#define P3	IFP(3)
#define R0	IFR(0)
#define R1	IFR(1)

#if BISON 
#define myerr(arg) static int ierr=0;\
if (!(ierr++))yyerror(arg); --yyssp; --yyvsp; YYERROR
#else
#define myerr(arg) static int ierr=0;\
if (!(ierr++))yyerror(arg); --yyps; --yypv; YYERROR
#endif

extern Item *lastok;	/* last token accepted by expr */
static int blocktype;
static int unitflagsave; /*must turn off units in restartpass0 in kinetic block */
extern int lexcontext;

# line 45 "parse1.y"
typedef union  {
	Item	*qp;
} YYSTYPE;
# define VERBATIM 257
# define COMMENT 258
# define TITLE 259
# define CONSTANT 260
# define INDEPENDENT 261
# define ASSIGNED 262
# define STATE 263
# define END_VERBATIM 264
# define END_COMMENT 265
# define UNITS 266
# define BREAKPOINT 267
# define PARAMETER 268
# define INITIAL1 269
# define DERIVATIVE 270
# define SOLVE 271
# define USING 272
# define WITH 273
# define STEPPED 274
# define DISCRETE 275
# define FROM 276
# define TO 277
# define BY 278
# define WHILE 279
# define IF 280
# define ELSE 281
# define START1 282
# define STEP 283
# define SENS 284
# define SOLVEFOR 285
# define PROCEDURE 286
# define PARTIAL 287
# define DEL 288
# define DEL2 289
# define DEFINE1 290
# define IFERROR 291
# define DERFUNC 292
# define EQUATION 293
# define TERMINAL 294
# define LINEAR 295
# define NONLINEAR 296
# define FUNCTION1 297
# define LOCAL 298
# define METHOD 299
# define LIN1 300
# define NONLIN1 301
# define PUTQ 302
# define GETQ 303
# define INCLUDE1 304
# define OR 305
# define AND 306
# define GT 307
# define GE 308
# define LT 309
# define LE 310
# define EQ 311
# define NE 312
# define NOT 313
# define NAME 314
# define PRIME 315
# define REAL 316
# define INTEGER 317
# define DEFINEDVAR 318
# define KINETIC 319
# define CONSERVE 320
# define REACTION 321
# define REACT1 322
# define COMPARTMENT 323
# define PARTEQN 324
# define STRING 325
# define PLOT 326
# define VS 327
# define LAG 328
# define RESET 329
# define MATCH 330
# define MODEL_LEVEL 331
# define SWEEP 332
# define FIRST 333
# define LAST 334
# define SPACE 335
# define NEWLINE 336
# define TO_EOL 337
# define STUFF 338
# define UNITBLK 339
# define UNITSON 340
# define UNITSOFF 341
# define TABLE 342
# define DEPEND 343
# define NEURON 344
# define SUFFIX 345
# define NONSPECIFIC 346
# define READ 347
# define WRITE 348
# define USEION 349
# define VALENCE 350
# define GLOBAL 351
# define SECTION 352
# define RANGE 353
# define POINTER 354
# define EXTERNAL 355
# define ELECTRODE_CURRENT 356
# define UNARYMINUS 357
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 733 "parse1.y"

	/* end of grammar */

yyerror(s)	/* called for yacc syntax error */
	char *s;
{
	Fprintf(stderr, "%s:\n ", s);
}

static int yylex() {return next_intoken(&(yylval.qp));}

#if !NRNUNIT
nrn_list(q1, q2)
	Item *q1, *q2;
{
	/*ARGSUSED*/
}
nrn_use(q1, q2, q3)
	Item *q1, *q2, *q3;
{
	/*ARGSUSED*/
}
#endif

/*
$Log: ytab.c,v $
 * Revision 1.2  1994/10/12  20:55:12  hines
 * first pass at neuron under cvs control
 *
 * Revision 1.1.1.1  1994/10/12  17:22:52  hines
 * NEURON 3.0 distribution
 *
 * Revision 1.31  1994/09/26  18:51:06  hines
 * USEION ... VALENCE real
 *
 * Revision 1.30  1994/08/18  12:09:42  hines
 * check units of CONSERVE stmt
 *
 * Revision 1.29  1994/07/30  17:12:53  hines
 * standard check for BISON
 *
 * Revision 1.28  1994/05/18  18:08:13  hines
 * INCLUDE "file"
 * tries originalpath/file ./file MODL_INCLUDEpaths/file
 *
 * Revision 1.27  1993/07/08  14:36:56  hines
 * An alternative to NONSPECIFIC_CURRENT is ELECTRODE_CURRENT
 *
 * Revision 1.26  92/06/01  13:25:50  hines
 * NEURON {EXTERNAL name, name, ...} allowed
 * 
 * Revision 1.25  92/03/09  17:22:27  hines
 * internal error in handling stoichiometry units. fixed.
 * 
 * Revision 1.24  92/02/17  12:30:56  hines
 * constant states with a compartment size didn't have space allocated
 * to store the compartment size.
 * 
 * Revision 1.23  92/02/15  21:19:41  hines
 * if translated by bison use -DBISON=1
 * NEURON { POINTER ...} allowed
 * 
 * Revision 1.22  91/12/27  10:57:13  hines
 * units for f_flux and b_flux in KINETIC block.
 * Implemented by turning off units checking on pass 3 of restartpass 0
 * and then turning it back on on pass3 of restartpass 1.
 * 
 * Revision 1.21  91/09/16  16:04:02  hines
 * NEURON { RANGE SECTION GLOBAL} syntax
 * 
 * Revision 1.20  91/06/29  08:45:57  hines
 * more general units factor of form name=(unit) (unit)
 * slight change to syntax
 * 
 * Revision 1.19  91/02/09  16:39:39  hines
 * special neuron variables checked for correct units.
 * 
 * Revision 1.18  91/01/25  09:31:26  hines
 * botched last fix
 * 
 * Revision 1.17  91/01/24  15:24:20  hines
 * translation error when last token of LOCAL statement was the first token
 * after the LOCAL statement. Fixed by changing symbols at the parser insteadof the lexical analyser.
 * 
 * Revision 1.16  91/01/24  11:45:57  hines
 * PROCEDURE argument units were not being saved.
 * 
 * Revision 1.15  91/01/07  14:31:25  hines
 * Compartment list is space separated not comma separated
 * 
 * Revision 1.14  90/12/12  11:33:10  hines
 * LOCAL vectors allowed. Some more NEURON syntax added
 * 
 * Revision 1.13  90/11/26  13:09:18  hines
 * sometimes need to swap top of units stack.
 * 
 * Revision 1.12  90/11/23  13:43:56  hines
 * BREAKPOINT PARAMETER
 * 
 * Revision 1.11  90/11/20  15:39:23  hines
 * comment out print statements that debug value, units for factordef:
 * 
 * Revision 1.10  90/11/20  15:33:08  hines
 * added 4 varieties of unit factors. They are 
 * name = (real)
 * name = ((unit) -> (unit))	must be conformable
 * name = (physical_constant)
 * name = (physical_constant (unit))	must be conformable
 * 
 * Revision 1.9  90/11/16  14:23:05  hines
 * units for partial derivative equation. fixed bug in array declarations
 * get sources from rcs correctly
 * 
 * Revision 1.8  90/11/15  13:01:19  hines
 * function units and number units work. accepts NEURON block
 * 
 * Revision 1.7  90/11/13  16:13:17  hines
 * prototype units checking
 * 
 * Revision 1.6  90/07/12  09:17:20  hines
 * works well through scriven.mod  now need kinetic
 * 
 * Revision 1.5  90/07/10  15:18:28  hines
 * working with (cnvfac)
 * 
 * Revision 1.4  90/07/10  09:59:01  hines
 * discarding the UNITS block conversion factor
 * 
 * Revision 1.3  90/07/09  11:11:25  hines
 * want to try  keeping not only first token but also last token
 * on the stack.
 * 
 * Revision 1.2  90/07/06  06:38:51  hines
 * ready to start on units
 * 
 * Revision 1.1  90/07/04  08:33:33  hines
 * Initial revision
 * 
 * Revision 1.1  90/07/02  08:44:07  hines
 * Initial revision
 * 
*/

int yyexca[] ={
-1, 0,
	0, 3,
	257, 3,
	258, 3,
	259, 3,
	260, 3,
	261, 3,
	262, 3,
	263, 3,
	267, 3,
	268, 3,
	269, 3,
	270, 3,
	274, 3,
	275, 3,
	286, 3,
	287, 3,
	290, 3,
	294, 3,
	295, 3,
	296, 3,
	297, 3,
	298, 3,
	304, 3,
	319, 3,
	326, 3,
	331, 3,
	339, 3,
	340, 3,
	341, 3,
	344, 3,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
-1, 2,
	267, 101,
	269, 97,
	270, 99,
	275, 113,
	286, 109,
	287, 115,
	294, 111,
	295, 103,
	296, 105,
	297, 107,
	319, 117,
	-2, 1,
-1, 288,
	44, 242,
	-2, 22,
-1, 358,
	41, 187,
	44, 187,
	-2, 0,
-1, 381,
	40, 273,
	-2, 270,
	};
# define YYNPROD 296
# define YYLAST 1113
int yyact[]={

   258,   233,   182,   507,   449,   442,   359,   375,   380,   260,
   259,   279,   267,   276,   404,   404,   405,   406,   308,    43,
    45,    46,    47,   216,    52,   450,   451,    44,   124,   325,
    83,   230,    93,    48,   285,   149,   384,    30,    31,    14,
    43,    45,    46,    47,   266,   102,   103,    58,    44,   366,
    80,   365,   229,   434,    48,   312,   102,   103,   387,   102,
   103,   283,    94,   105,   280,   283,    94,   108,   440,   101,
    16,   283,    94,    92,   437,   245,   297,   113,    15,   283,
    94,   148,   282,   568,    34,    49,    95,    94,   552,   554,
   443,   383,   283,    94,   291,   287,   172,    91,    50,   452,
   327,   158,   277,    51,   275,   144,    49,   269,   295,   153,
   134,    18,   310,   130,   221,    57,   172,   141,   142,    50,
    32,    33,   283,    94,    51,   282,    54,   487,   160,   493,
   471,   447,    95,   444,   296,   294,   377,   154,   218,   165,
   334,   222,   324,   199,   156,   156,   227,   163,   164,    95,
    94,   303,    95,    94,   129,    95,    94,   116,   326,   169,
    95,   115,   274,   225,   225,   268,   153,   152,   114,   112,
   111,   110,   220,    56,   109,   107,   470,   309,   435,   430,
    15,   166,    70,    68,    55,    66,    74,   361,   360,   521,
    78,    72,   137,   466,   236,   106,   534,   459,   457,   236,
   458,   373,   460,   527,   396,   394,   256,   361,   445,   232,
   289,    76,   147,   234,   502,    62,    60,   323,   281,   286,
    64,     3,    82,    81,   152,   293,   459,   457,   199,   458,
   383,   460,   157,   241,   290,   223,   147,   298,   299,   278,
   106,   311,   151,    99,   278,   311,   261,   315,   311,   311,
   311,   313,   132,   321,   316,   317,   319,   300,   335,   128,
    96,    89,   150,   351,   352,   353,    88,    87,   157,    86,
   146,   355,   356,   320,   388,   322,   125,   488,   306,   328,
   329,   330,   331,   332,   333,   357,   314,    85,    95,    94,
    95,    94,    84,   367,   146,   246,   248,   155,   370,   255,
    17,   252,   251,   250,   253,   254,   249,   341,   524,   522,
   391,   123,   171,   350,   386,   364,   488,   162,   508,   492,
   509,   509,   395,   311,   381,   262,    95,    94,   363,   390,
   264,   240,    95,   175,   385,   102,   103,   407,   408,   409,
   410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
   420,   454,   549,   400,   401,   448,     6,   389,   339,   428,
   425,   392,   378,   340,   431,   301,   126,   386,   100,   438,
   170,   397,   272,   174,   281,   433,   226,   436,   273,   183,
   439,   117,   543,   312,   102,   103,   217,   385,   453,   446,
   541,   422,   266,   102,   103,   432,   262,   465,   235,   135,
   386,   264,   272,   381,   236,   131,   523,   311,   278,   311,
   341,   311,   311,   464,   231,   467,   262,   468,   469,   159,
   385,   264,   376,   354,   461,   257,   475,   476,   242,   106,
   243,   302,   200,   532,   369,   472,   473,   480,   386,   172,
   238,   239,   486,   463,   262,   237,   489,   478,   484,   264,
   479,   485,   368,   491,   459,   457,   494,   458,   385,   460,
   228,   474,   477,   133,   183,   500,   362,   118,   441,   505,
   386,   386,   386,   386,   404,   481,   459,   510,   366,   311,
   514,   460,   516,   517,   518,   504,   399,   386,   393,   305,
   385,   385,   385,   385,   495,   496,   497,   498,   219,   567,
   339,   337,   506,   338,    98,   340,   106,   385,   176,   200,
   138,   511,   172,   566,   526,   490,   143,   402,   503,   530,
   563,   539,   403,   307,   542,   538,   339,   337,   544,   338,
   172,   340,   304,   546,   398,   172,   551,   550,   529,   560,
   311,   265,   555,   540,   556,   386,   545,   558,   483,   482,
   559,   455,   341,   561,   339,   337,   271,   338,   528,   340,
   270,   565,   198,    30,    31,   385,   562,   140,   139,   548,
   569,   339,   337,   535,   338,   173,   340,   205,   341,    97,
   197,   186,   201,    12,    11,   202,   203,   371,   462,   547,
   206,   339,   337,   358,   338,    29,   340,   557,   263,   204,
    94,   266,   102,   103,   185,    28,   341,    10,   213,   214,
   515,   564,   265,   537,   339,   337,    27,   338,    26,   340,
   204,    94,    25,   341,    24,    23,   208,   207,    22,   209,
   212,    21,   265,    20,   210,   195,   215,    19,   244,   198,
    30,    31,   104,   341,   247,    42,    32,    33,   211,   536,
   339,   337,    13,   338,   205,   340,   168,   167,   127,   201,
   265,    41,   202,   203,   382,   379,   341,   206,   196,   263,
   204,    94,   266,   102,   103,   194,   525,   339,   337,   191,
   338,   429,   340,   284,   188,   213,   214,    79,   190,   263,
   204,    94,   266,   102,   103,   189,   187,   204,    94,    73,
    63,   136,   341,   208,   207,   184,   209,   212,    71,   224,
    69,   210,   195,   215,   193,    77,    67,   263,   288,    94,
   266,   102,   103,    32,    33,   211,    65,   339,   337,   341,
   338,    61,   340,   374,   424,   339,   337,   292,   338,   192,
   340,   533,   512,   181,   423,   339,   337,   180,   338,   531,
   340,   179,   421,   339,   337,   427,   338,   553,   340,   426,
   178,   177,    53,   342,   343,   344,   346,   345,   347,   348,
   349,    59,     9,   339,   337,    90,   338,    40,   340,   341,
    75,   339,   337,   121,   338,    38,   340,   341,   120,   342,
   343,   344,   346,   345,   347,   348,   349,   341,   339,   337,
    37,   338,   501,   340,   119,   341,    36,   318,   519,   161,
   122,   339,   337,    39,   338,   145,   340,   342,   343,   344,
   346,   345,   347,   348,   349,   341,   520,    35,     8,     7,
   336,     5,     4,   341,   342,   343,   344,   346,   345,   347,
   348,   349,   339,   337,     2,   338,     1,   340,   339,   337,
   341,   338,     0,   340,   342,   343,   344,   346,   345,   347,
   348,   349,   372,   341,     0,     0,     0,     0,     0,     0,
   459,   457,     0,   458,     0,   460,     0,   342,   343,   344,
   346,   345,   347,   348,   349,   459,   457,     0,   458,     0,
   460,   499,   459,   457,   341,   458,     0,   460,     0,     0,
   341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   342,   343,   344,   346,   345,   347,   348,
   349,   513,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   456,     0,     0,     0,
   342,   343,   344,   346,   345,   347,   348,   349,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   342,   343,   344,   346,   345,   347,   348,   349,   342,   343,
   344,   346,   345,   347,   348,   349,     0,     0,   342,   343,
   344,   346,   345,   347,   348,   349,   342,   343,   344,   346,
   345,   347,   348,   349,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   342,   343,   344,   346,
   345,   347,   348,   349,   342,   343,   344,   346,   345,   347,
   348,   349,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   343,   344,   346,   345,   347,   348,   349,     0,
     0,     0,     0,     0,   342,   343,   344,   346,   345,   347,
   348,   349,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   344,   346,   345,
   347,   348,   349 };
int yypact[]={

   -35, -1000,  -220, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,  -313,  -130,  -141, -1000,  -270,   -53,
   -55,   -47,  -110,  -113,  -115,   -95,  -108,   -64,   -97,  -269,
   -41,   -43, -1000, -1000,  -295, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000,   169,   164,   146,   144,   143,   138,  -159,
   137, -1000, -1000,   460, -1000,   277,  -258, -1000, -1000, -1000,
   117, -1000,  -139, -1000,   117, -1000,  -140, -1000,  -143, -1000,
  -144, -1000,  -145, -1000,   117, -1000,  -146, -1000,  -153, -1000,
  -157, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -16, -1000,   275, -1000, -1000, -1000, -1000,   136,  -160, -1000,
  -258, -1000, -1000, -1000,  -241, -1000,  -118,   117, -1000,   -93,
   -93,   528,   527, -1000,   117,   117,   -93,   -20,   -44,   -90,
    12,   -24,     3,  -228,  -228, -1000,  -258,    56, -1000,   277,
   240, -1000,   383, -1000, -1000,   117,   454,  -142,   117,  -228,
  -228, -1000, -1000,   117, -1000, -1000,   399, -1000, -1000, -1000,
 -1000,  -147,   -67, -1000, -1000, -1000,   122, -1000, -1000, -1000,
 -1000, -1000,   384,   275,   275,   238, -1000, -1000, -1000,   172,
   369, -1000, -1000,   -50, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,   364,
   376,  -149,   520,   516,   338,  -152,  -154,  -192,  -222,   404,
  -162,  -182,  -180,  -228,  -228,   134,   274,   306, -1000,  -163,
 -1000, -1000, -1000,   491,   445,   495,   482, -1000,    67, -1000,
 -1000, -1000,    67,   495,  -258,    67,    67,    67, -1000, -1000,
 -1000,   495, -1000,    76,   -49, -1000,  -172, -1000,  -156,  -156,
  -156,  -156,  -156,  -156,  -156,  -174, -1000,   376,   769, -1000,
   495, -1000,   376,   376,   376, -1000, -1000, -1000,   362, -1000,
   376,   376,  -258, -1000,   -84, -1000,   422, -1000, -1000,     6,
 -1000, -1000,  -253,   308,   391, -1000, -1000,  -253,   338,   739,
   -77, -1000,  -336,   422,   361,  -178,   271, -1000, -1000, -1000,
  -165,    18, -1000, -1000,   495,  -228, -1000,   117,   495, -1000,
  -261, -1000, -1000,   -72, -1000,   229,   -73, -1000,   490,   442,
 -1000,   495,   472,   481, -1000,   430, -1000, -1000,   430,   430,
   430,   430,   430,   430,  -331,   731,   376,   376,   376,   376,
   376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
 -1000,   711,   213,   213,    18,   703,   693,   269,   356, -1000,
  -120,   117,  -182,  -235,  -256,  -129,  -243, -1000,   376,  -249,
 -1000,   424,  -224,  -181,   -68,  -182,  -183,   264,  -308,   -26,
 -1000,   260,   511, -1000,   843, -1000, -1000,    18, -1000, -1000,
   495, -1000, -1000, -1000,    67,   -83,    67, -1000,    67,    67,
 -1000, -1000,  -131, -1000,  -184,  -156,  -156,   731,   316,   316,
   213,   213,   213,   756,   800,   806,   806,   806,   806,   806,
   806, -1000,   184,   117,   117,    18,   406, -1000,   731, -1000,
  -104, -1000, -1000,   435,   509,   508, -1000,  -253,   731, -1000,
  -253,   376,     2, -1000, -1000,   376,   422,   473,  -308,   226,
 -1000, -1000, -1000, -1000,  -185,   376, -1000,    18,    18,    18,
    18,   850,   117, -1000,   -59,   495,    67,   -88, -1000, -1000,
   495, -1000,   -30,   -29,    18, -1000, -1000,   828, -1000,   285,
 -1000,   376,   376,   376, -1000, -1000,   685, -1000, -1000,   549,
  -100,   216,   345,   215,   635,   434,   434, -1000, -1000, -1000,
 -1000,  -258, -1000, -1000,   -74,   495, -1000, -1000,  -156,  -272,
 -1000,   155,   -85, -1000,   731, -1000,   529,   608,   572,  -224,
   376,   503,   329,   376, -1000,   321,   -88,    67, -1000,   -29,
 -1000, -1000,    18, -1000,    72,   376, -1000, -1000,   -37,   484,
  -225,   376,   731,   376,   495,   -88, -1000,   117,   412,   499,
 -1000,   512, -1000,  -258,   479,   731,   731, -1000,   495, -1000,
   376, -1000, -1000,   470, -1000,   458,  -231,   117, -1000, -1000 };
int yypgo[]={

     0,   846,   844,   832,   831,   604,   581,   829,   828,   300,
   827,   381,   815,    52,   813,   810,   809,    32,   807,    23,
    18,   177,    12,     9,   806,   804,   262,   802,   800,   788,
   297,     1,   785,   783,   780,   777,   775,   276,   772,   771,
     2,   252,   356,   762,   243,   761,   760,    10,    36,     0,
   246,   759,   755,   751,   749,   747,   743,   742,   741,   739,
   737,   733,   731,   726,   716,   715,   714,     4,   710,   235,
   709,   708,   705,     6,   701,   399,   700,   699,   696,     5,
   695,   688,    13,   687,   684,    11,   683,   679,   675,   668,
   665,     8,   664,   661,   580,   658,   657,    31,   656,   652,
   645,   644,    29,     3,   642,   638,   637,   633,   631,   628,
   625,   624,   622,   618,   616,   605,   595,   593,   589,   588,
   587,   579,   575 };
int yyr1[]={

     0,     1,     1,     2,     2,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     4,     5,     6,    94,    94,    99,
     7,     7,    17,     8,   104,     8,     9,     9,     9,     9,
     9,     9,     9,     9,    10,    10,    11,    11,    12,    12,
    12,    13,    13,   105,    97,    14,    15,    15,    16,    18,
    18,    19,    19,    20,    20,    21,    21,    22,    22,    23,
    23,    24,    25,    25,    25,    26,    26,    27,    28,    29,
    29,    30,    30,    30,    30,    30,    31,    31,    32,    33,
    33,    35,    35,    36,    36,    37,    37,    93,    95,    95,
    95,    96,    96,    98,    98,    98,    98,   106,    38,   107,
    38,   108,    38,   109,    38,   110,    38,   111,    38,   112,
    38,   113,    38,   114,    38,   115,    38,   116,    38,    39,
    40,    40,    42,    42,    43,    43,    44,    44,    41,    41,
    45,    45,    45,    45,    45,    45,    45,    45,    45,    45,
    45,    45,    45,    45,    45,    45,    45,    45,    45,    45,
    45,    46,    46,    47,    47,    47,    47,    48,    48,    48,
    48,    48,    48,    48,    48,    49,    49,    49,    49,    49,
    49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
    49,    49,    49,    49,    49,   117,    50,    51,    51,    52,
    52,    52,    52,   118,    53,    53,    54,    54,    55,    56,
    57,    57,    58,    58,    62,    63,    64,    34,    65,    66,
    66,    66,    66,    67,    67,   119,    68,    69,    69,    70,
    70,    71,    72,    72,    72,    73,    73,    75,    75,    74,
    74,    74,    76,    77,    78,    78,    80,    80,    86,    86,
    86,    86,   120,    81,    81,    79,    79,    82,    82,    83,
    84,    84,    84,    84,    85,    85,    85,    85,    87,    87,
    59,    60,    60,    61,    61,    88,    88,    89,    90,    90,
    91,    91,    91,    92,    92,   121,   100,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   101,   101,   101,
   101,   102,   102,   102,   103,   103 };
int yyr2[]={

     0,     2,     3,     1,     4,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     5,     4,     4,     3,     3,     5,
     7,     5,     3,     2,     1,     9,     2,     2,     2,     2,
     2,     2,     2,     2,     8,     8,     1,     4,     9,     5,
     3,     1,     2,     1,     9,     8,     1,     4,     9,     6,
     6,     3,     3,     3,     5,     2,     2,     2,     2,     3,
     3,     8,     1,     5,     7,    19,     3,     2,     8,     1,
     5,     7,    13,    15,    21,     3,     1,     5,     8,     1,
     5,    10,     5,     4,     8,     1,     7,     8,     1,     4,
     4,     7,     5,     9,     9,    13,     3,     1,     5,     1,
     5,     1,     5,     1,     5,     1,     5,     1,     5,     1,
     5,     1,     5,     1,     5,     1,     5,     1,     5,     4,
     7,     9,     4,     5,     5,     9,     1,     7,     1,     4,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     3,     7,     9,     3,     9,     7,    13,     3,     3,     7,
     6,     6,     6,     6,     3,     3,     5,     3,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     5,     4,     3,     1,    11,     1,     2,     3,
     2,     7,     6,     1,    19,     5,     1,     4,    11,    15,
     1,    15,     1,     4,     7,     9,     9,     7,     7,    23,
    17,    15,     5,     2,     2,     1,    17,     1,     2,     5,
     9,    13,     7,    11,     5,     1,     5,     1,     2,     5,
     7,     5,     4,     4,     4,     5,     9,     5,     3,     5,
     7,     9,     1,    17,    11,     3,     5,     2,     6,     9,
    19,    15,    15,     5,     3,     5,     7,     9,     8,     5,
    19,     1,     2,     1,     4,     4,     4,     8,     2,     4,
     2,    12,     3,     2,     8,     1,    11,     0,     7,     4,
     7,     7,     7,     7,     7,     7,     7,    11,    11,    15,
     3,     3,     7,     3,     1,     5 };
int yychk[]={

 -1000,    -1,    -2,   256,    -3,    -4,   -42,    -7,    -8,   -38,
    -5,    -6,   -94,   -99,   259,   298,   290,    -9,   331,  -106,
  -107,  -108,  -109,  -110,  -111,  -112,  -113,  -114,  -115,  -116,
   257,   258,   340,   341,   304,   -10,   -24,   -28,   -32,   -14,
   -35,   -93,  -100,   260,   268,   261,   262,   263,   274,   326,
   339,   344,   337,   -43,   256,   314,   314,   256,   317,   -39,
   269,   -62,   270,   -76,   267,   -63,   295,   -64,   296,   -68,
   297,   -71,   286,   -77,   294,   -34,   275,   -65,   287,   -83,
   319,   264,   265,   325,   123,   123,   123,   123,   123,   123,
   -36,   256,   -19,   -17,   315,   314,   123,  -121,    44,   -44,
    91,   -22,   317,   318,  -104,   -40,   123,   314,   -40,   314,
   314,   314,   314,   -40,   314,   314,   314,   -11,   -11,   -25,
   -29,   -33,   -15,   327,    44,   -37,    91,   -95,   123,   314,
   -22,    -9,   -41,   -42,   -40,   -75,   -74,   285,   -75,    40,
    40,   -40,   -40,   -75,   125,   -12,   314,   256,   125,   125,
   -26,   332,   314,   256,   125,   -30,   -19,   256,   125,   -30,
   125,   -16,   314,   -19,   -19,   -22,   125,   -96,   -98,   -97,
   314,   256,    40,  -122,   -44,    93,   125,   -45,   -46,   -53,
   -55,   -56,   -40,   -50,   -72,    -5,    -6,   -78,   -84,   -80,
   -81,   -87,   -59,   -66,   -88,   329,   -89,   -94,   256,   -47,
   126,   276,   279,   280,   314,   271,   284,   321,   320,   323,
   328,   342,   324,   302,   303,   330,   -19,   -41,   -40,    44,
   314,   256,   -40,   -69,   -70,   -19,   -69,   -40,    61,   -13,
   -97,   -26,   276,   -31,    91,   276,   282,    61,   -37,   -37,
    93,    61,   256,    61,  -105,   125,   345,  -101,   346,   356,
   353,   352,   351,   354,   355,   349,   256,    61,   -49,   -47,
   -23,   -50,    40,   313,    45,   256,   316,   -22,   314,   256,
    40,    40,    64,    40,   314,   256,   -82,   256,   -17,   -85,
   256,   -47,   317,   314,   -86,   256,   -47,   317,   314,   -49,
   -19,   256,   -60,   -82,   315,   288,   314,   256,   -19,   -19,
   123,    91,   125,   314,    41,    44,   -13,    41,   -20,   -21,
    45,   -22,   316,   -20,   -13,   -22,   -20,   -20,   -18,   -20,
   -97,   -23,   -97,   266,   314,  -102,   314,   256,  -102,  -102,
  -102,  -102,  -102,  -102,   314,   -49,    61,    43,    45,    42,
    47,    94,   305,   306,   307,   309,   308,   310,   311,   312,
   -13,   -49,   -49,   -49,    61,   -49,   -49,   -22,  -117,   -73,
   272,   291,    44,   322,   309,    45,    43,   -47,    61,    43,
   -47,  -120,   123,   278,   -61,   343,    61,   314,    91,   -90,
   -91,   -19,   -92,   256,   -48,   -17,   -22,    40,   256,   -13,
   -19,   -40,   -13,   -21,   277,    93,   277,   -13,    44,    44,
   -97,   -97,    45,    41,    44,   347,   348,   -49,   -49,   -49,
   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
   -49,    41,   -48,    41,    41,    91,   -51,   -52,   -49,   325,
   299,   -40,   -17,   -85,   309,   307,   -47,   317,   -49,   -47,
   317,    44,   -79,   314,   314,   276,   -82,   314,    91,   -67,
   333,   334,   125,   -91,    91,    40,    93,    43,    45,    42,
    47,   -48,  -119,   -13,   -20,   -31,   276,   -20,   -20,   -20,
   307,   314,  -102,  -102,   277,   -40,   -40,   -48,    41,    44,
   -73,    40,    40,    40,   -47,   -47,   -49,   125,   314,   -49,
    42,   -67,    93,   314,   -49,   -48,   -48,   -48,   -48,    41,
   -40,   -27,   273,   -13,   -20,   -31,   -97,  -103,   348,   350,
  -103,   -48,   -57,    93,   -49,   325,   -49,   -49,   -49,   123,
   277,   289,    93,    61,    93,    41,   -22,   277,   -13,  -102,
   -23,   -54,   278,   -58,   281,    44,    41,    41,   -79,   -49,
    40,    61,   -49,    61,   -31,   -20,  -103,  -118,   -48,   280,
   -40,   -49,   125,   273,   314,   -49,   -49,   -13,   -31,   -40,
    40,    41,   -22,    41,   -13,   -49,    43,    41,   314,   -40 };
int yydef[]={

    -2,    -2,    -2,     2,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,     0,     0,     0,    23,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    17,    18,     0,    26,    27,    28,    29,    30,
    31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
     0,   275,    14,   122,   123,   126,     0,    21,    24,    98,
     0,   100,     0,   102,     0,   104,     0,   106,     0,   108,
     0,   110,     0,   112,     0,   114,     0,   116,     0,   118,
     0,    15,    16,    19,    36,    36,    62,    69,    79,    46,
     0,    82,    85,    51,    52,    22,    88,     0,     0,   124,
     0,    20,    57,    58,     0,   119,   128,     0,   232,   227,
   227,     0,     0,   233,     0,     0,   227,     0,     0,     0,
     0,     0,     0,     0,     0,    83,     0,     0,   277,   126,
     0,    25,     0,   128,   204,     0,   228,     0,     0,   217,
   217,   207,   208,     0,    34,    37,    41,    40,    35,    61,
    63,     0,     0,    66,    68,    70,    76,    75,    78,    80,
    45,    47,     0,    85,    85,     0,    87,    89,    90,     0,
     0,    96,    43,     0,   125,   127,   120,   129,   130,   131,
   132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
   142,   143,   144,   145,   146,   147,   148,   149,   150,     0,
     0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
     0,   261,     0,     0,     0,     0,   153,     0,   205,     0,
   229,   231,   206,     0,   218,    41,     0,   249,     0,    39,
    42,    64,     0,    41,     0,     0,     0,     0,    81,    84,
    86,     0,    92,     0,     0,   276,     0,   279,     0,     0,
     0,     0,     0,     0,     0,     0,   290,     0,     0,   165,
    41,   167,     0,     0,     0,   184,    59,    60,     0,   195,
     0,     0,     0,   185,   225,   224,   234,   235,   247,     0,
   253,   254,     0,    22,     0,   237,   238,     0,    -2,     0,
     0,   259,   263,   262,     0,     0,     0,   212,   265,   266,
     0,     0,   121,   230,    41,     0,   219,     0,    41,    53,
     0,    55,    56,     0,    71,     0,     0,    77,    41,     0,
    91,     0,     0,     0,   278,   280,   291,   293,   281,   282,
   283,   284,   285,   286,     0,   151,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   166,     0,   182,   183,     0,     0,     0,   155,    -2,   222,
     0,     0,     0,     0,     0,     0,     0,   255,     0,     0,
   239,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   268,    -2,     0,   272,     0,   157,   158,     0,   164,   215,
    41,   221,    38,    54,     0,    76,     0,    48,     0,     0,
    93,    94,     0,    44,     0,     0,     0,   152,   169,   170,
   171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
   181,   168,     0,     0,     0,     0,     0,   188,   189,   190,
   225,   226,   248,     0,     0,     0,   256,     0,   236,   240,
     0,     0,     0,   245,   258,     0,   264,     0,     0,     0,
   213,   214,   267,   269,     0,     0,   154,     0,     0,     0,
     0,     0,     0,   220,     0,    41,     0,    76,    50,    49,
     0,   292,   294,   294,     0,   198,   200,     0,   186,     0,
   223,     0,     0,     0,   257,   241,     0,   244,   246,     0,
     0,     0,     0,     0,     0,   160,   161,   162,   163,   159,
   216,     0,    67,    72,     0,    41,    95,   287,     0,     0,
   288,   196,   202,   156,   191,   192,     0,     0,     0,     0,
     0,     0,     0,     0,   274,     0,    76,     0,    73,   294,
   295,   193,     0,   199,     0,     0,   251,   252,     0,     0,
     0,     0,   211,     0,    41,    76,   289,     0,   197,     0,
   203,     0,   243,     0,     0,   210,   271,    65,    41,   194,
     0,   250,   260,     0,    74,     0,     0,     0,   209,   201 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"VERBATIM",	257,
	"COMMENT",	258,
	"TITLE",	259,
	"CONSTANT",	260,
	"INDEPENDENT",	261,
	"ASSIGNED",	262,
	"STATE",	263,
	"END_VERBATIM",	264,
	"END_COMMENT",	265,
	"UNITS",	266,
	"BREAKPOINT",	267,
	"PARAMETER",	268,
	"INITIAL1",	269,
	"DERIVATIVE",	270,
	"SOLVE",	271,
	"USING",	272,
	"WITH",	273,
	"STEPPED",	274,
	"DISCRETE",	275,
	"FROM",	276,
	"TO",	277,
	"BY",	278,
	"WHILE",	279,
	"IF",	280,
	"ELSE",	281,
	"START1",	282,
	"STEP",	283,
	"SENS",	284,
	"SOLVEFOR",	285,
	"PROCEDURE",	286,
	"PARTIAL",	287,
	"DEL",	288,
	"DEL2",	289,
	"DEFINE1",	290,
	"IFERROR",	291,
	"DERFUNC",	292,
	"EQUATION",	293,
	"TERMINAL",	294,
	"LINEAR",	295,
	"NONLINEAR",	296,
	"FUNCTION1",	297,
	"LOCAL",	298,
	"METHOD",	299,
	"LIN1",	300,
	"NONLIN1",	301,
	"PUTQ",	302,
	"GETQ",	303,
	"INCLUDE1",	304,
	"{",	123,
	"}",	125,
	"(",	40,
	")",	41,
	"[",	91,
	"]",	93,
	"@",	64,
	"+",	43,
	"*",	42,
	"-",	45,
	"/",	47,
	"=",	61,
	"^",	94,
	":",	58,
	",",	44,
	"~",	126,
	"OR",	305,
	"AND",	306,
	"GT",	307,
	"GE",	308,
	"LT",	309,
	"LE",	310,
	"EQ",	311,
	"NE",	312,
	"NOT",	313,
	"NAME",	314,
	"PRIME",	315,
	"REAL",	316,
	"INTEGER",	317,
	"DEFINEDVAR",	318,
	"KINETIC",	319,
	"CONSERVE",	320,
	"REACTION",	321,
	"REACT1",	322,
	"COMPARTMENT",	323,
	"PARTEQN",	324,
	"STRING",	325,
	"PLOT",	326,
	"VS",	327,
	"LAG",	328,
	"RESET",	329,
	"MATCH",	330,
	"MODEL_LEVEL",	331,
	"SWEEP",	332,
	"FIRST",	333,
	"LAST",	334,
	"SPACE",	335,
	"NEWLINE",	336,
	"TO_EOL",	337,
	"STUFF",	338,
	"UNITBLK",	339,
	"UNITSON",	340,
	"UNITSOFF",	341,
	"TABLE",	342,
	"DEPEND",	343,
	"NEURON",	344,
	"SUFFIX",	345,
	"NONSPECIFIC",	346,
	"READ",	347,
	"WRITE",	348,
	"USEION",	349,
	"VALENCE",	350,
	"GLOBAL",	351,
	"SECTION",	352,
	"RANGE",	353,
	"POINTER",	354,
	"EXTERNAL",	355,
	"ELECTRODE_CURRENT",	356,
	"%",	37,
	"UNARYMINUS",	357,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"top : all",
	"top : error",
	"all : /* empty */",
	"all : all all1",
	"all1 : title",
	"all1 : locallist",
	"all1 : define1",
	"all1 : declare",
	"all1 : proc",
	"all1 : verbatim",
	"all1 : comment",
	"all1 : unitflag",
	"all1 : include1",
	"title : TITLE TO_EOL",
	"verbatim : VERBATIM END_VERBATIM",
	"comment : COMMENT END_COMMENT",
	"unitflag : UNITSON",
	"unitflag : UNITSOFF",
	"include1 : INCLUDE1 STRING",
	"define1 : DEFINE1 NAME integer",
	"define1 : DEFINE1 error",
	"Name : NAME",
	"declare : declare1",
	"declare : MODEL_LEVEL INTEGER",
	"declare : MODEL_LEVEL INTEGER declare1",
	"declare1 : constblk",
	"declare1 : indepblk",
	"declare1 : depblk",
	"declare1 : stateblk",
	"declare1 : stepblk",
	"declare1 : plotdecl",
	"declare1 : unitblk",
	"declare1 : neuronblk",
	"constblk : CONSTANT '{' constbody '}'",
	"constblk : PARAMETER '{' constbody '}'",
	"constbody : /* empty */",
	"constbody : constbody constasgn",
	"constasgn : NAME '=' number units",
	"constasgn : NAME units",
	"constasgn : error",
	"units : /* empty */",
	"units : Units",
	"Units : '('",
	"Units : '(' UNITS ')'",
	"stepblk : STEPPED '{' stepbdy '}'",
	"stepbdy : /* empty */",
	"stepbdy : stepbdy stepped",
	"stepped : NAME '=' numlist units",
	"numlist : number ',' number",
	"numlist : numlist ',' number",
	"name : Name",
	"name : PRIME",
	"number : NUMBER",
	"number : '-' NUMBER",
	"NUMBER : integer",
	"NUMBER : REAL",
	"integer : INTEGER",
	"integer : DEFINEDVAR",
	"real : REAL",
	"real : integer",
	"indepblk : INDEPENDENT '{' indepbody '}'",
	"indepbody : /* empty */",
	"indepbody : indepbody indepdef",
	"indepbody : indepbody SWEEP indepdef",
	"indepdef : NAME FROM number TO number withby integer opstart units",
	"indepdef : error",
	"withby : WITH",
	"depblk : ASSIGNED '{' depbody '}'",
	"depbody : /* empty */",
	"depbody : depbody depdef",
	"depdef : name opstart units",
	"depdef : name '[' integer ']' opstart units",
	"depdef : name FROM number TO number opstart units",
	"depdef : name '[' integer ']' FROM number TO number opstart units",
	"depdef : error",
	"opstart : /* empty */",
	"opstart : START1 number",
	"stateblk : STATE '{' statbody '}'",
	"statbody : /* empty */",
	"statbody : statbody depdef",
	"plotdecl : PLOT pvlist VS name optindex",
	"plotdecl : PLOT error",
	"pvlist : name optindex",
	"pvlist : pvlist ',' name optindex",
	"optindex : /* empty */",
	"optindex : '[' integer ']'",
	"unitblk : UNITBLK '{' unitbody '}'",
	"unitbody : /* empty */",
	"unitbody : unitbody unitdef",
	"unitbody : unitbody factordef",
	"unitdef : Units '=' Units",
	"unitdef : Units error",
	"factordef : NAME '=' real Units",
	"factordef : NAME '=' Units Units",
	"factordef : NAME '=' Units '-' GT Units",
	"factordef : error",
	"proc : /* empty */",
	"proc : initblk",
	"proc : /* empty */",
	"proc : derivblk",
	"proc : /* empty */",
	"proc : eqnblk",
	"proc : /* empty */",
	"proc : linblk",
	"proc : /* empty */",
	"proc : nonlinblk",
	"proc : /* empty */",
	"proc : funcblk",
	"proc : /* empty */",
	"proc : procedblk",
	"proc : /* empty */",
	"proc : terminalblk",
	"proc : /* empty */",
	"proc : discretblk",
	"proc : /* empty */",
	"proc : partialblk",
	"proc : /* empty */",
	"proc : kineticblk",
	"initblk : INITIAL1 stmtlist",
	"stmtlist : '{' stmtlist1 '}'",
	"stmtlist : '{' locallist stmtlist1 '}'",
	"locallist : LOCAL locallist1",
	"locallist : LOCAL error",
	"locallist1 : NAME locoptarray",
	"locallist1 : locallist1 ',' NAME locoptarray",
	"locoptarray : /* empty */",
	"locoptarray : '[' integer ']'",
	"stmtlist1 : /* empty */",
	"stmtlist1 : stmtlist1 stmt",
	"stmt : asgn",
	"stmt : fromstmt",
	"stmt : whilestmt",
	"stmt : ifstmt",
	"stmt : stmtlist",
	"stmt : funccall",
	"stmt : solveblk",
	"stmt : verbatim",
	"stmt : comment",
	"stmt : sens",
	"stmt : reaction",
	"stmt : conserve",
	"stmt : compart",
	"stmt : lagstmt",
	"stmt : tablestmt",
	"stmt : pareqn",
	"stmt : queuestmt",
	"stmt : RESET",
	"stmt : matchblk",
	"stmt : unitflag",
	"stmt : error",
	"asgn : varname '=' expr",
	"asgn : '~' expr '=' expr",
	"varname : name",
	"varname : name '[' intexpr ']'",
	"varname : NAME '@' integer",
	"varname : NAME '@' integer '[' intexpr ']'",
	"intexpr : Name",
	"intexpr : integer",
	"intexpr : '(' intexpr ')'",
	"intexpr : intexpr '+' intexpr",
	"intexpr : intexpr '-' intexpr",
	"intexpr : intexpr '*' intexpr",
	"intexpr : intexpr '/' intexpr",
	"intexpr : error",
	"expr : varname",
	"expr : real units",
	"expr : funccall",
	"expr : '(' expr ')'",
	"expr : expr '+' expr",
	"expr : expr '-' expr",
	"expr : expr '*' expr",
	"expr : expr '/' expr",
	"expr : expr '^' expr",
	"expr : expr OR expr",
	"expr : expr AND expr",
	"expr : expr GT expr",
	"expr : expr LT expr",
	"expr : expr GE expr",
	"expr : expr LE expr",
	"expr : expr EQ expr",
	"expr : expr NE expr",
	"expr : NOT expr",
	"expr : '-' expr",
	"expr : error",
	"funccall : NAME '('",
	"funccall : NAME '(' exprlist ')'",
	"exprlist : /* empty */",
	"exprlist : exprlist1",
	"exprlist1 : expr",
	"exprlist1 : STRING",
	"exprlist1 : exprlist ',' expr",
	"exprlist1 : exprlist ',' STRING",
	"fromstmt : FROM NAME '=' intexpr TO intexpr opinc",
	"fromstmt : FROM NAME '=' intexpr TO intexpr opinc stmtlist",
	"fromstmt : FROM error",
	"opinc : /* empty */",
	"opinc : BY intexpr",
	"whilestmt : WHILE '(' expr ')' stmtlist",
	"ifstmt : IF '(' expr ')' stmtlist optelseif optelse",
	"optelseif : /* empty */",
	"optelseif : optelseif ELSE IF '(' expr ')' stmtlist",
	"optelse : /* empty */",
	"optelse : ELSE stmtlist",
	"derivblk : DERIVATIVE NAME stmtlist",
	"linblk : LINEAR NAME solvefor stmtlist",
	"nonlinblk : NONLINEAR NAME solvefor stmtlist",
	"discretblk : DISCRETE NAME stmtlist",
	"partialblk : PARTIAL NAME stmtlist",
	"pareqn : PARTEQN PRIME '=' NAME '*' DEL2 '(' NAME ')' '+' NAME",
	"pareqn : PARTEQN DEL NAME '[' firstlast ']' '=' expr",
	"pareqn : PARTEQN NAME '[' firstlast ']' '=' expr",
	"pareqn : PARTEQN error",
	"firstlast : FIRST",
	"firstlast : LAST",
	"funcblk : FUNCTION1 NAME '(' arglist ')' units",
	"funcblk : FUNCTION1 NAME '(' arglist ')' units stmtlist",
	"arglist : /* empty */",
	"arglist : arglist1",
	"arglist1 : name units",
	"arglist1 : arglist1 ',' name units",
	"procedblk : PROCEDURE NAME '(' arglist ')' stmtlist",
	"solveblk : SOLVE NAME ifsolerr",
	"solveblk : SOLVE NAME USING METHOD ifsolerr",
	"solveblk : SOLVE error",
	"ifsolerr : /* empty */",
	"ifsolerr : IFERROR stmtlist",
	"solvefor : /* empty */",
	"solvefor : solvefor1",
	"solvefor1 : SOLVEFOR NAME",
	"solvefor1 : solvefor1 ',' NAME",
	"solvefor1 : SOLVEFOR error",
	"eqnblk : BREAKPOINT stmtlist",
	"terminalblk : TERMINAL stmtlist",
	"sens : SENS namelist",
	"sens : SENS error",
	"conserve : CONSERVE consreact '=' expr",
	"conserve : CONSERVE error",
	"consreact : varname",
	"consreact : INTEGER varname",
	"consreact : consreact '+' varname",
	"consreact : consreact '+' INTEGER varname",
	"compart : COMPARTMENT NAME",
	"compart : COMPARTMENT NAME ',' expr '{' compartlist '}'",
	"compart : COMPARTMENT expr '{' compartlist '}'",
	"compartlist : NAME",
	"compartlist : compartlist NAME",
	"namelist : Name",
	"namelist : namelist ',' Name",
	"kineticblk : KINETIC NAME solvefor stmtlist",
	"reaction : REACTION react REACT1 react '(' expr ',' expr ')'",
	"reaction : REACTION react LT LT '(' expr ')'",
	"reaction : REACTION react '-' GT '(' expr ')'",
	"reaction : REACTION error",
	"react : varname",
	"react : INTEGER varname",
	"react : react '+' varname",
	"react : react '+' INTEGER varname",
	"lagstmt : LAG name BY NAME",
	"lagstmt : LAG error",
	"tablestmt : TABLE tablst dependlst FROM expr TO expr WITH integer",
	"tablst : /* empty */",
	"tablst : namelist",
	"dependlst : /* empty */",
	"dependlst : DEPEND namelist",
	"queuestmt : PUTQ name",
	"queuestmt : GETQ name",
	"matchblk : MATCH '{' matchlist '}'",
	"matchlist : match",
	"matchlist : matchlist match",
	"match : name",
	"match : matchname '(' expr ')' '=' expr",
	"match : error",
	"matchname : name",
	"matchname : name '[' NAME ']'",
	"neuronblk : NEURON",
	"neuronblk : NEURON '{' nrnstmt '}'",
	"nrnstmt : /* empty */",
	"nrnstmt : nrnstmt SUFFIX NAME",
	"nrnstmt : nrnstmt nrnuse",
	"nrnstmt : nrnstmt NONSPECIFIC nrnlist",
	"nrnstmt : nrnstmt ELECTRODE_CURRENT nrnlist",
	"nrnstmt : nrnstmt RANGE nrnlist",
	"nrnstmt : nrnstmt SECTION nrnlist",
	"nrnstmt : nrnstmt GLOBAL nrnlist",
	"nrnstmt : nrnstmt POINTER nrnlist",
	"nrnstmt : nrnstmt EXTERNAL nrnlist",
	"nrnuse : USEION NAME READ nrnlist valence",
	"nrnuse : USEION NAME WRITE nrnlist valence",
	"nrnuse : USEION NAME READ nrnlist WRITE nrnlist valence",
	"nrnuse : error",
	"nrnlist : NAME",
	"nrnlist : nrnlist ',' NAME",
	"nrnlist : error",
	"valence : /* empty */",
	"valence : VALENCE real",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{  return(0); }
#define YYABORT		{  return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
if (!yyv) {

	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
}

	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 2:
# line 104 "parse1.y"
{diag("Illegal block", (char *)0);} break;
case 3:
# line 107 "parse1.y"
{yyval.qp = ITEM0;} break;
case 14:
# line 115 "parse1.y"
{P1{if (!title) title = yypvt[-0].qp;}} break;
case 17:
# line 122 "parse1.y"
{ unitonflag = unitflagsave = 1;} break;
case 18:
# line 124 "parse1.y"
{unitonflag = unitflagsave = 0;} break;
case 19:
# line 127 "parse1.y"
{P1{include_file(yypvt[-0].qp);}} break;
case 20:
# line 130 "parse1.y"
{P1{define_value(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 21:
# line 131 "parse1.y"
{myerr("syntax: DEFINE name integer");} break;
case 22:
# line 134 "parse1.y"
{P1{yypvt[-0].qp->element = (void *)checklocal(SYM(yypvt[-0].qp));}} break;
case 24:
# line 137 "parse1.y"
{declare_level = atoi(STR(yypvt[-0].qp));} break;
case 25:
# line 138 "parse1.y"
{declare_level = 0;} break;
case 36:
# line 147 "parse1.y"
{yyval.qp = ITEM0;} break;
case 38:
# line 154 "parse1.y"
{P1{yyval.qp = itemarray(7, yypvt[-3].qp, yypvt[-0].qp, yypvt[-1].qp,ITEM0,ITEM0,ITEM0,ITEM0); declare(CONST, yypvt[-3].qp, yyval.qp);}} break;
case 39:
# line 156 "parse1.y"
{P1{yyval.qp = itemarray(7, yypvt[-1].qp, yypvt[-0].qp, ITEM0,ITEM0,ITEM0,ITEM0,ITEM0); declare(CONST, yypvt[-1].qp, yyval.qp);}} break;
case 40:
# line 157 "parse1.y"
{myerr("name = number");} break;
case 41:
# line 160 "parse1.y"
{yyval.qp = ITEM0;} break;
case 43:
# line 163 "parse1.y"
{P1{lex_units();}} break;
case 44:
# line 164 "parse1.y"
{yyval.qp = yypvt[-1].qp; lastok = yypvt[-0].qp; P2{unitcheck(STR(yypvt[-1].qp));}} break;
case 46:
# line 169 "parse1.y"
{yyval.qp = ITEM0;} break;
case 48:
# line 173 "parse1.y"
{P1{yyval.qp = itemarray(3,yypvt[-3].qp, yypvt[-0].qp, yypvt[-1].qp); declare(STEP1, yypvt[-3].qp, yyval.qp);}} break;
case 51:
# line 178 "parse1.y"
{lastok = yypvt[-0].qp;} break;
case 52:
# line 179 "parse1.y"
{lastok = yypvt[-0].qp;} break;
case 53:
# line 182 "parse1.y"
{lastok = yypvt[-0].qp;} break;
case 54:
# line 184 "parse1.y"
{lastok = yypvt[-0].qp;} break;
case 59:
# line 192 "parse1.y"
{lastok = yypvt[-0].qp;} break;
case 60:
# line 194 "parse1.y"
{lastok = yypvt[-0].qp;} break;
case 62:
# line 199 "parse1.y"
{yyval.qp = ITEM0;} break;
case 63:
# line 201 "parse1.y"
{P1{declare(INDEP, ITMA(yypvt[-0].qp)[0], yypvt[-0].qp);}} break;
case 64:
# line 203 "parse1.y"
{P1{ITMA(yypvt[-0].qp)[7] = yypvt[-1].qp; declare(INDEP, ITMA(yypvt[-0].qp)[0], yypvt[-0].qp);}} break;
case 65:
# line 207 "parse1.y"
{P1{yyval.qp = itemarray(8, yypvt[-8].qp, yypvt[-0].qp, yypvt[-6].qp, yypvt[-4].qp, yypvt[-3].qp, yypvt[-2].qp, yypvt[-1].qp, ITEM0);}} break;
case 66:
# line 208 "parse1.y"
{myerr("name FROM number TO number WITH integer");} break;
case 69:
# line 215 "parse1.y"
{yyval.qp = ITEM0;} break;
case 70:
# line 217 "parse1.y"
{P1{declare(DEP, ITMA(yypvt[-0].qp)[0], yypvt[-0].qp);}} break;
case 71:
# line 220 "parse1.y"
{P1{yyval.qp = itemarray(7, yypvt[-2].qp, yypvt[-0].qp, ITEM0, ITEM0, ITEM0, yypvt[-1].qp, ITEM0);}} break;
case 72:
# line 222 "parse1.y"
{P1{yyval.qp = itemarray(7, yypvt[-5].qp, yypvt[-0].qp, yypvt[-3].qp, ITEM0, ITEM0, yypvt[-1].qp, ITEM0);}} break;
case 73:
# line 224 "parse1.y"
{P1{yyval.qp = itemarray(7, yypvt[-6].qp, yypvt[-0].qp, ITEM0, yypvt[-4].qp, yypvt[-2].qp, yypvt[-1].qp, ITEM0);}} break;
case 74:
# line 226 "parse1.y"
{P1{yyval.qp = itemarray(7, yypvt[-9].qp, yypvt[-0].qp, yypvt[-7].qp, yypvt[-4].qp, yypvt[-2].qp, yypvt[-1].qp, ITEM0);}} break;
case 75:
# line 227 "parse1.y"
{
diag("name FROM number TO number START number\n",
"FROM...TO and START are optional, name can be name[integer]\n");} break;
case 76:
# line 231 "parse1.y"
{yyval.qp = ITEM0;} break;
case 77:
# line 232 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 79:
# line 237 "parse1.y"
{yyval.qp = ITEM0;} break;
case 80:
# line 239 "parse1.y"
{P1{declare(STAT, ITMA(yypvt[-0].qp)[0], yypvt[-0].qp);}} break;
case 82:
# line 242 "parse1.y"
{ myerr("PLOT namelist VS name");} break;
case 85:
# line 248 "parse1.y"
{ yyval.qp = ITEM0;} break;
case 86:
# line 250 "parse1.y"
{ yyval.qp = yypvt[-1].qp;} break;
case 88:
# line 255 "parse1.y"
{yyval.qp = ITEM0;} break;
case 91:
# line 260 "parse1.y"
{P1{install_units(STR(yypvt[-2].qp), STR(yypvt[-0].qp));}} break;
case 92:
# line 261 "parse1.y"
{myerr("Unit definition syntax: (units) = (units)");} break;
case 93:
# line 264 "parse1.y"
{P1{yyval.qp = itemarray(3, yypvt[-3].qp, yypvt[-0].qp, yypvt[-1].qp); declare(UFACTOR, yypvt[-3].qp, yyval.qp);}} break;
case 94:
# line 266 "parse1.y"
{P1{Item *q; double d, unit_mag();
		    Unit_push(STR(yypvt[-1].qp));
			Unit_push(STR(yypvt[-0].qp)); unit_div();
			dimensionless();
			Sprintf(buf, "%g", unit_mag());
			yyval.qp = itemarray(3, yypvt[-3].qp, yypvt[-0].qp, lappendstr(misc, buf));
/*printf("%s has value %s and units (%s)\n", SYM($1)->name, buf, STR($5));*/
		    unit_pop();
		    declare(UFACTOR, yypvt[-3].qp, yyval.qp);
		}} break;
case 95:
# line 277 "parse1.y"
{P1{ Item *q; double unit_mag();
		    Unit_push(STR(yypvt[-3].qp)); Unit_push(STR(yypvt[-0].qp)); unit_div();
		    q = lappendstr(misc, unit_str());
		    dimensionless();
		    Sprintf(buf, "%g", 1./unit_mag());
		    yyval.qp = itemarray(3, yypvt[-5].qp, lappendstr(misc, buf), q),
/*printf("%s has value %s and units (%s)\n", SYM($1)->name, STR(q), buf );*/
		    unit_pop();
		    declare(UFACTOR, yypvt[-5].qp, yyval.qp);
		}} break;
case 96:
# line 287 "parse1.y"
{myerr("Unit factor syntax: examples:\n\
foot2inch = (foot) -> (inch)\n\
F = 96520 (coulombs)\n\
R = (k-mole) (joule/degC)");
		} break;
case 97:
# line 293 "parse1.y"
{blocktype = INITIAL1;} break;
case 98:
# line 294 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 99:
# line 295 "parse1.y"
{lexcontext = NONLINEAR; blocktype = DERIVATIVE;} break;
case 100:
# line 296 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 101:
# line 297 "parse1.y"
{blocktype = BREAKPOINT;} break;
case 102:
# line 298 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 103:
# line 299 "parse1.y"
{lexcontext = blocktype = LINEAR;} break;
case 104:
# line 300 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 105:
# line 301 "parse1.y"
{lexcontext = blocktype = NONLINEAR;} break;
case 106:
# line 302 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 107:
# line 303 "parse1.y"
{blocktype = FUNCTION1;} break;
case 108:
# line 304 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 109:
# line 305 "parse1.y"
{blocktype = PROCEDURE;} break;
case 110:
# line 306 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 111:
# line 307 "parse1.y"
{blocktype = TERMINAL;} break;
case 112:
# line 308 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 113:
# line 309 "parse1.y"
{blocktype = DISCRETE;} break;
case 114:
# line 310 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 115:
# line 311 "parse1.y"
{lexcontext = blocktype = PARTIAL;} break;
case 116:
# line 312 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
case 117:
# line 313 "parse1.y"
{lexcontext = blocktype = KINETIC;
		P3 R0{unitflagsave=unitonflag; unitonflag=0;}} break;
case 118:
# line 316 "parse1.y"
{yyval.qp = yypvt[-0].qp; P3{ R0{unitonflag=unitflagsave;}
		R1{clear_compartlist();} parse_restart(yyval.qp, 1);}} break;
case 120:
# line 322 "parse1.y"
{yyval.qp = yypvt[-1].qp;} break;
case 121:
# line 324 "parse1.y"
{P1{poplocal();}} break;
case 123:
# line 327 "parse1.y"
{myerr("Illegal LOCAL declaration");} break;
case 124:
# line 330 "parse1.y"
{P1{pushlocal(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 125:
# line 332 "parse1.y"
{P1{install_local(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 126:
# line 335 "parse1.y"
{ yyval.qp = ITEM0;} break;
case 127:
# line 337 "parse1.y"
{yyval.qp = yypvt[-1].qp;} break;
case 128:
# line 340 "parse1.y"
{yyval.qp = ITEM0;} break;
case 150:
# line 364 "parse1.y"
{myerr("Illegal statement");} break;
case 151:
# line 367 "parse1.y"
{
		  P3 {
			if (SYM(yypvt[-2].qp)->subtype & LOCL) {
				SYM(yypvt[-2].qp)->u.str = stralloc(unit_str(), (char *)0);
				unit_pop();
			}else{
			   unit_push(yypvt[-2].qp); unit_swap();
			   unit_cmp(yypvt[-2].qp, yypvt[-1].qp, lastok); unit_pop();
			}
		  }
		} break;
case 152:
# line 379 "parse1.y"
{
		  P3 {
			unit_cmp(yypvt[-2].qp, yypvt[-1].qp, lastok); unit_pop();
		  }
		} break;
case 153:
# line 386 "parse1.y"
{lastok = yypvt[-0].qp;
		  P1{SYM(yypvt[-0].qp)->usage |= DEP;}
		  P2{ if (SYM(yypvt[-0].qp)->subtype & ARRAY) {
			myerr("variable needs an index");}
		  }
		} break;
case 154:
# line 393 "parse1.y"
{lastok = yypvt[-0].qp; 
		  P1{SYM(yypvt[-3].qp)->usage |= DEP;}
		  P2{ if ((SYM(yypvt[-3].qp)->subtype & ARRAY) == 0)
			{myerr("variable is not an array");}
		  }
		} break;
case 155:
# line 400 "parse1.y"
{lastok = yypvt[-0].qp;
		  P1{SYM(yypvt[-2].qp)->usage |= DEP;}
		  P2{ if (SYM(yypvt[-2].qp)->subtype & ARRAY) {
			myerr("variable needs an index");}
		  }
		} break;
case 156:
# line 408 "parse1.y"
{lastok = yypvt[-0].qp;
		  P1{SYM(yypvt[-5].qp)->usage |= DEP;}
		  P2{ if ((SYM(yypvt[-5].qp)->subtype & ARRAY) == 0)
			{myerr("variable is not an array");}
		  }
		} break;
case 157:
# line 416 "parse1.y"
{lastok = yypvt[-0].qp; P1{SYM(yypvt[-0].qp)->usage |= DEP;}} break;
case 158:
# line 417 "parse1.y"
{ lastok = yypvt[-0].qp;} break;
case 159:
# line 418 "parse1.y"
{ lastok = yypvt[-0].qp;} break;
case 164:
# line 423 "parse1.y"
{myerr("Illegal integer expression");} break;
case 165:
# line 425 "parse1.y"
{P3{unit_push(yypvt[-0].qp);}} break;
case 166:
# line 426 "parse1.y"
{P3{if (yypvt[-0].qp) {
				Unit_push(STR(yypvt[-0].qp));
			     }else{		
				Unit_push((char *)0);
			     }
			}} break;
case 167:
# line 432 "parse1.y"
{P3{unit_push(yypvt[-0].qp);}} break;
case 168:
# line 433 "parse1.y"
{ lastok = yypvt[-0].qp;
			  P3{ifcnvfac(yypvt[-0].qp);}
			} break;
case 169:
# line 436 "parse1.y"
{P3{unit_cmp(yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 170:
# line 437 "parse1.y"
{P3{unit_cmp(yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 171:
# line 438 "parse1.y"
{P3{unit_mul();}} break;
case 172:
# line 439 "parse1.y"
{P3{unit_div();}} break;
case 173:
# line 440 "parse1.y"
{P3{unit_exponent(yypvt[-0].qp, lastok);}} break;
case 174:
# line 441 "parse1.y"
{P3{unit_logic(1, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 175:
# line 442 "parse1.y"
{P3{unit_logic(1, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 176:
# line 443 "parse1.y"
{P3{unit_logic(2, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 177:
# line 444 "parse1.y"
{P3{unit_logic(2, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 178:
# line 445 "parse1.y"
{P3{unit_logic(2, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 179:
# line 446 "parse1.y"
{P3{unit_logic(2, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 180:
# line 447 "parse1.y"
{P3{unit_logic(2, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 181:
# line 448 "parse1.y"
{P3{unit_logic(2, yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 182:
# line 449 "parse1.y"
{P3{unit_pop(); Unit_push("");}} break;
case 184:
# line 451 "parse1.y"
{myerr("Illegal expression");} break;
case 185:
# line 453 "parse1.y"
{P3{unit_push_args(yypvt[-1].qp);}} break;
case 186:
# line 454 "parse1.y"
{ lastok = yypvt[-0].qp; P1{SYM(yypvt[-4].qp)->usage |= FUNCT;}
		  P3{unit_done_args();}
		} break;
case 187:
# line 459 "parse1.y"
{yyval.qp = ITEM0; } break;
case 189:
# line 462 "parse1.y"
{P3{unit_chk_arg(yypvt[-0].qp, lastok);}} break;
case 191:
# line 464 "parse1.y"
{P3{unit_chk_arg(yypvt[-0].qp, lastok);}} break;
case 193:
# line 467 "parse1.y"
{P1{pushlocal(yypvt[-5].qp, ITEM0);}} break;
case 194:
# line 468 "parse1.y"
{P1{yyval.qp = itemarray(6, yypvt[-8].qp, yypvt[-7].qp, yypvt[-5].qp, yypvt[-3].qp, yypvt[-2].qp, yypvt[-0].qp); poplocal();}} break;
case 195:
# line 469 "parse1.y"
{
myerr("FROM intvar = intexpr TO intexpr BY intexpr { statements }");} break;
case 196:
# line 472 "parse1.y"
{yyval.qp = ITEM0;} break;
case 198:
# line 475 "parse1.y"
{P3{unit_pop();}} break;
case 199:
# line 477 "parse1.y"
{P3{unit_pop();}} break;
case 200:
# line 480 "parse1.y"
{yyval.qp = ITEM0;} break;
case 201:
# line 481 "parse1.y"
{P3{unit_pop();}} break;
case 202:
# line 484 "parse1.y"
{yyval.qp = ITEM0;} break;
case 204:
# line 488 "parse1.y"
{P1{yyval.qp = itemarray(3, yypvt[-2].qp, yypvt[-1].qp, yypvt[-0].qp); declare(DERF, yypvt[-1].qp, yyval.qp);}} break;
case 205:
# line 491 "parse1.y"
{P1{yyval.qp = itemarray(4, yypvt[-3].qp, yypvt[-2].qp, yypvt[-1].qp, yypvt[-0].qp); declare(LINF, yypvt[-2].qp, yyval.qp);}} break;
case 206:
# line 494 "parse1.y"
{P1{yyval.qp = itemarray(4, yypvt[-3].qp, yypvt[-2].qp, yypvt[-1].qp, yypvt[-0].qp); declare(NLINF, yypvt[-2].qp, yyval.qp);}} break;
case 207:
# line 497 "parse1.y"
{P1{yyval.qp = itemarray(3, yypvt[-2].qp, yypvt[-1].qp, yypvt[-0].qp); declare(DISCF, yypvt[-1].qp, yyval.qp);}} break;
case 208:
# line 500 "parse1.y"
{P1{yyval.qp = itemarray(3, yypvt[-2].qp, yypvt[-1].qp, yypvt[-0].qp); declare(PARF, yypvt[-1].qp, yyval.qp);}} break;
case 209:
# line 503 "parse1.y"
{lastok = yypvt[-0].qp;
		 P3{
			unit_push(yypvt[-7].qp); unit_del(2); unit_mul();
			unit_push(yypvt[-3].qp); unit_mul();
			unit_push(yypvt[-0].qp); unit_cmp(yypvt[-7].qp, yypvt[-1].qp, yypvt[-0].qp);
			unit_push(yypvt[-9].qp); unit_swap(); unit_cmp(yypvt[-9].qp, yypvt[-8].qp, yypvt[-0].qp);
			unit_pop();
		}} break;
case 210:
# line 512 "parse1.y"
{P3{
			unit_del(1);
			unit_push(yypvt[-5].qp); unit_mul(); unit_swap();
			unit_cmp(yypvt[-6].qp,yypvt[-1].qp,lastok); unit_pop();
		}} break;
case 211:
# line 518 "parse1.y"
{P3{unit_push(yypvt[-5].qp); unit_swap();
		    unit_cmp(yypvt[-5].qp,yypvt[-1].qp,lastok); unit_pop();
		}} break;
case 212:
# line 521 "parse1.y"
{myerr("Illeqal partial diffeq");} break;
case 215:
# line 526 "parse1.y"
{P1{pushlocal(yypvt[-4].qp, ITEM0); func_unit(yypvt[-4].qp, yypvt[-0].qp);}} break;
case 216:
# line 528 "parse1.y"
{P1{
		    declare(FUNCT, yypvt[-6].qp, itemarray(3, yypvt[-6].qp, yypvt[-2].qp, yypvt[-4].qp));
		    poplocal(); poplocal(); SYM(yypvt[-6].qp)->usage |= FUNCT;
		   }
		} break;
case 217:
# line 535 "parse1.y"
{yyval.qp = ITEM0; P1{pushlocal(ITEM0, ITEM0);}} break;
case 219:
# line 539 "parse1.y"
{P1{
		    yyval.qp = (Item *)newlist();
		    pushlocal(yypvt[-1].qp, ITEM0);
		    if (yypvt[-0].qp) {
			checklocal(SYM(yypvt[-1].qp))->u.str = STR(yypvt[-0].qp);
			Lappendstr((List *)yyval.qp, STR(yypvt[-0].qp));
		    }else{
			Lappendstr((List *)yyval.qp, "");
		    }
		}} break;
case 220:
# line 550 "parse1.y"
{P1{
		    pushlocal(yypvt[-1].qp, ITEM0);
		    if (yypvt[-0].qp) {
			checklocal(SYM(yypvt[-1].qp))->u.str = STR(yypvt[-0].qp);
			Lappendstr((List *)yypvt[-3].qp, STR(yypvt[-0].qp));
		    }else{
			Lappendstr((List *)yypvt[-3].qp, "");
		    }
		}} break;
case 221:
# line 561 "parse1.y"
{P1{
		    declare(PROCED, yypvt[-4].qp, itemarray(3, yypvt[-4].qp, ITEM0, yypvt[-2].qp));
		    poplocal(); SYM(yypvt[-4].qp)->usage |= FUNCT;
		   }
		} break;
case 222:
# line 568 "parse1.y"
{P1{yyval.qp = itemarray(4, yypvt[-2].qp, yypvt[-1].qp, ITEM0, yypvt[-0].qp); lappenditem(solvelist, yyval.qp);}} break;
case 223:
# line 570 "parse1.y"
{P1{yyval.qp = itemarray(4, yypvt[-4].qp, yypvt[-3].qp, yypvt[-2].qp, yypvt[-1].qp); lappenditem(solvelist, yyval.qp);}} break;
case 224:
# line 571 "parse1.y"
{ myerr("Illegal SOLVE statement");} break;
case 225:
# line 574 "parse1.y"
{ yyval.qp = ITEM0; } break;
case 226:
# line 576 "parse1.y"
{ yyval.qp = yypvt[-0].qp; } break;
case 227:
# line 579 "parse1.y"
{yyval.qp = ITEM0;} break;
case 229:
# line 583 "parse1.y"
{ P2{if(!(SYM(yypvt[-0].qp)->subtype&STAT)){
			myerr("Not a STATE");}
		  }
		} break;
case 230:
# line 588 "parse1.y"
{ P2{if(!(SYM(yypvt[-1].qp)->subtype&STAT)){
			myerr("Not a STATE");}
		  }
		} break;
case 231:
# line 592 "parse1.y"
{myerr("Syntax: SOLVEFOR name, name, ...");} break;
case 235:
# line 599 "parse1.y"
{myerr("syntax is SENS var1, var2, var3, etc");} break;
case 236:
# line 603 "parse1.y"
{P3{unit_cmp(yypvt[-2].qp, yypvt[-1].qp, lastok);}} break;
case 237:
# line 604 "parse1.y"
{myerr("Illegal CONSERVE syntax");} break;
case 238:
# line 606 "parse1.y"
{P3{consreact_push(yypvt[-0].qp);}} break;
case 239:
# line 607 "parse1.y"
{P3{consreact_push(yypvt[-0].qp);}} break;
case 240:
# line 608 "parse1.y"
{P3{consreact_push(yypvt[-0].qp); unit_cmp(yypvt[-2].qp,yypvt[-1].qp,lastok);}} break;
case 241:
# line 609 "parse1.y"
{
		  P3{consreact_push(yypvt[-0].qp); unit_cmp(yypvt[-3].qp,yypvt[-2].qp,lastok);}
		} break;
case 242:
# line 613 "parse1.y"
{P1{pushlocal(yypvt[-0].qp, ITEM0);}} break;
case 243:
# line 614 "parse1.y"
{P1{poplocal();}
		  P3{
		    unit_pop();
		  }
		} break;
case 244:
# line 620 "parse1.y"
{ P3{
		    unit_pop();
		  }
		} break;
case 245:
# line 626 "parse1.y"
{P3 R0{unit_compartlist(yypvt[-0].qp);}} break;
case 246:
# line 628 "parse1.y"
{P3 R0{unit_compartlist(yypvt[-0].qp);}} break;
case 249:
# line 634 "parse1.y"
{P1{declare(KINF, yypvt[-2].qp, ITEM0);}} break;
case 250:
# line 637 "parse1.y"
{P3{kinunits(yypvt[-6].qp, restart_pass);}} break;
case 251:
# line 639 "parse1.y"
{P3{kinunits(yypvt[-4].qp, restart_pass);}} break;
case 252:
# line 641 "parse1.y"
{P3{kinunits(yypvt[-4].qp, restart_pass);}} break;
case 253:
# line 642 "parse1.y"
{myerr("Illegal reaction syntax");} break;
case 254:
# line 644 "parse1.y"
{P3{R1{ureactadd(yypvt[-0].qp);} unit_push(yypvt[-0].qp);}} break;
case 255:
# line 645 "parse1.y"
{P3{R1{ureactadd(yypvt[-0].qp);} unit_push(yypvt[-0].qp); Unit_push((char*)0); unit_exponent(yypvt[-1].qp,yypvt[-1].qp);}} break;
case 256:
# line 646 "parse1.y"
{P3{R1{ureactadd(yypvt[-0].qp);}unit_push(yypvt[-0].qp); unit_mul();}} break;
case 257:
# line 647 "parse1.y"
{
		  P3{R1{ureactadd(yypvt[-0].qp);}unit_push(yypvt[-0].qp); Unit_push((char*)0); unit_exponent(yypvt[-1].qp,yypvt[-1].qp); unit_mul();}
		} break;
case 259:
# line 652 "parse1.y"
{myerr("Lag syntax is: LAG name BY const");} break;
case 260:
# line 655 "parse1.y"
{P3{unit_pop(); unit_pop();}} break;
case 261:
# line 658 "parse1.y"
{yyval.qp = ITEM0;} break;
case 263:
# line 662 "parse1.y"
{yyval.qp = ITEM0;} break;
case 272:
# line 676 "parse1.y"
{myerr("MATCH syntax is state0 or state(expr)=expr or\
state[i](expr(i)) = expr(i)");} break;
case 275:
# line 684 "parse1.y"
{
			  lastok = yypvt[-0].qp;
#if NRNUNIT
			  P2{nrn_unit_chk();}
#endif
			} break;
case 276:
# line 691 "parse1.y"
{lastok = yypvt[-2].qp;} break;
case 278:
# line 695 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 280:
# line 698 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp,yypvt[-0].qp);}} break;
case 281:
# line 700 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp,yypvt[-0].qp);}} break;
case 282:
# line 702 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 283:
# line 704 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 284:
# line 706 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 285:
# line 708 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 286:
# line 710 "parse1.y"
{ P1{nrn_list(yypvt[-1].qp, yypvt[-0].qp);}} break;
case 287:
# line 713 "parse1.y"
{P1{nrn_use(yypvt[-3].qp, yypvt[-1].qp, ITEM0);}} break;
case 288:
# line 715 "parse1.y"
{P1{nrn_use(yypvt[-3].qp, ITEM0, yypvt[-1].qp);}} break;
case 289:
# line 717 "parse1.y"
{P1{nrn_use(yypvt[-5].qp, yypvt[-3].qp, yypvt[-1].qp);}} break;
case 290:
# line 719 "parse1.y"
{myerr("syntax is: USEION ion READ list WRITE list");} break;
case 291:
# line 722 "parse1.y"
{P1{yyval.qp = (Item *)newlist(); Lappendsym((List *)yyval.qp, SYM(yypvt[-0].qp));}} break;
case 292:
# line 724 "parse1.y"
{P1{ Lappendsym((List *)yypvt[-2].qp, SYM(yypvt[-0].qp));}} break;
case 293:
# line 726 "parse1.y"
{myerr("syntax is: keyword name , name, ..., name");} break;
case 294:
# line 729 "parse1.y"
{yyval.qp = ITEM0;} break;
case 295:
# line 731 "parse1.y"
{yyval.qp = yypvt[-0].qp;} break;
	}
	goto yystack;		/* reset registers in driver code */
}
