#include "modl.h"
#include "ytab.h"
extern Symbol *indepsym;
extern Symbol *scop_indep;
extern List   *indeplist;
extern Symbol *stepsym;
extern char   *reprime();
extern List	*symlist[];
List *syminorder;
List *plotlist;
List *defs_list;
#define SYMITER(arg) ITERATE(q, syminorder){ \
		s = SYM(q); if (s->type == arg)

#define SYMLISTITER for (i = 'A'; i <= 'z'; i++)\
	ITERATE(q, symlist[i])
	
#define IFTYPE(arg)	if ((s->subtype & arg)\
			 && ( (s->usage & EXPLICIT_DECL) != automatic) )

/* varcount holds the index into the .var file and is saved in s->used
   parraycount holds the index into the p array and is saved in s->varnum
*/
static varcount, parraycount;
static var_count();
static defs_h();

parout() {
	int i;
	Item *q;
	Symbol *s;
	double d1, d2;
	varcount = parraycount = 0;
	defs_list = newlist();	/* relates hoc names to c-variables */

	/************ Declare static variable */
	Lappendstr(defs_list, "\n\
typedef struct { char *name; int (*func)();} IntFunc;\n\
typedef struct { char *name; double *pdoub;} DoubScal;\n\
typedef struct { char *name; double *pdoub; int index1;} DoubVec;\n\
");
	Lappendstr(defs_list, "extern double *getarg();\n");
	
	SYMLISTITER {
		s = SYM(q);
		if (s->subtype & (FUNCT | PROCED) && s->name[0] != '_') {
Sprintf(buf, "static int _hoc_%s();\n", s->name);
			Lappendstr(defs_list, buf);
		}
	}
	ITERATE(q, syminorder) { /* declarations */
		s = SYM(q);
		if ((s->type == NAME || s->type == PRIME) && s != indepsym) {
			var_count(s);
			if (!(s->subtype & ARRAY)) {
				if (s->subtype & PARM) {
					decode_ustr(s, &d1, &d2, buf);
Sprintf(buf, " %s = %g;\n", s->name, d1);
					Lappendstr(initlist, buf);
				}
			}
		}
	}
	var_count(indepsym);
	Sprintf(buf, "static double _p[%d];\n", parraycount);
	Linsertstr(defs_list, buf);

	/*********** Global variables as opposed to range variables */
	/* functions */
	Lappendstr(defs_list,"static IntFunc hoc_intfunc[] = {\n");
 	SYMLISTITER {
		s = SYM(q);
		if ((s->subtype & (FUNCT | PROCED)) && s->name[0] != '_') {
Sprintf(buf, "\"%s\", _hoc_%s,\n", s->name, s->name);
			Lappendstr(defs_list, buf);
		}
	}
	Lappendstr(defs_list, "0, 0\n};\n");

	/* double scalars */
	Lappendstr(defs_list,"static DoubScal hoc_scdoub[] = {\n");
 	ITERATE(q, syminorder) {
		s = SYM(q);
		if (s->type == NAME || s->type == PRIME) {
			if (!(s->subtype & ARRAY) && s != indepsym) {
if (s->subtype & PARM && s->usage & EXPLICIT_DECL) {
Sprintf(buf, "\"%s\", &%s,\n", s->name, s->name);
					Lappendstr(defs_list, buf);
				}else{
Sprintf(buf, "\"%s\", &%s,\n", s->name, s->name);
					Lappendstr(defs_list, buf);
				}
			}
		}
	}
	Sprintf(buf, "\"%s\", &%s,\n", indepsym->name, indepsym->name);
	Lappendstr(defs_list, buf);
	Lappendstr(defs_list, "0,0\n};\n");
	
	/* double vectors */
	Lappendstr(defs_list,"static DoubVec hoc_vdoub[] = {\n");
 	ITERATE(q, syminorder) {
		s = SYM(q);
		if (s->type == NAME || s->type == PRIME) {
			if (s->subtype & ARRAY) {
Sprintf(buf, "\"%s\", %s, %d,\n", s->name, s->name, s->araydim);
				Lappendstr(defs_list, buf);
			}
		}
	}
	Lappendstr(defs_list, "0,0,0\n};\n");
	Sprintf(buf, "int hoc_pindepindex = %d;\n", indepsym->varnum);
	Lappendstr(defs_list, buf);
	Lappendstr(defs_list, "static double _sav_indep;\n");

	/**** create function that registers the above info to NEURON and HOC*/
	Lappendstr(defs_list, "static _initlists();\n");
	Lappendstr(defs_list, "_hoc_reg() {\n	_initlists();\n");

	Lappendstr(defs_list, "\
	hoc_register_var(hoc_scdoub, hoc_vdoub, hoc_intfunc);\n");
	Lappendstr(defs_list, "}\n");

}

decode_ustr(sym, pg1, pg2, s)	/* decode sym->u.str */
	Symbol *sym;
	char *s;
	double *pg1, *pg2;
{
	int i, n;
	char *cp, *cp1;
	
	switch (sym->subtype & (INDEP | DEP | STAT | PARM)) {

	case INDEP:	/* but doesnt get all info */
	case DEP:
	case STAT:
		assert(sym && sym->u.str);
		if (sym->subtype & ARRAY) { /* see parsact.c */
			i = sscanf(sym->u.str, "[%*d]\n%lf%*c%lf", pg1, pg2);
		}else{			
			i = sscanf(sym->u.str, "%lf%*c%lf", pg1, pg2);
		}
		assert(i == 2);
		for (n=0, cp = sym->u.str; n < 2;) {
			if (*cp++ == '\n') {
				n++;
			}
		}
		for (cp1 = s; *cp != '\n';) {
			*cp1++ = *cp++;
		}
		*cp1 = '\0';
		break;

	case PARM:
		assert(sym && sym->u.str);
		i = sscanf(sym->u.str, "%lf\n%s", pg1, s);
		if (i == 1) {
			s[0] = '\0';
			i = 2;
		}
		assert(i == 2);
		break;
	default:
		/*SUPPRESS 558*/
		assert(0);
	}
#if SIMSYS
	if (s[0] == '\0') {
		Sprintf(s, "none");
	}
#endif
}

static
var_count(s)
	Symbol *s;
{
	defs_h(s);
	s->used = varcount++;
	s->varnum = parraycount;
	if (s->subtype & ARRAY) {
		parraycount += s->araydim;
	}else{
		parraycount++;
	}
}

static
defs_h(s)
	Symbol *s;
{
	Item *q;
	
	if (s->subtype & ARRAY) {
		Sprintf(buf, "#define %s (_p + %d)\n", s->name, parraycount);
		q = lappendstr(defs_list, buf);
	} else {
		Sprintf(buf, "#define %s _p[%d]\n", s->name, parraycount);
		q = lappendstr(defs_list, buf);
	}
	q->itemtype = VERBATIM;
}

