/* $Header: /timshel2g/src/master/nrn/src/nmodl/init.c,v 1.1.1.1 1994/10/12 17:21:35 hines Exp $ */
/*
$Log: init.c,v $
 * Revision 1.1.1.1  1994/10/12  17:21:35  hines
 * NEURON 3.0 distribution
 *
 * Revision 9.193  1994/09/26  18:37:06  hines
 * forgot to checkin last time
 *
 * Revision 9.180  1994/05/18  18:11:56  hines
 * INCLUDE "file"
 * tries originalpath/file ./file MODL_INCLUDEpaths/file
 *
 * Revision 9.171  1993/07/08  14:46:03  hines
 * Alternative to NONSPECIFIC_CURRENT is ELECTRODE_CURRENT
 * at this time is identical to old way. Introduced because membrane
 * mechanisms for electrode currents don't work right because the
 * current is assumed to pass from the extracellular space to the inside
 * and thus current injection does not change vext (and it is opposite in
 * sign to what one would expect). This change is not complete here. Only
 * the scaffolding is now in place and it has been verified to be identical
 * to the old way. The change is mostly to non-vectorized models and
 * now
 * void nrn_cur(Node*, double*, Datum*) so that the model gets v directly
 * from the node and changes d and rhs from the node.
 *
 * Revision 9.138  92/06/01  12:02:07  hines
 * NEURON { EXTERNAL name, name, ...}
 * translates to extern double name;
 * GLOBAL changed to translate to
 * #define name name_suffix
 * extern double name
 * 
 * Revision 9.126  92/02/05  08:32:06  hines
 * NEURON {POINTER ...} allows a model to connect to external variables
 * #includes in nparout moved to beginning of defslist so crucial fields in
 * section structures not defined into nonsense.
 * 
 * Revision 9.120  91/09/16  15:43:19  hines
 * reorganization of how NEURON variables are declared.
 * RANGE: definitely range variables, can be param, assigned, or state
 * GLOBAL: definitely global variables, can be param or assigned
 * SECTION: not implemented
 * By default params are global variables.
 * By default states are range
 * By default  assigned are in p array but not accessible from NEURON
 * NON-SPECIFIC current not accessible unless specified in RANGE.
 * 
 * Revision 9.98  91/03/18  09:10:10  hines
 * FORALL i {} loops over all elements of vectors in statements. vector
 * length must be the same.
 * 
 * Revision 9.90  91/01/02  08:00:21  hines
 * stepforce and schedule added to list of functions which handle 
 * discontinuities.
 * 
 * Revision 9.88  90/12/14  12:52:03  hines
 * nmodl: point processes allowed via POINT_PROCESS
 * 
 * Revision 9.85  90/12/12  17:23:04  hines
 * nmodl: FROM i translates i as double  fh.mod works properly
 * 
 * Revision 9.84  90/12/12  10:06:19  hines
 * nmodl: GLOBAL allowed in NEURON block
 * 
 * Revision 9.78  90/12/10  16:56:11  hines
 * TABLE allowed in FUNCTION and PROCEDURE
 * 
 * Revision 9.66  90/11/27  10:47:08  hines
 * allow multiple partial equations within a partial block
 * 
 * Revision 9.64  90/11/26  08:16:05  hines
 * external functions of type EXTDEF3 get two extra arguments.
 * The first arg is a pointer to _reset which should be set by the
 * function upon the occurence of a discontinuity.
 * The second arg is a pointer to a double which may be used by the
 * function to store information to help determine if a discontinuity
 * has occurred.  init.c gives a list of these functions.
 * 
 * Revision 9.58  90/11/20  17:23:56  hines
 * CONSTANT changed to PARAMETER
 * CONSTANT now refers to variables that don't get put in .var file
 * 
 * Revision 9.57  90/11/20  15:56:58  hines
 * EQUATION changed to BREAKPOINT
 * STEADYSTATE keyword added, EQUATION keyword still exists
 * 
 * Revision 9.52  90/11/10  15:44:53  hines
 * nmodl: uses new NEURON { USEION ... format
 * passive.c works
 * 
 * Revision 9.51  90/11/02  09:11:30  hines
 * TABLE keyword added. For now it is translated just as FUNCTION
 * 
 * Revision 9.50  90/11/02  08:31:46  hines
 * Allow UNITS block and make a  units defintion scale factor a static
 * variable so that it doesn't have to appear in the var file. eg.
 * UNITS { FARADAY = 96520 (coul) }
 * 
 * Revision 9.48  90/11/02  06:58:38  hines
 * new way of specifying NEURON info. Keywords are
 * NEURON SUFFIX CURRENT NEED GET SET
 * 
 * Revision 9.29  90/09/10  14:09:12  hines
 * certain functions specified in extdef2.h can have arguments which are
 * pointers to functions and pointers to vectors.
 * 
 * Revision 9.28  90/09/09  17:28:24  hines
 * merge the summer's work at nbsr into modl
 * 
 * Revision 9.13  90/07/30  14:37:14  hines
 * NMODL looks pretty good. Ready to start testing. Have not yet tried
 * to compile the .c file.
 *
 * Revision 8.10  90/09/04  09:42:20  mdf
 * Keyword "gear" added for Mike Kohn's implementation of gear integrator.
 * 
 * Revision 9.12  90/07/30  12:37:50  hines
 * wrong name for ASSIGNED
 *
 * Revision 8.9  90/08/03  16:20:58  mdf
 * Keyword csoda changed to clsoda.
 * 
 * Revision 9.10  90/07/27  13:57:57  hines
 * nmodl handles declarations about right for first pass at this.
 *
 * Revision 8.8  90/08/03  14:49:00  mdf
 * Method csoda changed to accept additional argument "maxerr".
 * for tolerances.
 * 
 * Revision 9.9  90/07/26  09:24:10  hines
 * beginning interface to NEURON
 * new keywords are PARAMETER and CURRENT
 *
 * Revision 8.7  90/06/14  22:00:21  mdf
 * keyword "gear" changed to "csoda"
 * 
 * Revision 9.6  90/07/18  08:13:57  hines
 * PARAMETER is synonym for CONSTANT
 * Distinguishing them is necessary for NEURON since PARAMETER's can
 * vary with position on the neuron.
 * 
 * Revision 8.6  90/05/11  13:34:16  mdf
 * gear added to "methods" with flag value 0 to indicate that the tolerance
 * is not to be set by the user.  It is built in to scopgear.c for now.
 * scopgear.c should be changed to accept a tolerance like e.g. adeuler.
 * 
 * Revision 8.5  90/04/09  08:41:34  mlh
 * implicit method for derivative blocks (allows mixed equations also).
 * The solve statement must precede the derivative block
 * 
 * Revision 8.4  90/01/29  14:07:21  mlh
 * simplex is a nonlinear method
 * 
 * Revision 8.3  90/01/18  11:45:43  mlh
 * SOLVEFOR statement added
 * syntax is 
 *   blocktype blockname [SOLVEFOR name, name, ...] {statment}
 * where blocktype is KINETIC, NONLINEAR, or LINEAR
 * Only the states in the SOLVEFOR statement are solved
 * in that block. If the statement is not present then
 * all states are solved that appear in that block.
 * 
 * Revision 8.2  90/01/16  11:06:09  mlh
 * error checking and cleanup after error and call to abort_run()
 * 
 * Revision 8.1  89/10/25  13:47:50  mlh
 * PUTQ and GETQ implemented
 * 
 * Revision 8.0  89/09/22  17:26:10  nfh
 * Freezing
 * 
 * Revision 7.1  89/09/05  08:08:15  mlh
 * COMPARTMENT keyword for KINETIC block
 * COMPARTMENT size {scalar state list}
 * COMPARTMENT index, size(index) {vector state list}
 * 
 * Revision 7.0  89/08/30  13:31:37  nfh
 * Rev 7 is now Experimental; Rev 6 is Testing
 * 
 * Revision 6.0  89/08/14  16:26:22  nfh
 * Rev 6.0 is latest of 4.x; now the Experimental version
 * 
 * Revision 4.1  89/08/01  07:35:19  mlh
 * DEPENDENT keyword changed to ASSIGNED
 * 
 * Revision 4.0  89/07/24  17:02:50  nfh
 * Freezing rev 3.  Rev 4 is now Experimental
 * 
 * Revision 3.2  89/07/18  11:55:04  mlh
 * first_time removed and MODEL_LEVEL used for declaration precedence
 * 
 * Revision 1.3  89/07/18  09:48:45  mlh
 * variable declaration precedence in submodels handled with
 * MODEL_LEVEL level prefix generated by merge. Lowest level takes
 * precedence.
 * 
 * Revision 1.2  89/07/07  08:54:52  mlh
 * START field in INDEPENDENT block
 * SWEEP keyword replaces SCOP in INDEPENDENT block
 * FIRST and LAST keywords in PARTIAL block for boundaries rplace index
 * y'0 etc. allowed for constants
 * 
 * Revision 1.1  89/07/06  14:48:35  mlh
 * Initial revision
 * 
*/

#include "modl.h"
#include "ytab.h"

extern List    *firstlist;
extern List    *syminorder;
Symbol         *semi, *beginblk, *endblk;
List           *intoken;
char		buf[512];	/* volatile temporary buffer */

static struct {			/* Keywords */
	char           *name;
	short           kval;
}               keywords[] = {
	                "VERBATIM", VERBATIM,
	                "COMMENT", COMMENT,
	                "TITLE", MODEL,
	                "CONSTANT", CONSTANT,
			"PARAMETER", PARAMETER,
	                "INDEPENDENT", INDEPENDENT,
	                "ASSIGNED", DEPENDENT,
	                "INITIAL", INITIAL1,
	                "TERMINAL", TERMINAL,
	                "DERIVATIVE", DERIVATIVE,
	                "EQUATION", EQUATION,
	                "BREAKPOINT", BREAKPOINT,
	                "SOLVE", SOLVE,
	                "STATE", STATE,
	                "STEPPED", STEPPED,
	                "LINEAR", LINEAR,
	                "NONLINEAR", NONLINEAR,
	                "DISCRETE", DISCRETE,
	                "FUNCTION", FUNCTION1,
	                "PROCEDURE", PROCEDURE,
	                "PARTIAL", PARTIAL,
			"DEL2", DEL2,
	                "DEL", DEL,
	                "LOCAL", LOCAL,
	                "METHOD", USING,
			"STEADYSTATE", USING,
	                "SENS", SENS,
	                "STEP", STEP,
	                "WITH", WITH,
	                "FROM", FROM,
			"FORALL", FORALL1,
	                "TO", TO,
	                "BY", BY,
	                "if", IF,
	                "else", ELSE,
	                "while", WHILE,
	                "START", START1,
	                "DEFINE", DEFINE1,

	                "KINETIC", KINETIC,
	                "CONSERVE", CONSERVE,
			"PLOT", PLOT,
			"VS", VS,
			"LAG", LAG,
			"RESET", RESET,
			"MATCH", MATCH,
			"MODEL_LEVEL", MODEL_LEVEL,	/* inserted by merge */
			"SWEEP", SWEEP,
			"FIRST", FIRST,
			"LAST", LAST,
			"COMPARTMENT", COMPARTMENT,
			"PUTQ", PUTQ,
			"GETQ", GETQ,
			"IFERROR", IFERROR,
			"SOLVEFOR", SOLVEFOR,
			"UNITS", UNITS,
			"UNITSON", UNITSON,
			"UNITSOFF", UNITSOFF,
			"TABLE", TABLE,
			"DEPEND", DEPEND,
			"NEURON", NEURON,
			"SUFFIX", SUFFIX,
			"POINT_PROCESS", SUFFIX,
			"NONSPECIFIC_CURRENT", NONSPECIFIC,
			"ELECTRODE_CURRENT", ELECTRODE_CURRENT,
			"SECTION", SECTION,
			"RANGE", RANGE,
			"USEION", USEION,
			"READ", READ,
			"WRITE", WRITE,
			"VALENCE", VALENCE,
			"GLOBAL", GLOBAL,
			"POINTER", POINTER,
			"EXTERNAL", EXTERNAL,
			"INCLUDE", INCLUDE1,
	                0, 0
};

/*
 * the following special output tokens are used to make the .c file barely
 * readable 
 */
static struct {			/* special output tokens */
	char           *name;
	short           subtype;
	Symbol        **p;
}               special[] = {
	                ";", SEMI, &semi,
	                "{", BEGINBLK, &beginblk,
	                "}", ENDBLK, &endblk,
	                0, 0, 0
};

static struct {			/* numerical methods */
	char           *name;
	long           subtype;	/* All the types that will work with this */
	short		varstep;
}               methods[] = {
	                "adams", DERF | KINF, 0,
	                "runge", DERF | KINF, 0,
	                "euler", DERF | KINF, 0,
	                "adeuler", DERF | KINF, 1,
	                "heun", DERF | KINF, 0,
			"adrunge", DERF | KINF, 1,
	                "gear", DERF | KINF, 1,
	                "newton", NLINF, 0,
	                "simplex", NLINF, 0,
	                "simeq", LINF, 0,
	                "seidel", LINF, 0,
			"_advance", KINF, 0,
			"sparse", KINF, 0,
			"derivimplicit", DERF, 0, /* name hard wired in deriv.c */
	                "clsoda", DERF | KINF, 1,   /* Tolerance built in to
scopgear.c */
	                0, 0, 0
};

static char    *extdef[] = {	/* external names that can be used as doubles
				 * without giving an error message */
#include "extdef.h"
			    0
};

static char    *extdef2[] = {	/* external function names that can be used
				 * with array and function name arguments  */
#include "extdef2.h"
			    0
};

static char	*extdef3[] = {	/* function names that get two reet arguments
				 * added */
	"threshold",
	"squarewave",
	"sawtooth",
	"revsawtooth",
	"ramp",
	"pulse",
	"perpulse",
	"step",
	"perstep",
	"stepforce",
	"schedule",
	0
};

init()
{
	int             i;
	Symbol         *s;

	symbol_init();
	for (i = 0; keywords[i].name; i++) {
		s = install(keywords[i].name, keywords[i].kval);
		s->subtype = KEYWORD;
	}
	for (i = 0; methods[i].name; i++) {
		s = install(methods[i].name, METHOD);
		s->subtype = methods[i].subtype;
		s->u.i = methods[i].varstep;
	}
	for (i = 0; special[i].name; i++) {
		s = install(special[i].name, SPECIAL);
		*(special[i].p) = s;
		s->subtype = special[i].subtype;
	}
	for (i = 0; extdef[i]; i++) {
		s = install(extdef[i], NAME);
		s->subtype = EXTDEF;
	}
	for (i = 0; extdef2[i]; i++) {
		s = install(extdef2[i], NAME);
		s->subtype = EXTDEF2;
	}
	for (i = 0; extdef3[i]; i++) {
		s = lookup(extdef3[i]);
		assert(s && (s->subtype & EXTDEF));
		s->subtype |= EXTDEF3;
	}
	intoken = newlist();
	initfunc = newlist();
	modelfunc = newlist();
	termfunc = newlist();
	procfunc = newlist();
	initlist = newlist();
	firstlist = newlist();
	syminorder = newlist();
	plotlist = newlist();
#if NMODL
	nrninit();
#endif
}
