# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO Fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/* $Header: /timshel2g/src/master/nrn/src/nmodl/lex.c,v 1.4 1994/10/26 20:07:04 hines Exp $ */
/*
$Log: lex.c,v $
 * Revision 1.4  1994/10/26  20:07:04  hines
 * xxx
 *
 * Revision 1.2  1994/10/25  17:22:38  hines
 * flex should work now on lex.l
 *
 * Revision 1.1.1.1  1994/10/12  17:21:38  hines
 * NEURON 3.0 distribution
 *
 * Revision 8.2  1994/03/08  17:52:54  hines
 * allow help syntax, ? treated sam as :
 *
 * Revision 8.1  1989/09/29  16:26:01  mlh
 * ifdef for VMS and SYSV and some fixing of assert
 *
 * Revision 8.0  89/09/22  17:26:16  nfh
 * Freezing
 * 
 * Revision 7.1  89/09/20  11:33:41  mdf
 * Test for VMS environment added to that for __TURBOC__
 * 
 * Revision 7.0  89/08/30  13:31:45  nfh
 * Rev 7 is now Experimental; Rev 6 is Testing
 * 
 * Revision 6.0  89/08/14  16:26:28  nfh
 * Rev 6.0 is latest of 4.x; now the Experimental version
 * 
 * Revision 4.0  89/07/24  17:02:55  nfh
 * Freezing rev 3.  Rev 4 is now Experimental
 * 
 * Revision 3.1  89/07/07  16:54:06  mlh
 * FIRST LAST START in independent SWEEP higher order derivatives
 * 
 * Revision 1.2  89/07/07  08:54:39  mlh
 * START field in INDEPENDENT block
 * SWEEP keyword replaces SCOP in INDEPENDENT block
 * FIRST and LAST keywords in PARTIAL block for boundaries rplace index
 * y'0 etc. allowed for constants
 * 
 * Revision 1.1  89/07/06  14:46:09  mlh
 * Initial revision
 * 
*/


#undef output
#undef unput

#ifdef FLEX_SCANNER
#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	{ \
	int c = Getc(); \
	result = (c==EOF) ? YY_NULL : (buf[0]=c, 1); \
	}
#else
#undef input
#endif


#include "modl.h"
#include "ytab.h"

int lexcontext = 0;

#define debug(arg1,arg2) /*printf("lex:arg1|%s|\n", arg2);*/
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{ /*PRIME possibly high order*/
	char *cp, buf[100];
	int i;
	Symbol *base;

	/* count the primes  and create SCoP name*/
#if __TURBOC__ || SYSV || VMS
#define index strchr
#endif
	cp = index(yytext, '\'');
	i = strlen(yytext) - (cp - yytext);
	*cp = '\0';
	if (i > 1) {
		Sprintf(buf, "D%d%s", i, yytext);
	}else{
		Sprintf(buf, "D%s", yytext);
	}
	/* determine if really a constant */
	if ((i = input()) == '0') {
		Strcat(buf, "0");
		yylval.qp = putintoken(buf, NAME);
		return NAME;
	}else{
		unput(i);
	}
			
	/*create symbol if needed and store in intoken list*/
	yylval.qp = putintoken(buf, PRIME);
	if (SYM(yylval.qp)->type != PRIME) {
		diag(yytext, " needed as derivative variable");
#if LINT
goto yyfussy;
#endif
	}
	/* the high order prime might not be explicitly declared at this
	time. But the base state may be an array. If it is, then make
	the PRIME an array of the same dimension. */
	if ((base = lookup(yytext))) {
		if (base->subtype & ARRAY) {
			SYM(yylval.qp)->subtype |= ARRAY;
			SYM(yylval.qp)->araydim = base->araydim;
		}
	}
	return PRIME;
}
break;
case 2:
case 3:
case 4:
{ /* translate to lower case */
	char *cp;
	for (cp = yytext; *cp; cp++) {
		*cp += 'a' - 'A';
	}
	yylval.qp = putintoken(yytext, NAME);
	return SYM(yylval.qp)->type;
	}
break;
case 5:
{ /*NAME*/
	Symbol *s;

	yylval.qp = putintoken(yytext, NAME);
	s = SYM(yylval.qp);
	if (s->type == PRIME)
		diag(yytext, " being used as derivative variable");
	return s->type;
}
break;
case 6:
{ /*INTEGER*/
	yylval.qp = putintoken(yytext, INTEGER); /* Numbers are not looked for */
	return INTEGER;
}
break;
case 7:
case 8:
case 9:
{ /*REAL*/
	yylval.qp = putintoken(yytext, REAL); /* Numbers are not looked for */
	return REAL;
}
break;
case 10:
{ /* STRING */
	yylval.qp = putintoken(yytext, STRING);
	return STRING;
		/* can't quote \" */
}
break;
case 11:
{ yylval.qp = putintoken(yytext, 0); return GT;}
break;
case 12:
{ yylval.qp = putintoken(yytext, 0); return GE;}
break;
case 13:
{ yylval.qp = putintoken(yytext, 0); return LT;}
break;
case 14:
{ yylval.qp = putintoken(yytext, 0); return LE;}
break;
case 15:
{ yylval.qp = putintoken(yytext, 0); return EQ;}
break;
case 16:
{ yylval.qp = putintoken(yytext, 0); return NE;}
break;
case 17:
{ yylval.qp = putintoken(yytext, 0); return NOT;}
break;
case 18:
{ yylval.qp = putintoken(yytext, 0); return AND;}
break;
case 19:
{ yylval.qp = putintoken(yytext, 0); return OR;}
break;
case 20:
{ yylval.qp = putintoken(yytext, 0); return REACT1;}
break;
case 21:
{ /* syntactic sugar for equation addition */
	yylval.qp = putintoken(yytext, 0);
	if (lexcontext == NONLINEAR) return NONLIN1;
	if (lexcontext == LINEAR) return LIN1;
	diag("equation addition can't occur in this type of block", (char *)0);
	}
break;
case 22:
{ /* syntactic sugar for equations */
	yylval.qp = putintoken(yytext, 0);
	if (lexcontext == NONLINEAR) return NONLIN1;
	if (lexcontext == LINEAR) return LIN1;
	if (lexcontext == PARTIAL) return yytext[0];
	if (lexcontext == KINETIC) return REACTION;
	diag("equations can't occur in this type of block", (char *)0);
	}
break;
case 23:
{/*ignore spacing characters*/;}
break;
case 24:
{/*ignore newline*/}
break;
case 25:
{/*ignore inline comments*/;}
break;
case 26:
{/*ignore inline comments*/;}
break;
case 27:
{ yylval.qp = putintoken("{", 0); return yytext[0]; }
break;
case 28:
{ yylval.qp = putintoken("}", 0); return yytext[0]; }
break;
case 29:
{ yylval.qp = putintoken(yytext, 0); return yytext[0]; }
break;
case -1:
break;
default:
Fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */


#ifndef FLEX_SCANNER
int input()
{
	int c;
	c = Getc();
	if (c == EOF) {
		c = 0;
	}
	return c;
}
#endif


int unput(c) int c; {
	unGetc(c);
}


int output(c) int c; {
#if LINT
	IGNORE(c);
#endif
	diag("internal error: ", "called output");
}

int yywrap() {
	return 1;
}

char           *
inputtopar()
{				/* returns string up to and not including
				 * next closing parenthesis */
	/* main usage is to read the units string */
	char            *cp;
	int             c;

	cp = buf;
	while ((c = input()) != ')' && c != '\n' && c != 0) {
		*cp++ = c;
	}
	if (c != ')')
		diag("Syntax error:", " no closing ')'");
	*cp = '\0';
	unput(c);
	return stralloc(buf, (char *) 0);
}
int yyvstop[] = {
0,

29,
0,

23,
29,
0,

24,
0,

17,
29,
0,

29,
0,

29,
0,

29,
0,

6,
29,
0,

25,
29,
0,

13,
29,
0,

29,
0,

11,
29,
0,

26,
29,
0,

5,
29,
0,

5,
29,
0,

5,
29,
0,

5,
29,
0,

27,
29,
0,

29,
0,

28,
29,
0,

22,
29,
0,

16,
0,

10,
0,

18,
0,

8,
0,

7,
0,

6,
0,

25,
0,

14,
0,

15,
0,

12,
0,

26,
0,

1,
0,

5,
0,

5,
0,

3,
5,
0,

5,
0,

19,
0,

21,
0,

7,
8,
0,

9,
0,

20,
0,

5,
0,

5,
0,

8,
0,

7,
0,

4,
5,
0,

5,
0,

7,
8,
0,

2,
5,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
7,25,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
7,25,	7,25,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
32,0,	37,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	1,7,	
0,0,	7,26,	0,0,	1,8,	
8,27,	0,0,	0,0,	0,0,	
1,3,	0,0,	7,25,	1,9,	
0,0,	1,10,	0,0,	7,25,	
2,6,	12,33,	38,38,	0,0,	
0,0,	2,8,	23,44,	1,11,	
0,0,	1,12,	1,13,	1,14,	
1,15,	2,9,	1,16,	6,24,	
7,25,	12,34,	1,17,	13,35,	
7,25,	14,36,	1,18,	18,41,	
19,42,	2,11,	17,40,	2,12,	
2,13,	2,14,	2,15,	33,50,	
51,58,	28,45,	46,55,	42,52,	
1,19,	59,62,	52,59,	0,0,	
2,18,	0,0,	0,0,	0,0,	
1,3,	40,51,	7,25,	0,0,	
0,0,	0,0,	1,16,	0,0,	
0,0,	0,0,	2,19,	9,28,	
9,28,	9,28,	9,28,	9,28,	
9,28,	9,28,	9,28,	9,28,	
9,28,	28,45,	46,55,	0,0,	
2,16,	0,0,	0,0,	0,0,	
1,20,	1,21,	1,22,	1,23,	
10,29,	21,43,	10,30,	10,30,	
10,30,	10,30,	10,30,	10,30,	
10,30,	10,30,	10,30,	10,30,	
11,32,	0,0,	2,20,	2,21,	
2,22,	2,23,	15,37,	0,0,	
11,32,	11,0,	0,0,	10,31,	
0,0,	0,0,	15,37,	15,0,	
29,46,	29,46,	29,46,	29,46,	
29,46,	29,46,	29,46,	29,46,	
29,46,	29,46,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	11,32,	0,0,	0,0,	
0,0,	29,47,	0,0,	15,37,	
0,0,	0,0,	11,32,	10,31,	
0,0,	0,0,	0,0,	11,32,	
15,37,	31,48,	0,0,	31,48,	
0,0,	15,37,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
11,32,	0,0,	0,0,	0,0,	
11,32,	29,47,	15,37,	0,0,	
0,0,	0,0,	15,37,	16,38,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	11,32,	0,0,	
0,0,	0,0,	0,0,	0,0,	
15,37,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	0,0,	
0,0,	0,0,	0,0,	16,39,	
0,0,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	16,39,	
16,39,	16,39,	16,39,	45,53,	
0,0,	45,53,	0,0,	0,0,	
45,54,	45,54,	45,54,	45,54,	
45,54,	45,54,	45,54,	45,54,	
45,54,	45,54,	47,56,	0,0,	
47,56,	0,0,	0,0,	47,57,	
47,57,	47,57,	47,57,	47,57,	
47,57,	47,57,	47,57,	47,57,	
47,57,	48,49,	48,49,	48,49,	
48,49,	48,49,	48,49,	48,49,	
48,49,	48,49,	48,49,	53,54,	
53,54,	53,54,	53,54,	53,54,	
53,54,	53,54,	53,54,	53,54,	
53,54,	55,60,	0,0,	55,60,	
0,0,	0,0,	55,61,	55,61,	
55,61,	55,61,	55,61,	55,61,	
55,61,	55,61,	55,61,	55,61,	
56,57,	56,57,	56,57,	56,57,	
56,57,	56,57,	56,57,	56,57,	
56,57,	56,57,	60,61,	60,61,	
60,61,	60,61,	60,61,	60,61,	
60,61,	60,61,	60,61,	60,61,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-19,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+6,	0,		yyvstop+8,
yycrank+-3,	0,		yyvstop+11,
yycrank+2,	0,		yyvstop+13,
yycrank+59,	0,		yyvstop+15,
yycrank+82,	0,		yyvstop+17,
yycrank+-139,	0,		yyvstop+20,
yycrank+8,	0,		yyvstop+23,
yycrank+10,	0,		yyvstop+26,
yycrank+12,	0,		yyvstop+28,
yycrank+-145,	0,		yyvstop+31,
yycrank+176,	0,		yyvstop+34,
yycrank+2,	yysvec+16,	yyvstop+37,
yycrank+5,	yysvec+16,	yyvstop+40,
yycrank+4,	yysvec+16,	yyvstop+43,
yycrank+0,	0,		yyvstop+46,
yycrank+5,	0,		yyvstop+49,
yycrank+0,	0,		yyvstop+51,
yycrank+15,	0,		yyvstop+54,
yycrank+0,	0,		yyvstop+57,
yycrank+0,	yysvec+7,	0,	
yycrank+0,	0,		yyvstop+59,
yycrank+0,	0,		yyvstop+61,
yycrank+16,	yysvec+9,	yyvstop+63,
yycrank+108,	0,		yyvstop+65,
yycrank+0,	yysvec+10,	yyvstop+67,
yycrank+146,	0,		0,	
yycrank+-14,	yysvec+11,	yyvstop+69,
yycrank+21,	0,		0,	
yycrank+0,	0,		yyvstop+71,
yycrank+0,	0,		yyvstop+73,
yycrank+0,	0,		yyvstop+75,
yycrank+-15,	yysvec+15,	yyvstop+77,
yycrank+15,	0,		yyvstop+79,
yycrank+0,	yysvec+16,	yyvstop+81,
yycrank+14,	yysvec+16,	yyvstop+83,
yycrank+0,	yysvec+16,	yyvstop+85,
yycrank+14,	yysvec+16,	yyvstop+88,
yycrank+0,	0,		yyvstop+90,
yycrank+0,	0,		yyvstop+92,
yycrank+256,	0,		0,	
yycrank+17,	yysvec+29,	yyvstop+94,
yycrank+271,	0,		0,	
yycrank+281,	0,		0,	
yycrank+0,	yysvec+48,	yyvstop+97,
yycrank+0,	0,		yyvstop+99,
yycrank+15,	yysvec+16,	yyvstop+101,
yycrank+14,	yysvec+16,	yyvstop+103,
yycrank+291,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+105,
yycrank+306,	0,		0,	
yycrank+316,	0,		0,	
yycrank+0,	yysvec+56,	yyvstop+107,
yycrank+0,	yysvec+16,	yyvstop+109,
yycrank+20,	yysvec+16,	yyvstop+112,
yycrank+326,	0,		0,	
yycrank+0,	yysvec+60,	yyvstop+114,
yycrank+0,	yysvec+16,	yyvstop+117,
0,	0,	0};
struct yywork *yytop = yycrank+383;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,'+' ,01  ,'+' ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,'_' ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)Fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				Fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)Fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					Fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)Fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				Fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			Fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					Fprintf(yyout,"\nmatch ");
					sprint(yytext);
					Fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
