/* $Header: /timshel2g/src/master/nrn/src/nmodl/parout.c,v 1.1.1.1 1994/10/12 17:21:36 hines Exp $ */

#include "modl.h"
#include "ytab.h"
extern Symbol *indepsym;
extern Symbol *scop_indep;
extern List   *indeplist;
extern Symbol *stepsym;
extern char   *reprime();
extern List	*symlist[];
List *syminorder;
List *plotlist;
List *defs_list;
#if SIMSYS
extern FILE *fctlout, *fnumout;
#endif
#define SYMITER(arg) ITERATE(q, syminorder){ \
		s = SYM(q); if (s->type == arg)

#define SYMLISTITER for (i = 'A'; i <= 'z'; i++)\
	ITERATE(q, symlist[i])
	
#define IFTYPE(arg)	if ((s->subtype & arg)\
			 && ( (s->usage & EXPLICIT_DECL) != automatic) )

/* varcount holds the index into the .var file and is saved in s->used
   parraycount holds the index into the p array and is saved in s->varnum
*/
static varcount, parraycount;

#if SIMSYS	/* started out as copy of standard SCoP */
parout()
{
	int i, automatic, pindex;
	Symbol *s;
	double g1, g2, value;
	int size;
	char sunit[100];
	Item *q;

	defs_list = newlist();	/* replaces defs.h */

	Fprintf(fcout, "#define _sav_indep _p[0]\n");
	warnsiz(indepsym);
	varcount = parraycount = 1;

/* .var file divided into two groups: those variables which are explicitly
declared and those variables which are constructed by default.
This is so that the important variables are not cluttered with unimportant
ones in the scop editor.
*/
for (automatic = 0; automatic <= EXPLICIT_DECL; automatic += EXPLICIT_DECL) {
	SYMITER(NAME) {
		IFTYPE(PARM){
			warnsiz(s);
			decode_ustr(s,&g1,&g2,buf);
			size=1;
			Fprintf(fparout, "%s\t%s\tconst\t%d\t%d\t%g\n",
				s->name, buf, size, varcount, g1);
			var_count(s);
		}
	}}
	if (stepsym && !automatic) {
		warnsiz(stepsym);
			decode_ustr(s,&g1,&g2,buf);
			size=1;
			Fprintf(fparout, "%s\t%s\tconst\t%d\t%d\t%g\n",
				s->name, buf, size, varcount, g1);
		var_count(stepsym);
	}
	if (indepsym && !automatic) {
		if (scop_indep != indepsym) {
diag("In SIMSYS the control independent variable and the mathematical\n",
"independent variable must be the same. I.e. No SWEEP statement allowed");
		}
		warnsiz(indepsym);
			decode_ustr(indepsym,&g1,&g2,buf);
			size=1;
			Fprintf(fparout, "%s\t%s\tiv\t%d\t%d\t%g\n",
				indepsym->name, buf,
				size, varcount, STR(indeplist->prev->prev));
		var_count(indepsym);
	}
	SYMITER(NAME) {
		IFTYPE(STAT){
			warnsiz(s);
			decode_ustr(s,&g1,&g2,buf);
			if (s->subtype & ARRAY) {
				size = s->araydim;
			}else{
				size=1;
			}
			Fprintf(fparout, "%s\t%s\tdv\t%d\t%d\t%g\n",
				s->name, buf, size, varcount, 0.);
			var_count(s);
		}
	}}
	SYMITER(PRIME) {
		IFTYPE(DEP) if (s->usage & DEP) {
			warnsiz(s);
			decode_ustr(s,&g1,&g2,buf);
			if (s->subtype & ARRAY) {
				size = s->araydim;
			}else{
				size=1;
			}
			Fprintf(fparout, "%s\t%s\tdv\t%d\t%d\t%g\n",
				s->name, buf, size, varcount, 0.);
			var_count(s);
		}
		IFTYPE(STAT) {
			warnsiz(s);
			decode_ustr(s,&g1,&g2,buf);
			if (s->subtype & ARRAY) {
				size = s->araydim;
			}else{
				size=1;
			}
			Fprintf(fparout, "%s\t%s\tdv\t%d\t%d\t%g\n",
				reprime(s), buf, size, varcount, 0.);
			var_count(s);
		}
	}}
	SYMITER(NAME) {
		IFTYPE(DEP) {
			warnsiz(s);
			decode_ustr(s,&g1,&g2,buf);
			if (s->subtype & ARRAY) {
				size = s->araydim;
			}else{
				size=1;
			}
			Fprintf(fparout, "%s\t%s\tdv\t%d\t%d\t%g\n",
				s->name, buf, size, varcount, 0.);
			var_count(s);
		}
	}}
}
	Fflush(fparout);
	Sprintf(buf, "\ndouble _p[%d];\n", varcount);
	Lappendstr(defs_list, buf);
	
	/* now print the information for the control file */
	{double g3, atof();
	g1=atof(STR(indeplist->next));
	g2=atof(STR(indeplist->next->next));
	g3=atof(STR(indeplist->next->next->next));
	Fprintf(fctlout, "%g\n%g\n%g\n", g1, g2, (g2 - g1)/g3);
	Fflush(fctlout);
	}
	
	/* The plotlist is organized in pairs of symbol followed by
	index string which is "-1" for scalars and anything for arrays.
	-1 for an array means that no index appeared in the spec */
	if (plotlist->next == plotlist) { /* empty so use first state */
		SYMITER(NAME) {
			if (s->subtype & STAT) {
				Lappendsym(plotlist, s);
				if (s->subtype & ARRAY) {
					Lappendstr(plotlist, "0");
				}else{
					Lappendstr(plotlist, "-1");
				}
				break; /* default is first one only */
			}
		}}
	}
	if (plotlist->next == plotlist) { /* still empty so use first DEP */
		SYMITER(NAME) {
			if (s->subtype & DEP) {
				Lappendsym(plotlist, s);
				if (s->subtype & ARRAY) {
					Lappendstr(plotlist, "0");
				}else{
					Lappendstr(plotlist, "-1");
				}
				break; /* default is first one only */
			}
		}}
	}
	if (plotlist->next == plotlist) { /*still empty so leave blank */
		;
	}else if (plotlist->next->next->next == plotlist) {
		/* only one so add indep*/
		Linsertsym(plotlist, scop_indep);
		Insertstr(plotlist->next->next, "-1");
	}
	/* check consistency of plot list if array has no index 
	if H is array and has no index then all the rest must
	be arrays, have no index, and have the same dimension.
	if H is scalar or has an index then all the rest must be
	scalars or have an index */
{ int hindex; Symbol  *hsym;
	if (plotlist->next != plotlist) {
		q = plotlist->next;
		hsym = SYM(q);
		hindex = atoi(STR(q->next));
		i = 0;
	}
	ITERATE(q, plotlist) {
		if (++i > 6) {
			break;
		}
		s = SYM(q);
		pindex = atoi(STR(q = q->next));
		if (!(s->subtype & (DEP | STAT | INDEP))) {
			diag(s->name, " is Illegal type for PLOT variable");
		}
		if ((pindex != -1) && !(s->subtype & ARRAY)) {
			diag(reprime(s), " must be scalar in PLOT statement");
		}
		if ( (s->subtype & ARRAY) && (pindex >= s->araydim)) {
			diag(reprime(s), ": Index too high in PLOT statement");
		}
		if ((hsym->subtype & ARRAY) && (hindex == -1)) {
			if (!(s->subtype & ARRAY) || (pindex != -1)) {
				diag(reprime(s),
" in PLOT must be like the horizontal axis variable:\n\
I.e., an array with no index specified");
			}
			if (hsym->araydim != s->araydim) {
				diag(reprime(s),
" in PLOT must have same dimension as horzontal axis variable.");
			}
		}else{
			if ((s->subtype & ARRAY) && (pindex == -1)) {
				diag(reprime(s),
" in this PLOT context must have an index explicitly specified");
			}
		}
	}
}

	i = 0;
	ITERATE(q, plotlist) { int kludge;
		if (++i > 6) {
			break;
		}
		s = SYM(q);
		pindex = atoi(STR(q = q->next));
/*aaarrrggg*/
kludge = pindex;
if ((s->subtype & ARRAY) && (pindex == -1)) {
	pindex = s->araydim;
	Sprintf(buf, "%d", pindex);
	replacstr(q, buf);
	if (i == 1) {
		kludge = pindex - 1;
	}else{
		kludge = 0;
	}
}
		if (s->subtype & ARRAY) {
Fprintf(fnumout, "%s[%d]\n", reprime(s), pindex);
		}else{
		Fprintf(fnumout, "%s\n", reprime(s));
		}
	}
	Fflush(fnumout);
}

#else	/* standard SCoP */
parout()
{
	int i, automatic, pindex;
	Symbol *s;
	double g1, g2;
	Item *q;

	defs_list = newlist();	/* replaces defs.h */

	Fprintf(fparout, "_sav_indep\n0\n\n0\n");
	Fprintf(fcout, "#define _sav_indep _p[0]\n");
	warnsiz(indepsym);
	varcount = parraycount = 1;

/* .var file divided into two groups: those variables which are explicitly
declared and those variables which are constructed by default.
This is so that the important variables are not cluttered with unimportant
ones in the scop editor.
*/
for (automatic = 0; automatic <= EXPLICIT_DECL; automatic += EXPLICIT_DECL) {
	SYMITER(NAME) {
		IFTYPE(PARM){
			warnsiz(s);
			Fprintf(fparout, "%s%s1\n", s->name, s->u.str);
			var_count(s);
		}
	}}
	if (stepsym && !automatic) {
		warnsiz(stepsym);
		Fprintf(fparout, "%s%s8\n", stepsym->name, stepsym->u.str);
		var_count(stepsym);
	}
	if (indepsym && !automatic) {
		warnsiz(indepsym);
		warnsiz(scop_indep);
		Fprintf(fparout, "%s%s4\n", scop_indep->name, scop_indep->u.str);
		var_count(scop_indep);
		if (scop_indep != indepsym) {
			/* then the modl independent variable is a parameter
			   with value equal to the final value */
			Fprintf(fparout, "%s\n%s\n%s\n1\n", indepsym->name,
STR(indeplist->next->next), STR(indeplist->prev));
			var_count(indepsym);
		}
	}
	SYMITER(NAME) {
		IFTYPE(STAT){
			warnsiz(s);
			Fprintf(fparout, "%s%s16\n", s->name, s->u.str);
			var_count(s);
		}
	}}
	SYMITER(PRIME) {
		IFTYPE(DEP) if (s->usage & DEP) {
			warnsiz(s);
			Fprintf(fparout, "%s%s2\n", reprime(s), s->u.str);
			var_count(s);
		}
		IFTYPE(STAT) {
			warnsiz(s);
			Fprintf(fparout, "%s%s16\n", reprime(s), s->u.str);
			var_count(s);
		}
	}}
	SYMITER(NAME) {
		IFTYPE(DEP) {
			warnsiz(s);
			Fprintf(fparout, "%s%s2\n", s->name, s->u.str);
			var_count(s);
		}
	}}
}
	/* The plotlist is organized in pairs of symbol followed by
	index string which is "-1" for scalars and anything for arrays.
	-1 for an array means that no index appeared in the spec */
	if (plotlist->next == plotlist) { /* empty so use first state */
		SYMITER(NAME) {
			if (s->subtype & STAT) {
				Lappendsym(plotlist, s);
				if (s->subtype & ARRAY) {
					Lappendstr(plotlist, "0");
				}else{
					Lappendstr(plotlist, "-1");
				}
				break; /* default is first one only */
			}
		}}
	}
	if (plotlist->next == plotlist) { /* still empty so use first DEP */
		SYMITER(NAME) {
			if (s->subtype & DEP) {
				Lappendsym(plotlist, s);
				if (s->subtype & ARRAY) {
					Lappendstr(plotlist, "0");
				}else{
					Lappendstr(plotlist, "-1");
				}
				break; /* default is first one only */
			}
		}}
	}
	/*EMPTY*/
	if (plotlist->next == plotlist) { /*still empty so leave blank */
		;
	}else if (plotlist->next->next->next == plotlist) {
		/* only one so add indep*/
		Linsertsym(plotlist, scop_indep);
		Insertstr(plotlist->next->next, "-1");
	}
	/* check consistency of plot list if array has no index 
	if H is array and has no index then all the rest must
	be arrays, have no index, and have the same dimension.
	if H is scalar or has an index then all the rest must be
	scalars or have an index */
{ int hindex; Symbol  *hsym;
	if (plotlist->next != plotlist) {
		q = plotlist->next;
		hsym = SYM(q);
		hindex = atoi(STR(q->next));
		i = 0;
	}
	ITERATE(q, plotlist) {
		if (++i > 6) {
			break;
		}
		s = SYM(q);
		pindex = atoi(STR(q = q->next));
		if (!(s->subtype & (DEP | STAT | INDEP))) {
			diag(s->name, " is Illegal type for PLOT variable");
		}
		if ((pindex != -1) && !(s->subtype & ARRAY)) {
			diag(reprime(s), " must be scalar in PLOT statement");
		}
		if ( (s->subtype & ARRAY) && (pindex >= s->araydim)) {
			diag(reprime(s), ": Index too high in PLOT statement");
		}
		if ((hsym->subtype & ARRAY) && (hindex == -1)) {
			if (!(s->subtype & ARRAY) || (pindex != -1)) {
				diag(reprime(s),
" in PLOT must be like the horizontal axis variable:\n\
I.e., an array with no index specified");
			}
			if (hsym->araydim != s->araydim) {
				diag(reprime(s),
" in PLOT must have same dimension as horzontal axis variable.");
			}
		}else{
			if ((s->subtype & ARRAY) && (pindex == -1)) {
				diag(reprime(s),
" in this PLOT context must have an index explicitly specified");
			}
		}
	}
}

	i = 0;
	ITERATE(q, plotlist) {
		if (++i > 6) {
			break;
		}
		s = SYM(q);
		pindex = atoi(STR(q = q->next));
		if ((s->subtype & ARRAY) && (pindex == -1)) {
			pindex = s->araydim;
			Sprintf(buf, "%d", pindex);
			replacstr(q, buf);
Fprintf(fparout, "%s[%d]\n%d %d %d\n", reprime(s), pindex, s->used, s->varnum, pindex);
		}else if (s->subtype & ARRAY) {
Fprintf(fparout, "%s[%d]\n%d %d 1\n", reprime(s), pindex, s->used, s->varnum+pindex);
		}else{
Fprintf(fparout, "%s\n%d %d 0\n", reprime(s), s->used, s->varnum);
		}
	}
	for (; ++i<=6; ) {
		Fprintf(fparout, "\n0 0 0\n");
	}
	q = plotlist->next;
	if (q == plotlist) { /* empty */
		Fprintf(fparout, "\n0 0\n\n0 0\n");
	}else{ /*otherwise guaranteed to be at least 2 of them */
int j; for (j=0; j < 2; j++) { char units[50];
		s = SYM(q); /* the V variable */
		decode_ustr(s, &g1, &g2, units);
		if (units[0] != '\0') {
			Sprintf(buf, " (%s)", units);
		}else{
			buf[0] = '\0';
		}
		pindex = atoi(STR(q = q->next));
		if (s->subtype & ARRAY) {
Fprintf(fparout, "%s[%d]%s\n%g %g\n", reprime(s), pindex, buf, g1, g2);
		}else{
Fprintf(fparout, "%s%s\n%g %g\n", reprime(s), buf, g1, g2);
		}
q = q->next;
}
	}
	Fflush(fparout);
}
#endif /*not SIMSYS*/

static warnsiz(s)
	Symbol *s;
{
	
	if (s->subtype & ARRAY) {
		Sprintf(buf, "%s[%d]", reprime(s), s->araydim);
	}else{
		Sprintf(buf, "%s", reprime(s));
	}
	if (strlen(buf) > 20 ) {
		diag(buf ," is more than 20 characters long\n");
	}
}

decode_ustr(sym, pg1, pg2, s)	/* decode sym->u.str */
	Symbol *sym;
	char *s;
	double *pg1, *pg2;
{
	int i, n;
	char *cp, *cp1;
	
	switch (sym->subtype & (INDEP | DEP | STAT | PARM)) {

	case INDEP:	/* but doesnt get all info */
	case DEP:
	case STAT:
		assert(sym && sym->u.str);
		if (sym->subtype & ARRAY) { /* see parsact.c */
			i = sscanf(sym->u.str, "[%*d]\n%lf%*c%lf", pg1, pg2);
		}else{			
			i = sscanf(sym->u.str, "%lf%*c%lf", pg1, pg2);
		}
		assert(i == 2);
		for (n=0, cp = sym->u.str; n < 2;) {
			if (*cp++ == '\n') {
				n++;
			}
		}
		for (cp1 = s; *cp != '\n';) {
			*cp1++ = *cp++;
		}
		*cp1 = '\0';
		break;

	case PARM:
		assert(sym && sym->u.str);
		i = sscanf(sym->u.str, "%lf\n%s", pg1, s);
		if (i == 1) {
			s[0] = '\0';
			i = 2;
		}
		assert(i == 2);
		break;
	default:
		/*SUPPRESS 558*/
		assert(0);
	}
#if SIMSYS
	if (s[0] == '\0') {
		Sprintf(s, "none");
	}
#endif
}

static
var_count(s)
	Symbol *s;
{
	defs_h(s);
	s->used = varcount++;
	s->varnum = parraycount;
	if (s->subtype & ARRAY) {
		parraycount += s->araydim;
	}else{
		parraycount++;
	}
}

static
defs_h(s)
	Symbol *s;
{
	Item *q;
	
	if (s->subtype & ARRAY) {
		Sprintf(buf, "#define %s (_p + %d)\n", s->name, parraycount);
		q = lappendstr(defs_list, buf);
	} else {
		Sprintf(buf, "#define %s _p[%d]\n", s->name, parraycount);
		q = lappendstr(defs_list, buf);
	}
	q->itemtype = VERBATIM;
}

/*
$Log: parout.c,v $
 * Revision 1.1.1.1  1994/10/12  17:21:36  hines
 * NEURON 3.0 distribution
 *
 * Revision 9.76  90/12/07  09:27:19  hines
 * new list structure that uses unions instead of void *element
 * 
 * Revision 9.75  90/12/05  11:02:59  hines
 * forgot to add pindex to s->varnum to get index into parray for specific index.
 * 
 * Revision 9.73  90/12/04  12:00:23  hines
 * model version displayed only as comment in generated c file
 * format of plot lines for scalar in .var file is
 * name nl vindex pindex 1 nl
 * for vector with specific index:
 * name[index] vindex pindex 1
 * for vector without index
 * name[size] vindex pindex size
 * 
 * Revision 9.58  90/11/20  17:24:08  hines
 * CONSTANT changed to PARAMETER
 * CONSTANT now refers to variables that don't get put in .var file
 * 
 * Revision 9.44  90/10/30  10:24:59  hines
 * modl: saber warning free except for ytab.c and lex.c
 * 
 * Revision 9.37  90/10/15  13:08:17  hines
 * parout separated into parout for modl, hparout for hmodl nparout for nmodl
 * 
 * Revision 9.34  90/10/15  11:47:05  hines
 * hmodl: use _p[]
 * 
 * Revision 9.32  90/10/08  14:12:52  hines
 * index vector instead of pointer vector for slist and dlist
 * 
 * Revision 9.31  90/10/08  11:34:02  hines
 * simsys prototype
 * 
 * Revision 9.24  90/08/17  08:44:50  hines
 * mistake on last checkin
 * 
 * Revision 9.23  90/08/17  08:39:15  hines
 * no more modltype for double scalars
 * 
 * Revision 9.22  90/08/17  08:15:00  hines
 * HMODL change define from HOC to HMODL, ensure all .c files compiled
 * 
 * Revision 9.19  90/08/07  15:36:15  hines
 * forgot name of mechanism. Also append suffix to all range names
 * 
 * Revision 9.17  90/08/07  08:43:25  hines
 * functions and procedures interfaced to NMODL and HMODL
 * 
 * Revision 9.16  90/08/02  08:58:44  hines
 * NMODL can use more than one mechanism. Integrators that use ninits and
 * reset will not work, though.
 * 
 * Revision 9.15  90/08/01  07:48:18  hines
 * repair HOC portion after all the errors introduced by NMODL
 * 
 * Revision 9.14  90/07/31  17:03:50  hines
 * NMODL getting close. Compiles but multiple .mod files cause
 * multiple definitions.
 * 
 * Revision 9.13  90/07/30  14:37:17  hines
 * NMODL looks pretty good. Ready to start testing. Have not yet tried
 * to compile the .c file.
 * 
 * Revision 9.11  90/07/30  11:51:14  hines
 * NMODL getting better, almost done
 * 
 * Revision 9.10  90/07/27  13:58:06  hines
 * nmodl handles declarations about right for first pass at this.
 * 
 * Revision 9.8  90/07/26  07:58:43  hines
 * interface modl to hoc and call the translator hmodl
 * 
 * Revision 3.73  90/07/19  08:31:40  hines
 * double scalar and double vector structures replace the P array
 * definitions.
 * 
 * Revision 9.5  90/07/18  07:59:42  hines
 * define for arrays now (p + n) instead of &p[n]. This allows the c file
 * to have arrays that look like a[i] instead of *(a + i).
 * 
 * Revision 9.3  90/06/01  11:00:17  mlh
 * checks for conformability of units but does not check for
 * correct conversion factors.
 * in x^y, both x and y must be dimensionless
 * 
 * Revision 8.5  90/04/03  07:48:18  mlh
 * typo in previous change. Due to nature of RCS on nbsr, it is unfortunately
 * necessary to check things back in before testing.
 * 
 * Revision 8.4  90/04/03  07:46:59  mlh
 * for turbo-c defs.h stuff must appear after inclusion of scoplib.h
 * This is done by now saving defs.h stuff in defs_list and printing
 * it in cout.c.  Note that each item is type VERBATIM so that there
 * is no prepended space.
 * 
 * Revision 8.3  90/02/15  10:10:17  mlh
 * defs.h no longer included. #defines come from parraycount during
 * handling of .var file.  Thsi handling must be before putting info
 * in .c file
 * 
 * Revision 8.2  90/01/18  08:12:33  mlh
 * serious error in calculating p-array index for
 * plot variables in .var file.
 * Fixed by using symbol->varnum to hold the p-index.
 * 
 * Revision 8.1  89/12/18  07:57:31  mlh
 * Fixed problem in .var file in which x-axis array variable's dimension
 * was 1 too large.
 * 
 * Revision 8.0  89/09/22  17:26:47  nfh
 * Freezing
 * 
 * Revision 7.0  89/08/30  13:32:18  nfh
 * Rev 7 is now Experimental; Rev 6 is Testing
 * 
 * Revision 6.2  89/08/24  12:08:08  mlh
 * failed to declare reprime(), make lint free
 * 
 * Revision 6.1  89/08/23  10:32:10  mlh
 * derivative variables in .var file have names like var' instead of Dvar
 * 
 * Revision 6.0  89/08/14  16:27:03  nfh
 * Rev 6.0 is latest of 4.x; now the Experimental version
 * 
 * Revision 4.1  89/08/05  11:38:41  mlh
 * axis units info now in .var file
 * units for higher order derivatives auto generated
 * .var syntax for higher order derivative states now a:b
 * 
 * Revision 4.0  89/07/24  17:03:31  nfh
 * Freezing rev 3.  Rev 4 is now Experimental
 * 
 * Revision 3.1  89/07/07  16:54:42  mlh
 * FIRST LAST START in independent SWEEP higher order derivatives
 * 
 * Revision 1.1  89/07/06  14:50:01  mlh
 * Initial revision
 * 
*/

