/* $Header: /timshel2g/src/master/nrn/src/nrnoc/init.c,v 1.1.1.1 1994/10/12 17:22:33 hines Exp $ */
/*
$Log: init.c,v $
 * Revision 1.1.1.1  1994/10/12  17:22:33  hines
 * NEURON 3.0 distribution
 *
 * Revision 4.68  1994/07/04  15:12:14  hines
 * new banner for a distributed version; Version 3.0. This avoids confusion
 * with the many rcs versions of the several modules that make up NEURON.
 * It is intended that the version will be incremented when a new
 * distribution is made
 *
 * Revision 4.57  1994/05/03  15:16:48  hines
 * temporarily use nil for checkpoint functions
 *
 * Revision 4.50  1993/12/15  15:04:19  hines
 * SectionRef class holds pointer to section.
 * special .sec method handles section stack properly
 *
 * Revision 4.49  1993/11/04  15:56:56  hines
 * port to solaris2 (no more warnings)
 *
 * Revision 4.45  1993/08/20  10:28:43  hines
 * writing to a constant string. gcc doesn't like that unless we use
 * -fwritable-strings. repaired in init.c
 *
 * Revision 4.38  93/07/13  11:49:09  hines
 * declare all current functions properly (now Pfri instead of Pfrd)
 * 
 * Revision 4.36  93/07/08  14:34:19  hines
 * a start on fixing the bug of electode point processes not working
 * correctly in presence of extracellular. At this time the functionality
 * is identical as before but passing node to  models in nrn_cur instead
 * of passing pointer to nd->d and returning rhs.
 * There is an alternative now to NONSPECIFIC_CURRENT which is
 * ELECTRODE_CURRENT
 * 
 * Revision 4.33  93/05/31  15:35:00  hines
 * for (ch=sec->child; ch; ch=ch->sibling) is loop over all sections connect
 * directly to sec in order of increasing distance from connection end of sec.
 * there is no longer a Node->child pointer.
 * 
 * Revision 4.25  93/04/20  08:58:41  hines
 * rootsection no longer exists. section structure changed so
 * sec->parentnode is a Node*. sec->parentsec no longer changed but
 * kept the way user specified it. The function Section* nrn_trueparent(sec)
 * returns the section that used to be in parentsec after setup_topology()
 * was executed. no more inode_exact(Section** psec, double x)---has been
 * replaced by Node* node_exact(Section* sec, double x)
 * There is now a rootnode list. parentsec of a section which was not
 * connect'ed to anything has a parentsec of nil. One can now disconnect
 * and delete sections without otherwise changing user spec (except
 * point processes at ends may be moved or changed -- will be fixed later)
 * 
 * Revision 4.23  93/04/12  14:15:03  hines
 * first pass at merging Fisher's addition of LINDA
 * 
 * Revision 4.15  93/02/20  09:03:16  hines
 * aix
 * 
 * Revision 4.7  93/01/14  10:38:19  hines
 * Steve Fisher's contribution to RCS parameter dumps.
 * 
 * Revision 3.44  92/12/31  15:32:44  hines
 * modl_set_dt is here
 * 
 * Revision 3.43  92/12/16  14:24:32  hines
 * Ra switched from global variable to section variable in which it can
 * take on different values in different sections. Similar to L.
 * No need to set diam_changed when Ra changed.
 * 
 * Revision 3.35  92/10/27  12:09:49  hines
 * list.c list.h moved from nrnoc  to oc
 * 
 * Revision 3.34  92/10/27  09:26:44  hines
 * diam_changed can be set from hoc (to be used by xvalue of L an diam
 * 	that use pointers.)
 * steer for point processes always comes from steer_point_process and that
 * is how one can determine that an object is a point process.
 * need to have a better secname implementation that actually returns a
 * valid path
 * 
 * Revision 3.33  92/10/24  16:30:14  hines
 * freeing vars notifies interviews.
 * sec_and_position(sec, inode) returns string in form section(x)
 * some portability fixes from pittsburgh
 * 
 * Revision 3.26  92/10/10  12:34:47  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * 
 * Revision 3.22  92/10/09  07:46:37  hines
 * replace vector style point process syntax with objectvar style.
 * POINTER not yet implemented and old syntax not yet removed from parser.
 * usage:
 * objectvar s
 * s = PulseStim(.5)
 * s.del = 5
 * relocate with
 * s.loc(x)
 * x = s.getloc() pushes section on section stack and must be removed with
 * popsec()
 * 
 * Revision 3.13  92/09/27  17:43:11  hines
 * non vectorized model descriptions with _method3 fill thisnode.GC,EC
 * instead of d,rhs when models are channel densities.
 * HH doesn't work too well with G' and E' as first order differences so
 * now it is zeroed.
 * 
 * Revision 3.3  92/08/18  07:32:53  hines
 * arrays in different objects can have different sizes
 * 
 * Revision 2.86  92/08/13  11:20:41  hines
 * default parameters collected into membdef.h
 * 
 * Revision 2.85  92/08/12  16:19:34  hines
 * uninsert mechanism_name
 * do not uninsert an ion unless no other mechanism in the section uses the
 * ion. Invalid memory references will result.
 * 
 * Revision 2.84  92/08/12  11:57:43  hines
 * initnrn separated into hoc_last_init and initnrn. this last can be
 * called from hoc to reset built-in globals such as secondorder, celsius, etc.
 * 
 * Revision 2.75  92/08/07  16:11:57  hines
 * sections as objects. nsection and section gone. now list of sections
 * in nmodl list style in its place. vectorization no longer optional
 * probably many bugs at this point but all examples run correctly.
 * Need tests with complete code coverage.
 * 
 * Revision 2.71  92/08/05  09:27:02  hines
 * VECTORIZE, NTS_SPINE, EXTRAEQN merged from neuron
 * 
 * Revision 2.65  92/04/13  16:23:22  hines
 * Old HH and passive built-in models discarded in favor of hh and pas
 * models from .mod files. The hh variables now have _hh suffixes
 * and the passive variables are g_pas and e_pas.
 * stim.mod, syn.mod, and vclmp.mod have also been added.
 * ftim, fsyn, and fclamp are still present but are considered obsolete
 * and will be eventually phased out.
 * 
 * Revision 2.60  92/03/20  09:38:46  hines
 * finitialize()
 * 
 * Revision 2.50  92/02/05  08:48:09  hines
 * Can connect nmodl POINTER variables to external variables using:
 * connect var_suffix.section(x), anyvar for range variables or
 * connect var_suffix[i], anyvar for point process variables
 * This can be dangerous if the user fails to make these variables point to
 * something.
 * 
 * Revision 2.49  92/01/30  11:08:32  hines
 * verified with respect to all neuron/examples. Under control of imake.
 * ObjectCenter warning free. Some changes to match neuron.
 * 
 * Revision 2.48  91/11/05  11:22:33  hines
 * all neuron/examples produce same results with nrnoc as neuron
 * 
 * Revision 2.12  91/01/23  11:38:49  hines
 * was not calculating index into modl p_array in presence of
 * vector varibles
 * 
 * Revision 2.8  90/12/14  13:46:08  hines
 * point process works but current is /cm2
 * 
 * Revision 2.7  90/12/14  09:48:20  hines
 * First pass at handling point processes.
 * 
 * Revision 2.6  90/12/11  15:41:51  hines
 * range variables can be vectors
 * syntax is  range[index].section[index](expr: expr)
 * 
 * Revision 1.91  90/11/29  17:22:23  hines
 * secondorder replaces implicit
 * secondorder=0 means implicit with no adjustment of current
 * secondorder=1 means crank-nicolson with no adjustment of current
 * secondorder=2 means crank-nicolson with adjustment of current to t-dt/2
 * 
 * Revision 1.87  90/10/29  12:31:29  hines
 * main parameter list for a property is now a double vector. This makes
 * it easier to interface model descriptions using nmodl since only a pointer
 * change is needed to switch between segments.  cases such as ena, ina,
 * and section names are handled as vector of Datum as before but in
 * the dparam record.
 * 
 * Revision 1.85  90/10/25  06:58:42  hines
 * variables in neuron.h made extern so turbo-c would not complain.
 * 
 * Revision 1.84  90/10/24  10:56:41  hines
 * saber warnings gone
 * 
 * Revision 1.83  90/10/24  10:02:07  hines
 * forgot to check it in last time
 * 
 * Revision 1.79  90/10/10  08:50:30  hines
 * Oops. fix of warnings didn't make it to the files
 * 
 * Revision 1.75  90/08/06  17:23:22  hines
 * all intefacing of mechanisms with modl now comes from modl_reg();
 * 
 * Revision 1.74  90/08/02  08:56:18  hines
 * can use more than one mechanism.  Integrators that use ninits and reset
 * will not work, though.
 * 
 * Revision 1.72  90/07/31  10:47:39  hines
 * detailed info removed from cabvars. Only thing necessary is to
 * declare a registration function.
 * 
 * Revision 1.52  90/01/24  07:04:56  mlh
 * emalloc() and ecalloc() are macros which first return a null and then
 * do execerror if out of space.
 * 
 * Revision 1.47  90/01/12  06:48:14  mlh
 * celcius is spelled celsius
 * 
 * Revision 1.45  89/10/30  09:55:34  mlh
 * range variables have a subtype of CONST, DEPENDENT, or STATE
 * 
 * Revision 1.44  89/10/30  07:44:47  mlh
 * crank-nicolson available with implicit=0
 * 
 * Revision 1.30  89/09/06  10:26:03  mlh
 * newcable to neuron
 * 
 * Revision 1.29  89/09/06  09:21:50  mlh
 * newcable changed to neuron
 * 
 * Revision 1.26  89/08/31  14:49:08  mlh
 * name of mechanism out of memb_func and back in mechanism[].
 * memb_func[].sym now points to mechanism symbol.
 * This allows us to retrieve property names.
 * 
 * Revision 1.21  89/08/24  09:21:39  mlh
 * New channel additions localized to cabvars.h which in turn is
 * used only by init.c
 * 
 * Revision 1.20  89/08/13  08:53:50  mlh
 * banner flushed on entry
 * 
 * Revision 1.18  89/08/12  14:48:57  mlh
 * Lint free
 * 
 * Revision 1.16  89/08/12  09:52:23  mlh
 * hh added
 * 
 * Revision 1.14  89/08/10  16:22:34  mlh
 * clamp works at least with one level
 * 
 * Revision 1.13  89/08/10  11:07:41  mlh
 * var.sec syntax, no overloading of range, stack the open sections
 * 
 * Revision 1.12  89/08/09  11:30:23  mlh
 * banners on stderr
 * 
 * Revision 1.11  89/08/09  11:23:26  mlh
 * new banner
 * 
 * Revision 1.9  89/08/07  10:23:36  mlh
 * getting good v with single section. matrix solving for v (not deltav)
 * 
 * Revision 1.7  89/08/04  14:47:51  mlh
 * 2nd order correct in dx handled pretty well with nnode-1 segments
 * and last node being at the end of the section with 0 length.
 * Problem with connecting to position 0 since first node
 * not at beginning of section.
 * 
 * Revision 1.6  89/08/02  16:11:50  mlh
 * range variables implemented in open mechanism context
 * 
 * Revision 1.4  89/07/27  16:14:38  mlh
 * at point where topology() works
 * 
 * Revision 1.2  89/07/20  10:16:57  mlh
 * trivial at this point
 * 
*/
extern char *RCS_cableversion;
extern char *RCS_cabledate;
static char header[] =
"NEURON --";

static char distributed_version[] =
"Version 3.0";

static char banner[] =
"by John W. Moore, Duke University Medical Center\n\
and Michael Hines, Yale University -- Copyright 1994\n\
We would appreciate reprints of publications which make use of this program.";

#include "section.h"
#include "ytab.h"
#include "membfunc.h"
#include "cabvars.h"
#include "neuron.h"
#include "membdef.h"

# include	<stdio.h>

# define	CHECK(name)	if (hoc_lookup(name) != (Symbol *)0){\
		IGNORE(fprintf(stderr, CHKmes, name));\
		exit(1);}

static char	CHKmes[] = "%s cannot be a user defined name\n";

extern Symlist	*hoc_symlist;

int secondorder=0;
double t, dt, clamp_resist, celsius, htablemin, htablemax;
hoc_List* section_list;
int rootnodecount = 0;
hoc_List* rootsection_list;

#if FISHER
#include <stdlib.h>
#include "fisher.h"
double id_number;              /* for rcs control, set in setup_id_info() */
char login_name[20];           /* store user's login for sys.c & rcs.c    */
char *pipe_filter = "more";    /* allow for running NEURON in emacs       */
#endif

int nrn_is_cable() {return 1;}

hoc_last_init()
{
	int i;
	Pfri *m;
	Symbol *s;

 	if (!parallel_sub) { 
#if 0
	    Fprintf(stderr, "%s   %s   %s\n", header,
		    RCS_cableversion, RCS_cabledate);
#else
	    Fprintf(stderr, "%s  %s   %s\n", header,
		    distributed_version, RCS_cabledate);
#endif
	    Fprintf(stderr, "%s\n", banner);
	    IGNORE(fflush(stderr));
 	} 
#if FISHER
	/* get login_name from 'LOGNAME' */
	strcpy(login_name, getenv("LOGNAME"));
	
	if (getenv("CAT_PIPE")) {
	    pipe_filter = "cat";   /* preferred for emacs environment */
	} else {
	    pipe_filter = "more";  /* preferred for xterm environment */
	}
#endif

	section_list = hoc_l_newlist();
	rootsection_list = hoc_l_newlist();
	
	CHECK("v");
	s = hoc_install("v", RANGEVAR, 0.0, &hoc_symlist);
	s->u.rng.type = VINDEX;
	
	for (i = 0; usrprop[i].name; i++) {
		CHECK(usrprop[i].name);
		s = hoc_install(usrprop[i].name, UNDEF, 0.0, &hoc_symlist);
		s->type = VAR;
		s->subtype = USERPROPERTY;
		s->u.rng.type = usrprop[i].type;
		s->u.rng.index = usrprop[i].index;
	}
	SectionList_reg();
	SectionRef_reg();
#if VECTORIZE
	register_mech(morph_mech, morph_alloc, (Pfri)0, (Pfri)0, (Pfri)0, -1, 0);
#else
	register_mech(morph_mech, morph_alloc, (Pfri)0, (Pfri)0, (Pfri)0, -1);
#endif
	for (m = mechanism; *m; m++) {
		(*m)();
	}
	modl_reg();
}

initnrn() {
	secondorder = DEF_secondorder;	/* >0 means crank-nicolson. 2 means currents
				   adjusted to t+dt/2 */
	t = 0;		/* msec */
	dt = DEF_dt;	/* msec */
	clamp_resist = DEF_clamp_resist;	/*megohm*/
	celsius = DEF_celsius;	/* degrees celsius */
	ret(1.);
}

static int pointtype = 1; /* starts at 1 since 0 means not point in pnt_map*/
static int mech = 1;
Symbol *pointsym[NMECHMAX];
Point_process *point_process[NMECHMAX];
char pnt_map[NMECHMAX];		/* so prop_free can know its a point mech*/
int n_memb_func;
#if VECTORIZE
Memb_list memb_list[NMECHMAX];

register_mech(m, alloc, cur, stat, initialize, nrnpointerindex, vectorized)
#else
register_mech(m, alloc, cur, stat, initialize, nrnpointerindex)
#endif

	char **m;
	Pfri alloc;
	Pfri cur;
	Pfri stat;
	Pfri initialize;
	int nrnpointerindex; /* if -1 then there are none */
#if VECTORIZE
	int vectorized;
#endif
{
	static int type = 2;	/* 0 unused, 1 for cable section */
	int j, k, modltype, pindx, modltypemax;
	Symbol *s;
	char **m2;

	if (type >= NMECHMAX) {
		IGNORE(fprintf(stderr, "Too many mechanisms\n"));
		exit(1);
	}

	memb_func[type].current = cur;
	memb_func[type].alloc = alloc;
	memb_func[type].state = stat;
	memb_func[type].initialize = initialize;
#if VECTORIZE
	memb_list[type].vectorized = vectorized;
	memb_list[type].is_point = 0;
#endif

	CHECK(*m);
	s = hoc_install(*m, MECHANISM, 0.0, &hoc_symlist);
	s->subtype = type;
	memb_func[type].sym = s;
/*	printf("%s type=%d\n", s->name, type);*/
	m2 = m + 1;
	if (nrnpointerindex == -1) {
		modltypemax = STATE;
	} else {
		modltypemax = NRNPOINTER;
	}
	for (k=0, j=0, modltype=CONST; modltype<=modltypemax; modltype++, j++){
		/*EMPTY*/
		for (; m2[j]; j++, k++) {
			;
		}
	}
	s->s_varn = k;
	s->u.ppsym = (Symbol **) emalloc((unsigned)(j*sizeof(Symbol *)));
/* this is set up for the possiblility of overloading range variables.
We are currently not allowing this. Hence the #if.
If never overloaded then no reason for list of symbols for each mechanism.
*/
/* the indexing is confusing because k refers to index in the range indx list
and j refers to index in mechanism list which has 0 elements to separate
CONST, DEPENDENT, and STATE */
/* variable pointers added on at end, if they exist */
/* allowing range variable arrays. Must extract dimension info from name[%d]*/
/* pindx refers to index into the p-array */
	pindx = 0;
	for (j=0, k=0, modltype=CONST; modltype <= modltypemax; modltype++, j++) {
		for (; m2[j]; j++, k++) {
			Symbol *s2;
			char buf[200], *cp; int indx; unsigned nsub=0;
			strcpy(buf, m2[j]); /* not allowed to change constant string */
			indx = 1;
			cp = strchr(buf, '[');
			if (cp) {
				*cp = '\0';
				sscanf(cp+1, "%d", &indx);
				nsub = 1;
			}
			/*SUPPRESS 624*/
			if ((s2 = hoc_lookup(buf))) {
#if 0
				if (s2->subtype != RANGEVAR) {
					IGNORE(fprintf(stderr, CHKmes,
					buf));
				}
#else
IGNORE(fprintf(stderr, CHKmes, buf));
#endif
			}else{
			  s2 = hoc_install(buf, RANGEVAR, 0.0, &hoc_symlist);
				s2->subtype = modltype;
				s2->u.rng.type = type;
				s2->public = 1;
				if (modltype == NRNPOINTER) { /* not in p array */
					s2->u.rng.index = nrnpointerindex;
				} else {
					s2->u.rng.index = pindx;
				}
			  if (nsub) {
				s2->arayinfo = (Arrayinfo *) emalloc(
				  sizeof(Arrayinfo) + nsub * sizeof(int));
				s2->arayinfo->a_varn = (unsigned *)0;
				s2->arayinfo->refcount = 1;
				s2->arayinfo->nsub = nsub;
				s2->arayinfo->sub[0] = indx;
			  }
			  if (modltype == NRNPOINTER) {
				nrnpointerindex += indx;
			  }else {
				pindx += indx;
			  }
			}
			s->u.ppsym[k] = s2;
		}
	}
	++type;
	n_memb_func = type;
}

struct Member_func { char* _name; double (*_member)();};

int
#if VECTORIZE
point_register_mech(m, alloc, cur, stat, initialize, nrnpointerindex,
	constructor, destructor, fmember,
	vectorized
)
	char **m;
	Pfri alloc;
	Pfri cur;
	Pfri stat;
	Pfri initialize;
	int nrnpointerindex;
	int vectorized;

	void* (*constructor)();
	void (*destructor)();
	struct Member_func* fmember;
{
	extern void steer_point_process();
	Symlist* sl;
	Symbol* s, *s2;
	void class2oc();
	mech = 0;
	class2oc(m[0], constructor, destructor, fmember, (void*)0, (void*)0);
	s = hoc_lookup(m[0]);
	sl = hoc_symlist;
	hoc_symlist = s->u.template->symtable;
	s->u.template->steer = steer_point_process;
	register_mech(m, alloc, cur, stat, initialize, nrnpointerindex, vectorized);
	s2 = hoc_lookup(m[0]);
	pointsym[pointtype] = s2;
	s2->public = 0;
	hoc_symlist = sl;
	pnt_map[n_memb_func-1] = pointtype;
	memb_list[n_memb_func-1].is_point = 1;
	mech = 1;
	return pointtype++;
}
#else
point_register_mech(m, alloc, cur, stat, initialize, nrnpointerindex)
	char **m;
	Pfri alloc;
	Pfrd cur;
	Pfri stat;
	Pfri initialize;
	int nrnpointerindex;
{
	hoc_execerror("obsolete point registration\n", 0);
	mech = 0;
	register_mech(m, alloc, cur, stat, initialize, nrnpointerindex);
	mech = 1;
	return pointtype++;
}
#endif

/* some stuff from scopmath needed for built-in models */
 
#if 0
double*
makevector(nrows)
        int nrows;
{
        double* v;
        v = (double*)emalloc((unsigned)(nrows*sizeof(double)));
        return v;
}
#endif
  
int _ninits;
_modl_cleanup(){}

#if 1
_modl_set_dt(newdt) double newdt; {
	dt = newdt;
}
#endif	
