/* $Header: /timshel2g/src/master/nrn/src/nrnoc/membfunc.h,v 1.1.1.1 1994/10/12 17:22:31 hines Exp $ */
/*
$Log: membfunc.h,v $
 * Revision 1.1.1.1  1994/10/12  17:22:31  hines
 * NEURON 3.0 distribution
 *
 * Revision 4.79  1994/10/03  17:51:31  hines
 * more flexibility in relationship between reversal potential and concentrations. May also specify whether CONST, DEP, STATE
 * see ion_style
 *
 * Revision 4.77  1994/09/26  18:26:47  hines
 * ions more nearly do the "right thing"
 * presence of mechanism that WRITE's a concentration computes
 * the reversal potential every fadvance and finitialize, initializes
 * the concentrations to global variables, makes the concentrations have
 * the type STATE and the reversal potential the style DEP
 * presence of mech that READ's a concentration computes reversal
 * every finitialize, and treats concentration as CONST and reversal
 * potential style DEP.
 * If no mechanism reads or writes concentrations the reversal is
 * treated as CONST.
 *
 * Revision 4.36  1993/07/08  14:34:20  hines
 * a start on fixing the bug of electode point processes not working
 * correctly in presence of extracellular. At this time the functionality
 * is identical as before but passing node to  models in nrn_cur instead
 * of passing pointer to nd->d and returning rhs.
 * There is an alternative now to NONSPECIFIC_CURRENT which is
 * ELECTRODE_CURRENT
 *
 * Revision 3.13  92/09/27  17:45:09  hines
 * non vectorized model descriptions with _method3 fill thisnode.GC,EC
 * instead of d,rhs when models are channel densities.
 * HH doesn't work too well with G' and E' as first order differences so
 * now it is zeroed.
 * 
 * Revision 3.1  92/08/13  16:30:51  hines
 * merge sejnowski contributions of synapse and parameter dump. All files
 * present with sej_ prefix. invoke by defineing Sejnowski in Imakefile
 * Unfortunately much of the implementation needs to be changed to conform
 * to new section list. Problem is that much use was made of section indices.
 * 
 * Revision 2.71  92/08/05  09:27:04  hines
 * VECTORIZE, NTS_SPINE, EXTRAEQN merged from neuron
 * 
 * Revision 2.63  92/04/01  13:00:18  hines
 * increase mech array to 40
 * 
 * Revision 2.60  92/03/20  09:38:47  hines
 * finitialize()
 * 
 * Revision 2.55  92/03/10  09:26:35  hines
 * nrniv: automatic menus - mainmenu(), good start.
 * 
 * Revision 2.50  92/02/05  08:48:10  hines
 * Can connect nmodl POINTER variables to external variables using:
 * connect var_suffix.section(x), anyvar for range variables or
 * connect var_suffix[i], anyvar for point process variables
 * This can be dangerous if the user fails to make these variables point to
 * something.
 * 
 * Revision 1.87  90/10/29  12:31:30  hines
 * main parameter list for a property is now a double vector. This makes
 * it easier to interface model descriptions using nmodl since only a pointer
 * change is needed to switch between segments.  cases such as ena, ina,
 * and section names are handled as vector of Datum as before but in
 * the dparam record.
 * 
 * Revision 1.48  90/01/16  07:05:38  mlh
 * extracellular membrane type: tested up to single section
 * 
 * Revision 1.45  89/10/30  09:55:39  mlh
 * range variables have a subtype of CONST, DEPENDENT, or STATE
 * 
 * Revision 1.26  89/08/31  14:49:12  mlh
 * name of mechanism out of memb_func and back in mechanism[].
 * memb_func[].sym now points to mechanism symbol.
 * This allows us to retrieve property names.
 * 
 * Revision 1.22  89/08/29  11:07:42  mlh
 * move name of membrane to memb_func
 * 
 * Revision 1.21  89/08/24  09:21:44  mlh
 * New channel additions localized to cabvars.h which in turn is
 * used only by init.c
 * 
 * Revision 1.16  89/08/12  09:52:37  mlh
 * hh added
 * 
 * Revision 1.9  89/08/07  10:23:51  mlh
 * getting good v with single section. matrix solving for v (not deltav)
 * 
 * Revision 1.7  89/08/04  14:47:55  mlh
 * 2nd order correct in dx handled pretty well with nnode-1 segments
 * and last node being at the end of the section with 0 length.
 * Problem with connecting to position 0 since first node
 * not at beginning of section.
 * 
 * Revision 1.3  89/07/21  17:38:23  mlh
 * compiles
 * 
 * Revision 1.1  89/07/20  07:55:19  mlh
 * Initial revision
 * 
*/


typedef Datum *(*Pfrpdat)();

#define NULL_CUR (Pfri)0
#define NULL_ALLOC (Pfri)0
#define NULL_STATE (Pfri)0
#define NULL_INITIALIZE (Pfri)0

typedef struct Memb_func {
	Pfri	current;
	Pfri	alloc;
	Pfri	state;
	Pfri	initialize;
	Symbol	*sym;
} Memb_func;

#if VECTORIZE
typedef struct Memb_list {
	Node** nodelist;
	double** data;
	Datum** pdata;
	int nodecount;
	int vectorized;
	int is_point;
} Memb_list;
#endif

#if defined(__TURBOC__)
#define NMECHMAX 20
#else
#define NMECHMAX 40
#endif

#define VINDEX	-1
#define CABLESECTION	1
#define MORPHOLOGY	2
#define CAP	3
#if EXTRACELLULAR
#define EXTRACELL	5
#endif

#define CONST 1
#define DEP 2
#define STATE 3	/*See init.c and cabvars.h for order of CONST, DEP, and STATE */

extern Memb_func memb_func[];
extern int n_memb_func;
#if VECTORIZE
extern Memb_list memb_list[];
#endif
#define NRNPOINTER 4 /* added on to list of mechanism variables.These are
pointers which connect variables  from other mechanisms via the _ppval array.
*/

#define _AMBIGUOUS 5




