/* $Header: /timshel2g/src/master/nrn/src/nrnoc/passive0.c,v 1.1.1.1 1994/10/12 17:22:34 hines Exp $ */
/*
$Log: passive0.c,v $
 * Revision 1.1.1.1  1994/10/12  17:22:34  hines
 * NEURON 3.0 distribution
 *
 * Revision 4.77  1994/09/26  18:26:47  hines
 * ions more nearly do the "right thing"
 * presence of mechanism that WRITE's a concentration computes
 * the reversal potential every fadvance and finitialize, initializes
 * the concentrations to global variables, makes the concentrations have
 * the type STATE and the reversal potential the style DEP
 * presence of mech that READ's a concentration computes reversal
 * every finitialize, and treats concentration as CONST and reversal
 * potential style DEP.
 * If no mechanism reads or writes concentrations the reversal is
 * treated as CONST.
 *
 * Revision 4.38  1993/07/13  11:49:10  hines
 * declare all current functions properly (now Pfri instead of Pfrd)
 *
 * Revision 3.33  92/10/24  16:30:15  hines
 * freeing vars notifies interviews.
 * sec_and_position(sec, inode) returns string in form section(x)
 * some portability fixes from pittsburgh
 * 
 * Revision 3.20  92/10/08  08:19:36  hines
 * fast passive mechanism `p' changed to fastpas to avoid disallowing p
 * for other uses.
 * 
 * Revision 3.11  92/09/24  17:03:48  hines
 * METHOD3 option. use with spatial_method(i) with i=0-3
 * 0 is the default and is the normal neuron method with zero area nodes
 * at boundaries and branch points.
 * 1 is the standard method with half area nodes at boundaries
 * 2 is a modified second order method which weights by 2/12, 8/12, 2/12
 * 3 is a third order correct method which weights by 1/12 10/12 1/12
 * with the last three methods x = i/nnode with i=0 to nnode
 * methods 1 and 2 are at present quite inefficient since they use the
 * data structures of 3.
 * Works in steady state. not tested with dynamic simulations
 * At this time, discontinuities in parameters (except diameter) is
 * not handled well across nodes and all parameters are assumed to
 * be constant in interval between node and parent node.
 * Good deal of difficulty remains in managing values that change discontinuously
 * 
 * Revision 2.86  92/08/13  11:20:46  hines
 * default parameters collected into membdef.h
 * 
 * Revision 2.73  92/08/05  10:28:57  hines
 * got rid of objectcenter messages
 * 
 * Revision 2.71  92/08/05  09:27:12  hines
 * VECTORIZE, NTS_SPINE, EXTRAEQN merged from neuron
 * 
 * Revision 1.1  92/08/05  09:14:42  hines
 * Initial revision
 * 
*/

#include	"section.h"
#include	"membdef.h"
static char *mechanism[] = {
	"fastpas", "g_fastpas", "e_fastpas", 0,0,0
};
static pas_alloc(), pas_cur();
passive0_reg() {
#if VECTORIZE
	register_mech(mechanism, pas_alloc, pas_cur, (Pfri)0, (Pfri)0, -1, 1);
#else
	register_mech(mechanism, pas_alloc, pas_cur, (Pfri)0, (Pfri)0, -1);
#endif
}

#if VECTORIZE
static pas_cur(count, vnode, vdata, vpdata, type)
/*ARGSUSED*/
	int count, type;
	Node *vnode[];
	double *vdata[];
	Datum *vpdata[];
{
#define g vdata[i][0]
#define e vdata[i][1]
#define v vnode[i]->v

	int i;
#if METHOD3
   if (_method3) {
#if _CRAY
#pragma _CRI ivdep
#endif
	for (i=0; i < count; ++i) {
		vnode[i]->thisnode.GC += g;
		vnode[i]->thisnode.EC += g * e;
	}
   }else
#endif
   {
#if _CRAY
#pragma _CRI ivdep
#endif
	for (i=0; i < count; ++i) {
		vnode[i]->d += g;
		vnode[i]->rhs += g * e;
	}
   }
}

/* the rest can be constructed automattically from the above info*/

static pas_alloc(p)
	Prop *p;
{
	double *pd;
#define	nparm 2
	pd = (double *)emalloc(nparm * sizeof(double));
	p->param_size = nparm;
	pd[0] = DEF_g;
	pd[1] = DEF_e;
	p->param = pd;
}

#else

static double pas_cur(p, pd, v)
	Prop *p;
	double *pd;
	double v;
{
	double g, erev;

	g = p->param[0];
	erev = p->param[1];
			
	p->param[2] = g * (v - erev);

	*pd += g;
	return -g*erev;
}

/* the rest can be constructed automattically from the above info*/

static pas_alloc(p)
	Prop *p;
{
	double *pd;
#define	nparm 2
	pd = (double *)emalloc(nparm * sizeof(double));
	pd[0] = DEF_g;
	pd[1] = DEF_e;
	p->param = pd;
}
#endif
