#define HOC_L_LIST 1
#include "section.h"
#include "neuron.h"
#include "ytab.h"

extern char* secname();
extern Object** hoc_objpop();

/*ARGSUSED*/
static void* constructor(ho)Object* ho;
{
	List* sl;
	sl = newlist();	
	return (void*)sl;
}

static void destructor(v) void* v;
{
	Item* q;
	List* sl = (List*)v;
	ITERATE(q, sl) {
		section_unref(q->element.sec);
	}
	freelist(&sl);
}

static double append(v) void* v;
{
	Section* sec = chk_access();
	lappendsec((List*)v, sec);
	section_ref(sec);
	return 1.;
}

static double seclist_remove(v) void* v;
{
	Section* sec = chk_access();
	Item* q;
	List* sl = (List*)v;
	ITERATE(q, sl) {
		if (sec == q->element.sec) {
			delete(q);
			section_unref(sec);
			return 1.;
		}
	}
	hoc_warning(secname(sec), "not in this section list");
	return 0.;
}

static double printnames(v) void* v;
{
	char* secname();
	Item* q;
	List* sl = (List*)v;
	ITERATE(q, sl) {
		printf("%s\n", secname(q->element.sec));
	}
	return 1.;
}

static struct Member_func {char* name; double (*func)();} members[] = {
	"append", append,
	"remove", seclist_remove,
	"printnames", printnames,
	0,0
};

SectionList_reg() {
	void class2oc();
/*	printf("SectionList_reg\n");*/
	class2oc("SectionList", constructor, destructor, members, (void*)0, (void*)0);
}

#define relative(pc)	(pc + (pc)->i)
extern int hoc_returning;

static check(ob) Object* ob; {
	if (!ob) {
		hoc_execerror("nil object is not a SectionList", (char*)0);
	}
	if (ob->template->constructor != constructor) {
		hoc_execerror(ob->template->sym->name, " is not a SectionList");
	}
}

forall_sectionlist() {
	Inst* savepc = pc;
	Item* q, *q1;
	Section* sec;
	List* sl;
	Object* ob;
	
	ob = *hoc_objpop();
	check(ob);
	sl = (List*)(ob->u.this_pointer);
	for (q = sl->next; q != sl; q = q1) {
		q1 = q->next;
		sec = q->element.sec;
		if (!sec->prop) {
			delete(q);
			section_unref(sec);
			continue;
		}
		nrn_pushsec(sec);
		hoc_execute(relative(savepc));
		nrn_popsec();
		if (hoc_returning == 1 || hoc_returning == 4) {
			break;
		}else if (hoc_returning ==2) {
			hoc_returning = 0;
			break;
		}else{
			hoc_returning = 0;
		}
	}
	if (!hoc_returning) {
		pc = relative(savepc+1);
	}
}

hoc_ifseclist() {
	Inst *savepc = pc;
	Item* q;
	Section* sec = chk_access();
	List* sl;
	Object* ob;
	
	ob = *hoc_objpop();
	check(ob);
	sl = (List*)(ob->u.this_pointer);
	ITERATE(q, sl) {
		if (sec == q->element.sec) {
			hoc_execute(relative(savepc));
			if (!hoc_returning) {
				pc = relative(savepc+1);
			}
			return;
		}
	}
	if (!hoc_returning) {
		pc = relative(savepc+1);
	}
}

