/*
Section reference
Allows sections to be stored as variables and passed as arguments by
using an object as a label for a particular section.

Usage is:

objectvar s1, s2
soma s1 = new SectionRef()
print s1.sec.L	// prints length of soma
s2 = s1
s2.sec {psection()} // makes soma the currently accessed section for a statement

access s1.sec	// soma becomes the default section
*/

#include "section.h"
#include "ytab.h"

/*ARGSUSED*/
static void* cons(ho)Object* ho; {
	Section* sec = chk_access();
	section_ref(sec);
	return (void*)sec;
}

static void destruct(v) void* v; {
	section_unref((Section*)v);
}

static double dummy(v) void* v; {
	char* secname();
	printf("%s\n", secname((Section*)v));
	return 0.;
}

static struct Member_func {char* name; double (*func)();} members[] = {
	"sec", dummy,	/* will actually become a SECTIONREF below */
	0, 0
};

SectionRef_reg() {
	Symbol* s, *hoc_table_lookup();
	extern void class2oc();
	
	class2oc("SectionRef", cons, destruct, members, 0, 0);
	/* now make the sec variable an actual SECTIONREF */
	s = hoc_lookup("SectionRef");
	s = hoc_table_lookup("sec", s->u.template->symtable);
	s->type = SECTIONREF;
}
