/* $Header: /timshel2g/src/master/nrn/src/oc/code.c,v 1.6 1994/11/08 19:37:07 hines Exp $ */
/*
$Log: code.c,v $
 * Revision 1.6  1994/11/08  19:37:07  hines
 * command line editing works while in graphics mode with GRX and GO32
 *
 * Revision 1.5  1994/11/02  18:55:19  hines
 * can find hoc object name from a scene. constructor of built in classes
 * now gets the Object* argument of the hoc object. Also some porting mods
 * for GO32
 *
 * Revision 1.4  1994/10/28  15:17:51  hines
 * yet another common name defined in an include file. this time ALPHA
 *
 * Revision 1.3  1994/10/26  17:24:56  hines
 * access name changed to an explicit hoc_access and taken out of redef.h
 *
 * Revision 1.2  1994/10/14  19:06:13  hines
 * close to a release. verifies with oc,nrnoc,nmodl. Note there is a bug
 * when oc/parse.y translated by yacc
 *
 * Revision 1.1.1.1  1994/10/12  17:22:06  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.100  1994/06/21  12:36:04  hines
 * allow recursive calls to interpreter even in case of hoc_execerror.
 *
 * Revision 2.80  1994/04/06  17:14:24  hines
 * minor changes to structures to allow checkpointing in ivoc
 * basically no more codepfd
 *
 * Revision 2.66  1993/12/15  15:02:01  hines
 * SECTIONREF and allow ob connect ob()(0or1), expr
 *
 * Revision 2.62  1993/10/18  13:24:19  hines
 * A start on an audit system. see audit.c
 *
 * Revision 2.60  93/09/01  08:22:54  hines
 * some string assignment statements not popping stack so loops can eventually
 * give stack overflow
 * 
 * Revision 2.55  93/08/13  17:10:21  hines
 * fix bug where we did not allow multiple line statements entered
 * from console as direct command
 * 
 * Revision 2.48  93/05/25  14:02:05  hines
 * some functions that check on the arg type. eg hoc_is_object_arg(narg)
 * 
 * Revision 2.45  93/04/28  10:07:12  hines
 * when a new variable is created at the top level then hoc_top_level_data
 * is reallocated. (this can happen when xopen is called) however the
 * function call handlers save and restore a pointe to hoc_objectdata and
 * between save and restore the pointer may become invalid. This is
 * avoided with the idiom
 * Objectdata* obdsav = hoc_objectdata_save()
 * ...
 * hoc_objectdata = hoc_objectdata_restore(obdsav);
 * 
 * Revision 2.39  93/04/12  14:08:32  hines
 * first pass at merging Fisher's LINDA addition
 * 
 * Revision 2.35  93/03/11  07:37:23  hines
 * Nigel Goddards fix to div() so it works on a cray.
 * 
 * Revision 2.33  93/03/09  07:44:38  hines
 * hoc_call_func accepts BLTIN
 * 
 * Revision 2.32  93/03/05  15:56:29  hines
 * slider and can call a user interpreted function or procedure via
 * hoc_call_func(Symbol*, int narg) with args on stack in first arg order
 * 
 * Revision 2.31  93/03/05  08:42:12  hines
 * some slight performance improvements by avoidin hoc_lookup for objects
 * and use stack macros in code.c
 * 
 * Revision 2.19  93/02/02  10:34:22  hines
 * static functions declared before used
 * 
 * Revision 2.18  93/01/27  13:53:48  hines
 * get METHOD3 from options.h
 * 
 * Revision 2.11  93/01/14  13:02:42  hines
 * switch from Objectdata.pstr to Objectdata.ppstr so we can eventually have
 * arrays of strings and so ivoc's varlabel will work properly.
 * 
 * Revision 2.7  93/01/12  08:57:08  hines
 * to assign to a hoc string use
 * hoc_assign_str(char** cpp, char* buf)
 * Some minor modifications to allow use of some functions by File class
 * 
 * Revision 2.5  93/01/06  09:25:35  hines
 * cray c90 needs include <errno.h>   remove some codecenter warnings
 * 
 * Revision 1.42  92/12/22  16:53:18  hines
 * problem with new lines after public and external fixed.
 * public and external now can be anywhere in template but they had better
 * be before declarations (at least for external) and usage.
 * 
 * Revision 1.41  92/12/22  15:27:12  hines
 * a template can have an external statement followin the public
 * statement which is a comma separated list of functions or procedures
 * defined at the top level which can be executed within the object.
 * (the function is executed in a top level context).
 * public and external statements are optional
 * 
 * Revision 1.40  92/11/13  16:08:54  hines
 * parseexec gives execerror when incomplete parse
 * 
 * Revision 1.39  92/10/28  17:33:26  hines
 * *getarg() now checks to make sure it is returning a number
 * 
 * Revision 1.38  92/10/24  10:16:22  hines
 * noiv.c is place to put function stubs that only make sense with interviews
 * whenever any VAR is freed it should be done with hoc_free_val... which
 * will notify the interviews objects that hold pointers to variables.
 * 
 * Revision 1.37  92/10/23  14:06:06  hines
 * only complete statements can be parsed in hoc_oc for now
 * also resetting parser yystart on hoc-execerror
 * object_name(Object*) returns object name
 * 
 * Revision 1.36  92/10/21  14:51:48  hines
 * fixed several errors having to do with stack and frame overflows
 * under object.section { stmt} and calling hoc procedures with
 * object.proc()
 * 
 * Revision 1.35  92/10/14  14:34:28  hines
 * numarg() returns the number of arguments in a hoc procedure or function.
 * hoc_typestack returns the type of the Datum on the stack
 * hoc_argtype(i) returns the type of the ith arg.
 * 
 * Revision 1.34  92/10/14  10:10:19  hines
 * move oc specific stuff out of axis.c and into code2.c
 * new argument function hoc_pgetarg checks for double pointer on stack
 * and returns it.
 * hoc_val_pointer(string) returns a pointer to the variable resulting
 * from parsing the string.
 * 
 * Revision 1.33  92/10/10  12:30:11  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * Revision 1.32  92/10/07  13:49:43  hines
 * strings can be passed as args and read and set with $S1 = $S2
 * 
 * Revision 1.31  92/09/24  16:49:17  hines
 * METHOD3 for nrnoc. when _method3 != 0 then x = i/nnode from i=0 to nnode
 * 
 * Revision 1.30  92/08/25  12:28:25  hines
 * hoc_araystr(Symbol*, index, Objectdata*) returns a string expressing the
 * array part of a variable
 * hoc_total_array_data(Symbol*, Objectdata*) returns the total length of
 * the variable vector.
 * 
 * Revision 1.29  92/08/18  07:29:59  hines
 * arrays in different objects can have different sizes.
 * Now one uses araypt(symbol, SYMBOL) or araypt(symbol, OBJECTVAR) to
 * return index of an array variable.
 * 
 * Revision 1.28  92/08/17  12:47:42  hines
 * arrays in different objects can have different sizes. Now arayinfo
 * gets carried along in objectdata. arayinfo is reference counted.
 * 
 * Revision 1.27  92/08/17  07:30:22  hines
 * change from new(template) to new template(args)
 * strange problem with tests/test5.hoc with segmentation violation that
 * isn't seen with objectcenter and goes away when xopens have a path to the
 * file.
 * 
 * Revision 1.26  92/08/15  12:39:55  hines
 * can pass object variable as arg to oc functions and procedures. Within
 * the procedures the syntax is
 * $$1.ob.ob.var etc.
 * see test7.hoc for usage with array of strings
 * 
 * Revision 1.25  92/08/12  16:15:51  hines
 * uninsert mechanism_name
 * 
 * Revision 1.24  92/08/12  11:53:36  hines
 * hoc_fake_ret() allows calls to functions that do a ret(). These functions
 * can have no arguments and the caller must pop the stack and deal with
 * hoc_returning.
 * This was done so init... could be called both from hoc_spinit and from
 * hoc.
 * last function called by hoc_spinit in hocusr.c is hoc_last_init()
 * 
 * Revision 1.23  92/08/10  15:58:27  hines
 * lists of sections with seclistdef ,,,
 * append_seclist(seclist)
 * remove_seclist(seclist)
 * forsec seclist
 * ifsec seclist
 * 
 * 
 * Revision 1.22  92/08/08  12:40:37  hines
 * to get decent section names each object of a template has a unique index
 * a count of the objects is kept in the template and when the count is
 * 0 then the index restarts at 0.
 * print ob will show the style
 * 
 * Revision 1.21  92/08/07  16:12:53  hines
 * sections as objects. sections now live in nmodl style list
 * 
 * Revision 1.20  92/07/31  16:16:19  hines
 * float_epsilon used for logical comparisons, int(), indexing and short for
 * default value is 1e-11
 * Hopfully no one has to worry about roundoff for the loops to come out
 * right.
 * 
 * 
 * Revision 1.19  92/07/31  14:16:47  hines
 * better handling of errno as in hoc
 * 
 * Revision 1.18  92/07/31  13:48:12  hines
 * fix up forsec and ifsec so it works in object context
 * 
 * Revision 1.17  92/07/06  16:12:48  hines
 * good start with interfacing c++ objects so they are callable from oc
 * 
 * Revision 1.16  92/03/11  19:06:45  hines
 * proper passing of strings as arguments to built-in functions.
 * gargstr(i) and hoc_pgargstr(i)
 * 
 * Revision 1.15  92/03/06  15:51:55  hines
 * hoc_oc can be used while executing. uses rinitcode(). But a problem
 * exists when single tokens are parsed.
 * 
 * Revision 1.14  92/02/19  15:00:22  hines
 * preparing for sections within objects. syntax is
 * ob.section stmt    section.var
 * this causes about 36 extra shift/reduce conflicts
 * 
 * Revision 1.13  92/02/03  11:20:22  hines
 * rudimentary event driven version of oc. tested with the
 * interviews based simpleeditor.
 * 
 * Revision 1.12  92/01/30  11:05:08  hines
 * leave out an xflush in x.c so doesn't hang. error in cable part of code.c
 * found by codecenter. "if (a=b) instead of if(a == b)"
 * Imakefile invokes ObjectOrientedHoc
 * 
 * Revision 1.11  92/01/30  08:16:17  hines
 * bug fixes found in hoc incorporated. if()return, no else, objectcenter
 * warnings.
 * 
 * Revision 1.10  91/11/18  10:51:36  hines
 * xview menus. Doesn't work too well. ^C exits altogether.
 * 
 * Revision 1.9  91/11/13  07:56:28  hines
 * userdouble uses old style sym->u.pval
 * 
 * Revision 1.8  91/11/05  11:23:26  hines
 * all neuron/examples produce same results with nrnoc as with neuron.
 * Found quite a few bugs this way.
 * 
 * Revision 1.7  91/10/25  09:30:55  hines
 * object arrays. stack.hoc works. need to work on stop command and
 * necessity for braces around single statements in for loops.
 * 
 * Revision 1.6  91/10/24  16:20:38  hines
 * can call object functions and procedures. Object arrays not working yet.
 * object_id(obj) is used for tests.
 * STKDEBUG turned on in code.c in which every element also carries a type.
 * 
 * Revision 1.5  91/10/22  15:46:00  hines
 * objects and components. can assign, evaluate, and print.
 * No object arrays or function components yet.
 * At level of test3.hoc
 * 
 * Revision 1.4  91/10/18  14:40:32  hines
 * symbol tables now are type Symlist containing pointers to first and last
 * symbols.  New symbols get added onto the end.
 * 
 * Revision 1.3  91/10/17  14:59:14  hines
 * VAR, STRING now handled with pointer to value located in object data space
 * to allow future multiple objects. Ie symbol for var, string, objectvar
 * has offset into a pointer data space.
 * 
 * Revision 1.2  91/10/16  12:46:52  hines
 * symbol tables for the templates. Prototype not even executed.
 * need to come to grips with how to find data in the objects.
 * 
 * Revision 1.1  91/10/11  11:11:56  hines
 * Initial revision
 * 
 * Revision 4.43  91/10/01  11:33:01  hines
 * gather console input at one place in preparation for adding
 * emacs like command line editing. Hoc input now reads entire line.
 * 
 * Revision 4.42  91/09/16  16:32:11  hines
 * initcode call nrn_initcode under #if CABLE
 * 
 * Revision 4.40  91/08/22  17:01:26  hines
 * for distribution to work on RS6000
 * 
 * Revision 4.34  91/08/08  16:37:27  hines
 * saber lint free. Fixed problem when neuron uses s_varn for something
 * other than dependent variables by demanding that all depvar variables
 * have a 0 subtype (created by the user in the interpreter).
 * 
 * Revision 4.30  91/08/06  08:58:02  hines
 * when new variables are assigned a value for the first time a message
 * is printed to that effect.  scalar variables can be deleted using
 * 	delete varname
 * This change was donated by Jack Wathey
 * 
 * Revision 4.29  91/06/20  08:16:54  hines
 * print a,b,c,... prints newline after last arg.
 * 
 * Revision 4.26  91/05/09  10:38:57  hines
 * userfloat always present not just with NEMO
 * 
 * Revision 4.24  91/05/09  09:33:17  hines
 * minor mods to interface hoc to NEMO. USERFLOAT, NEMONODE, NEMOAREA
 * 
 * Revision 4.19  91/04/03  09:44:53  hines
 * DECstation 5000 increment pc++ AFTER the return from the function call.
 * 
 * Revision 4.17  91/03/18  10:40:35  hines
 * some builtin functions take address of varname. eg. regraph(&name)
 * regraph saves list of addresses for fast plotting
 * 
 * Revision 4.8  90/12/14  09:49:38  hines
 * first pass in code.c for hanling point processes.
 * 
 * Revision 3.108  90/10/24  09:44:00  hines
 * saber warnings gone
 * 
 * Revision 3.83  90/07/25  10:40:18  hines
 * almost lint free on sparc 1+ under sunos 4.1
 * 
 * Revision 3.29  89/10/19  06:55:40  mlh
 * printing directed through plprint(string) instead
 * of detailed routing at each place
 * 
 * Revision 3.20  89/08/15  08:28:50  mlh
 * compiles under turbo-c 1.5 -- some significant bugs found
 * 
 * Revision 3.19  89/08/12  14:35:57  mlh
 * so newcable can be lint free
 * 
 * Revision 3.16  89/08/10  11:09:13  mlh
 * integers allowed on stack
 * 
 * Revision 3.15  89/08/09  10:51:59  mlh
 * for (x) returns 0<=x<=1
 * 
 * Revision 3.12  89/07/27  16:15:53  mlh
 * at point in newcable where topology() works
 * 
 * Revision 3.7  89/07/13  08:21:05  mlh
 * stack functions involve specific types instead of Datum
 * 
 * Revision 3.4  89/07/12  10:26:17  mlh
 * Lint free
 * 
 * Revision 3.3  89/07/10  15:45:13  mlh
 * Lint pass1 is silent. Inst structure changed to union.
 * 
 * Revision 2.0  89/07/07  11:29:59  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:15:33  mlh
 * Initial revision
 * 
*/

/* version 7.1.1  12/8/88
   function return values should be printed to stdout, not the graphics device
   */
/* version 7.2.1 2-jan-89 short form of for statement */
/* version 7.2.1 21-apr-89 fix segmentation violation on call to undefined
   function
   */
#if defined(__GO32__) 
#include <go32.h>
#endif

#include <errno.h>
#include "hoc.h"
#include "ytab.h"
#include "equation.h"
#include "math.h"
#include <stdio.h>
#if CABLE
#include "options.h"
#endif

/*MUST use STKDEBUG. Not optional */
#define	STKDEBUG 1

# define	STACKCHK	if (stackp >= stack+NSTACK) \
					execerror("Stack too deep", (char *)0);
#if STKDEBUG
int tstkchk_actual(i, j) int i, j; {
	int k, l;
	char *s[2];
	if (i != j) {
		for (k =0, l=i; k<2; k++, l=j) {
			switch (l) {
			case NUMBER:
				s[k] = "(double)";
				break;
			case STRING:
				s[k] = "(char *)";
				break;
			case OBJECTVAR:
				s[k] = "(Object **)";
				break;
			case USERINT:
				s[k] = "(int)";
				break;
			case SYMBOL:
				s[k] = "(Symbol)";
				break;
			case VAR:
				s[k] = "(double *)";
				break;
			}
		}
		fprintf(stderr, "bad stack access: expecting %s; really %s\n", s[1], s[0]);
		execerror("interpreter stack type error", (char *)0);
	}
	return 0;
}
#endif

#define USEMACROS 1

#if USEMACROS
#define pushxm(d)	((stackp++)->val = (d));((stackp++)->i = NUMBER)
#define pushsm(d)	((stackp++)->sym = (d));((stackp++)->i = SYMBOL)
#define xpopm()		(tstkchk((--stackp)->i, NUMBER), (--stackp)->val)
#define spopm()		(tstkchk((--stackp)->i, SYMBOL), (--stackp)->sym)
#define nopopm()	(stackp -= 2)
#define tstkchk(i,j)	(((i)!=(j))?tstkchk_actual(i,j):0)
#else
#define pushxm(d) pushx(d)
#define pushsm(d) pushs(d)
#define xpopm() xpop()
#define spopm()	spop()
#define nopopm() nopop()
#define tstkchk(i,j) tstkchk_actual(i,j)
#endif

#define EPS hoc_epsilon
extern double EPS;

#define	NSTACK	1000
static Datum	*stack;	/* the stack */
static	Datum	*stackp;	/* next free spot on stack */

#define	NPROG	5000
Inst	*prog;	/* the machine */
Inst	*progp;		/* next free spot for code generation */
Inst	*pc;		/* program counter during execution */
Inst	*progbase; /* start of current subprogram */
Inst	*prog_parse_recover; /* start after parse error */
int	hoc_returning;	/* 1 if return stmt seen, 2 if break, 3 if continue */
			/* 4 if stop */
typedef struct Frame {	/* proc/func call stack frame */
	Symbol	*sp;	/* symbol table entry */
	Inst	*retpc;	/* where to resume after return */
	Datum	*argn;	/* n-th argument on stack */
	int	nargs;	/* number of arguments */
} Frame;
#define NFRAME	100
static Frame	*frame;
static Frame	*fp;		/* frame pointer */

extern Symlist *p_symlist;

hoc_init_space()	/* create space for stack and code */
{
	stackp = stack = (Datum *)emalloc(sizeof(Datum)*NSTACK);
	progp = progbase = prog = (Inst *)emalloc(sizeof(Inst)*NPROG);
	fp = frame = (Frame *)emalloc(sizeof(Frame)*NFRAME);
}

#define MAXINITFCNS 10
static int maxinitfcns;
static Pfri initfcns[MAXINITFCNS];

hoc_on_init_register(pf)
	Pfri pf;
{
	/* modules that may have to be cleaned up after an execerror */
	if (maxinitfcns < MAXINITFCNS) {
		initfcns[maxinitfcns++] = pf;
	}else{
		fprintf(stderr, "increase definition for MAXINITFCNS\n");
		exit(1);
	}
}

initcode()	/* initialize for code generation */
{
	int i;
	extern int hoc_errno_count;
	errno = 0;
	if (hoc_errno_count > 5) {
fprintf(stderr, "errno set %d times on last execution\n", hoc_errno_count);
	}
	hoc_errno_count = 0;
	prog_parse_recover = progbase = prog;
	progp = progbase;
	stackp = stack;
	fp = frame;
	free_list(&p_symlist);
	hoc_returning = 0;
	do_equation = 0;
	for (i=0; i < maxinitfcns; ++i) {
		(*initfcns[i])();
	}
#if CABLE
	nrn_initcode(); /* special requirements for NEURON */
#endif
}


static Frame *rframe;
static Datum *rstack;
static char *parsestr;

oc_save_code(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11)
	Inst*	*a1;
	Inst*	*a2;
	Datum*	*a3;
	Frame*	*a4;
	int	*a5;
	int	*a6;
	Inst*	*a7;
	Frame*	*a8;
	Datum*	*a9;
	Symlist* *a10;
	Inst*	*a11;
{
	*a1 = progbase;
	*a2 = progp;
	*a3 = stackp;
	*a4 = fp;
	*a5 = hoc_returning;
	*a6 = do_equation;
	*a7 = pc;
	*a8 = rframe;
	*a9 = rstack;
	*a10 = p_symlist;
	*a11 = prog_parse_recover;
}

oc_restore_code(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11)
	Inst*	*a1;
	Inst*	*a2;
	Datum*	*a3;
	Frame*	*a4;
	int	*a5;
	int	*a6;
	Inst*	*a7;
	Frame*	*a8;
	Datum*	*a9;
	Symlist* *a10;
	Inst*	*a11;
{
	progbase = *a1;
	progp = *a2;
	stackp = *a3;
	fp = *a4;
	hoc_returning = *a5;
	do_equation = *a6;
	pc = *a7;
	rframe = *a8;
	rstack = *a9;
	p_symlist = *a10;
	prog_parse_recover = *a11;
}

char *
hoc_strgets(cbuf, nc)	/* getc for a string, used by parser */
	char *cbuf;
	int nc;
{
	strncpy(cbuf, parsestr, nc);
	if (*parsestr == '\0') {
		return (char *)0;
	}else{
		return cbuf;
	}
}

static
rinitcode()	/* initialize for recursive code generation */
{
	extern int hoc_errno_count;
	errno = 0;
	hoc_errno_count = 0;
	prog_parse_recover = progbase;
	progp = progbase;
	stackp = rstack;
	fp = rframe;
	free_list(&p_symlist);
	if (hoc_returning != 4) {	/* if stop not seen */
		hoc_returning = 0;
	}
	do_equation = 0;
}

int hoc_ParseExec(yystart) int yystart; {
	/* can recursively parse and execute what is in cbuf.
	   may parse single tokens. called from hoc_oc(str).
	   All these parse and execute routines should be combined into
	   a single method robust method. The pipeflag method has become
	   encrusted with too many irrelevant mechanisms. There is no longer
	   anything sacred about the cbuf. The only requiremnent is to tell
	   the get line function where to get its string.
	 */
	int yret;
	
	extern int hoc_pipeflag, hoc_in_yyparse;
	Frame *sframe, *sfp;
	Inst *sprogbase, *sprogp, *spc, *sprog_parse_recover;
	Datum *sstackp, *sstack;
	Symlist *sp_symlist;

	if (yystart) {
		sframe=rframe;sfp=fp;
		sprogbase=progbase; sprogp=progp; spc=pc,
		sprog_parse_recover=prog_parse_recover;
		sstackp=stackp; sstack=rstack;
		sp_symlist=p_symlist;
		rframe = fp;
		rstack = stackp;
		progbase = progp;
		p_symlist = (Symlist *)0;
	}
	
	if (yystart) {
		rinitcode();
	}
	if (hoc_in_yyparse) {
		hoc_execerror("Cannot reenter parser.",
		"Maybe you were in the middle of a direct command.");
	}
	yret = yyparse();
	switch (yret) {
	case 1:
		execute(progbase);
		rinitcode();
		break;
	case 'e':
		hoc_edit();
		for (rinitcode(); hoc_yyparse(); rinitcode()) {
			execute(progbase);
		}
		break;
	case -3 :
		hoc_execerror("incomplete statement parse not allowed\n", (char*)0);
	default:
		break;
	}
	if (yystart) {
		rframe=sframe; fp=sfp;
		progbase=sprogbase; progp=sprogp; pc=spc;
		prog_parse_recover=sprog_parse_recover;
		stackp=sstackp; rstack=sstack; p_symlist=sp_symlist;
	}

	return yret;
}
	
int
hoc_xopen_run(sp, str) /*recursively parse and execute for xopen*/
	Symbol *sp;	/* if sp != 0 then parse string and save code */
	char *str;	/*  without executing. Note str must be a 'list'*/
{
	int n=0;
	extern int hoc_pipeflag;
	Frame *sframe=rframe, *sfp=fp;
	Inst *sprogbase=progbase, *sprogp=progp, *spc=pc,
		*sprog_parse_recover=prog_parse_recover;
	Datum *sstackp=stackp, *sstack=rstack;
	Symlist *sp_symlist=p_symlist;
	rframe = fp;
	rstack = stackp;
	progbase = progp;
	p_symlist = (Symlist *)0;
	
	if (sp == (Symbol *)0) {
		for (rinitcode(); hoc_yyparse(); rinitcode())
			execute(progbase);
	}else{ int savpipeflag;
		rinitcode();
		savpipeflag = hoc_pipeflag;
		hoc_pipeflag = 2;
		parsestr=str;
		if(!hoc_yyparse()) {
			execerror("Nothing to parse", (char *)0);
		}
		n = (int)(progp-progbase);
		hoc_pipeflag = savpipeflag;
		hoc_define(sp);
		rinitcode();
	}
	rframe=sframe; fp=sfp;
	progbase=sprogbase; progp=sprogp; pc=spc;
	prog_parse_recover=sprog_parse_recover;
	stackp=sstackp; rstack=sstack; p_symlist=sp_symlist;
	return n;
}

int
hoc_stack_type() {
#if STKDEBUG
	return stackp[-1].i;
#else
	return 0;
#endif
}

pushx(d)		/* push double onto stack */
	double d;
{
	STACKCHK
	(stackp++)->val = d;
#if STKDEBUG
	(stackp++)->i = NUMBER;
#endif
}

hoc_pushobj(d)		/* push pointer to object pointer onto stack */
	Object **d;
{
	STACKCHK
	(stackp++)->pobj = d;
#if STKDEBUG
	(stackp++)->i = OBJECTVAR;
#endif
}

#if 0	/* not used */
hoc_pushsecitm(d)		/* push pointer to item pointing to section */
	struct Item *d;
{
	STACKCHK
	(stackp++)->itm = d;
#if STKDEBUG
	(stackp++)->i = SECTION;
#endif
}
#endif

hoc_pushstr(d)		/* push pointer to string pointer onto stack */
	char **d;
{
	STACKCHK
	(stackp++)->pstr = d;
#if STKDEBUG
	(stackp++)->i = STRING;
#endif
}

hoc_push_string() {	/* code for pushing a symbols string */
	Symbol *s;
	s = (pc++)->sym;
	if (!s) {
		hoc_pushstr((char**) 0);
		return;
	}
	if (s->type == CSTRING) {
		hoc_pushstr(&(s->u.cstr));
	}else{
		hoc_pushstr(OPSTR(s));
	}
}

hoc_pushpx(d)		/* push double pointer onto stack */
	double *d;
{
	STACKCHK
	(stackp++)->pval = d;
#if STKDEBUG
	(stackp++)->i = VAR;
#endif
}

pushs(d)		/* push symbol pointer onto stack */
	Symbol * d;
{
	STACKCHK
	(stackp++)->sym = d;
#if STKDEBUG
	(stackp++)->i = SYMBOL;
#endif
}
pushi(d)		/* push integer onto stack */
	int d;
{
	STACKCHK
	(stackp++)->i = d;
#if STKDEBUG
	(stackp++)->i = USERINT;
#endif
}

int
hoc_stacktype() {
	if (stackp <= stack) {
		execerror("stack empty", (char*)0);
	}
	return (stackp - 1)->i;
}

int hoc_argtype(narg) /* type of nth arg */
	int narg;
{
	if (narg > fp->nargs)
		execerror(fp->sp->name, "not enough arguments");
	return(fp->argn[(narg - fp->nargs)*2 + 1].i);
}

int hoc_is_double_arg(narg) int narg; {
	return (hoc_argtype(narg) == NUMBER);
}

int hoc_is_pdouble_arg(narg) int narg; {
	return (hoc_argtype(narg) == VAR);
}

int hoc_is_str_arg(narg) int narg; {
	return (hoc_argtype(narg) == STRING);
}

int hoc_is_object_arg(narg) int narg; {
	return (hoc_argtype(narg) == OBJECTVAR);
}

Datum *
hoc_look_inside_stack(i, type) /* stack pointer at depth i; i=0 is top */
	int i;
	int type;
{
#if STKDEBUG
	tstkchk((stackp - 2*i - 1)->i, type);
	return stackp - 2*(i + 1);
#else
	return stackp - i - 1;
#endif
}

double
xpop()		/* pop double and return top elem from stack */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, NUMBER);
#endif
	return (--stackp)->val;
}

double *
hoc_pxpop()		/* pop double pointer and return top elem from stack */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, VAR);
#endif
	return (--stackp)->pval;
}

Symbol *
spop()		/* pop symbol pointer and return top elem from stack */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, SYMBOL);
#endif
	return (--stackp)->sym;
}

Object **
hoc_objpop()		/* pop pointer to object pointer and return top elem from stack */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, OBJECTVAR);
#endif
	return (--stackp)->pobj;
}

#if 0 	/* unused */
struct Item*
hoc_secitmpop()		/* pop pointer to item pointing to section */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, SECTION);
#endif
	return (--stackp)->itm;
}
#endif

char **
hoc_strpop()		/* pop pointer to string pointer and return top elem from stack */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, STRING);
#endif
	return (--stackp)->pstr;
}

int
ipop()		/* pop symbol pointer and return top elem from stack */
{
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
	tstkchk(stackp->i, USERINT);
#endif
	return (--stackp)->i;
}

nopop()	/* just pop the stack without returning anything */
{
	
	if (stackp <= stack)
		execerror("stack underflow", (char *) 0);
#if STKDEBUG
	--stackp;
#endif
	--stackp;
}

constpush()	/* push constant onto stack */
{
	pushxm(*((pc++)->sym)->u.pnum);
}

pushzero()	/* push zero onto stack */
{
	pushxm(0.);
}

varpush()	/* push variable onto stack */
{
	pushsm((pc++)->sym);
}

# define	relative(pc)	(pc + (pc)->i)

forcode()
{
	double d;
	Inst *savepc = pc;	/* loop body */

	execute(savepc+3);	/* condition */
	d = xpopm();
	while (d)
	{
		execute(relative(savepc));	/* body */
		if (hoc_returning == 1 || hoc_returning == 4)	/* return or stop */
			break;
		else if (hoc_returning == 2)	/* break */
		{
			hoc_returning = 0;
			break;
		}
		else				/* continue */
			hoc_returning = 0;
		if ((savepc+2)->i)   /* diff between while and for */
			execute(relative(savepc+2)); /* increment */
		execute(savepc+3);
		d = xpopm();
	}
	if (!hoc_returning)
		pc = relative(savepc+1);	/* next statement */
}

shortfor()
{
	Inst *savepc = pc;
	double begin, end, *pval;
	Symbol *sym;
	
	end = xpopm() + EPS;
	begin = xpopm();
	sym = spopm();

	switch (sym->type) {
	case UNDEF:
		hoc_execerror(sym->name, "undefined variable");
	case VAR:
if (!ISARRAY(sym)) {
		if (sym->subtype == USERINT) {
			execerror("integer iteration variable", sym->name);
		}else if (sym->subtype == USERDOUBLE) {
			pval = sym->u.pval;
		}else{
			pval = OPVAL(sym);
		}
		break;
} else {
		if (sym->subtype == USERINT)
			execerror("integer iteration variable", sym->name);
		else if (sym->subtype == USERDOUBLE)
			pval = sym->u.pval + araypt(sym, SYMBOL);
		else
			pval = OPVAL(sym) + araypt(sym, OBJECTVAR);
}
		break;
	case AUTO:
#if STKDEBUG
		pval = &(fp->argn[sym->u.u_auto*2].val);
#else
		pval = &(fp->argn[sym->u.u_auto].val);
#endif
		break;
	default:
		execerror("for loop non-variable", sym->name);
	}
	for (*pval = begin; *pval<=end; *pval += 1.) {
		execute(relative(savepc));
		if (hoc_returning == 1 || hoc_returning == 4) {
			break;
		}else if (hoc_returning == 2) {
			hoc_returning = 0;
			break;
		}else{
			hoc_returning = 0;
		}
	}
	if (!hoc_returning)
		pc =relative(savepc+1);
}

for_segment() {
	/* symbol on stack; statement pointed to by pc
	continuation pointed to by pc+1. template used is shortfor in code.c
	of hoc system.
	*/
	
#if CABLE
	int i, imax;
	Inst *savepc = pc;
	double *pval, dx;
	Symbol *sym;
#if METHOD3
	extern int _method3;
#endif
	
	sym = spopm();

	switch (sym->type) {
	case UNDEF:
		hoc_execerror(sym->name, "undefined variable");
	case VAR:
if (!ISARRAY(sym)) {
		if (sym->subtype == USERINT)
			execerror("integer iteration variable", sym->name);
		else if (sym->subtype == USERDOUBLE)
			pval = sym->u.pval;
		else
			pval = OPVAL(sym);
		break;
} else {
		if (sym->subtype == USERINT)
			execerror("integer iteration variable", sym->name);
		else if (sym->subtype == USERDOUBLE)
			pval = sym->u.pval + araypt(sym, SYMBOL);
		else
			pval = OPVAL(sym) + araypt(sym, OBJECTVAR);
}
		break;
	case AUTO:
#if STKDEBUG
		pval = &(fp->argn[sym->u.u_auto*2].val);
#else
		pval = &(fp->argn[sym->u.u_auto].val);
#endif
		break;
	default:
		execerror("for loop non-variable", sym->name);
	}
	imax = segment_limits(&dx);
#if METHOD3
   if (_method3) {
	for (i=0, *pval=0; i <= imax; i++) {
		if (i == imax) {
			*pval = 1.;
		} else {
			*pval = i * dx;
		}
		execute(relative(savepc));
		if (hoc_returning == 1 || hoc_returning == 4) {
			break;
		}else if (hoc_returning == 2) {
			hoc_returning = 0;
			break;
		}else{
			hoc_returning = 0;
		}
	}
   }else
#endif
   {
	for (i=0, *pval=0; i <= imax; i++) {
		if (i == imax) {
			*pval = 1.;
		}
		execute(relative(savepc));
		if (hoc_returning == 1 || hoc_returning == 4) {
			break;
		}else if (hoc_returning == 2) {
			hoc_returning = 0;
			break;
		}else{
			hoc_returning = 0;
		}
		if (i == 0) {
			*pval += dx/2.;
		}
		else if (i < imax) {
			*pval += dx;
		}
	}
   }
	if (!hoc_returning)
		pc =relative(savepc+1);
#else
	execerror("for (var) {stmt} syntax only allowed in CABLE", (char *)0);
#endif
}
	
ifcode()
{
	double d;
	Inst *savepc = pc;	/* then part */

	execute(savepc+3);	/* condition */
	d = xpopm();
	if (d)
		execute(relative(savepc));
	else if ((savepc+1)->i)	/* else part? */
		execute(relative(savepc+1));
	if (!hoc_returning)
		pc = relative(savepc+2);	/* next stmt */
}

Break()		/* break statement */
{
	hoc_returning = 2;
}

Continue()	/* continue statement */
{
	hoc_returning = 3;
}

Stop()		/* stop statement */
{
	hoc_returning = 4;
}

hoc_define(sp)	/* put func/proc in symbol table */
	Symbol *sp;
{
	Inst *inst, *newinst;

	if (sp->u.u_proc->defn.in != STOP)
		free((char *) sp->u.u_proc->defn.in);
	free_list(&(sp->u.u_proc->list));
	sp->u.u_proc->list = p_symlist;
	p_symlist = (Symlist *)0;
	sp->u.u_proc->size =(unsigned)(progp - progbase);
	sp->u.u_proc->defn.in = (Inst *) emalloc((unsigned)(progp-progbase)*sizeof(Inst));
	newinst = sp->u.u_proc->defn.in;
	for (inst = progbase; inst != progp; )
		*newinst++ = *inst++;
	progp = progbase;	/* next code starts here */
}

frame_debug()	/* print the call sequence on an execerror */
{
	Frame *f;
	int i, j;
	char* hoc_object_name();

	for (i=5, f=fp; f != frame && --i; f=f-1) { /* print only to depth of 5 */
		for (j=i; j; j--) {
			IGNORE(fputs("  ",stderr));
		}
		Fprintf(stderr, "%s(", f->sp->name);
		for (j=1; j<=f->nargs;) {
#if STKDEBUG
		   switch(f->argn[(j - f->nargs)*2 + 1].i) {
		   case NUMBER:
			Fprintf(stderr, "%g", f->argn[(j - f->nargs)*2].val);
			break;
		   case STRING:
		   	Fprintf(stderr, "\"%s\"", *f->argn[(j - f->nargs)*2].pstr);
			break;
		   case OBJECTVAR:
Fprintf(stderr, "%s", hoc_object_name(*f->argn[(j - f->nargs)*2].pobj));
			break;
		   default:
		   	Fprintf(stderr, "...");
		   	break;
		   }
#else
			Fprintf(stderr, "%g", f->argn[j - f->nargs].val);
#endif
			if (++j <= f->nargs) {
				IGNORE(fputs(", ", stderr));
			}
		}
		IGNORE(fputs(")\n", stderr));
	}
	if (i <= 0) {
		Fprintf(stderr, "and others\n");
	}
}

push_frame(sp, narg) /* helpful for explicit function calls */
	Symbol* sp;
	int narg;
{
	if (fp++ >= &frame[NFRAME-1]) {
		fp--;
		execerror(sp->name, "call nested too deeply");
	}
	fp->sp = sp;
	fp->nargs = narg;
#if STKDEBUG
	fp->argn = stackp - 2;	/* last argument */
#else
	fp->argn = stackp - 1;	/* last argument */
#endif
}

pop_frame() {
	int i;
	for (i = 0; i < fp->nargs; i++)
		nopopm();	/* pop arguments */
	--fp;
}

call()		/* call a function */
{
	Symbol *sp = pc[0].sym;	/* symbol table entry */
					/* for function */
	if (fp++ >= &frame[NFRAME-1]) {
		fp--;
		execerror(sp->name, "call nested too deeply");
	}
	fp->sp = sp;
	fp->nargs = pc[1].i;
	fp->retpc = pc + 2;
#if STKDEBUG
	/*SUPPRESS 26*/
	fp->argn = stackp - 2;	/* last argument */
#else
	fp->argn = stackp - 1;	/* last argument */
#endif
	if (sp->type == FUN_BLTIN) {
#if STKDEBUG
		stackp += sp->u.u_proc->nauto * 2;	/* Offset stack for auto space */
#else
		stackp += sp->u.u_proc->nauto;	/* Offset stack for auto space */
#endif
		STACKCHK
		(*(sp->u.u_proc->defn.pf))();
		if (hoc_errno_check()) {
			hoc_warning("errno set during call of", sp->name);
		}
	} else if ((sp->type == FUNCTION || sp->type == PROCEDURE)
		&& sp->u.u_proc->defn.in != STOP) {
#if STKDEBUG
		stackp += sp->u.u_proc->nauto * 2;	/* Offset stack for auto space */
#else
		stackp += sp->u.u_proc->nauto;	/* Offset stack for auto space */
#endif
		STACKCHK
		if (sp->public == 2) {
			extern Objectdata* hoc_objectdata, *hoc_top_level_data;
			extern Object* hoc_thisobject;
			extern Symlist* hoc_symlist, *hoc_top_level_symlist;

			Objectdata* odsav = hoc_objectdata_save();
			Object* obsav = hoc_thisobject;
			Symlist* slsav = hoc_symlist;

			hoc_objectdata = hoc_top_level_data;
			hoc_thisobject = 0;
			hoc_symlist = hoc_top_level_symlist;

			execute(sp->u.u_proc->defn.in);

			hoc_objectdata = hoc_objectdata_restore(odsav);
			hoc_thisobject = obsav;
			hoc_symlist = slsav;
		}else{
			execute(sp->u.u_proc->defn.in);
		}
	} else {
		execerror(sp->name, "undefined function");
	}
	if (hoc_returning != 4) {	/*if not stopping */
		hoc_returning = 0;
	}
}

hoc_fake_call(s) Symbol* s; {
	/*fake it so c code can call functions that ret() */
	/* but these functions better not ask for any arguments */
	/* don't forget a double is left on the stack and returning = 1 */
	/* use the symbol for the function as the argument, only requirement
	   which is always true is that it has no local variables pushed on
	   the stack so nauto=0 */
	++fp;
	fp->sp = s;
	fp->nargs = 0;
	fp->retpc = pc;
}

double hoc_call_func(s, narg)
	Symbol* s;
	int narg;
{
	/* call the symbol as a function, The args better be pushed on the stack
	first arg first. */
	if (s->type == BLTIN) {
		return (*(s->u.ptr))(xpop());
	}else{
		Inst* pcsav;
		Inst fc[4];
		fc[0].pf = hoc_call;
		fc[1].sym = s;
		fc[2].i = narg;
		fc[3].in = STOP;

		pcsav = hoc_pc;
		hoc_execute(fc);
		hoc_pc = pcsav;
		return hoc_xpop();
	}
}

ret()		/* common return from func or proc */
{
	int i;
#if STKDEBUG
	stackp -= fp->sp->u.u_proc->nauto * 2;	/* Pop off the autos */
#else
	stackp -= fp->sp->u.u_proc->nauto;	/* Pop off the autos */
#endif
	for (i = 0; i < fp->nargs; i++)
		nopopm();	/* pop arguments */
	pc = (Inst *)fp->retpc;
	--fp;
	hoc_returning = 1;
}

funcret()	/* return from a function */
{
	double d;
	if (fp->sp->type == PROCEDURE)
		execerror(fp->sp->name, "(proc) returns value");
	d = xpopm();	/* preserve function return value */
	ret();
	pushxm(d);
}

procret()	/* return from a procedure */
{
	if (fp->sp->type == FUNCTION)
		execerror(fp->sp->name,
			"(func) returns no value");
	ret();
	pushxm(0.);	/*will be popped immediately; necessary because caller
					may have compiled it as a function*/
}

hoc_Numarg()
{
	int narg;
	Frame* f = fp - 1;
	if (f == frame) {
		narg = 0;
	}else{
		narg = f->nargs;
	}
	ret();
	pushxm((double)narg);
}

int
ifarg(narg)	/* true if there is an nth argument */
	int narg;
{
	if (narg > fp->nargs)
		return 0;
	return 1;
}

Object **
hoc_objgetarg(narg)	/* return pointer to nth argument */
	int narg;
{
	if (narg > fp->nargs)
		execerror(fp->sp->name, "not enough arguments");
#if STKDEBUG
	tstkchk(fp->argn[(narg - fp->nargs)*2 + 1].i, OBJECTVAR);
	return fp->argn[(narg - fp->nargs)*2].pobj;
#else
	return fp->argn[narg - fp->nargs].pobj;
#endif
}

char **
hoc_pgargstr(narg)	/* return pointer to nth argument */
	int narg;
{
	char ** cpp;
	Symbol *sym;
	int type;
	if (narg > fp->nargs)
		execerror(fp->sp->name, "not enough arguments");
#if STKDEBUG
	type = fp->argn[(narg - fp->nargs)*2 + 1].i;
   if (type == STRING) {
	cpp = fp->argn[(narg - fp->nargs)*2].pstr;
   }else if (type != SYMBOL) {
	execerror("Expecting string argument", (char *)0);
   }else{
	sym = fp->argn[(narg - fp->nargs)*2].sym;
#else
   {
	sym =  fp->argn[narg - fp->nargs].sym;
#endif
	if (sym->type == CSTRING) {
		cpp = &sym->u.cstr;
	}else if (sym->type == STRING) {
		cpp = OPSTR(sym);
	}else{
		execerror("Expecting string argument", (char *)0);
	}
   }
	return cpp;
}

double* 
hoc_pgetarg(narg)	/* return pointer to nth argument */
	int narg;
{
	if (narg > fp->nargs)
		execerror(fp->sp->name, "not enough arguments");
#if STKDEBUG
	tstkchk(fp->argn[(narg - fp->nargs)*2 + 1].i, VAR);
	return fp->argn[(narg - fp->nargs)*2].pval;
#else
	return fp->argn[narg - fp->nargs].pval;
#endif
}

double *
getarg(narg)	/* return pointer to nth argument */
	int narg;
{
	if (narg > fp->nargs)
		execerror(fp->sp->name, "not enough arguments");
#if STKDEBUG
#if 1
	tstkchk(fp->argn[(narg - fp->nargs)*2 + 1].i, NUMBER);
#endif
	return &fp->argn[(narg - fp->nargs)*2].val;
#else
	return &fp->argn[narg - fp->nargs].val;
#endif
}

arg()	/* push argument onto stack */
{
	pushxm( *getarg((pc++)->i));
}

hoc_stringarg() /* push string arg onto stack */
{
	hoc_pushstr(hoc_pgargstr((pc++)->i));
}

argassign()	/* store top of stack in argument */
{
	double d;
	d = xpopm();
	pushxm(d);	/* leave value on stack */
	*getarg((pc++)->i) = d;
}

bltin()		/* evaluate built-in on top of stack */
{
	double d;
	d = xpopm();
	d = (*((pc++)->sym->u.ptr))(d);
	pushxm(d);
}

eval()			/* evaluate variable on stack */
{
	double d, cable_prop_eval();
	Symbol *sym;
	sym = spopm();
	switch (sym->type)
	{
	case UNDEF:
		execerror("undefined variable", sym->name);
	case VAR:
if (!ISARRAY(sym)) {
		if (do_equation && sym->s_varn > 0
		&& hoc_access[sym->s_varn] == 0)
		{
			hoc_access[sym->s_varn] = var_access;
			var_access = sym->s_varn;
		}
		switch (sym->subtype) {
		case USERDOUBLE:
			d = *(sym->u.pval);
			break;
		case USERINT:
			d = (double)(*(sym->u.pvalint));
			break;
#if	CABLE
		case USERPROPERTY:
			d = cable_prop_eval(sym);
			break;
#endif
		case USERFLOAT:
			d = (double)(*(sym->u.pvalfloat));
			break;
		default:
			d = *(OPVAL(sym));
			break;
		}
}else {
		switch (sym->subtype) {
		case USERDOUBLE:
			d = (sym->u.pval)[araypt(sym, SYMBOL)];
			break;
		case USERINT:
			d = (sym->u.pvalint)[araypt(sym, SYMBOL)];
			break;
		case USERFLOAT:
			d = (sym->u.pvalfloat)[araypt(sym, SYMBOL)];
			break;
#if NEMO
		case NEMONODE:
			hoc_eval_nemonode(sym, xpopm(), &d);
			break;
		case NEMOAREA:
			hoc_eval_nemoarea(sym, xpopm(), &d);
			break;
#endif /*NEMO*/
		default:
			d = (OPVAL(sym))[araypt(sym, OBJECTVAR)];
			break;
		}
}
		break;
	case AUTO:
#if STKDEBUG
		d = fp->argn[sym->u.u_auto*2].val;
#else
		d = fp->argn[sym->u.u_auto].val;
#endif
		break;
	default:
		execerror("attempt to evaluate a non-variable", sym->name);
	}
	pushxm(d);
}

hoc_evalpointer()			/* leave pointer to variable on stack */
{
	double *d, *cable_prop_eval_pointer();
	Symbol *sym;
	sym = spopm();
	switch (sym->type)
	{
	case UNDEF:
		execerror("undefined variable", sym->name);
	case VAR:
if (!ISARRAY(sym)) {
		switch (sym->subtype) {
		case USERDOUBLE:
			d = sym->u.pval;
			break;
		case USERINT:
		case USERFLOAT:
			execerror("can use pointer only to doubles", sym->name);
			break;
#if	CABLE
		case USERPROPERTY:
			d = cable_prop_eval_pointer(sym);
			break;
#endif
		default:
			d = OPVAL(sym);
			break;
		}
}else {
		switch (sym->subtype) {
		case USERDOUBLE:
			d = sym->u.pval + araypt(sym, SYMBOL);
			break;
		case USERINT:
		case USERFLOAT:
#if NEMO
		case NEMONODE:
		case NEMOAREA:
#endif /*NEMO*/
			execerror("can use pointer only to doubles", sym->name);
			break;
		default:
			d = OPVAL(sym) + araypt(sym, OBJECTVAR);
			break;
		}
}
		break;
	case AUTO:
		execerror("can't use pointer to local variable", sym->name);
		break;
	default:
		execerror("attempt to evaluate pointer to a non-variable", sym->name);
	}
	hoc_pushpx(d);
}

add()		/* add top two elems on stack */
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 += d2;
	pushxm(d1);
}

sub()		/* subtract top two elems on stack */
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 -= d2;
	pushxm(d1);
}

mul()		/* multiply top two elems on stack */
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 *= d2;
	pushxm(d1);
}

#if _CRAY
/*
  try to do integer division, so that if x is an exact multiple of y
  then we really get an integer as the result.
  Algorithm: find n such that tx = x * 10^n and ty = y * 10^n are both
  integral.  If tx/ty leaves no remainder, then tx/ty is the correct
  answer and is stored in iptr, intdiv returns true.  Otherwise a
  floating point division can be done, intdiv returns false.
*/   
extern double fabs(double x);

static int intdiv(x, y, iptr)
     double x, y;
     int * iptr;
{
  long ix, iy, iz;
  int done = 0;
  while (!done)
    {
      if (fabs(x) > (1<<62) || fabs(y) > (1<<62))
      return 0;               /* out of range of integers */
      if (x == (long) x && y == (long) y)
      done = 1;
      else
      {
        x *= (long double) 10;
        y *= (long double) 10;
      }
    }
  ix = (long) x;
  iy = (long) y;
  iz = ix/iy;
  if (ix == iz*iy)
    {                         /* no remainder */
      *iptr = (int) iz;
      return 1;
    }
  return 0;
}
#endif

hoc_div()		/* divide top two elems on stack */
{
	double d1, d2;
	d2 = xpopm();
	if (d2 == 0.0)
		execerror("division by zero", (char *) 0);
	d1 = xpopm();
#if _CRAY
      {
        int i;
        if (intdiv(d1, d2, &i))
          d1 = (int) i;       /* result is an integer */
        else
          d1 = d1/d2;         /* result is not an integer */
      }
#else
      d1 /= d2;
#endif
	pushxm(d1);
}

hoc_cyclic()	/* the modulus function */
{
	double d1, d2;
	double r, q;
	d2 = xpopm();
	if (d2 <= 0.)
		execerror("a%b, b<=0", (char *) 0);
	d1 = xpopm();
	r = d1;
	if ( r >= d2) {
		q = floor(d1/d2);
		r = d1 - q*d2;
	}
	else if ( r <= -d2) {
		q = floor(-d1/d2);
		r = d1 + q*d2;
	}
	if (r > d2) {
		r = r - d2;
	}
	if (r < 0.) {
		r = r + d2;
	}

	pushxm(r);
}

negate()		/* negate top element on stack */
{
	double d;
	d = xpopm();
	pushxm(-d);
}

gt()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 > d2 + EPS);
	pushxm(d1);
}

lt()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 < d2 - EPS);
	pushxm(d1);
}

ge()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 >= d2 - EPS);
	pushxm(d1);
}

le()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 <= d2 + EPS);
	pushxm(d1);
}

eq()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 <= d2 + EPS && d1 >= d2 - EPS);
	pushxm(d1);
}

ne()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 < d2 - EPS || d1 > d2 + EPS);
	pushxm(d1);
}

and()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 != 0.0 && d2 != 0.0);
	pushxm(d1);
}

or()
{
	double d1, d2;
	d2 = xpopm();
	d1 = xpopm();
	d1 = (double)(d1 != 0.0 || d2 != 0.0);
	pushxm(d1);
}

not()
{
	double d;
	d = xpopm();
	d = (double)(d == 0.0);
	pushxm(d);
}

power()			/* arg1 raised to arg2 */
{
	double d1, d2;
	extern double Pow();
	d2 = xpopm();
	d1 = xpopm();
	d1 = Pow(d1, d2);
	pushxm(d1);
}

assign()	/* assign result of execute to top symbol */
{
	Symbol *sym;
	double d2;
	sym = spopm();
	d2 = xpopm();
	switch (sym->type)
	{
	case UNDEF:
		hoc_execerror(sym->name, "undefined variable");
	case VAR:
if(!ISARRAY(sym)) {
		switch (sym->subtype) {
		case USERDOUBLE:
			*(sym->u.pval) = d2;
			break;
		case USERINT:
			*(sym->u.pvalint) = (int)(d2 + EPS);
			break;
#if	CABLE
		case USERPROPERTY:
			cable_prop_assign(sym, d2);
			break;
#endif
		case USERFLOAT:
			*(sym->u.pvalfloat) = (float)(d2);
			break;
		default:
			*(OPVAL(sym)) = d2;
			break;
		}
}else {
		switch (sym->subtype) {
		case USERDOUBLE:
			(sym->u.pval)[araypt(sym, SYMBOL)] = d2;
			break;
		case USERINT:
			(sym->u.pvalint)[araypt(sym, SYMBOL)] = (int)(d2 + EPS);
			break;
		case USERFLOAT:
			(sym->u.pvalfloat)[araypt(sym, SYMBOL)] = (float)d2;
			break;
#if NEMO
		case NEMONODE:
			hoc_asgn_nemonode(sym, xpopm(), d2);
			break;
		case NEMOAREA:
			hoc_asgn_nemoarea(sym, xpopm(), d2);
			break;
#endif /*NEMO*/
		default:
			(OPVAL(sym))[araypt(sym, OBJECTVAR)] = d2;
			break;
		}
}
		break;
	case AUTO:
#if STKDEBUG
		fp->argn[sym->u.u_auto*2].val = d2;
#else
		fp->argn[sym->u.u_auto].val = d2;
#endif
		break;
	default:
		execerror("assignment to non-variable", sym->name);
	}
	pushxm(d2);
}

hoc_assign_str(cpp, buf)
	char** cpp, *buf;
{
	char* s = *cpp;
	*cpp = (char *)emalloc((unsigned)(strlen(buf) + 1));
	Strcpy(*cpp, buf);
	if (s) {
		hoc_free_string(s);
	}
}

int
assstr()	/* assign string on top to stack - 1 */
{
	char **ps1, **ps2;

	ps1 = hoc_strpop();
	ps2 = hoc_strpop();
	hoc_assign_str(ps2, *ps1);
}

char *
hoc_araystr(sym, index, obd) /* returns array string for multiple dimensions */
	Symbol *sym;
	int index;
	Objectdata* obd;
{
	static char name[100];
	char *cp = &name[100];
	char buf[10];
	int i, n, j;

	*--cp = '\0';
	if (ISARRAY(sym)) {
		Arrayinfo* a;
		if (sym->subtype == 0) {
			a = obd[sym->u.oboff + 1].arayinfo;
		}else{
			a = sym->arayinfo;
		}
		for (i = a->nsub - 1; i >= 0; --i) {
			n = a->sub[i];
			j = index%n;
			index /= n;
			*--cp = ']';
			Sprintf(buf, "%d", j);
			for (j = strlen(buf)-1; j >=0; --j) {
				*--cp = buf[j];
			}
			*--cp = '[';
		}
	}
	return cp;
}

int
hoc_array_index(sp, od)  /* subs must be in reverse order on stack */
	Symbol* sp;
	Objectdata* od;
{
	int i;
	if (ISARRAY(sp)) {
		if (sp->subtype == 0) {
			Objectdata* sav = hoc_objectdata;
			hoc_objectdata = od;
			i = araypt(sp, OBJECTVAR);
			hoc_objectdata = sav;
		}else{
			i = araypt(sp, 0);
		}
	}else{
		i= 0;
	}
	return i;
}

int
araypt(sp, type)	/* return subscript - subs in reverse order on stack */
	Symbol *sp;
	int type;
{
	int i, total, varn;
	int d;
	register Arrayinfo *aray;
	if (type == OBJECTVAR) {
		aray = OPARINFO(sp);
	}else{
		aray = sp->arayinfo;
	}

	total = 0;
	for (i = 0; i < aray->nsub; i++)
	{
#if STKDEBUG
		tstkchk((stackp - 2*(aray->nsub - i) + 1)->i, NUMBER);
		d = (int)((stackp - 2*(aray->nsub - i))->val + EPS);
#else
		d = (int)((stackp - aray->nsub + i)->val + EPS);
#endif
		if (d < 0 || d >= aray->sub[i])
			execerror("subscript out of range", sp->name);
		total = total * (aray->sub[i]) + d;
	}
	for (i = 0; i< aray->nsub; i++)
		nopopm();
	if (do_equation && sp->s_varn != 0
	&& (varn = (aray->a_varn)[total]) != 0 && hoc_access[varn] == 0)
	{
		hoc_access[varn] = var_access;
		var_access = varn;
	}
	return total;
}

/* obsolete */
#if CABLE && 0
int
nrnpnt_araypt(sp, pi)
	Symbol *sp;
	int *pi;
{
	int i, total;
	int d;
	register Arrayinfo *aray = sp->arayinfo;
	/* the difference is that the first index is for a neuron point
	   process vector, and the remaining incices are normal vector indices.
	   the return value is the parameter index and the first
	   index is returned in pi. return is 0 if not a vector or if element 0.
	*/
	total = 0;
	for (i = 0; i < aray->nsub; i++)
	{
#if STKDEBUG
		tstkchk((stackp - 2*(aray->nsub - i) + 1)->i, NUMBER);
		d = (int)((stackp - 2*(aray->nsub - i))->val + EPS);
#else
		d = (int)((stackp - aray->nsub + i)->val + EPS);
#endif
		if (d < 0 || d >= aray->sub[i])
			execerror("subscript out of range", sp->name);
		total = total * (aray->sub[i]) + d;
		if (i == 0) {
			*pi = total;
			total = 0;
		}
	}
	for (i = 0; i< aray->nsub; i++)
		nopopm();
	return total;
}
#endif

print()		/* pop top value from stack, print it */
{
#if defined(__GO32__)
	extern int egagrph;
#endif
	double d;
	d = xpop();
#if defined(__GO32__)
	if (egagrph) {
		char buf[50];
		sprintf(buf, "\t%.8g\n", d);
		grx_output_some_chars(buf, strlen(buf));
	}else
#endif
	{
	NOT_PARALLEL_SUB(Fprintf(stdout, "\t%.8g\n", d);)
	}
}

prexpr()	/* print numeric value */
{
	char s[256], *hoc_object_name();
#if CABLE
	char* secaccessname();
#endif
	Object *ob;
	
	switch (hoc_oop_type()) {
	case NUMBER:
		Sprintf(s, "%.8g ", xpopm());
		break;
	case STRING:
		Sprintf(s, "%s ",*(hoc_strpop()));
		break;
	case OBJECTVAR:		
		ob = *(hoc_objpop());
		Sprintf(s, hoc_object_name(ob));
		break;
#if CABLE
	case SECTION:
		Sprintf(s, secaccessname());
		break;
#endif
	default:
		hoc_execerror("Don't know how to print this type\n", 0);
	}
	plprint(s);

}

prstr()		/* print string value */
{
	char s[512], **cpp;
	cpp = hoc_strpop();
	Sprintf(s, "%s", *cpp);
	plprint(s);
}

/*-----------------------------------------------------------------*/
hoc_delete_symbol()
                 /* Added 15-JUN-90 by JCW.  This routine deletes a
                 "defined-on-the-fly" variable from the symbol
                 list. */
{
#if 0
                                       /*---- extern variables ----*/
    extern Symlist * symlist;
                                       /*---- local variables -----*/
    Symbol * doomed,
           * sp;
                                       /*---- start function ------*/

                /* copy address of the symbol that will be deleted */
    doomed = (pc++)->sym;

#endif
	hoc_execerror("delete_symbol doesn't work right now.", (char *)0);
#if 0
    if (doomed->type == UNDEF)
        fprintf(stderr, "%s: no such variable\n", doomed->name);
    else if (doomed->defined_on_the_fly == 0)
        fprintf(stderr, "%s: can't be deleted\n", doomed->name);
    else {
                                    /* find its place in the list */
	sp = (Symbol *)0;
	if (symlist) for (sp = symlist->first;

             sp
             &&
             sp != doomed
             &&
             sp->next != doomed;

	     sp=sp->next)
		/*EMPTY*/
		;
        if (!sp) {
            fprintf(stderr,
            "hoc: delete: can't find symbol in symlist\n");
            return;
        }
        else if (sp == doomed) {        /* doomed is first in list */
            symlist->first = doomed->next;
        }
        else {    /* sp points to Symbol just before doomed Symbol */
            sp->next = doomed->next;
        }
                                                /* kill the Symbol */
        free(doomed->name);
        hoc_free_val(OPVAL(doomed));
        free(doomed);
    }
#endif
}
/*----------------------------------------------------------*/

hoc_newline()		/* print newline */
{
	plprint("\n");
}

varread()	/* read into variable */
{
	double d;
	extern FILE *fin;
	Symbol *var = (pc++)->sym;

	if (! ((var->type == VAR || var->type == UNDEF) && !ISARRAY(var)
	       && var->subtype == NOTUSER
	      )
	   ) {
		execerror(var->name, "is not a scalar variable");
	}
  Again:
	switch (fscanf(fin, "%lf", OPVAL(var)))
	{
	case EOF:
		if (moreinput())
			goto Again;
		d = *(OPVAL(var)) = 0.0;
		break;
	case 0:
		execerror("non-number read into", var->name);
		break;
	default:
		d = 1.0;
		break;
	}
	var->type = VAR;
	pushxm(d);
}

extern int zzdebug;

static Inst *
codechk() {
	if (progp >= prog+NPROG-1)
		execerror("procedure too big", (char *) 0);
	if (zzdebug)
		debugzz(progp);
	return progp++;
}

Inst *
Code(f)		/* install one instruction or operand */
	Pfri f;
{
	progp->pf = f;
	return codechk();
}

codei(f)
	int f;
{
	progp->i = f;
	IGNORE(codechk());
}

codesym(f)
	Symbol *f;
{
	progp->sym = f;
	IGNORE(codechk());
}

codein(f)
	Inst *f;
{
	progp->in = f;
	IGNORE(codechk());
}

insertcode(begin, end, f)
	Inst *begin, *end;
	Pfri f;
{
	Inst *i;
	for (i = end - 1; i != begin; i--) {
		*i = *(i - 1);
	}
	begin->pf = f;

	if(zzdebug) {
		Inst* p;
		printf("insert code: what follows is the entire code so far\n");
		for (p = prog; p < progp; ++p) {
			debugzz(p);
		}
		printf("end of insert code debugging\n");
	}
}

#if defined(DOS) || defined(__GO32__)
static int ntimes;
#endif
extern int	intset;

execute(p)	/* run the machine */
	Inst *p;
{
	Inst *pcsav;
	
	for (pc = p; pc->in != STOP && !hoc_returning; )
	{
#ifdef DOS
		if (++ntimes > 10) {
			ntimes = 0;
			kbhit(); /* DOS can't capture interrupt when number crunching*/
		}
#endif
#if defined(__GO32__)
		if (++ntimes > 10) {
			ntimes = 0;
			hoc_check_intupt(1);
		}
#endif
		if (intset)
			execerror("interrupted", (char *)0);
		/* (*((pc++)->pf))(); DEC 5000 increments pc after the return!*/
		pcsav = pc++;
		(*((pcsav)->pf))();
	}
}
