/* $Header: /timshel2g/src/master/nrn/src/oc/code2.c,v 1.1.1.1 1994/10/12 17:22:06 hines Exp $ */
/*
$Log: code2.c,v $
 * Revision 1.1.1.1  1994/10/12  17:22:06  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.20  1993/02/03  11:27:41  hines
 * a bit more generic for portability. will possibly work on NeXT
 *
 * Revision 2.11  93/01/14  13:03:57  hines
 * switch from Objectdata.pstr to Objectdata.ppstr so we can eventually have
 * arrays of strings and so ivoc's varlabel will work properly.
 * 
 * Revision 2.7  93/01/12  08:58:42  hines
 * to assign to a hoc string use
 * hoc_assign_str(char** cpp, char* buf)
 * Some minor modifications to allow use of some functions by File class
 * 
 * Revision 1.8  92/11/11  12:39:41  hines
 * hoc_val_pointer more robust.
 * boolean is_obj_type(Object*, typename)
 * 
 * Revision 1.7  92/10/27  09:17:42  hines
 * rangevar(x) = y is an allowed syntax and sets the value at the segment that
 * contains x
 * 
 * Revision 1.6  92/10/14  10:10:22  hines
 * move oc specific stuff out of axis.c and into code2.c
 * new argument function hoc_pgetarg checks for double pointer on stack
 * and returns it.
 * hoc_val_pointer(string) returns a pointer to the variable resulting
 * from parsing the string.
 * 
 * Revision 1.5  92/07/31  08:33:27  hines
 * failed to checkin code2.c when chkarg got moved there
 * 
 * Revision 1.4  92/03/11  19:07:34  hines
 * proper passing of strings as arguments to built-in functions.
 * gargstr(i) and hoc_pgargstr(i)
 * 
 * Revision 1.3  91/10/18  14:40:34  hines
 * symbol tables now are type Symlist containing pointers to first and last
 * symbols.  New symbols get added onto the end.
 * 
 * Revision 1.2  91/10/17  15:01:24  hines
 * VAR, STRING now handled with pointer to value located in object data space
 * to allow future multiple objects. Ie symbol for var, string, objectvar
 * has offset into a pointer data space.
 * 
 * Revision 1.1  91/10/11  11:11:57  hines
 * Initial revision
 * 
 * Revision 4.38  91/08/15  11:12:53  hines
 * strcmp(s1,s2) returns >0, 0, or <0 according as s1 is lexicographically
 * greater than, equal to , or less than s2.
 * pgargstr(i) is for use internally so user programs can change the value
 * of hoc strings. This must be done properly though.
 * 
 * Revision 3.108  90/10/24  09:44:09  hines
 * saber warnings gone
 * 
 * Revision 3.83  90/07/25  10:40:23  hines
 * almost lint free on sparc 1+ under sunos 4.1
 * 
 * Revision 3.81  90/07/25  07:20:16  hines
 * system() now can print to the plotter.
 * 
 * Revision 3.50  90/02/17  10:12:00  mlh
 * lint free on sparc and makfile good for sparc
 * 
 * Revision 3.46  90/01/24  06:37:41  mlh
 * emalloc() and ecalloc() are macros which return null if out of space
 * and then call execerror.  This ensures that pointers are set to null.
 * If more cleanup necessary then use hoc_Emalloc() followed by hoc_malchk()
 * 
 * Revision 3.33  89/10/21  10:50:32  mlh
 * mistake on cray checkin
 * 
 * Revision 3.32  89/10/21  10:31:27  mlh
 * works on CRAY
 * 
 * Revision 3.7  89/07/13  08:21:14  mlh
 * stack functions involve specific types instead of Datum
 * 
 * Revision 3.4  89/07/12  10:26:33  mlh
 * Lint free
 * 
 * Revision 2.0  89/07/07  11:30:10  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:15:37  mlh
 * Initial revision
 * 
*/

/* version 7.2.1 2-jan-89 */
#include	"hoc.h"
#include	"ytab.h"
#include	<stdio.h>

extern FILE *fin;
extern char **gargv;
extern int gargc;

extern char **hoc_pgargstr();

char *
gargstr(narg)	/* Return pointer to string which is the narg argument */
	int narg;
{
	return *hoc_pgargstr(narg);
}

hoc_Strcmp()
{
	char *s1, *s2;
	s1=gargstr(1);
	s2=gargstr(2);
	ret();
	pushx((double)strcmp(s1 ,s2));
}

hoc_Sprint()    /* sprintf function */
{ 
        char buf[256];
	char **cpp;

	/* This is not guaranteed safe since we may be pointing to double */
	cpp = hoc_pgargstr(1);
	sprint(buf, 2);
	hoc_assign_str(cpp, buf);
        ret();
        pushx(1.);
}

System()
{
	extern int hoc_plttext;
	static char stdoutfile[]="systmp.tmp";
	double d;
	int system();
	FILE *fp;

	if (hoc_plttext && !strchr(gargstr(1), '>')) {
		char st[256];
		Sprintf(st, "%s > %s", gargstr(1), stdoutfile);
		d = (double) system(st);
#if 1
		if ((fp = fopen(stdoutfile, "r")) == (FILE *)0) {
hoc_execerror("Internal error in System(): can't open", stdoutfile);
		}
		while (fgets(st, 255, fp) == st) {
			plprint(st);
		}
#endif
		IGNORE(unlink(stdoutfile));
	} else {
		d = (double) system(gargstr(1));
	}
	ret();
	pushx(d);
}

int
Xred()	/* read with prompt string and default and limits */
{
	double d;
	double xred();

	d = xred(gargstr(1), *getarg(2), *getarg(3), *getarg(4));
	ret();
	pushx(d);
}

static struct { /* symbol types */
	char	*name;
	short	t_type;
} type_sym[] = {
	"Builtins",	BLTIN,
	"Other Builtins",	FUN_BLTIN,
	"Functions",	FUNCTION,
	"Procedures",	PROCEDURE,
	"Undefined",	UNDEF,
	"Scalars",	VAR,
	0,		0
};

extern Symlist *symlist;
extern Symlist	*p_symlist;
extern int	zzdebug;

static int
symdebug(s, list)	/* for debugging display the symbol lists */
	char *s;
	Symlist *list;
{
	Symbol *sp;

	Printf("\n\nSymbol list %s\n\n", s);
	if (list) for (sp = list->first; sp != (Symbol *)0; sp = sp->next)
	{
		Printf("name:%s\ntype:", sp->name);
		switch (sp->type)
		{
		case VAR: 
if(!ISARRAY(sp)) {
			if (sp->subtype == USERINT)
				Printf("VAR USERINT  %8d", *(sp->u.pvalint));
			else if (sp->subtype == USERDOUBLE)
				Printf("VAR USERDOUBLE  %.8g", *(OPVAL(sp)));
			else
				Printf("VAR   %.8g", *(OPVAL(sp)));
}else{
			if (sp->subtype == USERINT)
				Printf("ARRAY USERINT");
			else if (sp->subtype == USERDOUBLE)
				Printf("ARRAY USERDOUBLE");
			else Printf("ARRAY");
}
			break;
		case NUMBER: Printf("NUMBER   %.8g", *(OPVAL(sp)));break;
		case STRING: Printf("STRING   %s", *(OPSTR(sp)));break;
		case UNDEF: Printf("UNDEF");break;
		case BLTIN: Printf("BLTIN");break;
		case AUTO: Printf("AUTO");break;
		case FUNCTION: Printf("FUNCTION");
			symdebug(sp->name, sp->u.u_proc->list);
			break;
		case PROCEDURE: Printf("PROCEDURE");
			symdebug(sp->name, sp->u.u_proc->list);
			break;
		case FUN_BLTIN: Printf("FUN_BLTIN");break;
		default: Printf("%d", sp->type);break;
		}
		Printf("\n");
	}
}

symbols()	/* display the types above */
{
	int i, j;
	Symbol *sp;

	if (zzdebug == 0)
	for (i = 0; type_sym[i].t_type != 0; i++)
	{
		Printf("\n%s\n", type_sym[i].name);
		for (sp = symlist->first; sp != (Symbol *)0; sp = sp->next)
			if (sp->type == type_sym[i].t_type)
			{
				Printf("\t%s", sp->name);
				switch (sp->type)
				{

				case VAR:
if(ISARRAY(sp)){
					for (j=0; j < sp->arayinfo->nsub; j++)
						Printf("[%d]",
						  sp->arayinfo->sub[j]);
}
					break;

				default: break;

				}
			}
		Printf("\n");
	}
	else{
		symdebug("p_symlist", p_symlist);
		symdebug("symlist", symlist);
	}	
	ret();
	pushx(0.);
}

double
chkarg(arg, low, high) /* argument checking for user functions */
	int arg;
	double low, high;
{
	double *getarg(), val;

	val = *getarg(arg);
	if (val > high || val < low) {
		hoc_execerror("Arg out of range in user function", (char *)0);
	}
	return val;
}



extern Inst *hoc_pc;
extern int hoc_nopop(), hoc_print();
extern int hoc_xopen_run();
extern double hoc_xpop();

extern double hoc_ac_;

double hoc_run_expr(sym) /* value of expression in sym made by hoc_parse_expr*/
	Symbol* sym;
{
	Inst *pcsav = hoc_pc;	
	hoc_execute(sym->u.u_proc->defn.in);
	hoc_pc = pcsav;
	return hoc_ac_;
}

Symbol* hoc_parse_expr(str, psymlist)
	char* str;
	Symlist** psymlist;
{
	Symbol* sp;
	char s[BUFSIZ];
	extern Symlist* hoc_top_level_symlist;
	
	if (!psymlist) {
		psymlist = &hoc_top_level_symlist;
	}
	sp = hoc_install(str,PROCEDURE,0.,psymlist);
	sp->u.u_proc->defn.in = STOP;
	sp->u.u_proc->list = (Symlist *)0;
	sp->u.u_proc->nauto = 0;
	sprintf(s, "hoc_ac_ = %s\n", str);
	hoc_xopen_run(sp, s);
	return sp;
}

hoc_run_stmt(sym)
	Symbol* sym;
{
	Inst *pcsav = hoc_pc;	
	hoc_execute(sym->u.u_proc->defn.in);
	hoc_pc = pcsav;
}

Symbol* hoc_parse_stmt(str, psymlist)
	char* str;
	Symlist** psymlist;
{
	Symbol* sp;
	char s[BUFSIZ];
	extern Symlist* hoc_top_level_symlist;
	
	if (!psymlist) {
		psymlist = &hoc_top_level_symlist;
	}
	sp = hoc_install(str,PROCEDURE,0.,psymlist);
	sp->u.u_proc->defn.in = STOP;
	sp->u.u_proc->list = (Symlist *)0;
	sp->u.u_proc->nauto = 0;
	sprintf(s, "{%s}\n", str);
	hoc_xopen_run(sp, s);
	return sp;
}


static double* hoc_varpointer;

hoc_pointer() {
	double* hoc_pgetarg();
	hoc_varpointer = hoc_pgetarg(1);
	ret();
	pushx(1.);
}

double* hoc_val_pointer(s) char* s;
{
	char buf[256];
	hoc_varpointer = 0;
	sprintf(buf, "{hoc_pointer_(&%s)}\n", s);
	hoc_oc(buf);
	return hoc_varpointer;
}
