/* $Header: /timshel2g/src/master/nrn/src/oc/debug.c,v 1.2 1994/10/28 15:17:57 hines Exp $ */
/*
$Log: debug.c,v $
 * Revision 1.2  1994/10/28  15:17:57  hines
 * yet another common name defined in an include file. this time ALPHA
 *
 * Revision 1.1.1.1  1994/10/12  17:22:07  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.103  1994/07/12  13:45:48  hines
 * can use constant objects of form
 * template[index].
 * now object names are printed in this format as well.
 *
 * Revision 2.30  1993/03/02  08:30:05  hines
 * parallization of shortfor loop as in
 * parallel for i=1,10 print i
 *
 * Revision 1.15  92/12/18  15:11:22  hines
 * fix bug in which pointers to range variables in object not allowed.
 * 
 * Revision 1.14  92/10/27  09:17:44  hines
 * rangevar(x) = y is an allowed syntax and sets the value at the segment that
 * contains x
 * 
 * Revision 1.13  92/10/24  12:01:08  hines
 * portability fixes found at Pittsburgh for CRAY and HP
 * 
 * Revision 1.12  92/10/10  12:31:50  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * Revision 1.11  92/10/09  12:16:09  hines
 * remove old style point process syntax
 * make hoc_run_expr(sym) much more general
 * added hoc_run_stmt(sym) as well
 * create them with hoc_parse_expr(char*, Symlist**) and
 * hoc_parse_stmt(char*, Symlist**)
 * 
 * Revision 1.10  92/10/07  13:51:07  hines
 * strings can be passed as args and read and set with $S1 = $S2
 * 
 * Revision 1.9  92/10/07  10:45:07  hines
 * a simpler connect statement is now available in addition to the old
 * baroque syntax. it is
 * connect sec1(x), sec2(0 or 1)
 * 
 * Revision 1.8  92/08/18  07:31:27  hines
 * arrays in different objects can have different sizes.
 * Now one uses araypt(symbol, SYMBOL) or araypt(symbol, OBJECTVAR) to
 * return index of an array variable.
 * 
 * Revision 1.7  92/08/10  15:59:32  hines
 * lists of sections with seclistdef ,,,
 * append_seclist(seclist)
 * remove_seclist(seclist)
 * forsec seclist
 * ifsec seclist
 * 
 * 
 * Revision 1.6  92/08/08  10:02:59  hines
 * properly push section from object
 * 
 * Revision 1.5  92/02/05  08:42:10  hines
 * Can connect a NEURON {POINTER var,...} in models to external variables using
 * connect var_suffix, anyvar
 * 
 * Revision 1.4  91/10/22  15:47:07  hines
 * objects and components. can assign, evaluate, and print.
 * No object arrays or function components yet.
 * At level of test3.hoc
 * 
 * Revision 1.3  91/10/16  07:32:55  hines
 * prototype of type checking
 * 
 * Revision 1.2  91/10/14  17:36:06  hines
 * scaffolding for oop in place. Syntax about right. No action yet.
 * 
 * Revision 1.1  91/10/11  11:11:58  hines
 * Initial revision
 * 
 * Revision 3.96  90/09/04  08:31:21  hines
 * try to get dos and unix together again in one RCS directory
 * 
 * Revision 3.21  89/08/29  10:14:08  mlh
 * forall loop over sections, create instead of section, insert instead
 * of open membrane, access instead of open section
 * 
 * Revision 3.17  89/08/12  12:32:54  mlh
 * range variable may have no argument in expression
 * 
 * Revision 3.16  89/08/10  11:11:47  mlh
 * accept cable procedures
 * 
 * Revision 3.9  89/07/20  09:51:30  mlh
 * code functions put in code.h from hoc.h
 * 
 * Revision 3.7  89/07/13  08:21:18  mlh
 * stack functions involve specific types instead of Datum
 * 
 * Revision 3.4  89/07/12  10:26:46  mlh
 * Lint free
 * 
 * Revision 3.3  89/07/10  15:45:46  mlh
 * Lint pass1 is silent. Inst structure changed to union.
 * 
 * Revision 2.0  89/07/07  11:30:15  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:15:42  mlh
 * Initial revision
 * 
*/

/* version 7.2.1 2-jan-89 */
#include "hoc.h"
#include "code.h"
#include "equation.h"
#include <stdio.h>
int zzdebug;

#if	DOS
#define prcod(c1,c2)	else if (p->pf == c1) Printf("%p %p %s", p, p->pf, c2);
#else
#define prcod(c1,c2)	else if (p->pf == c1) Printf("%lx %lx %s", (long)p, (long)p->pf, c2);
#endif

debug()		/* print the machine */
{
	if (zzdebug == 0)
		zzdebug = 1;
	else
		zzdebug = 0;
	return;
}

debugzz(p)	/* running copy of calls to execute */
	Inst *p;
{
	int pushx();

	{
		if(p->in == STOP) Printf("STOP\n");
		prcod(pushx, "PUSH\n")
		prcod(nopop, "POP\n")
		prcod(eval, "EVAL\n")
		prcod(add, "ADD\n")
		prcod(sub, "SUB\n")
		prcod(mul, "MUL\n")
		prcod(hoc_div, "DIV\n")
		prcod(negate, "NEGATE\n")
		prcod(power, "POWER\n")
		prcod(assign, "ASSIGN\n")
		prcod(bltin, "BLTIN\n")
		prcod(varpush, "VARPUSH\n")
		prcod(constpush, "CONSTPUSH\n")
		prcod(pushzero, "PUSHZERO\n")
		prcod(print, "PRINT\n")
		prcod(varread, "VARREAD\n")
		prcod(prexpr, "PREXPR\n")
		prcod(prstr,"PRSTR\n")
		prcod(gt, "GT\n")
		prcod(lt, "LT\n")
		prcod(eq, "EQ\n")
		prcod(ge, "GE\n")
		prcod(le, "LE\n")
		prcod(ne, "NE\n")
		prcod(and, "AND\n")
		prcod(or, "OR\n")
		prcod(not, "NOT\n")
		prcod(ifcode, "IFCODE\n")
		prcod(forcode, "FORCODE\n")
		prcod(shortfor, "SHORTFOR\n")
		prcod(call, "CALL\n")
		prcod(arg, "ARG\n")
		prcod(argassign, "ARGASSIGN\n")
		prcod(funcret, "FUNCRET\n")
		prcod(procret, "PROCRET\n")
#if DOS
/* no room for all this stuff */
#else
		prcod(hoc_stringarg, "STRINGARG\n")
		prcod(hoc_push_string, "push_string\n")
		prcod(Break, "Break\n")
		prcod(Continue, "Continue\n")
		prcod(Stop, "Stop()\n")
		prcod(assstr, "assstr\n")
		prcod(hoc_evalpointer, "evalpointer\n")
		prcod(hoc_newline, "newline\n")
		prcod(hoc_delete_symbol, "delete_symbol\n")
		prcod(hoc_cyclic, "cyclic\n")
		prcod(hoc_parallel_begin, "parallel_begin\n")
		prcod(hoc_parallel_end, "parallel_end\n")

		prcod(dep_make, "DEPENDENT\n")
		prcod(eqn_name, "EQUATION\n")
		prcod(eqn_init, "eqn_init()\n")
		prcod(eqn_lhs, "eqn_lhs()\n")
		prcod(eqn_rhs, "eqn_rhs()\n")
/*OOP*/
		prcod(hoc_objectvar, "objectvar\n")
		prcod(hoc_object_component, "objectcomponent()\n")
		prcod(hoc_object_eval, "objecteval\n")
		prcod(hoc_object_asgn, "objectasgn\n")
		prcod(hoc_objvardecl, "objvardecl\n")
		prcod(hoc_cmp_otype, "cmp_otype\n")
		prcod(hoc_newobj, "newobject\n")
		prcod(hoc_asgn_obj_to_str, "assignobj2str\n")
		prcod(hoc_known_type, "known_type\n")
		prcod(hoc_push_string, "push_string\n")
		prcod(hoc_objectarg, "hoc_objectarg\n")
		prcod(hoc_ob_pointer, "hoc_ob_pointer\n")
		prcod(hoc_constobject, "hoc_constobject\n")

/*NEWCABLE*/
		prcod(connectsection, "connectsection()\n")
		prcod(simpleconnectsection, "simpleconnectsection()\n")
		prcod(connectpointer, "connectpointer()\n")
		prcod(add_section, "add_section()\n")
		prcod(range_const, "range_const()\n")
		prcod(range_interpolate, "range_interpolate()\n")
		prcod(range_interpolate_single, "range_interpolate_single()\n")
		prcod(rangevareval, "rangevareval()\n")
		prcod(rangepoint, "rangepoint()\n")
		prcod(sec_access, "sec_access()\n")
		prcod(ob_sec_access, "ob_sec_access()\n")
		prcod(mech_access, "mech_access()\n")
		prcod(for_segment, "forsegment()\n")
		prcod(sec_access_push, "sec_access_push()\n")
		prcod(sec_access_pop, "sec_access_pop()\n")
		prcod(forall_section, "forall_section()\n")
		prcod(hoc_ifsec, "hoc_ifsec()\n")
		prcod(hoc_ifseclist, "hocifseclist()\n")
		prcod(forall_sectionlist, "forall_sectionlist()\n")
		prcod(connect_point_process_pointer, "connect_point_process_pointer\n")
		prcod(nrn_cppp, "nrn_cppp()\n")
		prcod(rangevarevalpointer, "rangevarevalpointer\n")
		prcod(sec_access_object, "sec_access_object\n")
		prcod(mech_uninsert, "mech_uninsert\n")
#endif
		else
		{
			long offset = (long)p->in;
			if (offset < 1000)
				Printf("relative %ld\n", p->i);
			else {
			offset = (long)(p->in) - (long)p;
			if (offset > (long)prog - (long)p
			&& offset < (long)(&prog[2000]) - (long)p )
				Printf("relative %ld\n", p->in - p);
			else if (p->sym->name != (char *) 0)
				{
				if (p->sym->name[0] == '\0') {
					Printf("constant or string pointer\n");
/*Printf("value=%g\n", p->sym->u.val);*/
				}
				else
					Printf("%s\n", p->sym->name);
				}
			else
				Printf("symbol without name\n");
			}
		}
		p++;
	}
}
