/* $Header: /timshel2g/src/master/nrn/src/oc/fileio.c,v 1.3 1994/10/28 12:11:01 hines Exp $ */
/*
$Log: fileio.c,v $
 * Revision 1.3  1994/10/28  12:11:01  hines
 * port to __GO32__
 *
 * Revision 1.2  1994/10/18  13:34:51  hines
 * faster load_proc,load_func,load_template
 * cache of all names constructed by lib/hocload.sh on first call
 * the cache is unchanged throughout that neuron session.
 * On exit, all oc"pid".* files removed from /tmp
 *
 * Revision 1.1.1.1  1994/10/12  17:22:07  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.73  1994/03/04  21:37:01  hines
 * help for files invoked on command line
 *
 * Revision 2.65  1993/11/09  14:30:04  hines
 * partial port to djg dos extender go32
 *
 * Revision 2.63  1993/11/04  15:55:48  hines
 * port to solaris2 (no more warnings)
 *
 * Revision 2.62  1993/10/18  13:24:19  hines
 * A start on an audit system. see audit.c
 *
 * Revision 2.61  93/09/06  13:33:17  hines
 * hoc_scan reads one extra character after scanning the number and
 * discards it if it is a newline. Otherwise it ungetc's it.
 * 
 * Revision 2.49  93/06/30  11:28:19  hines
 * expand_env_var needed a static buf for return.
 * 
 * Revision 2.48  93/05/25  14:02:36  hines
 * some functions that check on the arg type. eg hoc_is_object_arg(narg)
 * 
 * Revision 2.39  93/04/12  14:08:34  hines
 * first pass at merging Fisher's LINDA addition
 * 
 * Revision 2.28  93/02/22  14:29:07  hines
 * nobody uses scanf("%F"..., everybody accepts scanf("%lf"...
 * 
 * Revision 2.22  93/02/12  08:51:34  hines
 * beginning of port to PC-Dos
 * 
 * Revision 2.15  93/01/21  16:19:42  hines
 * load_func("name"), load_proc("name1", ...), load_template(...)
 * searches *.oc and *.hoc in . HOCLIBRARYPATH, and $NEURONHOME/lib/hoc
 * for the appropriate declaration and xopen's the first file that contains
 * such a declaration.
 * 
 * Revision 2.12  93/01/15  08:19:45  hines
 * can print nam of object with printf("%s",object)
 * 
 * Revision 2.7  93/01/12  08:58:44  hines
 * to assign to a hoc string use
 * hoc_assign_str(char** cpp, char* buf)
 * Some minor modifications to allow use of some functions by File class
 * 
 * Revision 1.4  92/11/10  07:36:03  hines
 * char* expand_env_var(char*) expands all the $(...) in the string.
 * moved from ivoc/main.c to here so oc can use it too.
 * xopen("...") now allows environment variables
 * 
 * Revision 1.3  92/03/11  19:07:36  hines
 * proper passing of strings as arguments to built-in functions.
 * gargstr(i) and hoc_pgargstr(i)
 * 
 * Revision 1.2  91/10/17  15:01:26  hines
 * VAR, STRING now handled with pointer to value located in object data space
 * to allow future multiple objects. Ie symbol for var, string, objectvar
 * has offset into a pointer data space.
 * 
 * Revision 1.1  91/10/11  11:12:00  hines
 * Initial revision
 * 
 * Revision 4.33  91/08/08  15:24:36  hines
 * if ropen() not in effect, fscan gets its input from fin instead of stdin.
 * This allows data within hoc files read by scanf()
 * 
 * Revision 4.12  91/02/12  14:22:55  hines
 * xopen takes optional second argument which is revision number of an RCS
 * file.  The proper revision is checked out into a temporary file, executed
 * and then deleted. It does not affect any other file of the same name.
 * 
 * Revision 3.97  90/09/04  10:32:27  hines
 * hoc_co ifdefed away since accidentally removed rcs.c,v
 * hoc_init no longer depends on lineq.h
 * fixed makefile a little bit but still sometimes yac's twice
 * 
 * Revision 3.66  90/05/24  16:36:56  jamie
 * added optional call, hoc_co(), to xopen.
 * hoc_co() is in hoc_rcs.c
 * 
 * Revision 3.47  90/01/24  06:39:19  mlh
 * getstr(str) gets string from fin (stdin or ropen())
 * 
 * Revision 3.29  89/10/19  06:55:47  mlh
 * printing directed through plprint(string) instead
 * of detailed routing at each place
 * 
 * Revision 3.20  89/08/15  08:29:34  mlh
 * compiles under turbo-c 1.5 -- some significant bugs found
 * 
 * Revision 3.7  89/07/13  08:21:23  mlh
 * stack functions involve specific types instead of Datum
 * 
 * Revision 3.4  89/07/12  10:26:51  mlh
 * Lint free
 * 
 * Revision 3.3  89/07/10  15:45:51  mlh
 * Lint pass1 is silent. Inst structure changed to union.
 * 
 * Revision 2.0  89/07/07  11:30:53  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:15:52  mlh
 * Initial revision
 * 
*/

#include	<stdio.h>
#include	"hoc.h"
#include	"ytab.h"
#include	<setjmp.h>
#include	<errno.h>

extern FILE		*fin;
extern int		pipeflag;
extern jmp_buf		begin;

FILE	*frin = stdin;
FILE	*fout = stdout;

extern char** hoc_pgargstr();

int
ropen()		/* open file for reading */
{
	double d;
	char *fname;

	if (ifarg(1))
		fname = gargstr(1);
	else
		fname = "";
	d = 1.;
	if (frin != stdin)
		IGNORE(fclose(frin));
	frin = stdin;
	if (fname[0] != 0) {
		if ((frin = fopen(fname, "r")) == (FILE *)0)
		{
			char* retry, *expand_env_var();
			retry = expand_env_var(fname);
			if ((frin = fopen(retry, "r")) == (FILE *)0) {
				d = 0.;
				frin = stdin;
			}
		}
	}
	ret();
	pushx(d);
}

int
wopen()		/* open file for writing */
{
	char *fname;
	double d;

	if (ifarg(1))
		fname = gargstr(1);
	else
		fname = "";
	d = 1.;
	if (fout != stdout)
 	        ERRCHK(IGNORE(fclose(fout));) 
	fout = stdout;
	if (fname[0] != 0)
 		ERRCHK(if ((fout = fopen(fname, "w")) == (FILE *)0)
		{
			d = 0.;
			fout = stdout;
		})
	ret();
	pushx(d);
}

char* expand_env_var(s) char* s; {
	char* getenv();
	static char buf[256];
	char* cp1;
	char* cp2;
	for (cp1=s, cp2 = buf; *cp1; ++cp1) {
		if (*cp1 == '$' && cp1[1] == '(') {
			char* cp3;
			char buf[100];
			cp1 += 2;
			for (cp3 = buf; *cp1 && *cp1 != ')'; ++cp1) {
				*cp3++ = *cp1;
			}
			if (*cp1) {
				*cp3 = '\0';
				cp3 = getenv(buf);
				if (cp3) {
					while(*cp3) {
						*cp2++ = *cp3++;
					}
				}
			}else{
				--cp1;
			}
		}else{
			*cp2++ = *cp1;
		}
	}
	*cp2 = '\0';
	return buf;
}

char hoc_xopen_file_[200];

char* hoc_current_xopen() {
	return hoc_xopen_file_;
}

int hoc_xopen1(fname, rcs)	/* read and execute a hoc program */
	char* fname;
	char* rcs;
{
	FILE *savfin;
	int savpipflag;
	char st[120];

#if 1
	if (rcs) {
	   if (rcs[0] != '\0') {
		Sprintf(st, "co -p%s %s > %s-%s", rcs, fname,
			fname, rcs);
 		ERRCHK(if (system(st) != 0) { 
		    hoc_execerror("st", "\nreturned error in hoc_co system call");
		})
		Sprintf(st, "%s-%s", fname, rcs);
		fname = st;
	   }
	}else if (hoc_retrieving_audit()) {
		hoc_xopen_from_audit(fname);
		return;
	}
#endif
	savpipflag = pipeflag;
	savfin = fin;
	pipeflag = 0;

 	errno = EINTR; 
 	while (errno == EINTR) { 
	   errno = 0; 
	   if ((fin = fopen(fname, "r")) == NULL) {
		char* retry, *expand_env_var();
		fname = retry = expand_env_var(fname);
		if ((fin = fopen(retry, "r")) == NULL) {
			fin = savfin;
			pipeflag = savpipflag;
			execerror("Can't open ", retry);
		}
	   }
	}

	strcpy(hoc_xopen_file_, fname);
	if (fin) {
		hoc_audit_from_xopen1(fname, rcs);
		IGNORE(hoc_xopen_run((Symbol *)0, (char *)0));
	}
	if (fin && fin != stdin)
 		ERRCHK(IGNORE(fclose(fin));)
	fin = savfin;		
	pipeflag = savpipflag;
	if (fname == st) {
		unlink(st);
	}
	hoc_xopen_file_[0] = '\0';
}

xopen()		/* read and execute a hoc program */
{

	if (ifarg(2)) {
		hoc_xopen1(gargstr(1), gargstr(2));
	}else{
		hoc_xopen1(gargstr(1), 0);
	}
	ret();
	pushx(1.);
}

Fprint()	/* fprintf function */
{
	double d;
	char buf[256];

	sprint(buf, 1);
	d = (double)fprintf(fout, "%s", buf);
	ret();
	pushx(d);
}

PRintf()	/* printf function */
{
	double d;
	char buf[512];

	sprint(buf, 1);
	d = (int)strlen(buf);
	NOT_PARALLEL_SUB(plprint(buf);)
	ret();
	pushx(d);
}

double hoc_scan(fi)
	FILE* fi;
{
	int err;
	double d;

	ERRCHK(while ((err = fscanf(fi, "%lf", &d)) != 1)
	{
		if (err == EOF)
			execerror("EOF in fscan", (char *)0);
		IGNORE(fscanf(fi, "%*s"));
	})
	if((err = getc(fi)) != '\n') {
		ungetc(err, fi);
	}
	return d;
}

int
Fscan()		/* read a number from input file */
{
	double d;
	FILE *fi;

	if (frin == stdin) {
		fi = fin;
	}else{
		fi = frin;
	}
	d = hoc_scan(fi);
	ret();
	pushx(d);
}

int
hoc_Getstr()	/* read a line from input file */
{
	char buf[512];
	char **cpp;
	
	cpp = hoc_pgargstr(1);
	if (fgets(buf, 512, frin) == (char *)0) {
		execerror("EOF in getstr", (char *)0);
	}
	hoc_assign_str(cpp, buf);
	ret();
	pushx(0.);
}

int
sprint(buf, argn)	/* convert args to right type for conversion */
	char *buf;
	int argn;	/* argument number where format is */
{
	char *pbuf, *pfmt, *pfrag, frag[120];
	int convflag, lflag, didit, hoc_argtype();
	char *fmt;

	fmt = gargstr(argn++);
 	convflag = lflag = didit = 0;
	pbuf = buf;
	pfrag = frag;
	*pfrag = 0;

	for (pfmt = fmt; *pfmt; pfmt++)
	{
		*pfrag++ = *pfmt;
		*pfrag = 0;
		if (convflag) switch (*pfmt)
		{

		case 'l':
			lflag = 1;
			break;

		case 'd':
		case 'o':
		case 'x':
			if (lflag)
				Sprintf(pbuf, frag, (long)*getarg(argn));
			else
				Sprintf(pbuf, frag, (int)*getarg(argn));
			didit = 1;
			break;

		case 'c':
			Sprintf(pbuf, frag, (char)*getarg(argn));
			didit = 1;
			break;

		case 'f':
		case 'e':
		case 'g':
			Sprintf(pbuf, frag, *getarg(argn));
			didit = 1;
			break;

		case 's':
			if (hoc_argtype(argn) == OBJECTVAR) {
char* hoc_object_name();
Object** hoc_objgetarg();
Sprintf(pbuf, frag, hoc_object_name(*hoc_objgetarg(argn)));
			}else{
				Sprintf(pbuf, frag, gargstr(argn));
			}
			didit = 1;
			break;

		case '%':
			lflag = 0;
			convflag = 0;
			break;

		default:
			break;
		}
		else if (*pfmt == '%')
			convflag = 1;

		if (didit)
		{
			argn++;
			lflag = 0;
			convflag = 0;
			didit = 0;
			pfrag = frag;
			*pfrag = 0;
			while (*pbuf)
				pbuf++;
		}
	}
	if (pfrag != frag)
		Sprintf(pbuf, frag);
}

#if defined(__TURBOC__) || defined(__GO32__)
static FILE* oc_popen(char* cmd, char* type) {
	FILE* fp;
	char buf[256];
	sprintf(buf, "sh %s > hocload.tmp", cmd);
	if (system(buf) != 0) {
		return (FILE*)0;
	}else if ( (fp = fopen("hocload.tmp", "r")) == (FILE*)0) {
		return (FILE*)0;
	}else{
		return fp;
	}
}
static void oc_pclose(FILE* fp) {
	fclose(fp);
	system("del hocload.tmp");
}
#else
#define oc_popen popen
#define oc_pclose pclose
#endif

static hoc_load(stype)
	char* stype;
{
	int i=1;
	char* s;
	Symbol* sym;
	char cmd[256];
	FILE* p;
	char file[100], *f;

	while(ifarg(i)) {
		s = gargstr(i);
		++i;
		sym = hoc_lookup(s);
		if (!sym || sym->type == UNDEF) {
			sprintf(cmd, "$NEURONHOME/lib/hocload.sh %s %s %d", stype, s, hoc_pid());
			p = oc_popen(cmd, "r");
			if (p) {
				f = fgets(file, 100, p);
				if (f) {
					f[strlen(f)-1] = '\0';
				}
				oc_pclose(p);
				if (f) {
		fprintf(stderr, "Getting %s from %s\n", s, f);
					hoc_xopen1(f, 0);
				}else{
fprintf(stderr, "Couldn't find a file that declares %s\n", s);
				}
			}else{
				hoc_execerror("can't run:", cmd);
			}
		}
	}
}

hoc_load_proc() {
	hoc_load("proc");
	ret();
	pushx(1.);
}
hoc_load_func() {
	hoc_load("func");
	ret();
	pushx(1.);
}
hoc_load_template() {
	hoc_load("begintemplate");
	ret();
	pushx(1.);
}

machine_name()
{
#if !defined(__GO32__)
  				       /*----- functions called -----*/
				       /*----- local  variables -----*/
    char	buf[20];

    gethostname(buf, 20);
    hoc_assign_str(hoc_pgargstr(1), buf); 
#endif
    ret();
    pushx(0.);
}

