/* $Header: /timshel2g/src/master/nrn/src/oc/hoc.h,v 1.2 1994/11/02 18:55:27 hines Exp $ */
/*
$Log: hoc.h,v $
 * Revision 1.2  1994/11/02  18:55:27  hines
 * can find hoc object name from a scene. constructor of built in classes
 * now gets the Object* argument of the hoc object. Also some porting mods
 * for GO32
 *
 * Revision 1.1.1.1  1994/10/12  17:22:02  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.113  1994/09/20  14:50:42  hines
 * port to dec alpha (cxx thinks struct name inside struct is new def)
 *
 * Revision 2.91  1994/05/20  19:13:58  hines
 * object_push(objref) and object_pop()
 * allow more easy saving of internal state of objects.
 * after an object_puhs(objref) subsequent commands are executed in
 * the context of the object til the next object_pop()
 * Warning: do not create new variables within one of these object contexts.
 *
 * Revision 2.88  1994/05/09  13:54:21  hines
 * observers hook for templates.
 *
 * Revision 2.85  1994/05/03  15:11:02  hines
 * built-in classes can be checkpointed
 *
 * Revision 2.80  1994/04/06  17:14:24  hines
 * minor changes to structures to allow checkpointing in ivoc
 * basically no more codepfd
 *
 * Revision 2.45  1993/04/28  10:02:41  hines
 * when a new variable is created at the top level then hoc_top_level_data
 * is reallocated. (this can happen when xopen is called) however the
 * function call handlers save and restore a pointe to hoc_objectdata and
 * between save and restore the pointer may become invalid. This is
 * avoided with the idiom
 * Objectdata* obdsav = hoc_objectdata_save()
 * ...
 * hoc_objectdata = hoc_objectdata_restore(obdsav);
 *
 * Revision 2.44  93/04/21  10:33:49  hines
 * datum element can be _pvoid for generic pointer storage
 * 
 * Revision 2.39  93/04/12  14:08:37  hines
 * first pass at merging Fisher's LINDA addition
 * 
 * Revision 2.31  93/03/05  08:42:14  hines
 * some slight performance improvements by avoidin hoc_lookup for objects
 * and use stack macros in code.c
 * 
 * Revision 2.22  93/02/12  08:51:38  hines
 * beginning of port to PC-Dos
 * 
 * Revision 2.20  93/02/03  11:27:45  hines
 * a bit more generic for portability. will possibly work on NeXT
 * 
 * Revision 2.11  93/01/14  13:03:59  hines
 * switch from Objectdata.pstr to Objectdata.ppstr so we can eventually have
 * arrays of strings and so ivoc's varlabel will work properly.
 * 
 * Revision 1.22  92/10/27  12:08:11  hines
 * list.c list.h moved from nrnoc to oc
 * all templates maintain a list of their objects
 * 
 * Revision 1.21  92/10/10  12:31:51  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * Revision 1.20  92/10/09  07:47:14  hines
 * method available for setting and retrieving values from built-in classes.
 * used with new style of point processes.
 * 
 * Revision 1.19  92/09/18  15:13:11  hines
 * hoc_list now won't conflict with OS::list
 * 
 * Revision 1.18  92/09/18  13:38:08  hines
 * c++ class members interfaced to oc can return an Object**
 * used first for built in List class
 * 
 * Revision 1.17  92/08/24  14:09:53  hines
 * define OOP 1 in hoc.h
 * 
 * Revision 1.16  92/08/17  12:49:34  hines
 * arrays in different objects can have different sizes. Now arayinfo
 * gets carried along in objectdata. arayinfo is reference counted.
 * 
 * Revision 1.15  92/08/10  15:59:33  hines
 * lists of sections with seclistdef ,,,
 * append_seclist(seclist)
 * remove_seclist(seclist)
 * forsec seclist
 * ifsec seclist
 * 
 * 
 * Revision 1.14  92/08/08  12:42:17  hines
 * to get decent section names each object of a template has a unique index
 * a count of the objects is kept in the template and when the count is
 * 0 then the index restarts at 0.
 * print ob will show the style
 * 
 * Revision 1.13  92/08/07  16:13:21  hines
 * sections as objects. sections now live in nmodl style list
 * 
 * Revision 1.12  92/07/31  08:57:33  hines
 * no longer use strings.h
 * 
 * Revision 1.11  92/07/06  16:13:31  hines
 * good start with interfacing c++ objects so they are callable from oc
 * 
 * Revision 1.10  92/05/13  13:40:15  hines
 * some names in hoc.h were reserved for c++.These are changed to
 * cName when __cplusplus is defined.
 * 
 * Revision 1.9  91/11/13  07:57:05  hines
 * userdouble uses old style sym->u.pval
 * 
 * Revision 1.8  91/10/25  12:02:58  hines
 * double arrays in objects work.  init (if it exists) in a template
 * is executed for each new object.
 * 
 * Revision 1.7  91/10/22  15:47:10  hines
 * objects and components. can assign, evaluate, and print.
 * No object arrays or function components yet.
 * At level of test3.hoc
 * 
 * Revision 1.6  91/10/18  14:40:39  hines
 * symbol tables now are type Symlist containing pointers to first and last
 * symbols.  New symbols get added onto the end.
 * 
 * Revision 1.5  91/10/17  15:01:31  hines
 * VAR, STRING now handled with pointer to value located in object data space
 * to allow future multiple objects. Ie symbol for var, string, objectvar
 * has offset into a pointer data space.
 * 
 * Revision 1.4  91/10/16  13:13:42  hines
 * fix up mistakes in last checkin
 * 
 * Revision 1.3  91/10/16  12:47:51  hines
 * symbol tables for the templates. Prototype not even executed.
 * need to come to grips with how to find data in the objects.
 * 
 * Revision 1.2  91/10/14  17:36:10  hines
 * scaffolding for oop in place. Syntax about right. No action yet.
 * 
 * Revision 1.1  91/10/11  11:12:27  hines
 * Initial revision
 * 
 * Revision 4.40  91/08/22  17:01:02  hines
 * for distribution to work on RS6000
 *
 * Revision 1.1  89/07/07  11:16:09  mlh
 * Initial revision
 * 
*/

/* version 7.2.3 19-jan-89 add range stucture to symbol */
/* version 7.2.2 19-jan-89  add INCLUDEHOCH so section.h can get defs */
/* version 7.2.1 2-jan-89 */
#ifndef hoc_h
#define hoc_h
#define	INCLUDEHOCH	1
#define OOP 1

#include	"occonf.h"
#include	"hocassrt.h"
#include	<string.h>
#include	"redef.h"

/* the dec alpha cxx doesn't understand struct foo* inside a struct */

#if __cplusplus
#define HocStruct /**/
#define HocTypedef /**/
#define HocUnion /**/
union Inst;
struct Symbol;
struct Arrayinfo;
struct Proc;
struct Symlist;
union Datum;
struct cTemplate;
union Objectdata;
struct Object;
struct hoc_Item;
#else
#define HocStruct struct
#define HocUnion union
#define HocTypedef typedef
#endif

typedef int	(*Pfri)();
typedef double	(*Pfrd)();
typedef struct Object** (*Pfro)();
typedef union Inst { /* machine instruction list type */
	Pfri	pf;
	Pfrd	pfd;
	Pfro	pfo;
	HocUnion Inst	*in;
	HocStruct Symbol	*sym;
	int	i;
} Inst;

#define STOP	(Inst *)0

typedef struct Arrayinfo  { /* subscript info for arrays */
	unsigned *a_varn;	/* dependent variable number for array elms */
	int	nsub;		/* number of subscripts */
	int	refcount;	/* because one object always uses symbol's */
	int	sub[1];		/* subscript range */
} Arrayinfo;

typedef struct Proc {
	Inst	defn;	/* FUNCTION, PROCEDURE, FUN_BLTIN */
	unsigned long size;	/* length of instruction list */
	HocStruct Symlist	*list;	/* For constants and strings */
				/* not used by FUN_BLTIN */
	int	nauto;		/* # local variables */
} Proc;

typedef struct Symlist {
	HocStruct Symbol *first;
	HocStruct Symbol *last;
}Symlist;

typedef char	*Upoint;

# define	NOTUSER		0
# define	USERINT		1	/* For subtype */
# define	USERDOUBLE	2
#define		USERPROPERTY	3	/* for newcable non-range variables */
#define		USERFLOAT	4	/* John Miller's NEMO uses floats */
#if NEMO
#define		NEMONODE	5	/* looks syntactically like vector */
#define		NEMOAREA	6	/* looks like vector */
#endif
#define		SYMBOL		7	/* for stack type */
#define		CPLUSOBJECT	8	/* c++ registered class */

typedef struct Symbol {	/* symbol table entry */
	char	*name;
	short	type;
	short	subtype;	/* Flag for user integers */
#if __cplusplus
	short	cpublic;		/* flag set public variable */
#else
	short	public;		/* flag set public variable */
#endif
	union {
		int	oboff;	/* offset into object data pointer space */
#if 0 /* these are now found via oboff. */
		char	*str;		/* STRING */
		HocStruct Object **objvar; /* possibly an array of object variables */
#endif
		double	*pval;		/* User defined doubles */
		char	*cstr;		/* constant string */
		double	*pnum;		/* Numbers */
		int	*pvalint;	/* User defined integers */
		float	*pvalfloat;	/* User defined floats */
		int	u_auto;		/* stack offset # for AUTO variable */
		double	(*ptr)();	/* if BLTIN */
		Proc	*u_proc;
		struct {
			short type;	/* Membrane type to find Prop */
			short index;	/* prop->param[index] */
		}rng;
		HocStruct Symbol **ppsym;	/* Pointer to symbol pointer array */
#if __cplusplus
		HocStruct cTemplate *ctemplate;
#else
		HocStruct Template *template;
#endif
	} u;
	unsigned   s_varn;	/* dependent variable number - 0 means indep */
	Arrayinfo *arayinfo;	/* ARRAY information if null then scalar */
	HocStruct Symbol	*next;	/* to link to another */
	short	defined_on_the_fly;
} Symbol;
#if !__cplusplus
extern Symbol	*install(), *lookup();
#endif
#define	ISARRAY(arg)	(arg->arayinfo != (Arrayinfo *)0)


#ifndef hoc_list_h
#if __cplusplus
#define hoc_List struct hoc_Item
#else
typedef struct hoc_Item	hoc_List;
#define List hoc_List
#define Item hoc_Item
#endif
#endif

typedef union Datum {	/* interpreter stack type */
	double	val;
	Symbol	*sym;
	int i;
	double	*pval;	/* first used with Eion in NEURON */
	HocStruct Object **pobj;
	HocStruct Object *obj;	/* sections keep this to construct a name */
	char	**pstr;
	HocStruct hoc_Item* itm;
	hoc_List* lst;
	void* _pvoid;	/* not used on stack, see nrnoc/point.c */
} Datum;

#if OOP
#if __cplusplus
typedef struct cTemplate {
#else
typedef struct Template {
#endif
	Symbol *sym;
	Symlist *symtable;
	int dataspace_size;
	short *datatypes;
	Symbol *init;	/* null if there is no initialization function */
	int index;	/* next  unique integer used for name for section */
	int count;	/* how many of this kind of object */
	hoc_List* olist;	/* list of all instances */
	int id;
	void* observers;	/* hook to c++ ClassObservable */
#if __cplusplus
	void* (*constructor)(Object*);
	void (*destructor)(void*);
	void (*steer)(void*);	/* normally nil */
	int (*checkpoint)(void**);
} cTemplate;
#else
	void* (*constructor)();
	void (*destructor)();
	void (*steer)();	/* point processes have member variables */
	int (*checkpoint)();
} Template;
#endif

typedef union Objectdata{
	double *pval;	/* pointer to array of doubles, usually just 1 */
	char **ppstr;	/* pointer to pointer to string ,allows vectors someday*/
	HocStruct Object **pobj;	/* pointer to array of object pointers, usually just 1*/
	HocStruct hoc_Item** psecitm;   /* array of pointers to section items, usually just 1 */
	hoc_List** plist;	/* array of pointers to linked lists */
	Arrayinfo* arayinfo;
}Objectdata;

typedef struct Object {
	int refcount;		/* how many object variables point to this */
	int index;		/* unique integer used for names of sections */
	union {
	Objectdata *dataspace;	/* Points to beginning of object's data */
	void* this_pointer;	/* the c++ object */
	}u;
#if __cplusplus
	cTemplate *ctemplate;
#else
	Template *template;
#endif
	HocStruct hoc_Item* itm_me;/* this object in the template list */
	void* observers;	/* hook to c++ ObjObservable */
} Object;
#endif

typedef struct {		/* User Functions */
	char 	*name;
	int	(*func)();
} IntFunc;

typedef struct {		/* User Double Scalars */
	char 	*name;
	double	*pdoub;
} DoubScal;

typedef struct {		/* User Vectors */
	char 	*name;
	double	*pdoub;
	int	index1;
} DoubVec;


extern double xpop();
extern Symbol *spop();

#if __cplusplus
extern	double *getarg(int);
extern	char	*gargstr(int);
#else
extern	double *getarg();
extern	char	*gargstr();
#endif
#if !__cplusplus
#if LINT
extern	double	*hoc_Emalloc(), *hoc_Ecalloc(), *hoc_Erealloc();
#else
extern	char	*hoc_Emalloc(), *hoc_Ecalloc(), *hoc_Erealloc();
#endif
#define emalloc(arg)	hoc_Emalloc(arg), hoc_malchk()
#define ecalloc(arg1,arg2)	hoc_Ecalloc(arg1,arg2), hoc_malchk()
#define erealloc(arg1,arg2)	hoc_Erealloc(arg1,arg2), hoc_malchk()
#endif

extern	Inst *progp, *progbase, *prog, *prog_parse_recover, *Code(), *pc;

extern Objectdata *hoc_objectdata;
extern Objectdata *hoc_objectdata_save();
#if __cplusplus
extern Objectdata* hoc_objectdata_restore(Objectdata*);
#else
extern Objectdata* hoc_objectdata_restore();
#endif
#define OPVAL(sym) hoc_objectdata[sym->u.oboff].pval
#define OPSTR(sym) hoc_objectdata[sym->u.oboff].ppstr
#define OPOBJ(sym) hoc_objectdata[sym->u.oboff].pobj
#define OPSECITM(sym) hoc_objectdata[sym->u.oboff].psecitm
#define OPLIST(sym) hoc_objectdata[sym->u.oboff].plist
#define OPARINFO(sym) hoc_objectdata[sym->u.oboff + 1].arayinfo

#if LINT
#undef assert
#define assert(arg)	{if (arg) ;}	/* so fprintf doesn't give lint */
#define	IGNORE(arg)	{if(arg);}
#define LINTUSE(arg)	{if(arg);}
char	*cplint;
int	ilint;
#define Strcat          cplint = strcat
#define Strncat         cplint = strncat
#define Strcpy          cplint = strcpy
#define Strncpy         cplint = strncpy
#define Sprintf         cplint = sprintf
#define Printf		ilint = printf
#define Fprintf		ilint = fprintf
#else
#if defined(__TURBOC__)
#define IGNORE
#else
#define IGNORE(arg)	arg
#endif
#define LINTUSE(arg)
#define Strcat          strcat
#define Strncat         strncat
#define Strcpy          strcpy
#define Strncpy         strncpy
#define Sprintf         sprintf
#define Printf		printf
#define Fprintf		fprintf
#endif

#endif

/* EINTR handling for LINDA */
#if LINDA
#include <errno.h>
#define ERRCHK(c1) {errno=EINTR;while(errno==EINTR){errno=0;c1}}

#else
#define ERRCHK(c1) c1
#endif

extern int parallel_sub; /* for use with parallel neuron (see parallel.cl) */

#define NOT_PARALLEL_SUB(c1)  {if (!parallel_sub) c1}
