/* $Header: /timshel2g/src/master/nrn/src/oc/hoc_init.c,v 1.2 1994/10/26 17:25:02 hines Exp $ */
/*
$Log: hoc_init.c,v $
 * Revision 1.2  1994/10/26  17:25:02  hines
 * access name changed to an explicit hoc_access and taken out of redef.h
 *
 * Revision 1.1.1.1  1994/10/12  17:22:09  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.112  1994/09/20  14:49:25  hines
 * execute1("cmd") will return even on execerror. Note: does
 * not surround with {}
 *
 * Revision 2.108  1994/08/05  14:16:14  hines
 * show_errmess_always()
 * errno not defined from include file in hoc.c
 * NullArgument replaces null arguments in Imakefile
 *
 * Revision 2.106  1994/07/30  14:52:40  hines
 * pwman_place(left, top)
 *
 * Revision 2.91  1994/05/20  19:13:58  hines
 * object_push(objref) and object_pop()
 * allow more easy saving of internal state of objects.
 * after an object_puhs(objref) subsequent commands are executed in
 * the context of the object til the next object_pop()
 * Warning: do not create new variables within one of these object contexts.
 *
 * Revision 2.84  1994/05/02  12:53:54  hines
 * quit() function
 *
 * Revision 2.83  1994/04/27  12:43:47  hines
 * objref is keyword synonym for objectvar
 *
 * Revision 2.82  1994/04/27  12:17:56  hines
 * minor warnings from objectcenter fixed (and one serious problem from
 * last checkin)
 * PI, E, etc are now userdoubles and are available within objects.
 *
 * Revision 2.81  1994/04/27  11:21:31  hines
 * support for ivoc/SRC/checkpoint.c
 * usage is checkpoint("filename")
 * then ivoc filename ...
 * so far only for oc
 *
 * Revision 2.79  1994/04/05  16:35:20  hines
 * hook for checkpoint
 * hoc_new_object_asgn(Object**, Symbol*, void*)
 * double hoc_call_objfunc(Symbol*, int narg, Object*)
 *
 * Revision 2.75  1994/03/10  14:28:33  hines
 * invoke coredump_on_error() if want it on next segmentation violation or
 * bus error.
 *
 * Revision 2.70  1994/02/23  12:53:31  hines
 * help word word ... in ivoc tickles the help system
 *
 * Revision 2.62  1993/10/18  13:24:19  hines
 * A start on an audit system. see audit.c
 *
 * Revision 2.54  1993/08/11  11:04:21  hines
 * Zach Mainen's contribution of xstatebutton and xcheckbox
 *
 * Revision 2.39  93/04/12  14:08:38  hines
 * first pass at merging Fisher's LINDA addition
 * 
 * Revision 2.32  93/03/05  15:57:41  hines
 * slider and can call a user interpreted function or procedure via
 * hoc_call_func(Symbol*, int narg) with args on stack in first arg order
 * 
 * Revision 2.30  93/03/02  08:30:06  hines
 * parallization of shortfor loop as in
 * parallel for i=1,10 print i
 * 
 * Revision 2.22  93/02/12  08:51:39  hines
 * beginning of port to PC-Dos
 * 
 * Revision 2.15  93/01/21  16:21:28  hines
 * load_func("name"), load_proc("name1", ...), load_template(...)
 * searches *.oc and *.hoc in . HOCLIBRARYPATH, and $NEURONHOME/lib/hoc
 * for the appropriate declaration and xopen's the first file that contains
 * such a declaration.
 * 
 * Revision 2.10  93/01/13  08:51:18  hines
 * stubs for xvarlabel, xradiobutton, and xfixedvalue
 * mechanism in place for notifying if strdef is freed.
 * 
 * Revision 1.33  92/12/22  15:29:02  hines
 * a template can have an external statement followin the public
 * statement which is a comma separated list of functions or procedures
 * defined at the top level which can be executed within the object.
 * (the function is executed in a top level context).
 * public and external statements are optional
 * 
 * Revision 1.32  92/12/18  15:11:27  hines
 * fix bug in which pointers to range variables in object not allowed.
 * 
 * Revision 1.31  92/12/11  09:39:36  hines
 * execute("command", [objvar]) executes command in context of object (top-level
 * if arg not present). int hoc_obj_execute(const char* cmd, Object*) used
 * in C.
 * 
 * Revision 1.30  92/11/16  11:19:37  hines
 * error in x.c message when color doesn't exist
 * xlabel("string")
 * 
 * Revision 1.29  92/10/24  12:02:04  hines
 * portability fixes found at Pittsburgh for CRAY and HP
 * 
 * Revision 1.28  92/10/24  10:16:28  hines
 * noiv.c is place to put function stubs that only make sense with interviews
 * whenever any VAR is freed it should be done with hoc_free_val... which
 * will notify the interviews objects that hold pointers to variables.
 * 
 * Revision 1.27  92/10/14  14:35:53  hines
 * numarg() returns the number of arguments in a hoc procedure or function.
 * hoc_typestack returns the type of the Datum on the stack
 * hoc_argtype(i) returns the type of the ith arg.
 * 
 * Revision 1.26  92/10/14  10:10:23  hines
 * move oc specific stuff out of axis.c and into code2.c
 * new argument function hoc_pgetarg checks for double pointer on stack
 * and returns it.
 * hoc_val_pointer(string) returns a pointer to the variable resulting
 * from parsing the string.
 * 
 * Revision 1.25  92/10/10  12:32:02  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * Revision 1.24  92/10/07  09:46:17  hines
 * keyword for setting pointers in models has been changed
 * from connect to setpointer
 * 
 * Revision 1.23  92/10/05  10:15:31  hines
 * when _CRAY math functions get l suffix
 * 
 * Revision 1.22  92/08/12  16:16:10  hines
 * uninsert mechanism_name
 * 
 * Revision 1.21  92/08/12  10:45:35  hines
 * Changes of sejnowski lab. also gets sred from hoc. Major addition is
 * a new x.c which is modified for screen updating following an expose
 * event. This is in x_sejnowski.c and will compile to x.o when
 * Sejnowski is defined as 1 in Imakefile (don't forget imknrn -a when
 * changed and delete old x.o)
 * Does not contain get_default on this checkin
 * 
 * Revision 1.20  92/08/12  08:50:45  hines
 * FARADAY and R (molar gas constant) added as built-in constants.
 * 
 * Revision 1.19  92/08/10  15:59:34  hines
 * lists of sections with seclistdef ,,,
 * append_seclist(seclist)
 * remove_seclist(seclist)
 * forsec seclist
 * ifsec seclist
 * 
 * 
 * Revision 1.18  92/07/31  16:16:55  hines
 * float_epsilon used for logical comparisons, int(), indexing and short for
 * default value is 1e-11
 * Hopfully no one has to worry about roundoff for the loops to come out
 * right.
 * 
 * 
 * Revision 1.17  92/07/31  12:01:10  hines
 * forsec and ifsec merged from hoc/neuron
 * 
 * Revision 1.16  92/07/31  08:29:33  hines
 * remove the old newgraph stuff
 * 
 * Revision 1.15  92/07/06  16:13:33  hines
 * good start with interfacing c++ objects so they are callable from oc
 * 
 * Revision 1.14  92/04/09  12:39:47  hines
 * ready to add idplot usage with newgraph(), addgraph(), initgraph(), xgraph()
 * flushgraph().
 * A facilitating function exists called
 * Symbol* hoc_parse_expr(char* str, Symlist** psymlist) which
 * return a procedure symbol which can be used as
 * hoc_execute(sym->u.u_proc->defn.in);
 * val = hoc_xpop();
 * 
 * Revision 1.13  92/03/17  08:08:59  hines
 * xmenufile() adds menu which can save or open menufiles.
 * 
 * Revision 1.12  92/03/11  15:36:55  hines
 * doEvents() will execute InterViews events if any.
 * 
 * Revision 1.11  92/03/06  07:18:08  hines
 * hoc_ac_ global variable defined to allow evaluation of expressions
 * via hoc_oc("hoc_ac_ = expr\n");
 * Then the user can find the value in extern double hoc_ac_.
 * 
 * Revision 1.10  92/03/05  13:25:37  hines
 * fix problem where not initcode after a execution by hoc_oc()
 * xvalue added
 * 
 * Revision 1.9  92/02/26  10:27:48  hines
 * xview removed. nrnoc verified (needed fixes) for reversed section syntax.
 * 
 * Revision 1.8  91/11/18  10:52:50  hines
 * xview menus. Doesn't work too well. ^C exits altogether.
 * 
 * Revision 1.7  91/10/30  14:40:44  hines
 * stack.hoc works and can be reloaded
 * 
 * Revision 1.6  91/10/24  16:22:06  hines
 * can call object functions and procedures. Object arrays not working yet.
 * object_id(obj) is used for tests.
 * STKDEBUG turned on in code.c in which every element also carries a type.
 * 
 * Revision 1.5  91/10/22  15:47:12  hines
 * objects and components. can assign, evaluate, and print.
 * No object arrays or function components yet.
 * At level of test3.hoc
 * 
 * Revision 1.4  91/10/18  14:40:40  hines
 * symbol tables now are type Symlist containing pointers to first and last
 * symbols.  New symbols get added onto the end.
 * 
 * Revision 1.3  91/10/16  12:47:52  hines
 * symbol tables for the templates. Prototype not even executed.
 * need to come to grips with how to find data in the objects.
 * 
 * Revision 1.2  91/10/14  17:36:12  hines
 * scaffolding for oop in place. Syntax about right. No action yet.
 * 
 * Revision 1.1  91/10/11  11:12:06  hines
 * Initial revision
 * 
 * Revision 4.38  91/08/15  11:15:32  hines
 * strcmp(s1,s2) returns >0, 0, or <0 according as s1 is lexicographically
 * greater than, equal to , or less than s2.
 * pgargstr(i) is for use internally so user programs can change the value
 * of hoc strings. This must be done properly though.
*/

/* 5-5-89 fmenu added */
/* munge for newcable 12/30/88 */
/* version 7.1.1 12/8/88
   add graphmode()
   add laser writer plotting (lw) using fig output format
   */
#include "hoc.h"
#include "ytab.h"
#include <math.h>
#include "equation.h"

extern double	Log(), Log10(), Exp(), Sqrt(), integer();
extern int	System(), Prmat(), solve(), eqinit(), Plt();
extern int	symbols(), PRintf(), Xred(), hoc_Sred();
extern int	ropen(), wopen(), xopen(), Fscan(), Fprint();
extern int	hoc_Graph(), hoc_Graphmode(), Plot(), axis(), hoc_Sprint();
extern int 	hoc_fmenu(), hoc_Getstr(), hoc_Strcmp();
extern int	hoc_Lw(), machine_name(), hoc_Saveaudit(), hoc_Retrieveaudit();
extern int	hoc_plotx(), hoc_ploty(), hoc_regraph();
extern int	hoc_startsw(), hoc_stopsw(), hoc_object_id();
extern int	hoc_allobjects(), hoc_allobjectvars();
extern int	hoc_xpanel(), hoc_xbutton(), hoc_xmenu(), hoc_xslider();
extern int	hoc_xfixedvalue(), hoc_xvarlabel(), hoc_xradiobutton();
extern int	hoc_xvalue(), hoc_xpvalue(), hoc_xlabel();
extern int	hoc_boolean_dialog(), hoc_string_dialog(), hoc_continue_dialog();
extern int	hoc_single_event_run(), hoc_notify_iv();
extern int	hoc_pointer(), hoc_Numarg(), hoc_exec_cmd();
extern int	hoc_load_proc(), hoc_load_func(), hoc_load_template();
extern int      hoc_xcheckbox(), hoc_xstatebutton();
extern int	hoc_coredump_on_error(), hoc_checkpoint(), hoc_quit();
extern int	hoc_object_push(), hoc_object_pop(), hoc_pwman_place();
extern int	hoc_show_errmess_always(), hoc_execute1();
#if 0
extern int	hoc_co();
#endif
extern int	hoc_regexp_compile(), hoc_regexp_search();
extern int	hoc_Setcolor();
#if	DOS
extern int	hoc_settext();
extern double	erf(), erfc();	/* supplied by unix */
#endif
extern Symlist	*symlist;

static struct { /* Keywords */
	char	*name;
	int	kval;
} keywords[] = {
	"proc",		PROC,
	"func",		FUNC,
	"return",	RETURN,
	"break",	BREAK,
	"continue",	CONTINUE,
	"stop",		STOPSTMT,
	"if",		IF,
	"else",		ELSE,
	"while",	WHILE,
	"for",		FOR,
	"print",	PRINT,
	"delete",	DELETE,
	"read",		READ,
	"debug",	DEBUG,
	"double",	DOUBLE,
	"em",		EDIT,
	"depvar",	DEPENDENT,
	"eqn",		EQUATION,
	"local",	LOCAL,
	"strdef",	STRDEF,
	"parallel",	PARALLEL,
	"help",		HELP,
#if CABLE
	"create",	SECTIONKEYWORD,
	"connect",	CONNECTKEYWORD,
	"setpointer",	SETPOINTERKEYWORD,
	"access",	ACCESSKEYWORD,
	"insert",	INSERTKEYWORD,
	"uninsert",	UNINSERTKEYWORD,
	"forall",	FORALL,
	"ifsec",	IFSEC,
	"forsec",	FORSEC,
#endif /*CABLE*/
#if OOP
	"begintemplate", BEGINTEMPLATE,
	"endtemplate", ENDTEMPLATE,
	"objectvar",	OBJVARDECL,
	"objref",	OBJVARDECL,
	"public",	PUBLICDECL,
	"external",	EXTERNALDECL,
	"new",		NEW,
#endif
	0,		0
};
static struct {	/* Constants */
	char	*name;
	double cval;
} consts[] = {
	"PI",	3.14159265358979323846,
	"E",	2.71828182845904523536,
	"GAMMA",0.57721566490153286060,	/* Euler */
	"DEG", 57.29577951308232087680,	/* deg/radian */
	"PHI",	1.61803398874989484820,	/* golden ratio */
	"FARADAY", 96484.56,	/*coulombs/mole*/
	"R", 8.31441,		/*molar gas constant, joules/mole/deg-K*/
	0,	0
};

static struct {	/* Built-ins */
	char	*name;
	double	(*func)();
} builtins[] = {
	"sin",	sin,
	"cos",	cos,
	"atan",	atan,
	"log",	Log,	/* checks argument */
	"log10",Log10,	/* checks argument */
	"exp",	Exp,	/* checks argument */
	"sqrt",	Sqrt,	/* checks argument */
	"int",	integer,
	"abs",	fabs,
	"erf",	erf,
	"erfc", erfc,
	0,	0
};
static struct { /* Builtin functions with multiple or variable args */
	char 	*name;
	int	(*fun_blt)();
} fun_bltin[] = {
	"system",	System,
	"prmat",	Prmat,
	"solve",	solve,
	"eqinit",	eqinit,
	"plt",		Plt,
	"axis",		axis,
	"plot",		Plot,
	"plotx",	hoc_plotx,
	"ploty",	hoc_ploty,
	"regraph",	hoc_regraph,
	"symbols",	symbols,
	"printf",	PRintf,
	"xred",		Xred,
	"sred",		hoc_Sred,
	"ropen",	ropen,
	"wopen",	wopen,
	"xopen",	xopen,
	"fprint",	Fprint,
	"fscan",	Fscan,
	"sprint",	hoc_Sprint,
	"graph",	hoc_Graph,
	"graphmode",	hoc_Graphmode,
	"fmenu",	hoc_fmenu,
	"lw",		hoc_Lw,
	"getstr",	hoc_Getstr,
	"strcmp",	hoc_Strcmp,
	"setcolor",	hoc_Setcolor,
	"startsw",	hoc_startsw,
	"stopsw",	hoc_stopsw,
	"object_id",	hoc_object_id,
	"allobjectvars", hoc_allobjectvars,
	"allobjects",	hoc_allobjects,
	"xpanel",	hoc_xpanel,
	"xbutton",	hoc_xbutton,
	"xcheckbox",    hoc_xcheckbox,
	"xstatebutton", hoc_xstatebutton,
	"xlabel",	hoc_xlabel,
	"xmenu",	hoc_xmenu,
	"xvalue",	hoc_xvalue,
	"xpvalue",	hoc_xpvalue,
	"xradiobutton",	hoc_xradiobutton,
	"xfixedvalue",	hoc_xfixedvalue,
	"xvarlabel",	hoc_xvarlabel,
	"xslider",	hoc_xslider,
	"boolean_dialog",	hoc_boolean_dialog,
	"continue_dialog",	hoc_continue_dialog,
	"string_dialog",	hoc_string_dialog,
	"doEvents",	hoc_single_event_run,
	"doNotify",	hoc_notify_iv,
	"numarg",	hoc_Numarg,
	"hoc_pointer_",	hoc_pointer,		/* for internal use */
	"execute",	hoc_exec_cmd,
	"execute1",	hoc_execute1,
	"load_proc",	hoc_load_proc,
	"load_func",	hoc_load_func,
	"load_template", hoc_load_template,
	"machine_name", machine_name,
	"saveaudit", hoc_Saveaudit,
	"retrieveaudit", hoc_Retrieveaudit,
	"coredump_on_error", hoc_coredump_on_error,
	"checkpoint", hoc_checkpoint,
	"quit",		 hoc_quit,
	"object_push",	hoc_object_push,
	"object_pop",	hoc_object_pop,
	"pwman_place",	hoc_pwman_place,
	"show_errmess_always", hoc_show_errmess_always,
#if	DOS
	"settext",	hoc_settext,
#endif
	0,	0
};

double hoc_epsilon = 1.e-11;
double hoc_ac_; /*known to the interpreter to evaluate expressions with hoc_oc() */
double* hoc_varpointer; /* executing hoc_pointer(&var) will put the address of
			the variable in this location */

init()	/* install constants and built-ins table */
{
	int i;
	Symbol *s;

	hoc_init_space();
	for (i = 0; keywords[i].name; i++)
		IGNORE(install(keywords[i].name, keywords[i].kval, 0.0, &symlist));
	for (i = 0; consts[i].name; i++) {
		s = install(consts[i].name, UNDEF, consts[i].cval, &symlist);
		s->type = VAR;
		s->u.pval = &consts[i].cval;
		s->subtype = USERDOUBLE;
	}
	for (i = 0; builtins[i].name; i++)
	{
		s = install(builtins[i].name, BLTIN, 0.0, &symlist);
		s->u.ptr = builtins[i].func;
	}
	for (i = 0; fun_bltin[i].name; i++)
	{
		s = install(fun_bltin[i].name, FUN_BLTIN, 0.0, &symlist);
		s->u.u_proc->defn.pf = fun_bltin[i].fun_blt;
		s->u.u_proc->nauto = 0;
	}
	s = install("float_epsilon", UNDEF, 0., &symlist);
	s->type = VAR;
	s->subtype = USERDOUBLE;
	s->u.pval = &hoc_epsilon;
	/* hoc_ac_ is a way to evaluate an expression using the interpreter */
	s = install("hoc_ac_", UNDEF, 0.0, &symlist);
	s->type = VAR;
	s->u.pval = &hoc_ac_;
	s->subtype = USERDOUBLE;
	
	/* initialize pointers ( why doesn't Vax do this?) */
	hoc_access = (int *)0;
	spinit();
#if OOP
	class_registration();
	{extern Symlist *hoc_built_in_symlist, *hoc_top_level_symlist;
	 hoc_built_in_symlist = symlist;
	 symlist = (Symlist *)0;
	 /* start symlist and top level the same list */
	 hoc_top_level_symlist = symlist = (Symlist *)emalloc(sizeof(Symlist));
	 symlist->first = symlist->last = (Symbol *)0;
	}	
#endif
}
