/* $Header: /timshel2g/src/master/nrn/src/oc/hocmodl.c,v 1.1.1.1 1994/10/12 17:22:10 hines Exp $ */
/*
$Log: hocmodl.c,v $
 * Revision 1.1.1.1  1994/10/12  17:22:10  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.19  93/02/02  10:34:30  hines
 * static functions declared before used
 * 
 * Revision 2.16  93/01/22  17:34:19  hines
 * ocmodl, ivmodl working both for shared and static libraries
 * 
 * Revision 1.4  92/07/07  09:49:46  hines
 * chkarg moved to code2.c so always available
 * 
 * Revision 1.3  91/10/18  14:40:42  hines
 * symbol tables now are type Symlist containing pointers to first and last
 * symbols.  New symbols get added onto the end.
 * 
 * Revision 1.2  91/10/17  15:01:33  hines
 * VAR, STRING now handled with pointer to value located in object data space
 * to allow future multiple objects. Ie symbol for var, string, objectvar
 * has offset into a pointer data space.
 * 
 * Revision 1.1  91/10/11  11:12:08  hines
 * Initial revision
 * 
 * Revision 4.4  90/12/04  13:09:27  hines
 * hoc_pindepindex replaces hoc_pindep
 * 
 * Revision 3.94  90/08/17  08:46:16  hines
 * hocmodl style now that of nmodl
 * 
 * Revision 3.84  90/07/25  14:39:40  hines
 * no need for scoplib.lib.  special abort_run for hoc
 * 
 * Revision 3.79  90/07/24  12:29:33  hines
 * add prmodlconst() so easy to see what the values of the constants are.
 * This required a change to the scdoub structure.
 * 
 * Revision 3.75  90/07/20  08:22:32  hines
 * modl interface to hoc working
 * 
 * Revision 3.74  90/07/19  11:25:02  hines
 * first try
 * 
 * Revision 3.55  90/05/08  09:31:30  mlh
 * removed last lint message
 * 
 * Revision 3.46  90/01/24  06:37:55  mlh
 * emalloc() and ecalloc() are macros which return null if out of space
 * and then call execerror.  This ensures that pointers are set to null.
 * If more cleanup necessary then use hoc_Emalloc() followed by hoc_malchk()
 * 
 * Revision 3.23  89/09/14  14:34:04  mlh
 * for turboc 2.0 void the signal and malloc, and remove calloc
 * 
 * Revision 3.19  89/08/12  14:36:17  mlh
 * so newcable can be lint free
 * 
 * Revision 3.9  89/08/12  13:44:08  mlh
 * IGNORE defined in hocdec.h
 * 
 * Revision 3.8  89/07/14  14:11:06  mlh
 * pretty much lint free but having problems with declarations in
 * hocusr.h and use in hocusr.c
 * 
 * Revision 3.5  89/07/12  13:24:53  mlh
 * use the new Inst structure for defn
 * 
 * Revision 2.0  89/07/07  11:32:00  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:16:30  mlh
 * Initial revision
 * 
*/

/* version 7.2.1 2-jan-89 */
#include "hocdec.h"
#include "ytab.h"
#include "hocmodl.h"
# include	<stdio.h>

# define	CHECK(name)	if (hoc_lookup(name) != (Symbol *)0){\
		IGNORE(fprintf(stderr, CHKmes, name));\
		exit(1);}
static char	CHKmes[] = "%s cannot be a user defined name\n";

extern Symlist	*hoc_symlist;

static int arayinstal();

hoc_spinit()	/* install user variables and functions */
{
	int i;
	Symbol *s;

	hoc_register_var(scdoub, vdoub, function);
	for (i = 0; scint[i].name; i++)
	{
		CHECK(scint[i].name);
		s = hoc_install(scint[i].name, UNDEF, 0.0, &hoc_symlist);
		s->type = VAR;
		s->u.pvalint = scint[i].pint;
		s->subtype = USERINT;
	}
	for (i = 0; vint[i].name; i++)
	{
		CHECK(vint[i].name);
		s = hoc_install(vint[i].name, UNDEF, 0.0, &hoc_symlist);
		arayinstal(s, 1, vint[i].index1, 0, 0);
		s->u.pvalint = vint[i].pint;
		s->subtype = USERINT;
	}
	for (i = 0; ardoub[i].name; i++)
	{
		CHECK(ardoub[i].name);
		s = hoc_install(ardoub[i].name, UNDEF, 0.0, &hoc_symlist);
		arayinstal(s, 2, ardoub[i].index1, ardoub[i].index2, 0);
		s->u.pval = ardoub[i].pdoub;
		s->subtype = USERDOUBLE;
	}
	for (i = 0; thredim[i].name; i++)
	{
		CHECK(thredim[i].name);
		s = hoc_install(thredim[i].name, UNDEF, 0.0, &hoc_symlist);
		arayinstal(s, 3, thredim[i].index1, thredim[i].index2,
			thredim[i].index3);
		s->u.pval = thredim[i].pdoub;
		s->subtype = USERDOUBLE;
	}
	for (i = 0; function[i].name; i++)
	{
		if (!strcmp(function[i].name, "init"))
		{
			(*function[i].func)();
			continue;
		}
	}
	_hoc_reg();
}

hoc_register_var(scdoub, vdoub, function)
	DoubScal *scdoub;
	DoubVec *vdoub;
	IntFunc *function;
{
	int i;
	Symbol *s;
	
	if (scdoub) for (i = 0; scdoub[i].name; i++)
	{
		CHECK(scdoub[i].name);
		s = hoc_install(scdoub[i].name, UNDEF, 0.0, &hoc_symlist);
		s->type = VAR;
		s->u.pval = scdoub[i].pdoub;
		s->subtype = USERDOUBLE;
	}
	if (vdoub) for (i = 0; vdoub[i].name; i++)
	{
		CHECK(vdoub[i].name);
		s = hoc_install(vdoub[i].name, UNDEF, 0.0, &hoc_symlist);
		arayinstal(s, 1, vdoub[i].index1, 0, 0);
		s->u.pval = vdoub[i].pdoub;
		s->subtype = USERDOUBLE;
	}
	if (function) for (i = 0; function[i].name; i++)
	{
		CHECK(function[i].name);
		s=hoc_install(function[i].name, FUN_BLTIN, 0.0, &hoc_symlist);
		s->u.u_proc->defn.pf = function[i].func;
		s->u.u_proc->nauto = 0;
	}
}

static int
arayinstal(sp, nsub, sub1, sub2, sub3) /* set up arayinfo */
	Symbol *sp;
	int nsub, sub1, sub2, sub3;
{

	sp->type = VAR;
	sp->s_varn = 0;
	sp->arayinfo = (Arrayinfo *) emalloc(
		(unsigned)(sizeof(Arrayinfo)+nsub*sizeof(int)));
	sp->arayinfo->a_varn = (unsigned *) 0;
	sp->arayinfo->nsub = nsub;
	sp->arayinfo->sub[0] = sub1;
	if (nsub > 1)
		sp->arayinfo->sub[1] = sub2;
	if (nsub > 2)
		sp->arayinfo->sub[2] = sub3;
}

ret(x)		/* utility return for user functions */
	double x;
{
	hoc_ret();
	hoc_pushx(x);
}


hoc_initmodel()
{
	initmodel();
	ret(1.);
}

hoc_model()
{
	model((double *)0, hoc_pindepindex);
	ret(1.);
}

hoc_terminal()
{
	terminal();
	ret(1.);
}

#if 0
hoc_prconst() {
	int i;
	char buf[128];

	for (i = 0; scdoub[i].name; i++)
	{
		if (scdoub[i].modltype == 1) {
			Sprintf(buf, "%-8s = %g\n",
				scdoub[i].name, *scdoub[i].pdoub);
			plprint(buf);
		}
	}
	ret(1.);
}
#endif

cursrpos() {return;}
cls() {return;}

abort_run(code)
	int code;
{
	char s[10];

	Sprintf(s, "%d", code);
	_modl_cleanup();
	hoc_execerror("scopmath library error: code=", s);
}
