/* Copyright Costa M. Colbert 1992,1993. */
#ifdef NeXTstep
#import <appkit/appkit.h>
#import "UserPath.h" 
#import "VecView.h" 
#import <dpsclient/wraps.h>     // For PS and DPS function prototypes
//#import "RemCtxtInfo.h"
#import "YapWrap.h"

/* initial position of window */
#define WX	100
#define WY	100

/* size of window */
#define WIDTH  500 
#define HEIGHT 390
#define MARGIN 0

/* size of icon */
#define IWIDTH 64
#define IHEIGHT 20

#define BORDER 36.0

static int fast;	/* don't flush until plt(-1), use drawlines*/
static int nlinept = 0;
static int maxnlinept=1500;

static int D;
#define Color (D > 1)
#define Ncolors 11

int NeXT_init_done;
static int xnew, ynew;
static int xold = 0, yold= 0;
static double xscale, yscale;
#define TEKX 1000.
#define TEKY 780.

int 	 dummy;
id	 hocWin, myPanel, myMenu, windowText;
NXRect	 aRect;
id	 hocView;
UserPath* thePath;
DPSContext	tempContext,curContext;
int	manual;

void NeXT_fast(mode)
	int mode;
{
	if (mode > -1)
		fast = mode;
	else
		manual = 1;
}

static void getscale()
{
	xscale = [hocView width] / TEKX;
	yscale = [hocView height]/ TEKY;
}

inline void NeXT_coord(x, y)
	double x, y;
{
	xnew = (int)(xscale*x);
	ynew = (int)(yscale*y);
}

void NeXT_draw_vec() {
	if (nlinept) {
		endUserPath (thePath, dps_ustroke);
          	sendUserPath(thePath);
		beginUserPath(thePath, NO);
	}
	nlinept = 0;
}

void NeXTflush() {
	if (fast && nlinept) {
		NeXT_draw_vec();
	}
	NXPing();
}

void NeXT_vector()
{
	if (fast) {
		if (nlinept == 0){
			UPmoveto(thePath,xold,yold);
			++nlinept;
		}
		if (nlinept >= maxnlinept) {
			NeXTflush(); 
		}
		UPmoveto(thePath,xold,yold);
		UPlineto(thePath,xnew,ynew);
		++nlinept;
	}else{
		PSmoveto(xold,yold);
		PSlineto(xnew,ynew);
		PSstroke();
	}
	xold=xnew; yold=ynew;
}

void NeXT_point()
{
	PSmoveto(xnew,ynew);
	PSlineto(xnew,ynew);
	PSstroke();

	xold=xnew; yold=ynew;
	if (!fast) {
		NeXTflush(); 
	}
}

void NeXT_move()
{
	if (fast) {
		if (nlinept && (xnew != xold || ynew != yold)) {
			NeXT_draw_vec();
		}
	}
	xold=xnew; yold=ynew;
}

void NeXT_clear()
{
	NXRect* thebounds;

	if (fast && nlinept) {
                NeXT_draw_vec();
        }
	// PStranslate(-BORDER,-BORDER);
	thebounds = [hocView bounds];
	NXEraseRect(thebounds);
	getscale();
}

void NeXT_cleararea(){
	int w, h, x, y;
	NXRect	aRect;
	
	w = xnew-xold;
	h = ynew-yold;
	if (w < 0) {
		w = -w;
		x = xnew;
	}else{
		x = xold;
	}
	if (h < 0) {
		h = -h;
		y = ynew;
	}else{
		y=yold;
	}
	NXSetRect(&aRect, (double)x, (double)y, (double)x+w, (double)y+h);
	NXEraseRect(&aRect);
	
	if (!fast) {
		NXPing();
	}
}

void NeXT_put_text(s)
	char *s;
{
	if(fast && nlinept) {
		NeXT_draw_vec();
	}
	PSmoveto(xold,yold);
	PSshow(s); 
	PSstroke();

	if (!fast)
	{
		NXPing();
	}
}

void NeXT_setcolor(c)
	int c;
{
	void NeXT_open_window();
	if (!NeXT_init_done) {
		NeXT_open_window();
	}
	NeXT_draw_vec();
	if (c == 0) {
		PSsetgray(0.0);
	} else if (!Color) {
		PSsetgray(1.0);
	}
	if (!fast) {
		NXPing();
	}
}

static set_colors() {
}

void NeXT_open_window()
{
	NXRect	 aRect;
	ctxtInfo *tInfo;
	id ro;
        const char *app;

	if (NeXT_init_done) {
		return;
	}
	
	[Application new];
	NXSetRect(&aRect, (double)WX, (double)WY, 
		(double)WIDTH+WX, (double)HEIGHT+WY);
	hocView = [NXConnection connectToName:"NXnrnVecView"];
	if (Color) set_colors();
	NXPing();

	if (hocView != NULL){
	    app = [NXApp appName];
	    curContext = DPSGetCurrentContext();
    
	    tempContext = DPSCreateNonsecureContext(
			    NXGetDefaultValue(app, "NXHost"),
			    NXGetDefaultValue(app, "NXPSName"),
			    NULL, NULL, 60000, [NXApp zone]);
	    DPSSetContext(curContext);
	
	    tInfo = [hocView thectxtInfo];
	    DPSSetContext (tempContext);
	    ReFocus(tInfo->realWinNum, tInfo->winCTM, 	
		    tInfo->c1x,tInfo->c1y,tInfo->c2x,tInfo->c2y);
	}
	thePath = newUserPath();
	beginUserPath(thePath, NO);
	NeXT_init_done = 1;
	getscale();
	PSselectfont("Times-Roman",12.0);
	PSsetlinewidth(0.15);
	PStranslate(BORDER,BORDER);
	errno = 0;
}

void NeXT_close_window()
{
	if (NeXT_init_done) {
		[NXApp free];
	}
	NeXT_init_done = 0;
}
#endif
