/* $Header: /timshel2g/src/master/nrn/src/oc/ocmain.c,v 1.1.1.1 1994/10/12 17:22:12 hines Exp $ */
/*
$Log: ocmain.c,v $
 * Revision 1.1.1.1  1994/10/12  17:22:12  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.99  1994/06/17  13:00:35  hines
 * a number of things fixed while looking at the test coverage of hoc.c
 * mostly just to allow coverage.
 * CBUFSIZE is larger than 256
 * array index computed with double arithmetic.
 * corrected handling of end of file while in comments
 *
 * Revision 2.71  1994/02/23  15:51:16  hines
 * RETREAT_SIGNAL (SIGHUP) handled and user written routine "linda_retreat()"
 * called on a doEvent(). Just exit if no such routine.
 *
 * Revision 2.63  1993/11/04  15:55:48  hines
 * port to solaris2 (no more warnings)
 *
 * Revision 2.39  1993/04/12  14:08:41  hines
 * first pass at merging Fisher's LINDA addition
 *
 * Revision 1.9  92/12/18  15:11:31  hines
 * fix bug in which pointers to range variables in object not allowed.
 * 
 * Revision 1.8  92/08/12  10:45:37  hines
 * Changes of sejnowski lab. also gets sred from hoc. Major addition is
 * a new x.c which is modified for screen updating following an expose
 * event. This is in x_sejnowski.c and will compile to x.o when
 * Sejnowski is defined as 1 in Imakefile (don't forget imknrn -a when
 * changed and delete old x.o)
 * Does not contain get_default on this checkin
 * 
 * Revision 1.7  92/07/31  08:29:54  hines
 * remove the old newgraph stuff
 * 
 * Revision 1.6  92/07/06  16:13:36  hines
 * good start with interfacing c++ objects so they are callable from oc
 * 
 * Revision 1.5  92/04/24  13:09:32  hines
 * some undefined (but unused) functions revealed after upgrade to 4.1.2
 * 
 * Revision 1.4  92/04/09  12:34:26  hines
 * ready to add idplot usage with newgraph(), addgraph(), initgraph(), xgraph()
 * flushgraph().
 * A facilitating function exists called
 * Symbol* hoc_parse_expr(char* str, Symlist** psymlist) which
 * return a procedure symbol which can be used as
 * hoc_execute(sym->u.u_proc->defn.in);
 * val = hoc_xpop();
 * 
 * Revision 1.3  92/03/19  08:57:36  hines
 * axis labels close to origin set to 0 so label not strange looking.
 * 
 * Revision 1.2  92/03/11  15:37:25  hines
 * doEvents() will execute InterViews events if any.
 * 
 * Revision 1.1  91/10/11  11:12:10  hines
 * Initial revision
 * 
 * Revision 4.21  91/04/30  11:07:13  hines
 * allow hoc to be part of another program. Use hoc_main1(argc, argv, env)
 * on return hoc can be restarted by hoc_run() (but be sure to reopen the
 * stdin with clearerr(stdin). on final exit be sure to call hoc_final_exit()
 * to save edit buffers.
 * 
 * Revision 3.95  90/08/29  08:56:07  hines
 * now can load using saber-c. SUNCORE define for plot and sunplot
 * 
 * Revision 3.4  89/07/12  10:27:22  mlh
 * Lint free
 * 
 * Revision 3.1  89/07/07  14:16:08  mlh
 * automattic version numbering
 * 
 * Revision 2.0  89/07/07  11:32:18  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:17:12  mlh
 * Initial revision
 * 
*/

#include <stdio.h>
/* changes */
/* version 7.2.2 5-5-89 fmenu function */
/* version 7.2.1 2-jan-89  short form for statement. eg. for i=3,8 print i */

#if LINT
int ilint;
#define Fprintf		ilint = fprintf
#else
#define Fprintf		fprintf
#endif

#if LINDA /* LINDA (SAF) */
real_main(argc, argv, envp)
#else
main(argc, argv, envp)
#endif
	char *argv[], *envp[];
{
	int err;
	err = hoc_main1(argc, argv, envp);
	if (!err) {
		hoc_final_exit();
	}
#if EXPRESS
	exit(0);
#else
#if LINDA
	lexit(0);
#else
	return err;
#endif
#endif
}


hoc_single_event_run() { /* for interviews, ivoc make use of own main */
#if LINDA
	extern int hoc_retreat_flag;
	if (hoc_retreat_flag) {
		hoc_retreat();		
	}
#endif
#if INTERVIEWS && 0
	single_event_run();
#endif
	hoc_ret();
	hoc_pushx(0.);
}

class_registration() {}


int run_til_stdin() {return 1;}
hoc_notify_value(){}
