/* $Header: /timshel2g/src/master/nrn/src/oc/parse.y,v 1.5 1994/10/28 15:17:59 hines Exp $ */
/*
$Log: parse.y,v $
 * Revision 1.5  1994/10/28  15:17:59  hines
 * yet another common name defined in an include file. this time ALPHA
 *
 * Revision 1.4  1994/10/26  20:00:21  hines
 * I think things work properly now with yacc
 *
 * Revision 1.3  1994/10/25  17:24:46  hines
 * having the ytab files make for too large patches
 *
 * Revision 1.2  1994/10/14  19:06:17  hines
 * close to a release. verifies with oc,nrnoc,nmodl. Note there is a bug
 * when oc/parse.y translated by yacc
 *
 * Revision 1.1.1.1  1994/10/12  17:22:16  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.110  1994/08/18  12:19:15  hines
 * allow ob.sec.range[i](x)
 * this necessitated allowing parsing of ob[i](x) and then giving
 * an error dynamically.
 *
 * Revision 2.103  1994/07/12  13:45:48  hines
 * can use constant objects of form
 * template[index].
 * now object names are printed in this format as well.
 *
 * Revision 2.101  1994/06/29  12:37:28  hines
 * can switch between bison and yacc. so far I have never used the partial
 * parseing feature of bison anyway. This works around a problem on some
 * crays in which there is a bug in bison.
 *
 * Revision 2.97  1994/06/07  20:54:40  hines
 * anyname (eg local) can also be a mechanism name
 *
 * Revision 2.95  1994/06/07  18:42:38  hines
 * allow redeclaration of names in templates that are built-in names
 *
 * Revision 2.80  1994/04/06  17:14:24  hines
 * minor changes to structures to allow checkpointing in ivoc
 * basically no more codepfd
 *
 * Revision 2.70  1994/02/23  12:53:31  hines
 * help word word ... in ivoc tickles the help system
 *
 * Revision 2.68  1994/01/21  18:14:31  hines
 * some NeXT portability fixes and turn off parse error messages when
 * hoc_execerror_message == 0
 *
 * Revision 2.66  1993/12/15  15:02:01  hines
 * SECTIONREF and allow ob connect ob()(0or1), expr
 *
 * Revision 2.60  1993/09/01  08:23:31  hines
 * some string assignment statements not popping stack so loops can eventually
 * give stack overflow
 *
 * Revision 2.59  93/08/19  16:37:03  hines
 * if (!0) print "hello"
 * now works. before the ! was not transmitted from yylex as NOT
 * and print "hello" was given the wrong $$ code index
 * 
 * Revision 2.36  93/03/11  09:32:09  hines
 * better error message when pointer to rangevar does not have arc spec
 * 
 * Revision 2.31  93/03/05  08:42:18  hines
 * some slight performance improvements by avoidin hoc_lookup for objects
 * and use stack macros in code.c
 * 
 * Revision 2.30  93/03/02  08:30:07  hines
 * parallization of shortfor loop as in
 * parallel for i=1,10 print i
 * 
 * Revision 2.25  93/02/20  08:55:38  hines
 * AIX
 * 
 * Revision 2.23  93/02/12  10:01:08  hines
 * public names which are top level functions generated a syntax error.
 * 
 * Revision 2.19  93/02/02  10:34:33  hines
 * static functions declared before used
 * 
 * Revision 2.17  93/01/23  13:40:24  hines
 * don't inlclude stdio.h twice in ytab.c
 * 
 * Revision 2.13  93/01/21  12:45:30  hines
 * memory leak on multiple strdef of same symbol
 * 
 * Revision 2.11  93/01/14  13:04:03  hines
 * switch from Objectdata.pstr to Objectdata.ppstr so we can eventually have
 * arrays of strings and so ivoc's varlabel will work properly.
 * 
 * Revision 2.8  93/01/12  16:53:12  hines
 * "str" = strdef was being allowed
 * 
 * Revision 1.47  92/12/30  12:45:39  hines
 * don't require empty line after endtemplate
 * 
 * Revision 1.46  92/12/22  16:52:10  hines
 * problem with new lines after public and external fixed.
 * public and external now can be anywhere in template but they had better
 * be before declarations (at least for external) and usage.
 * 
 * Revision 1.45  92/12/22  15:29:06  hines
 * a template can have an external statement followin the public
 * statement which is a comma separated list of functions or procedures
 * defined at the top level which can be executed within the object.
 * (the function is executed in a top level context).
 * public and external statements are optional
 * 
 * Revision 1.44  92/12/18  15:11:33  hines
 * fix bug in which pointers to range variables in object not allowed.
 * 
 * Revision 1.43  92/10/27  09:17:46  hines
 * rangevar(x) = y is an allowed syntax and sets the value at the segment that
 * contains x
 * 
 * Revision 1.42  92/10/22  09:49:13  hines
 * ob.sec syntax must always do a poptypestack at end.
 * 
 * Revision 1.41  92/10/21  14:51:46  hines
 * fixed several errors having to do with stack and frame overflows
 * under object.section { stmt} and calling hoc procedures with
 * object.proc()
 * 
 * Revision 1.40  92/10/21  11:10:29  hines
 * didn't allow local variable names used as object components. fixed
 * objectvar this
 * inside template will automatically get set to itself.
 * fixed error in popping the object type stack when sections were a component
 * 
 * Revision 1.39  92/10/10  12:32:06  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * Revision 1.38  92/10/09  12:16:12  hines
 * remove old style point process syntax
 * make hoc_run_expr(sym) much more general
 * added hoc_run_stmt(sym) as well
 * create them with hoc_parse_expr(char*, Symlist**) and
 * hoc_parse_stmt(char*, Symlist**)
 * 
 * Revision 1.37  92/10/08  08:35:32  hines
 * some extra parse error messages about assignments and redeclaring
 * variables.
 * 
 * Revision 1.36  92/10/07  15:43:23  hines
 * arg syntax changed to $s1 and $o1 because O looked too much like 0
 * 
 * Revision 1.35  92/10/07  14:06:53  hines
 * get rid of irrelevant type clash on default action
 * 
 * Revision 1.34  92/10/07  13:51:13  hines
 * strings can be passed as args and read and set with $S1 = $S2
 * 
 * Revision 1.33  92/10/07  10:45:12  hines
 * a simpler connect statement is now available in addition to the old
 * baroque syntax. it is
 * connect sec1(x), sec2(0 or 1)
 * 
 * Revision 1.32  92/10/07  09:47:25  hines
 * keyword for setting pointers in models has been changed
 * from connect to setpointer
 * 
 * Revision 1.31  92/10/02  17:28:15  hines
 * can pass pointer to anything with &
 * 
 * Revision 1.30  92/09/18  13:38:58  hines
 * c++ class members interfaced to oc can return an Object**
 * used first for built in List class
 * 
 * Revision 1.29  92/08/18  10:24:40  hines
 * templates can not make new objects using templates declared at the top level.
 * first looks for local templates though.
 * 
 * Revision 1.28  92/08/17  08:19:06  hines
 * strdef, double, and objectvar can appear inside functions (any compound
 * statement). They are still global (within a template). When executed
 * (and if they are arrays) the old arayinfo is thrown away and the
 * proper aray storage is allocated. Note that arrays should at least be
 * initialized outside of a statement or else the parser will complain when
 * it sees the array syntax. next step is to give each array in each object
 * it's own arayinfo so they can have different bounds. At this time
 * they could be inconsistent. One should not try to have the same name
 * with different dimensions though.
 * 
 * Revision 1.27  92/08/17  07:32:04  hines
 * change from new(template) to new template(args)
 * strange problem with tests/test5.hoc with segmentation violation that
 * isn't seen with objectcenter and goes away when xopens have a path to the
 * file.
 * 
 * Revision 1.26  92/08/15  12:41:30  hines
 * can pass object variable as arg to oc functions and procedures. Within
 * the procedures the syntax is
 * $$1.ob.ob.var etc.
 * see test7.hoc for usage with array of strings
 * 
 * Revision 1.25  92/08/12  16:16:15  hines
 * uninsert mechanism_name
 * 
 * Revision 1.24  92/08/10  15:59:55  hines
 * forgot to checkin parse.y last time
 * 
 * Revision 1.23  92/08/08  12:57:41  hines
 * access object.section
 * 
 * Revision 1.22  92/08/07  16:13:25  hines
 * sections as objects. sections now live in nmodl style list
 * 
 * Revision 1.21  92/07/31  13:48:47  hines
 * fix up forsec and ifsec so it works in object context
 * 
 * Revision 1.20  92/07/31  12:01:13  hines
 * forsec and ifsec merged from hoc/neuron
 * 
 * Revision 1.19  92/03/11  13:53:51  hines
 * all parse errors now hoc_execerror
 * 
 * Revision 1.18  92/02/26  10:27:51  hines
 * xview removed. nrnoc verified (needed fixes) for reversed section syntax.
 * 
 * Revision 1.17  92/02/19  15:02:00  hines
 * preparing for sections within objects. syntax is
 * ob.section stmt    section.var
 * this causes about 36 extra shift/reduce conflicts
 * 
 * Revision 1.16  92/02/06  12:12:40  hines
 * Can have comments on same line with no tokens in between.
 * error fixed in translation of range vector with explicit section as first
 * item in a statement.
 * 
 * Revision 1.15  92/02/05  08:42:17  hines
 * Can connect a NEURON {POINTER var,...} in models to external variables using
 * connect var_suffix, anyvar
 * 
 * Revision 1.14  92/01/31  15:01:27  hines
 * fix a trivial type mismatch that was revealed on switch to bison.
 * Ready now to make oc event driven.
 * 
 * Revision 1.13  92/01/30  08:17:18  hines
 * bug fixes found in hoc incorporated. if()return, no else, objectcenter
 * warnings.
 * 
 * Revision 1.12  91/11/18  10:52:54  hines
 * xview menus. Doesn't work too well. ^C exits altogether.
 * 
 * Revision 1.11  91/11/05  11:24:15  hines
 * all neuron/examples produce same results with nrnoc as with neuron.
 * Found quite a few bugs this way.
 * 
 * Revision 1.10  91/10/25  10:30:01  hines
 * stop works inside object procedures
 * fixed problem with single object statement in loop or if with no braces
 * 
 * Revision 1.9  91/10/25  09:32:53  hines
 * object arrays. stack.hoc works. need to work on stop command and
 * necessity for braces around single statements in for loops.
 * 
 * Revision 1.8  91/10/24  16:22:08  hines
 * can call object functions and procedures. Object arrays not working yet.
 * object_id(obj) is used for tests.
 * STKDEBUG turned on in code.c in which every element also carries a type.
 * 
 * Revision 1.7  91/10/22  15:47:14  hines
 * objects and components. can assign, evaluate, and print.
 * No object arrays or function components yet.
 * At level of test3.hoc
 * 
 * Revision 1.6  91/10/18  14:40:46  hines
 * symbol tables now are type Symlist containing pointers to first and last
 * symbols.  New symbols get added onto the end.
 * 
 * Revision 1.5  91/10/17  15:01:37  hines
 * VAR, STRING now handled with pointer to value located in object data space
 * to allow future multiple objects. Ie symbol for var, string, objectvar
 * has offset into a pointer data space.
 * 
 * Revision 1.4  91/10/16  12:47:57  hines
 * symbol tables for the templates. Prototype not even executed.
 * need to come to grips with how to find data in the objects.
 * 
 * Revision 1.3  91/10/16  07:33:01  hines
 * prototype of type checking
 * 
 * Revision 1.2  91/10/14  17:36:15  hines
 * scaffolding for oop in place. Syntax about right. No action yet.
 * 
 * Revision 1.1  91/10/11  11:12:32  hines
 * Initial revision
 * 
 * Revision 4.43  91/10/01  11:34:25  hines
 * gather console input at one place in preparation for adding
 * emacs like command line editing. Hoc input now reads entire line.
*/

/* munge for newcable 12/30/88 */
%{

/* changes as of 2-jan-89 */
/*  version 7.2.1 2-jan-89 short form of the for statement */

#if AIX
#pragma alloca
#endif

#include "hoc.h"
#include "code.h"
#include "equation.h"

#if LINT
Inst *inlint;
#define code	inlint = Code
#else
#define code	Code
#endif

#define paction(arg) fprintf(stderr, "%s\n", arg)

/* maintain a list of ierr addresses so we can clear them */
#define HOCERRSIZE 20
static int** hoc_err;
static int hoc_errp;

static clean_err() {
	int i;
	for (i=0; i < hoc_errp; ++i) {
		*hoc_err[i] = 0;
	}
	hoc_errp = 0;
}

static pusherr(ip) int* ip; {
	if (!hoc_err) {
		hoc_err = (int**)ecalloc(HOCERRSIZE, sizeof(int*));
		hoc_errp = 0;
	}
	if (hoc_errp >= HOCERRSIZE) {
		clean_err();
		hoc_execerror("error stack full", (char*)0);
	}
	hoc_err[hoc_errp++] = ip;
}

#if BISON
#define myerr(arg) static int ierr=0;\
if (!(ierr++)){pusherr(&ierr);yyerror(arg);} --yyssp; --yyvsp; YYERROR
#else
#define myerr(arg) static int ierr=0;\
if (!(ierr++)){pusherr(&ierr);yyerror(arg);} YYERROR
#endif

#define code2(c1,c2)	code(c1); codein(c2)
#define code3(c1,c2,c3)	code(c1); codesym(c2); code(c3)
#define relative(ip1,ip2,offset)	((ip1-ip2) - offset)
#define CHECK 1	/* check syntactically the consistency of arrays */
#define NOCHECK 0 /* don't check syntactically. For object components */
#define PN pushi(NUMBER)	/* for type checking. expressions are usually numbers */
#define TPD hoc_ob_check(NUMBER);
#define TPDYNAM hoc_ob_check(0);

extern int pipeflag;
extern Symlist *symlist;	/* This list is permanent */
extern Symlist *p_symlist; /* Constants, strings, auto variables */
extern Symbol* hoc_decl();

extern arayinstal();
extern int indef;
static Inst *prog_error;			/* needed for stmtlist loc if error */
static int ntab;			/* auto indentation */
extern FILE	*fin;				/* input file pointer */

%}

%union {				/* stack type */
	Symbol	*sym;			/* symbol table pointer */
	Inst	*inst;			/* machine instruction */
	int	narg;			/* number of arguments */
}

%token		EQNEQ
%token	<sym>	NUMBER STRING PRINT DELETE VAR BLTIN UNDEF WHILE IF ELSE FOR
%token	<sym>	FUNCTION PROCEDURE RETURN FUNC PROC READ DOUBLE
%token	<sym>	DEBUG EDIT FUN_BLTIN DEPENDENT EQUATION LOCAL
%token	<sym>	BREAK CONTINUE AUTO STRDEF STOPSTMT CSTRING PARALLEL HELP
%token	<narg>	ARG NUMZERO
%type	<inst>	expr stmt asgn prlist delsym stmtlist strnasgn
%type	<inst>	cond while if begin end for_init for_st for_cond for_inc
%type	<inst>	eqn_list dep_list varname wholearray array pointer
%type	<inst>	doublelist strlist string1 string2
%type	<sym>	procname newname function string ckvar
%type	<sym>	anyname
%type	<narg>	arglist arglist1 local local1 newarray numdimen procstmt

/* NEWCABLE */
%token	<sym>	SECTIONKEYWORD SECTION CONNECTKEYWORD ACCESSKEYWORD
%token	<sym>	RANGEVAR MECHANISM INSERTKEYWORD FORALL NRNPNTVAR FORSEC IFSEC
%token	<sym>	UNINSERTKEYWORD SETPOINTERKEYWORD SECTIONREF
%type	<sym>	sectiondecl sectionname
%type	<inst>	rangevar rangevar1 section section_or_ob
/* END NEWCABLE */

/* OOP */
%token	<sym>	BEGINTEMPLATE ENDTEMPLATE NEW OBJECTVAR TEMPLATE
%token	<sym>	OBJVARDECL PUBLICDECL EXTERNALDECL OBFUNCTION
%token	<narg>	OBJECTARG STRINGARG
%type	<sym>	template publiclist externallist
%type	<sym>	obvarname
%type	<inst>	ob objvarlist object
%type	<narg>	func_or_range_array_case
/* END OOP */

%right	'='
%left	OR
%left	AND
%left	GT GE LT LE EQ NE
%left	'+' '-'	/* left associative, same precedence */
%left	'*' '/'	'%'/* left assoc., higher precedence */
%left	UNARYMINUS NOT
%right	'^'	/* exponentiation */

%%
list:	/* nothing */
		{ ntab = 0;}
	| list '\n' { return '\n';}
	| list defn '\n' { return '\n';}
	| list asgn '\n'
		{ hoc_ob_check(-1); code2(nopop, STOP); return 1; }
	| list stmt '\n'
		{ codein(STOP); return 1; }
	| list expr '\n'
		{ hoc_ob_check(-1); code2(print, STOP); return 1; }
	| list DEBUG '\n'
		{ debug(); return '\n';}
	| list EDIT '\n'
		{ return 'e';}
/* OOP */
	| list template '\n' { return '\n';}
/* END OOP */
	| list '' '\n'
		{ plt(-3,0.,0.); return '\n';}
	| list HELP {hoc_help();} '\n' { return '\n'; }
	| list error
		{clean_err(); hoc_execerror("parse error", (char*)0);
#if LINT
if (0) {
if(yydebug);
goto yynewstate;
}
#endif
		}
	;
asgn:	varname '=' expr
		{Symbol *s; TPD; s = spop();
		hoc_obvar_declare(s, VAR, 1);
		code3(varpush, s, assign); PN;}
	| ARG '=' expr
		{  TPD; defnonly("$"); code(argassign); codei($1); $$=$3; PN;}
/* NEWCABLE */
	| rangevar '=' expr
		{ TPD; code(range_const); codesym(spop()); PN;}
/* END NEWCABLE */
/* OOP */
	|ob '=' NEW anyname '(' arglist ')'
		{extern Symbol* hoc_which_template();
		 code(hoc_newobj); codesym(hoc_which_template($4)); codei($6);}
	| ob '=' expr
		{TPDYNAM; code(hoc_object_asgn); pushi(OBJECTVAR);}
/* END OOP */
	| varname '=' error {myerr("assignment to variable, make sure right side is a number");}
	;

/* OOP */
object:	OBJECTVAR {pushi(OBJECTVAR);pushs($1); pushi(CHECK);} wholearray
		{$$ = $3; code(hoc_objectvar); spop(); codesym($1);}
	| OBJECTARG
		{defnonly("$o"); $$ = code(hoc_objectarg); codei($1); pushi(OBJECTVAR);}
	| TEMPLATE '[' expr ']'
		{TPD; $$ = $3; code(hoc_constobject); codesym($1); pushi(OBJECTVAR);}
	;
ob:	object
	| ob '.' anyname {pushs($3);pushi(NOCHECK);} wholearray func_or_range_array_case
		{code(hoc_object_component); codesym(spop()); codei(ipop());
		 codei($6);
		 codei(0); codesym(0);
		}
	| OBJECTVAR error {myerr("object syntax is o1.o2.o3.");}
	;
func_or_range_array_case:	/* nothing */
		{$$ = 0;}
	| '(' arglist ')'
		{$$ = $2;}
	;
template: BEGINTEMPLATE anyname {hoc_begintemplate($2);}
	| publiclist
	| externallist
	| ENDTEMPLATE anyname {hoc_endtemplate($2);}
	| BEGINTEMPLATE error {myerr("begintemplate Name\npublic namelist\nexternal namelist\n...\nendtemplate Name");}
	;
objvarlist: OBJVARDECL begin objvarlst1
		{$$ = $2;}
	;
objvarlst1: obvarname
		{code(hoc_objvardecl); codesym($1); codei(0);}
	| obvarname numdimen
		{code(hoc_objvardecl); codesym($1); codei($2);}
	| objvarlst1 ',' obvarname
		{code(hoc_objvardecl); codesym($3); codei(0);}
	| objvarlst1 ',' obvarname numdimen
		{code(hoc_objvardecl); codesym($3); codei($4);}
	;
obvarname: anyname
		{
		  Symbol* s;
		  s = hoc_decl($1);
		  if (s->type != UNDEF && s->type != OBJECTVAR) {
			acterror(s->name, " already declared");
		  }
		  $$ = s;
		}
	;
publiclist: PUBLICDECL anyname
		{hoc_add_publiclist($2);}
	| publiclist ',' anyname
		{hoc_add_publiclist($3);}
	;
externallist: EXTERNALDECL VAR
		{hoc_external_var($2);}
	| externallist ',' VAR
		{hoc_external_var($3);}
	;
/* END OOP */

strnasgn: string2 '=' string1
		{code(assstr);}
	| ob '=' string1
		{pushi(STRING); TPDYNAM; code(hoc_object_asgn);
		 hoc_ob_check(-1); code(nopop);
		}
	| string2 '=' ob
		{code(hoc_asgn_obj_to_str);}
	| string2 error {myerr("string assignment: both sides need to be a string");}
;

string1: string2
	| CSTRING
		{$$ = code(hoc_push_string); codesym($1);}
;

string2: STRING
		{$$ = code(hoc_push_string); codesym($1);}
	| STRINGARG
		{defnonly("$s"); $$ = code(hoc_stringarg); codei($1);}
	;

strlist: STRDEF begin string
		{ $$ = $2; }
	| strlist ',' string
	;
string:	anyname
		{
			Symbol* s = hoc_decl($1);
			if (s->type == UNDEF) {
				hoc_obvar_declare(s, STRING, 0);
				OPSTR(s) = (char**)emalloc(sizeof(char*));
				*OPSTR(s) = 0;
			}else if (s->type != STRING) {
				acterror(s->name, " already declared");
			}
			hoc_assign_str(OPSTR(s), "");
		}
	;
stmt:	expr
		{ code(nopop); hoc_ob_check(-1); /*don't check*/}
	| strlist
	| doublelist
/* OOP */
	| objvarlist
/* END OOP */
	| strnasgn
	| DELETE delsym
		{ $$ = $2;}
	| RETURN begin
		{ defnonly("return"); $$=$2; code(procret); }
	| RETURN expr
		{  TPD; defnonly("return"); $$=$2; code(funcret);}
	| BREAK begin
		{ code(Break); $$ = $2; }
	| STOPSTMT begin
		{ code(Stop); $$ = $2; }
	| CONTINUE begin
		{ code(Continue); $$ = $2; }
	| PROCEDURE begin '(' arglist ')'
		{ $$ = $2; code(call); codesym($1); codei($4); code(nopop); }
	| PRINT prlist
		{ $$ = $2; code(hoc_newline); }
	| for_init for_st for_cond for_inc stmt end
			{
			($2)[1].i =relative($5, $2, 1);	/* body */
			($2)[2].i =relative($6, $2, 2); /* exit from the for */
			($2)[3].i  =relative($4, $2, 3);	/* increment */
			$$ = $1;
#if LINT
if (0){YYERROR;}
#endif
			}
	| FOR varname
		  { Symbol *s; $$ = Code(varpush); codesym(s = spop());
			hoc_obvar_declare(s, VAR, 1);
		  }
		'=' expr ',' expr
		  {$<inst>$ = code(shortfor); codei(0); codei(0); TPD; TPD;}
		stmt end
		  { $$ = $2; ($<inst>8)[1].i = relative($9, $<inst>8, 1); /* body */
			   ($<inst>8)[2].i = relative($10, $<inst>8, 2); /* exit */
		  }
	| PARALLEL FOR varname
		  { Symbol *s; $$ = Code(varpush); codesym(s = spop());
			hoc_obvar_declare(s, VAR, 1);
		  }
		'=' expr ',' expr
		  {  code(hoc_parallel_begin);
		     $<inst>$ = code(shortfor); codei(0); codei(0); TPD; TPD;}
		stmt end
		  { $$ = $3; ($<inst>9)[1].i = relative($10, $<inst>9, 1); /* body */
			   ($<inst>9)[2].i = relative($11, $<inst>9, 2); /* exit */
			code(hoc_parallel_end);
		  }
	| while cond stmt end
		{
		($1)[1].i = relative($3, $1, 1);	/* body of loop */
		($1)[2].i = relative($4, $1, 2); }/* end, if cond fails */
	| if cond stmt end	/* else-less if */
		{
		($1)[1].i = relative($3, $1, 1);	/* thenpart */
		($1)[3].i = relative($4, $1, 3); }/* end, if cond fails */
	| if cond stmt end ELSE stmt end	/* if with else */
		{
		($1)[1].i = relative($3, $1, 1);	/* thenpart */
		($1)[2].i = relative($6, $1, 2);	/* elsepart */
		($1)[3].i = relative($7, $1, 3); }/* end, if cond fails */
	| '{'
		{ ntab++;}
	stmtlist '}'
		{
		ntab--; $$ = $3;
		}
	| eqn_list

/* NEWCABLE */
	| SECTIONKEYWORD begin sectiondecl { $$ = $2; }
	| CONNECTKEYWORD section_or_ob '(' expr ')' ',' expr
		{ TPD; TPD; $$ = $2; code(connectsection);}
	| CONNECTKEYWORD section_or_ob '(' expr ')' ',' section '(' expr ')'
		{ TPD; TPD; $$ = $2; code(simpleconnectsection);}
	| SETPOINTERKEYWORD rangevar '(' expr ')' ',' pointer
		{ TPD; $$ = $2; code(connectpointer); codesym(spop());}
	| SETPOINTERKEYWORD begin {code(nrn_cppp);} ob ',' pointer
		{ $$ = $2; code(connect_point_process_pointer);
			 hoc_ob_check(-1);}
	| ACCESSKEYWORD section
		{ $$ = $2; code(sec_access);}
	| ACCESSKEYWORD ob
		{ $$ = $2; code(sec_access_object);}
	| INSERTKEYWORD MECHANISM
		{ $$ = Code(mech_access); codesym($2);}
	| UNINSERTKEYWORD MECHANISM
		{ $$ = Code(mech_uninsert); codesym($2);}
	| section stmt
		{ code(sec_access_pop);}
	| ob stmt end
		{ code(sec_access_pop); hoc_ob_check(-1);
			insertcode($2, $3, ob_sec_access);}
	| rangevar '(' expr ':' expr ')' '=' expr ':' expr
		{ TPD; TPD; TPD; TPD; code(range_interpolate); codesym(spop());}
	| rangevar '(' expr ')' '=' expr
		{ TPD; TPD; code(range_interpolate_single); codesym(spop());}
	| FOR '(' varname ')' 
		{Symbol *s; code(varpush); codesym(s = spop());
		 hoc_obvar_declare(s, VAR, 1);
		 $<inst>$ = code(for_segment); codei(0); codei(0);}
	stmt end
		{ $$ = $3; ($<inst>5)[1].i = relative($6, $<inst>5, 1); /* body */
			($<inst>5)[2].i = relative($7, $<inst>5, 2); /* exit */
		}
	| FORALL begin
		{	code(hoc_push_string); codesym((Symbol*)0);
			$<inst>$ = code(forall_section); codei(0); codei(0);}
	stmt end
		{ $$ = $2; ($<inst>3)[1].i = relative($4, $<inst>3, 1); /* body */
			($<inst>3)[2].i = relative($5, $<inst>3, 2); /* exit */
		}
	| FORSEC begin string1
		{ $<inst>$ = code(forall_section); codei(0); codei(0);}
	stmt end
		{ $$ = $2; ($<inst>4)[1].i = relative($5, $<inst>4, 1); /* body */
			($<inst>4)[2].i = relative($6, $<inst>4, 2); /* exit */
		}
	| IFSEC begin string1
		{ $<inst>$ = code(hoc_ifsec); codei(0); codei(0);}
	  stmt end
		{ $$ = $2; ($<inst>4)[1].i = relative($5, $<inst>4, 1); /* body */
			($<inst>4)[2].i = relative($6, $<inst>4, 2); /* exit */
		}
	| FORSEC begin object
		{hoc_ob_check(-1);
		$<inst>$ = code(forall_sectionlist); codei(0); codei(0); }
	stmt end
		{ $$ = $2; ($<inst>4)[1].i = relative($5, $<inst>4, 1); /* body */
			($<inst>4)[2].i = relative($6, $<inst>4, 2); /* exit */
		}
	| IFSEC begin object
		{ hoc_ob_check(-1);
		 $<inst>$ = code(hoc_ifseclist); codei(0); codei(0);
		}

	  stmt end
		{ $$ = $2; ($<inst>4)[1].i = relative($5, $<inst>4, 1); /* body */
			($<inst>4)[2].i = relative($6, $<inst>4, 2); /* exit */
		}
/* END NEWCABLE */
	;

/* NEWCABLE */
section: SECTION {pushs($1); pushi(CHECK);} wholearray
		{code(sec_access_push); codesym(spop()); $$ = $3;}
	;

section_or_ob: section
	| ob
		{hoc_ob_check(SECTION); code(ob_sec_access);}
	;

sectiondecl: sectionname
		{ code(add_section); codesym($1); codei(0);}
	| sectionname numdimen
		{ code(add_section); codesym($1); codei($2);}
	| sectiondecl ',' sectionname
		{code(add_section); codesym($3); codei(0);}
	| sectiondecl ',' sectionname numdimen
		{ code(add_section); codesym($3); codei($4);}
	;
sectionname:anyname
		{
			Symbol* s;
			s = hoc_decl($1);
			if (s->type != UNDEF && s->type != SECTION)
				acterror(s->name, " already declared");
		}
	;
rangevar: rangevar1
		{ code(sec_access_push); codesym((Symbol *)0);}
	| section '.' rangevar1
	;
rangevar1: RANGEVAR {pushs($1); pushi(CHECK);} wholearray
		{$$ = $3;}
	;
pointer: varname /*leave pointer on stack*/
		{ code3(varpush, spop(), hoc_evalpointer);}
	| rangevar '(' expr ')'
		{ TPD; code(rangevarevalpointer); codesym(spop());}
	| ob
		{hoc_ipop(); code(hoc_ob_pointer);}
	| rangevar error {myerr("rangevariable needs explicit arc position,eg. v(.5)");}
;

/* END NEWCABLE */

for_init: FOR '(' expr
		{ TPD; $$ = $3; code(nopop);}
	;
for_st:	/* nothing */
		{ $$ = code(forcode); codei(0); codei(0); codei(0); }
	;
for_cond: ';' expr
		{ TPD; $$ = $2; codein(STOP);}
	;
for_inc:  ';' expr ')'
		{ TPD; $$ = $2; code2(nopop, STOP);}
	;
cond:	'(' expr ')'
		{ TPD; codein(STOP); $$ = $2;}
	;
while:	WHILE for_st
		{ $$ = $2; }
	;
if:	IF
		{ $$=code(ifcode); codei(0); codei(0); codei(0); }
	;
begin:	/* nothing */
		{ $$ = progp; }
	;
end:	/* nothing */
		{ codein(STOP); $$ = progp; }
	;
stmtlist: /* nothing */
		{ $$ = progp; prog_error = $$; }
	| stmtlist '\n'
		{
			prog_parse_recover = progp;
			prog_error = $$;
			if (fin == stdin && !pipeflag)
			{	int i;
				Printf(">");
				for (i = 0; i < ntab; i++)
					Printf("	");
			}
		}
	| stmtlist stmt
	| error
		{myerr("syntax error in compound statement");}

	;

expr:	NUMBER
		{ $$ = code(constpush); codesym($1); PN;}
	|	NUMZERO
		{ $$ = code(pushzero); PN;}
	| varname
		{ code3(varpush, spop(), eval); PN;}
	| ARG
		{ defnonly("$"); $$ = code(arg); codei($1); PN;}
/* NEWCABLE */
	| rangevar
		{code(rangepoint); codesym(spop()); PN;}
	| rangevar '(' expr ')'
		{ TPD; code(rangevareval); codesym(spop()); PN;}
/* END NEWCABLE */
/* OOP */
	| ob
		{code(hoc_object_eval);}
/* END OOP */
	| asgn
	| function begin '(' arglist ')'
		{ $$ = $2; code(call); codesym($1); codei($4); PN;}
	| varname '(' arglist ')'	/* error will be flagged at runtime */
		{ code(call); codesym(spop()); codei($3); PN;}
	| READ '(' varname ')'
		{ $$=$3; code(varread); codesym(spop()); PN;}
	| BLTIN '(' expr ')'
		{ TPD; $$ = $3; code(bltin); codesym($1); PN;}
	| '(' expr ')'
		{ $$ = $2; }
	| '(' error
		{myerr("syntax error in expression");}
	| expr '+' expr
		{ TPD; TPD; code(add); PN; }
	| expr '-' expr
		{ TPD; TPD;code(sub); PN;}
	| expr '*' expr
		{ TPD; TPD; code(mul); PN;}
	| expr '/' expr
		{ TPD; TPD; code(hoc_div); PN;}
	| expr '%' expr
		{ TPD; TPD; code(hoc_cyclic); PN;}
	| expr '^' expr
		{ TPD; TPD; code(power); PN;}
	| '-' expr %prec UNARYMINUS
		{ TPD; $$ = $2; code(negate); PN;}
	| expr GT expr
		{ TPD; TPD; code(gt); PN;}
	| expr GE expr
		{ TPD; TPD; code(ge); PN;}
	| expr LT expr
		{ TPD; TPD; code(lt); PN;}
	| expr LE expr
		{ TPD; TPD; code(le); PN;}
	| expr EQ expr
		{ TPD; TPD; code(eq); PN;}
	| expr NE expr
		{ TPD; TPD; code(ne); PN;}
	| expr AND expr
		{ TPD; TPD; code(and); PN;}
	| expr OR expr
		{ TPD; TPD; code(or); PN;}
	| NOT expr
		{ TPD; $$ = $2; code(not); PN;}
	;
function: FUNCTION
	| FUN_BLTIN
	| OBFUNCTION
	;
doublelist: DOUBLE begin newarray
		{Symbol *s; code(varpush); codesym(s=spop()); $$ = $2;
		code(arayinstal); codei($3); hoc_obvar_declare(s, VAR, 0);}
	| doublelist ',' newarray
		{Symbol *s; code(varpush); codesym(s = spop());
		code(arayinstal); codei($3); hoc_obvar_declare(s, VAR, 0);}
	;

newarray: newname numdimen
		{pushs($1); $$ = $2;}
	;
numdimen: '[' expr ']'
		{  TPD; $$ = 1; }
	| numdimen '[' expr ']'
		{  TPD;$$ = $$ + 1; }
	;
newname: ckvar
	;

varname: AUTO begin
		{ pushs($1); $$ = $2; }
	| VAR begin
		{ if ($1->subtype == USERPROPERTY) {
			code(sec_access_push); codesym((Symbol *)0);
		  }
		pushs($1); pushi(CHECK);
		}
	wholearray {$$ = $2;}
	| section '.' VAR
		{ if ($3->subtype != USERPROPERTY) {
			acterror($3->name, "not a section variable");
		  }
		$$ = $1; pushs($3);
		}
	;

wholearray:begin array	/* using execution stack to get Symbol from array */
			/* and whether to do syntactic check or not */
			/* object component array may share a name with
				the current symbol table which is not an array.
				object component checking done dynamically */
	/* numindices, checkflag=1, arraysym -> arraysym */
	/* numindices, checkflag=0, arraysym -> arraysym numindices*/
		{
		int d1, chk;
		Symbol *sym;
		d1 = ipop();
		chk = ipop();
		sym = spop();
   if (chk) {
	if (!ISARRAY(sym)) {
		if (d1)
			acterror(sym->name, "not an array variable");
	}else{
		if ( d1 == 0 ) { /*fake index list with all 0's*/
			int i;
			for (i=0; i<sym->arayinfo->nsub; i++) {
				code(pushzero);
			}
		}			
		else if ( d1 != sym->arayinfo->nsub) {
			acterror("wrong # of subscripts",sym->name);
		}
	}
   }else {
	pushi(d1); /* must check dynamically */
   }
		pushs(sym);
		}
	;

array:	/* Nothing */
		{ pushi(0); }
	| array '[' expr ']'
		{  TPD;pushi(ipop() + 1); }
	;

prlist:	expr
		{ TPDYNAM; code(prexpr);}
	| string1
		{ code(prstr); }
	| prlist ',' expr
		{ TPDYNAM; code(prexpr);}
	| prlist ',' string1
		{ code(prstr); }
	;
delsym: VAR
		{ $$ = code(hoc_delete_symbol); codesym($1); }
	;
			
defn:	FUNC procname
		{$2->type=FUNCTION; indef=1; }
	'(' ')' procstmt
		{ code(procret); hoc_define($2);
		 $2->u.u_proc->nauto=$6; indef=0; }
	| PROC procname
		{ $2->type=PROCEDURE; indef=1; }
	'(' ')' procstmt
		{ code(procret); hoc_define($2);
		 $2->u.u_proc->nauto=$6; indef=0; }
	;
procname: ckvar
		{ Symbol *s; s=yylval.sym;
		if(s->type != UNDEF) acterror(s->name, "already defined");
		s->u.u_proc = (Proc *)emalloc(sizeof(Proc));
		s->u.u_proc->defn.in = STOP;
		s->u.u_proc->list = (Symlist *)0; }
	| FUNCTION
	| PROCEDURE
	;
procstmt: '{' local {ntab++;} stmtlist '}'
		{
		ntab--;
		$$ = $2;
		}
arglist: /* nothing */
		{ $$ = 0; }
	| arglist1
	;
arglist1: arglist2
		{$$ = 1;}
	| arglist1 ',' arglist2
		{$$ = $1 + 1;}
	;
arglist2: string1
		{}
	| expr
		{ hoc_ob_check(-1);}
	| '&' pointer
	;
eqn_list: DEPENDENT dep_list
		{ $$ = $2; }
	| EQUATION varname ':'
		{code3(varpush, spop(), eqn_name);
		do_equation = 1; }
	equation
		{ $$ = $2; do_equation = 0; }
	;
dep_list: varname
		{Symbol *s; $$ = code3(varpush,s= spop(), dep_make); hoc_obvar_declare(s, VAR, 0);}
	| dep_list ',' varname
		{Symbol *s; code3(varpush, s=spop(), dep_make); hoc_obvar_declare(s, VAR, 0);}
	;
equation: lhs EQNEQ
	| EQNEQ rhs
	| ':'
		{ code(eqn_init); }
	lhs EQNEQ rhs
	;
lhs:
		{ code(eqn_lhs); }
	expr
		{ codein(STOP); TPD; }
	;
rhs:
		{ code(eqn_rhs); }
	expr
		{ codein(STOP); TPD; }
	;
local:	/* nothing */
		{ $$ = 0; }
	| local1
	;
local1:	LOCAL anyname
		{
		Symbol *sp;
		$$ = 1;
		sp = install($2->name, AUTO, 0.0, &p_symlist);
		sp->u.u_auto = $$;
		}
	| local1 ',' anyname
		{
		Symbol *sp;
		$$ = $1 + 1;
		sp = install($3->name, AUTO, 0.0, &p_symlist);
		sp->u.u_auto = $$;
		}
	;
ckvar: VAR
	{  Symbol* s;
	   s = hoc_decl($1);
	   if (s->subtype != NOTUSER)
		acterror("can't redeclare user variable", s->name);
	   $$ = s;
	}
	;
anyname: STRING|VAR|UNDEF|FUNCTION|PROCEDURE|FUN_BLTIN|SECTION|RANGEVAR
	|NRNPNTVAR|OBJECTVAR|TEMPLATE|OBFUNCTION|AUTO|SECTIONREF
	|MECHANISM
	;
%%
	/* end of grammar */

yyerror(s)	/* called for yacc syntax error */
	char *s;
{
	execerror(s, (char *)0);
}

acterror(s, t)	/* recover from action error while parsing */
	char *s, *t;
{
	execerror(s,t);
}
