#if defined(__TURBOC__) || NeXT 
extern void *malloc(), *calloc(), *realloc();
#else
extern char *malloc(), *calloc(), *realloc();
#endif


# line 307 "parse.y"

/* changes as of 2-jan-89 */
/*  version 7.2.1 2-jan-89 short form of the for statement */

#if AIX
#pragma alloca
#endif

#include "hoc.h"
#include "code.h"
#include "equation.h"

#if LINT
Inst *inlint;
#define code	inlint = Code
#else
#define code	Code
#endif

#define paction(arg) fprintf(stderr, "%s\n", arg)

/* maintain a list of ierr addresses so we can clear them */
#define HOCERRSIZE 20
static int** hoc_err;
static int hoc_errp;

static clean_err() {
	int i;
	for (i=0; i < hoc_errp; ++i) {
		*hoc_err[i] = 0;
	}
	hoc_errp = 0;
}

static pusherr(ip) int* ip; {
	if (!hoc_err) {
		hoc_err = (int**)ecalloc(HOCERRSIZE, sizeof(int*));
		hoc_errp = 0;
	}
	if (hoc_errp >= HOCERRSIZE) {
		clean_err();
		hoc_execerror("error stack full", (char*)0);
	}
	hoc_err[hoc_errp++] = ip;
}

#if BISON
#define myerr(arg) static int ierr=0;\
if (!(ierr++)){pusherr(&ierr);yyerror(arg);} --yyssp; --yyvsp; YYERROR
#else
#define myerr(arg) static int ierr=0;\
if (!(ierr++)){pusherr(&ierr);yyerror(arg);} YYERROR
#endif

#define code2(c1,c2)	code(c1); codein(c2)
#define code3(c1,c2,c3)	code(c1); codesym(c2); code(c3)
#define relative(ip1,ip2,offset)	((ip1-ip2) - offset)
#define CHECK 1	/* check syntactically the consistency of arrays */
#define NOCHECK 0 /* don't check syntactically. For object components */
#define PN pushi(NUMBER)	/* for type checking. expressions are usually numbers */
#define TPD hoc_ob_check(NUMBER);
#define TPDYNAM hoc_ob_check(0);

extern int pipeflag;
extern Symlist *symlist;	/* This list is permanent */
extern Symlist *p_symlist; /* Constants, strings, auto variables */
extern Symbol* hoc_decl();

extern arayinstal();
extern int indef;
static Inst *prog_error;			/* needed for stmtlist loc if error */
static int ntab;			/* auto indentation */
extern FILE	*fin;				/* input file pointer */


# line 383 "parse.y"
typedef union  {				/* stack type */
	Symbol	*sym;			/* symbol table pointer */
	Inst	*inst;			/* machine instruction */
	int	narg;			/* number of arguments */
} YYSTYPE;
# define EQNEQ 257
# define NUMBER 258
# define STRING 259
# define PRINT 260
# define DELETE 261
# define VAR 262
# define BLTIN 263
# define UNDEF 264
# define WHILE 265
# define IF 266
# define ELSE 267
# define FOR 268
# define FUNCTION 269
# define PROCEDURE 270
# define RETURN 271
# define FUNC 272
# define PROC 273
# define READ 274
# define DOUBLE 275
# define DEBUG 276
# define EDIT 277
# define FUN_BLTIN 278
# define DEPENDENT 279
# define EQUATION 280
# define LOCAL 281
# define BREAK 282
# define CONTINUE 283
# define AUTO 284
# define STRDEF 285
# define STOPSTMT 286
# define CSTRING 287
# define PARALLEL 288
# define HELP 289
# define ARG 290
# define NUMZERO 291
# define SECTIONKEYWORD 292
# define SECTION 293
# define CONNECTKEYWORD 294
# define ACCESSKEYWORD 295
# define RANGEVAR 296
# define MECHANISM 297
# define INSERTKEYWORD 298
# define FORALL 299
# define NRNPNTVAR 300
# define FORSEC 301
# define IFSEC 302
# define UNINSERTKEYWORD 303
# define SETPOINTERKEYWORD 304
# define SECTIONREF 305
# define BEGINTEMPLATE 306
# define ENDTEMPLATE 307
# define NEW 308
# define OBJECTVAR 309
# define TEMPLATE 310
# define OBJVARDECL 311
# define PUBLICDECL 312
# define EXTERNALDECL 313
# define OBFUNCTION 314
# define OBJECTARG 315
# define STRINGARG 316
# define OR 317
# define AND 318
# define GT 319
# define GE 320
# define LT 321
# define LE 322
# define EQ 323
# define NE 324
# define UNARYMINUS 325
# define NOT 326
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 1081 "parse.y"

	/* end of grammar */

yyerror(s)	/* called for yacc syntax error */
	char *s;
{
	execerror(s, (char *)0);
}

acterror(s, t)	/* recover from action error while parsing */
	char *s, *t;
{
	execerror(s,t);
}
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 63,
	257, 20,
	258, 20,
	259, 20,
	260, 20,
	261, 20,
	262, 20,
	263, 20,
	265, 20,
	266, 20,
	267, 20,
	268, 20,
	269, 20,
	270, 20,
	271, 20,
	274, 20,
	275, 20,
	278, 20,
	279, 20,
	280, 20,
	282, 20,
	283, 20,
	284, 20,
	285, 20,
	286, 20,
	288, 20,
	290, 20,
	291, 20,
	292, 20,
	293, 20,
	294, 20,
	295, 20,
	296, 20,
	298, 20,
	299, 20,
	301, 20,
	302, 20,
	303, 20,
	304, 20,
	309, 20,
	310, 20,
	311, 20,
	314, 20,
	315, 20,
	316, 20,
	61, 20,
	317, 20,
	318, 20,
	319, 20,
	320, 20,
	321, 20,
	322, 20,
	323, 20,
	324, 20,
	43, 20,
	45, 20,
	42, 20,
	47, 20,
	37, 20,
	326, 20,
	94, 20,
	10, 20,
	40, 20,
	41, 20,
	91, 20,
	93, 20,
	46, 20,
	44, 20,
	123, 20,
	125, 20,
	58, 20,
	59, 20,
	-2, 0,
-1, 148,
	258, 134,
	259, 134,
	260, 134,
	261, 134,
	262, 134,
	263, 134,
	265, 134,
	266, 134,
	268, 134,
	269, 134,
	270, 134,
	271, 134,
	274, 134,
	275, 134,
	278, 134,
	279, 134,
	280, 134,
	282, 134,
	283, 134,
	284, 134,
	285, 134,
	286, 134,
	288, 134,
	290, 134,
	291, 134,
	292, 134,
	293, 134,
	294, 134,
	295, 134,
	296, 134,
	298, 134,
	299, 134,
	301, 134,
	302, 134,
	303, 134,
	304, 134,
	309, 134,
	310, 134,
	311, 134,
	314, 134,
	315, 134,
	316, 134,
	45, 134,
	326, 134,
	10, 134,
	40, 134,
	123, 134,
	125, 134,
	-2, 0,
-1, 436,
	258, 134,
	259, 134,
	260, 134,
	261, 134,
	262, 134,
	263, 134,
	265, 134,
	266, 134,
	268, 134,
	269, 134,
	270, 134,
	271, 134,
	274, 134,
	275, 134,
	278, 134,
	279, 134,
	280, 134,
	282, 134,
	283, 134,
	284, 134,
	285, 134,
	286, 134,
	288, 134,
	290, 134,
	291, 134,
	292, 134,
	293, 134,
	294, 134,
	295, 134,
	296, 134,
	298, 134,
	299, 134,
	301, 134,
	302, 134,
	303, 134,
	304, 134,
	309, 134,
	310, 134,
	311, 134,
	314, 134,
	315, 134,
	316, 134,
	45, 134,
	326, 134,
	10, 134,
	40, 134,
	123, 134,
	125, 134,
	-2, 0,
	};
# define YYNPROD 238
# define YYLAST 1953
int yyact[]={

   120,   382,     6,   262,   130,   304,    43,   244,   414,    67,
   386,   229,   242,   312,   265,   291,    72,   231,    63,    80,
    78,    81,   286,    43,    79,   127,   272,   159,   158,    81,
   136,   142,    63,    80,    60,    15,   143,    72,    79,   138,
    78,   420,    60,   151,   155,   156,   144,   272,    43,   139,
   368,   110,   110,   168,   170,   171,    59,   139,   108,   109,
    78,    61,   284,   172,    59,    72,   191,   141,    78,   207,
   125,    63,    80,    72,   384,   143,   143,    79,    82,   276,
    80,    63,    80,   444,   206,    79,    82,    79,   210,   211,
   212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   413,   353,   263,   195,   203,   204,   199,   245,
   387,    92,    62,   227,   233,   235,   236,   237,   239,   243,
   107,   359,   313,   138,   379,    91,   241,   138,   209,    91,
    89,    87,   140,    88,    89,    90,   422,   113,   322,    90,
   129,   118,    18,   256,   248,   367,   116,   260,   113,   143,
    43,   329,    43,     5,   356,   321,   249,   266,   112,    18,
   114,   319,   253,   296,   128,   115,    17,   115,   281,   112,
   119,   143,   118,   138,   138,   372,   270,   118,   255,   152,
   258,   157,    92,    17,    18,   173,    92,   257,   174,   161,
   443,   175,   437,   176,   440,   160,   161,   283,   177,   178,
   405,   201,   280,   404,   153,   345,   292,   179,    17,   138,
   299,   330,   303,   186,   295,   251,   190,   189,   123,   122,
   423,   378,   180,   271,   362,   181,   188,   351,   297,   182,
   350,   298,   341,   232,   187,   302,   394,   357,   183,   184,
   301,   300,   279,   185,   247,   268,   310,   267,   250,   314,
   239,   233,   316,    60,   320,   167,   166,   146,   145,   224,
   138,   138,   315,   137,   104,   103,   106,    43,   332,   333,
   305,   102,   324,   383,   326,    59,   275,   278,    43,   331,
   233,   111,   101,    85,    72,    84,    18,    83,    18,   138,
   121,   340,     4,   147,   415,   385,   416,   259,   381,   261,
   143,   348,   436,   200,   233,   346,   226,   289,   343,   355,
    17,   225,    17,   138,   360,   285,   288,   208,   247,   354,
   364,   352,   365,    43,   205,   339,   337,   338,   336,   273,
   366,   347,   271,   269,   358,   148,   449,   323,   266,   441,
   294,    43,    43,    43,    43,   369,   254,   290,   373,   311,
   194,   240,   105,   292,   389,     3,     1,   391,   233,   393,
   395,   380,   388,    21,    57,    56,     9,   138,   401,   392,
   150,    43,   264,    43,   419,   307,   397,    10,   406,   418,
   411,   230,     2,   403,    49,   246,   417,   407,   408,   409,
   410,    19,    20,   344,   412,   233,   202,   274,   277,   306,
   426,    36,   318,    18,   138,   430,   424,   252,   305,   431,
   334,   432,    52,   427,    18,   429,   434,    53,   435,    30,
    34,    33,    22,   439,   124,   335,   135,    17,   438,   442,
     0,     0,     0,   293,     0,     0,     0,     0,    17,     0,
   445,   305,     0,     0,   450,   446,    43,     0,   453,     0,
    43,   328,     0,   451,    43,     0,     0,     0,     0,    18,
     0,   454,     0,     0,     0,     0,     0,     0,   457,     0,
   363,     0,     0,     0,     0,     0,     0,    18,    18,    18,
    18,    52,     0,    17,     0,   317,    53,     0,   374,   375,
   376,   377,     0,     0,     0,    35,     0,     0,     0,     0,
     0,    17,    17,    17,    17,     0,     0,    18,     0,    18,
   328,     0,     0,   307,     0,     0,     0,     0,   400,     0,
   402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    17,     0,    17,     0,     0,     0,   306,     0,     0,
    52,     0,     0,     0,     0,    53,   307,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   174,     0,
     0,   175,     0,   176,    35,     0,   452,     0,   177,   178,
   306,     0,     0,     0,     0,     0,     0,   179,     0,     0,
     0,     0,    18,   186,     0,     0,    18,     0,     0,     0,
    18,     0,   180,   448,     0,   181,   188,     0,     0,   182,
     0,   455,     0,     0,   187,     0,    17,     0,   183,   184,
    17,    52,     0,   185,    17,     0,    53,   161,     0,     0,
     0,     0,     0,    35,     0,   327,     0,     0,    12,     0,
    47,    81,    29,    23,    60,    51,     0,    68,    69,     0,
    31,    73,    28,    24,    13,    14,    50,    65,     7,     8,
    74,    70,    71,     0,    25,    27,    59,    64,    26,     0,
    32,    11,    16,    48,    37,    72,    38,    40,    78,     0,
    41,    44,     0,    45,    46,    42,    39,     0,    55,    58,
     0,    63,    80,    66,    76,    77,    75,    79,    82,     0,
    52,     0,     0,     0,    35,    53,     0,     0,    54,    47,
    81,    29,    23,    60,    51,     0,    68,    69,     0,    31,
    73,    28,    24,     0,     0,    50,    65,     0,     0,    74,
    70,    71,     0,    25,    27,    59,    64,    26,     0,    32,
     0,    16,    48,    37,    72,    38,    40,    78,     0,    41,
    44,     0,    45,    46,    42,    39,     0,     0,     0,     0,
    63,    80,    66,     0,     0,    75,    79,    82,    47,    81,
    29,    23,    60,    51,     0,    68,    69,    54,    31,    73,
    28,    24,     0,    35,    50,    65,     0,     0,    74,    70,
    71,     0,    25,    27,    59,    64,    26,     0,    32,     0,
    16,    48,    37,    72,    38,    40,    78,     0,    41,    44,
    52,    45,    46,    42,    39,    53,   118,     0,     0,    63,
    80,    66,     0,     0,    75,    79,    82,     0,     0,     0,
     0,   117,     0,     0,     0,     0,    54,     0,     0,    47,
    81,    29,    23,    60,    51,     0,    68,    69,     0,    31,
    73,    28,    24,     0,     0,    50,    65,     0,     0,    74,
    70,    71,     0,    25,    27,    59,    64,    26,     0,    32,
     0,    16,    48,    37,    72,    38,    40,    78,     0,    41,
    44,    52,    45,    46,    42,    39,    53,   234,     0,    52,
    63,    80,    66,    35,    53,    75,    79,    82,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    54,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    47,    81,
    29,    23,    60,    51,     0,    68,    69,     0,    31,    73,
    28,    24,     0,     0,    50,    65,     0,     0,    74,    70,
    71,     0,    25,    27,    59,    64,    26,     0,    32,     0,
    16,    48,    37,    72,    38,    40,    78,     0,    41,    44,
    52,    45,    46,    42,    39,    53,     0,     0,     0,    63,
    80,    66,     0,     0,    75,    79,    82,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    54,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    52,
     0,     0,     0,     0,    53,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    47,    81,
    29,    23,    60,    51,     0,    68,    69,     0,    31,    73,
    28,    24,    52,     0,    50,    65,     0,    53,    74,    70,
    71,     0,    25,    27,    59,    64,    26,     0,    32,     0,
    16,    48,    37,    72,    38,    40,    78,     0,    41,    44,
     0,    45,    46,    42,    39,     0,     0,     0,     0,    63,
    80,    66,     0,     0,    75,    79,    82,     0,     0,     0,
     0,     0,    52,     0,     0,     0,    54,    53,     0,    47,
    81,     0,     0,    60,    51,     0,     0,    47,    81,     0,
    73,    60,    51,     0,     0,    50,     0,     0,    73,    74,
     0,     0,     0,    50,     0,    59,     0,    74,   139,     0,
     0,    16,    48,    59,    72,     0,   139,    78,     0,    16,
    48,    52,    72,     0,     0,    78,    53,     0,     0,   238,
    63,    80,     0,     0,     0,    75,    79,    82,    63,    80,
     0,     0,     0,    75,    79,    82,    91,    54,     0,     0,
   309,    89,    87,     0,    88,    54,    90,     0,    47,    81,
     0,     0,    60,    51,     0,     0,     0,   308,     0,    73,
     0,    91,     0,     0,    50,   456,    89,    87,    74,    88,
     0,    90,     0,     0,    59,     0,     0,   139,     0,     0,
    16,    48,     0,    72,     0,     0,    78,    47,     0,     0,
     0,    60,    51,    92,     0,     0,     0,     0,    73,    63,
    80,     0,     0,    50,    75,    79,    82,    74,     0,     0,
     0,     0,     0,    59,     0,     0,    54,     0,    92,    16,
    48,     0,    72,     0,     0,    78,     0,     0,   228,     0,
    47,     0,     0,     0,    60,    51,     0,   238,    63,    80,
     0,    73,     0,    75,    79,     0,    50,     0,     0,     0,
    74,     0,     0,     0,     0,    54,    59,     0,     0,     0,
     0,     0,    16,    48,     0,    72,     0,    91,    78,     0,
     0,     0,    89,    87,     0,    88,     0,    90,   169,     0,
    47,    63,    80,     0,    60,    51,    75,    79,   447,     0,
     0,    73,     0,     0,     0,     0,    50,    91,    54,     0,
    74,     0,    89,    87,     0,    88,    59,    90,     0,     0,
     0,     0,    16,    48,     0,    72,     0,     0,    78,     0,
    91,     0,     0,     0,    92,    89,    87,   428,    88,    47,
    90,    63,    80,    60,    51,     0,    75,    79,     0,     0,
    73,     0,     0,     0,     0,    50,     0,     0,    54,    74,
     0,     0,     0,   433,    92,    59,     0,     0,     0,     0,
     0,    16,    48,     0,    72,     0,     0,    78,    91,     0,
     0,     0,     0,    89,    87,     0,    88,    92,    90,     0,
    63,    80,     0,    91,     0,    75,    79,   421,    89,    87,
     0,    88,     0,    90,    91,     0,     0,    54,     0,    89,
    87,   399,    88,    91,    90,     0,     0,   398,    89,    87,
     0,    88,     0,    90,     0,     0,   100,    99,    93,    94,
    95,    96,    97,    98,   425,    92,    91,     0,     0,     0,
     0,    89,    87,     0,    88,     0,    90,     0,     0,     0,
    92,   100,    99,    93,    94,    95,    96,    97,    98,    91,
     0,    92,     0,   390,    89,    87,     0,    88,    91,    90,
    92,     0,   371,    89,    87,     0,    88,    91,    90,     0,
     0,   370,    89,    87,     0,    88,     0,    90,     0,     0,
    91,     0,   396,    92,   361,    89,    87,     0,    88,    91,
    90,     0,     0,     0,    89,    87,     0,    88,     0,    90,
     0,     0,     0,    91,     0,     0,    92,   342,    89,    87,
     0,    88,    91,    90,     0,    92,   325,    89,    87,     0,
    88,     0,    90,     0,    92,     0,     0,     0,    91,    86,
     0,     0,   282,    89,    87,     0,    88,    92,    90,     0,
     0,     0,     0,     0,     0,   349,    92,   100,    99,    93,
    94,    95,    96,    97,    98,     0,    91,     0,     0,     0,
    92,    89,    87,     0,    88,    91,    90,     0,     0,    92,
    89,    87,     0,    88,     0,    90,     0,   100,    99,    93,
    94,    95,    96,    97,    98,    92,    91,     0,     0,     0,
     0,    89,    87,     0,    88,     0,    90,     0,     0,     0,
   100,    99,    93,    94,    95,    96,    97,    98,     0,     0,
     0,     0,     0,    92,     0,    91,     0,     0,     0,     0,
    89,    87,    92,    88,     0,    90,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    92,     0,     0,     0,     0,   100,    99,
    93,    94,    95,    96,    97,    98,     0,     0,     0,     0,
     0,     0,     0,   100,    99,    93,    94,    95,    96,    97,
    98,     0,    92,     0,   100,    99,    93,    94,    95,    96,
    97,    98,     0,   100,    99,    93,    94,    95,    96,    97,
    98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   100,    99,    93,    94,
    95,    96,    97,    98,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   100,
    99,    93,    94,    95,    96,    97,    98,     0,   100,    99,
    93,    94,    95,    96,    97,    98,     0,   100,    99,    93,
    94,    95,    96,    97,    98,     0,     0,     0,     0,     0,
   100,    99,    93,    94,    95,    96,    97,    98,     0,   100,
    99,    93,    94,    95,    96,    97,    98,     0,     0,     0,
     0,     0,     0,   100,    99,    93,    94,    95,    96,    97,
    98,     0,   100,    99,    93,    94,    95,    96,    97,    98,
     0,     0,     0,     0,     0,     0,     0,     0,   100,    99,
    93,    94,    95,    96,    97,    98,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   100,    99,    93,    94,
    95,    96,    97,    98,     0,   100,    99,    93,    94,    95,
    96,    97,    98,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   287,     0,    99,    93,    94,
    95,    96,    97,    98,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   126,   131,   132,   133,   134,     0,     0,    93,    94,    95,
    96,    97,    98,   149,     0,   154,     0,     0,     0,     0,
   162,   163,   164,     0,     0,   165,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   192,   193,     0,     0,     0,
   196,   197,   198 };
int yypact[]={

 -1000,   372, -1000,   277,   275,   273,  1539,   272,   261,   255,
   254, -1000, -1000,  -211,  -211,   108,    99,   106,   760,   175,
   174, -1000, -1000,  -192,  1091, -1000, -1000, -1000, -1000,   910,
 -1000,    -9,  -222,   217,   217, -1000, -1000, -1000,  -277,  -256,
  -277,  -269,  -270,   571, -1000, -1000, -1000, -1000, -1000, -1000,
   216,   215,  1042,  1091,  1091,   -71,   173,   172,   299, -1000,
 -1000, -1000, -1000,  -151, -1000, -1000, -1000,    47, -1000, -1000,
  -220,  -220, -1000, -1000, -1000, -1000,   299,  -193, -1000, -1000,
    37, -1000, -1000, -1000, -1000, -1000, -1000,  1091,  1091,  1091,
  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
  1091, -1000, -1000, -1000, -1000,   249, -1000, -1000, -1000, -1000,
 -1000, -1000,   992,   839,  1091,  1091,  1091,   831,   299, -1000,
  1548, -1000,   299,  -210, -1000, -1000, -1000,  1548,   104,    95,
   143, -1000, -1000, -1000,   208,   171,  1548, -1000, -1000, -1000,
   103, -1000,  1091,   141,  -220,   650,  1091,   650,  -152,   299,
   207, -1000,   126,   205, -1000,   130, -1000,   126, -1000, -1000,
 -1000,  -236, -1000,  -230,  -230,   202,  -220,  1091,  1511, -1000,
    17,    17, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,   299,
  -200, -1000, -1000, -1000, -1000, -1000,   299,  -210,   299,  -238,
 -1000, -1000,   170, -1000,   105, -1000, -1000, -1000, -1000,  1091,
    92,    92,    17,    17,    17,    17,    88,    88,    88,    88,
    88,    88,  1598,  1569, -1000,   201,   200,  1548, -1000,   194,
   168, -1000, -1000,  1548,  -228,  1548,  1548,  1119,   299,  1548,
 -1000, -1000, -1000, -1000, -1000, -1000,    31, -1000,  1091,   949,
   839,   910,   102,  1091,    94,    97,  1548,  -215, -1000, -1000,
  1495, -1000,   500, -1000,   167,    31, -1000,  1091,  1091,  -291,
  -276, -1000, -1000,   650, -1000, -1000, -1000, -1000, -1000,   839,
   191,  1486, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   161,    31, -1000, -1000,   126,  -220, -1000, -1000, -1000,  1472,
   189,   186, -1000,   839, -1000, -1000,    63,   126,  1091,    93,
   197, -1000,    30,  1091,  1463,   183,  1548, -1000,   650,  1091,
  1548,  1091, -1000,    84, -1000, -1000,  -217, -1000, -1000, -1000,
   299,    30,  1450,  1441,   131, -1000,   650,   650,   650,   650,
   180, -1000, -1000, -1000,    33,   299,    30, -1000,    16, -1000,
   -13,   -13, -1000,  1091, -1000,  1432,  1091,   839,   196,  1091,
  1409, -1000, -1000, -1000,  1386,  1377,   650,  1091,   650,    31,
   159,   156,  -228, -1000, -1000, -1000, -1000, -1000, -1000,  1091,
    31, -1000,  -155, -1000, -1000,  1091, -1000,  -240, -1000,  1366,
    75,  1548,   179, -1000,   839,  1351, -1000, -1000, -1000,  1091,
 -1000,  1303, -1000,    30,  1091,  -228, -1000, -1000, -1000, -1000,
 -1000,  1280,    30, -1000, -1000,  1091, -1000,  1548, -1000,   148,
   299, -1000,  1091, -1000,   153, -1000,  1548, -1000,  1091, -1000,
  1548,   150, -1000, -1000,  1548,  -174,  -152,   299, -1000,  1250,
 -1000,   650,  1548,  1091, -1000,   441, -1000,  1091, -1000,   650,
  1144, -1000, -1000,  1548, -1000, -1000, -1000, -1000 };
int yypgo[]={

     0,     0,   151,   290,   426,   424,     3,   422,   258,   421,
   420,  1885,    12,   419,   132,   407,   402,   401,   396,    35,
    22,   393,     5,   392,   391,   233,     9,   266,   385,   384,
   119,   120,     7,    11,   381,   379,   374,   109,    13,    10,
   372,    14,   164,    61,     4,   370,   366,   365,   364,    15,
   140,   363,   112,   359,   356,   355,   352,   350,   349,   347,
   346,   339,   337,   336,   335,   333,   330,   329,   328,   327,
   326,   325,   324,   317,   315,   311,   306,   302,    17,   301,
   298,     1,     8,   296,   295,   294 };
int yyr1[]={

     0,    54,    54,    54,    54,    54,    54,    54,    54,    54,
    54,    56,    54,    54,     3,     3,     3,     3,     3,     3,
    57,    52,    52,    52,    50,    58,    50,    50,    53,    53,
    46,    46,    46,    46,    46,    51,    59,    59,    59,    59,
    49,    47,    47,    48,    48,     7,     7,     7,     7,    25,
    25,    26,    26,    24,    24,    30,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    60,    61,     2,    62,    63,     2,     2,     2,     2,    64,
     2,     2,     2,     2,     2,     2,    65,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    66,     2,    67,     2,
    68,     2,    69,     2,    70,     2,    71,     2,    72,    44,
    45,    45,    40,    40,    40,    40,    41,    42,    42,    73,
    43,    22,    22,    22,    22,    13,    14,    15,    16,     8,
     9,    10,    11,    12,     6,     6,     6,     6,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,    29,    29,
    29,    23,    23,    37,    38,    38,    28,    19,    74,    19,
    19,    20,    21,    21,     4,     4,     4,     4,     5,    75,
    55,    76,    55,    27,    27,    27,    77,    39,    33,    33,
    34,    34,    78,    78,    78,    17,    79,    17,    18,    18,
    80,    80,    83,    80,    84,    81,    85,    82,    35,    35,
    36,    36,    31,    32,    32,    32,    32,    32,    32,    32,
    32,    32,    32,    32,    32,    32,    32,    32 };
int yyr2[]={

     0,     1,     5,     7,     7,     7,     7,     7,     7,     7,
     7,     1,     9,     5,     7,     7,     7,    15,     7,     7,
     1,     7,     3,     9,     2,     1,    13,     5,     1,     7,
     5,     2,     2,     5,     5,     7,     3,     5,     7,     9,
     3,     5,     7,     5,     7,     7,     7,     7,     5,     2,
     3,     3,     3,     7,     6,     3,     3,     2,     2,     2,
     2,     5,     5,     5,     5,     5,     5,    11,     5,    13,
     1,     1,    21,     1,     1,    23,     9,     9,    15,     1,
     9,     2,     7,    15,    21,    15,     1,    13,     5,     5,
     5,     5,     5,     7,    21,    13,     1,    15,     1,    11,
     1,    13,     1,    13,     1,    13,     1,    13,     1,     7,
     2,     3,     3,     5,     7,     9,     3,     3,     6,     1,
     7,     3,     9,     3,     5,     7,     1,     5,     7,     7,
     5,     3,     1,     1,     1,     5,     4,     3,     3,     3,
     3,     3,     3,     9,     3,     2,    11,     9,     9,     9,
     7,     5,     7,     7,     7,     7,     7,     7,     5,     7,
     7,     7,     7,     7,     7,     7,     7,     5,     2,     2,
     2,     7,     7,     5,     7,     9,     2,     5,     1,     9,
     7,     5,     1,     9,     3,     3,     7,     7,     3,     1,
    13,     1,    13,     3,     2,     2,     1,    11,     1,     2,
     3,     7,     3,     3,     4,     5,     1,    11,     3,     7,
     4,     4,     1,    10,     1,     5,     1,     5,     1,     2,
     5,     7,     3,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2 };
int yychk[]={

 -1000,   -54,    10,   -55,    -3,    -2,    -1,   276,   277,   -46,
     5,   289,   256,   272,   273,   -19,   290,   -42,   -50,   -24,
   -23,   -51,    -7,   261,   271,   282,   286,   283,   270,   260,
   -13,   268,   288,    -9,   -10,   123,   -17,   292,   294,   304,
   295,   298,   303,   -44,   299,   301,   302,   258,   291,   -29,
   274,   263,    40,    45,   326,   306,   -47,   -48,   307,   284,
   262,   -43,   -52,   309,   285,   275,   311,   -26,   265,   266,
   279,   280,   293,   269,   278,   314,   312,   313,   296,   315,
   310,   259,   316,    10,    10,    10,    10,    43,    45,    42,
    47,    37,    94,   319,   320,   321,   322,   323,   324,   318,
   317,    10,    10,    10,    10,   -56,   -27,   -31,   269,   270,
   262,   -27,    61,    40,    61,    61,    40,    61,    46,    -2,
    -1,    -3,    44,    44,    -5,   262,   -11,    -1,   -42,   -50,
   -44,   -11,   -11,   -11,   -11,    -4,    -1,   -25,   -26,   287,
   -14,   -19,    40,   -44,   268,    -8,    40,    -8,   -64,   -11,
   -45,   -44,   -50,   -42,   -11,   -44,   -44,   -50,   297,   297,
    -2,    46,   -11,   -11,   -11,   -11,    40,    40,    -1,   256,
    -1,    -1,   -32,   256,   259,   262,   264,   269,   270,   278,
   293,   296,   300,   309,   310,   314,   284,   305,   297,    44,
    44,   -32,   -11,   -11,   -57,   256,   -11,   -11,   -11,    61,
   256,   -14,   -18,   -19,   -19,   -72,   -32,   262,   -73,    91,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    10,   -75,   -76,    -1,   256,   -33,
   -34,   -78,   -25,    -1,    38,    -1,    -1,    -1,   308,    -1,
   -25,   -32,   -12,   -30,   -32,   -37,   -28,   -31,    40,    61,
    40,    44,   -15,    59,   -60,   -19,    -1,    46,   -19,    -2,
    -1,    -2,    -6,   256,   -40,   -41,   -32,    40,    40,   -65,
    46,   -43,   262,   -67,   -25,   -52,   309,   -25,   -52,    40,
   -19,    -1,    41,   -32,   262,   -74,   -20,   -11,   -30,   -37,
   -59,   -49,   -32,   -25,   -50,    44,    58,   -20,   -20,    -1,
    40,    40,    41,    44,   -22,   -19,   -42,   -50,    58,    41,
   -32,   -58,   -38,    91,    -1,   -33,    -1,   -25,   -16,    59,
    -1,    61,    41,   -62,   -12,    41,   -12,   125,    10,    -2,
    44,   -38,    -1,    -1,   -50,    -2,   -68,   -70,   -69,   -71,
   -33,    41,    41,   -20,   -21,    44,   -38,   -19,   -79,    93,
    41,    41,   -78,    40,   256,    -1,    61,    40,   -20,    91,
    -1,    41,    41,    -2,    -1,    -1,   -66,    61,   267,   -41,
    41,    41,    44,   -12,    -2,    -2,    -2,    -2,    41,    91,
   -49,   -80,   -81,   257,    58,   -84,   -39,   123,   -39,    -1,
    41,    -1,   -33,   -53,    40,    -1,    93,   -12,    41,    44,
    -2,    -1,    -2,   -38,    44,    44,   -22,   -12,   -12,   -12,
   -12,    -1,   -38,   257,   -82,   -85,   -83,    -1,   -35,   -36,
   281,    41,    61,    41,   -33,    93,    -1,   -12,    44,   -12,
    -1,   -44,   -22,    93,    -1,   -81,   -77,    44,   -32,    -1,
    41,   -61,    -1,    40,   257,    -6,   -32,    58,    -2,   -63,
    -1,   -82,   125,    -1,   -12,    -2,    41,   -12 };
int yydef[]={

     1,    -2,     2,     0,   145,     0,     0,     0,     0,     0,
     0,    11,    13,     0,     0,   140,   141,   142,   144,    57,
    58,    59,    60,     0,   132,   132,   132,   132,   132,     0,
   126,     0,     0,     0,     0,    79,    81,   132,     0,   132,
     0,     0,     0,     0,   132,   132,   132,   138,   139,   132,
     0,     0,     0,     0,     0,     0,    31,    32,     0,   132,
   132,   117,    24,    -2,   132,   132,   132,     0,   126,   131,
     0,     0,   108,   168,   169,   170,     0,     0,   119,    22,
     0,    51,    52,     3,     4,     5,     6,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     7,     8,     9,    10,     0,   189,   193,   194,   195,
   222,   191,     0,   198,     0,     0,     0,     0,     0,   133,
    56,   145,     0,     0,    61,   188,    62,    63,   142,   144,
     0,    64,    65,    66,     0,    68,   184,   185,    49,    50,
     0,    70,     0,     0,     0,     0,     0,     0,    -2,     0,
     0,   110,   111,     0,    86,     0,    88,    89,    90,    91,
    92,     0,    98,     0,     0,     0,     0,     0,     0,   151,
   158,   167,    30,    34,   223,   224,   225,   226,   227,   228,
   229,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     0,    33,   177,   178,   132,    27,     0,     0,     0,     0,
    48,   130,   205,   208,     0,   132,    41,    43,   132,     0,
   152,   153,   154,   155,   156,   157,   159,   160,   161,   162,
   163,   164,   165,   166,    12,     0,     0,    14,    19,     0,
   199,   200,   202,   203,     0,    15,    16,     0,     0,    18,
    46,    25,    93,    54,    55,   172,     0,   176,     0,     0,
   198,     0,     0,     0,     0,   140,   125,     0,    73,   133,
     0,   133,     0,   137,    82,   112,   116,     0,     0,     0,
     0,   118,   180,     0,   100,   104,    20,   102,   106,   198,
     0,     0,   150,    42,    44,   132,    21,   182,    53,   171,
    35,    36,    40,    45,    47,     0,   206,   109,   120,     0,
     0,     0,   147,     0,   204,   121,     0,   123,     0,   143,
     0,   132,   173,     0,     0,     0,   186,   187,     0,     0,
   127,     0,    96,     0,    76,   129,    77,    80,   135,   136,
     0,   113,     0,     0,     0,   133,     0,     0,     0,     0,
     0,   148,   149,   179,   181,     0,    37,   209,   214,    23,
     0,     0,   201,     0,   124,     0,     0,   198,    28,     0,
     0,   143,    67,   133,     0,     0,     0,     0,     0,   114,
     0,     0,     0,    99,   133,   133,   133,   133,   146,     0,
    38,   207,     0,   216,   212,     0,   190,   218,   192,     0,
     0,    95,     0,    26,   198,     0,   174,    69,   128,     0,
   133,     0,   133,   115,     0,     0,    87,   101,   105,   103,
   107,     0,    39,   210,   211,     0,   214,   215,   196,   219,
     0,   122,     0,    17,     0,   175,    71,    97,     0,    78,
    83,     0,    85,   183,   217,     0,    -2,     0,   220,     0,
    29,     0,    74,     0,   216,     0,   221,     0,   133,     0,
     0,   213,   197,    94,    72,   133,    84,    75 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"EQNEQ",	257,
	"NUMBER",	258,
	"STRING",	259,
	"PRINT",	260,
	"DELETE",	261,
	"VAR",	262,
	"BLTIN",	263,
	"UNDEF",	264,
	"WHILE",	265,
	"IF",	266,
	"ELSE",	267,
	"FOR",	268,
	"FUNCTION",	269,
	"PROCEDURE",	270,
	"RETURN",	271,
	"FUNC",	272,
	"PROC",	273,
	"READ",	274,
	"DOUBLE",	275,
	"DEBUG",	276,
	"EDIT",	277,
	"FUN_BLTIN",	278,
	"DEPENDENT",	279,
	"EQUATION",	280,
	"LOCAL",	281,
	"BREAK",	282,
	"CONTINUE",	283,
	"AUTO",	284,
	"STRDEF",	285,
	"STOPSTMT",	286,
	"CSTRING",	287,
	"PARALLEL",	288,
	"HELP",	289,
	"ARG",	290,
	"NUMZERO",	291,
	"SECTIONKEYWORD",	292,
	"SECTION",	293,
	"CONNECTKEYWORD",	294,
	"ACCESSKEYWORD",	295,
	"RANGEVAR",	296,
	"MECHANISM",	297,
	"INSERTKEYWORD",	298,
	"FORALL",	299,
	"NRNPNTVAR",	300,
	"FORSEC",	301,
	"IFSEC",	302,
	"UNINSERTKEYWORD",	303,
	"SETPOINTERKEYWORD",	304,
	"SECTIONREF",	305,
	"BEGINTEMPLATE",	306,
	"ENDTEMPLATE",	307,
	"NEW",	308,
	"OBJECTVAR",	309,
	"TEMPLATE",	310,
	"OBJVARDECL",	311,
	"PUBLICDECL",	312,
	"EXTERNALDECL",	313,
	"OBFUNCTION",	314,
	"OBJECTARG",	315,
	"STRINGARG",	316,
	"=",	61,
	"OR",	317,
	"AND",	318,
	"GT",	319,
	"GE",	320,
	"LT",	321,
	"LE",	322,
	"EQ",	323,
	"NE",	324,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"%",	37,
	"UNARYMINUS",	325,
	"NOT",	326,
	"^",	94,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"list : /* empty */",
	"list : list '\n'",
	"list : list defn '\n'",
	"list : list asgn '\n'",
	"list : list stmt '\n'",
	"list : list expr '\n'",
	"list : list DEBUG '\n'",
	"list : list EDIT '\n'",
	"list : list template '\n'",
	"list : list '' '\n'",
	"list : list HELP",
	"list : list HELP '\n'",
	"list : list error",
	"asgn : varname '=' expr",
	"asgn : ARG '=' expr",
	"asgn : rangevar '=' expr",
	"asgn : ob '=' NEW anyname '(' arglist ')'",
	"asgn : ob '=' expr",
	"asgn : varname '=' error",
	"object : OBJECTVAR",
	"object : OBJECTVAR wholearray",
	"object : OBJECTARG",
	"object : TEMPLATE '[' expr ']'",
	"ob : object",
	"ob : ob '.' anyname",
	"ob : ob '.' anyname wholearray func_or_range_array_case",
	"ob : OBJECTVAR error",
	"func_or_range_array_case : /* empty */",
	"func_or_range_array_case : '(' arglist ')'",
	"template : BEGINTEMPLATE anyname",
	"template : publiclist",
	"template : externallist",
	"template : ENDTEMPLATE anyname",
	"template : BEGINTEMPLATE error",
	"objvarlist : OBJVARDECL begin objvarlst1",
	"objvarlst1 : obvarname",
	"objvarlst1 : obvarname numdimen",
	"objvarlst1 : objvarlst1 ',' obvarname",
	"objvarlst1 : objvarlst1 ',' obvarname numdimen",
	"obvarname : anyname",
	"publiclist : PUBLICDECL anyname",
	"publiclist : publiclist ',' anyname",
	"externallist : EXTERNALDECL VAR",
	"externallist : externallist ',' VAR",
	"strnasgn : string2 '=' string1",
	"strnasgn : ob '=' string1",
	"strnasgn : string2 '=' ob",
	"strnasgn : string2 error",
	"string1 : string2",
	"string1 : CSTRING",
	"string2 : STRING",
	"string2 : STRINGARG",
	"strlist : STRDEF begin string",
	"strlist : strlist ',' string",
	"string : anyname",
	"stmt : expr",
	"stmt : strlist",
	"stmt : doublelist",
	"stmt : objvarlist",
	"stmt : strnasgn",
	"stmt : DELETE delsym",
	"stmt : RETURN begin",
	"stmt : RETURN expr",
	"stmt : BREAK begin",
	"stmt : STOPSTMT begin",
	"stmt : CONTINUE begin",
	"stmt : PROCEDURE begin '(' arglist ')'",
	"stmt : PRINT prlist",
	"stmt : for_init for_st for_cond for_inc stmt end",
	"stmt : FOR varname",
	"stmt : FOR varname '=' expr ',' expr",
	"stmt : FOR varname '=' expr ',' expr stmt end",
	"stmt : PARALLEL FOR varname",
	"stmt : PARALLEL FOR varname '=' expr ',' expr",
	"stmt : PARALLEL FOR varname '=' expr ',' expr stmt end",
	"stmt : while cond stmt end",
	"stmt : if cond stmt end",
	"stmt : if cond stmt end ELSE stmt end",
	"stmt : '{'",
	"stmt : '{' stmtlist '}'",
	"stmt : eqn_list",
	"stmt : SECTIONKEYWORD begin sectiondecl",
	"stmt : CONNECTKEYWORD section_or_ob '(' expr ')' ',' expr",
	"stmt : CONNECTKEYWORD section_or_ob '(' expr ')' ',' section '(' expr ')'",
	"stmt : SETPOINTERKEYWORD rangevar '(' expr ')' ',' pointer",
	"stmt : SETPOINTERKEYWORD begin",
	"stmt : SETPOINTERKEYWORD begin ob ',' pointer",
	"stmt : ACCESSKEYWORD section",
	"stmt : ACCESSKEYWORD ob",
	"stmt : INSERTKEYWORD MECHANISM",
	"stmt : UNINSERTKEYWORD MECHANISM",
	"stmt : section stmt",
	"stmt : ob stmt end",
	"stmt : rangevar '(' expr ':' expr ')' '=' expr ':' expr",
	"stmt : rangevar '(' expr ')' '=' expr",
	"stmt : FOR '(' varname ')'",
	"stmt : FOR '(' varname ')' stmt end",
	"stmt : FORALL begin",
	"stmt : FORALL begin stmt end",
	"stmt : FORSEC begin string1",
	"stmt : FORSEC begin string1 stmt end",
	"stmt : IFSEC begin string1",
	"stmt : IFSEC begin string1 stmt end",
	"stmt : FORSEC begin object",
	"stmt : FORSEC begin object stmt end",
	"stmt : IFSEC begin object",
	"stmt : IFSEC begin object stmt end",
	"section : SECTION",
	"section : SECTION wholearray",
	"section_or_ob : section",
	"section_or_ob : ob",
	"sectiondecl : sectionname",
	"sectiondecl : sectionname numdimen",
	"sectiondecl : sectiondecl ',' sectionname",
	"sectiondecl : sectiondecl ',' sectionname numdimen",
	"sectionname : anyname",
	"rangevar : rangevar1",
	"rangevar : section '.' rangevar1",
	"rangevar1 : RANGEVAR",
	"rangevar1 : RANGEVAR wholearray",
	"pointer : varname",
	"pointer : rangevar '(' expr ')'",
	"pointer : ob",
	"pointer : rangevar error",
	"for_init : FOR '(' expr",
	"for_st : /* empty */",
	"for_cond : ';' expr",
	"for_inc : ';' expr ')'",
	"cond : '(' expr ')'",
	"while : WHILE for_st",
	"if : IF",
	"begin : /* empty */",
	"end : /* empty */",
	"stmtlist : /* empty */",
	"stmtlist : stmtlist '\n'",
	"stmtlist : stmtlist stmt",
	"stmtlist : error",
	"expr : NUMBER",
	"expr : NUMZERO",
	"expr : varname",
	"expr : ARG",
	"expr : rangevar",
	"expr : rangevar '(' expr ')'",
	"expr : ob",
	"expr : asgn",
	"expr : function begin '(' arglist ')'",
	"expr : varname '(' arglist ')'",
	"expr : READ '(' varname ')'",
	"expr : BLTIN '(' expr ')'",
	"expr : '(' expr ')'",
	"expr : '(' error",
	"expr : expr '+' expr",
	"expr : expr '-' expr",
	"expr : expr '*' expr",
	"expr : expr '/' expr",
	"expr : expr '%' expr",
	"expr : expr '^' expr",
	"expr : '-' expr",
	"expr : expr GT expr",
	"expr : expr GE expr",
	"expr : expr LT expr",
	"expr : expr LE expr",
	"expr : expr EQ expr",
	"expr : expr NE expr",
	"expr : expr AND expr",
	"expr : expr OR expr",
	"expr : NOT expr",
	"function : FUNCTION",
	"function : FUN_BLTIN",
	"function : OBFUNCTION",
	"doublelist : DOUBLE begin newarray",
	"doublelist : doublelist ',' newarray",
	"newarray : newname numdimen",
	"numdimen : '[' expr ']'",
	"numdimen : numdimen '[' expr ']'",
	"newname : ckvar",
	"varname : AUTO begin",
	"varname : VAR begin",
	"varname : VAR begin wholearray",
	"varname : section '.' VAR",
	"wholearray : begin array",
	"array : /* empty */",
	"array : array '[' expr ']'",
	"prlist : expr",
	"prlist : string1",
	"prlist : prlist ',' expr",
	"prlist : prlist ',' string1",
	"delsym : VAR",
	"defn : FUNC procname",
	"defn : FUNC procname '(' ')' procstmt",
	"defn : PROC procname",
	"defn : PROC procname '(' ')' procstmt",
	"procname : ckvar",
	"procname : FUNCTION",
	"procname : PROCEDURE",
	"procstmt : '{' local",
	"procstmt : '{' local stmtlist '}'",
	"arglist : /* empty */",
	"arglist : arglist1",
	"arglist1 : arglist2",
	"arglist1 : arglist1 ',' arglist2",
	"arglist2 : string1",
	"arglist2 : expr",
	"arglist2 : '&' pointer",
	"eqn_list : DEPENDENT dep_list",
	"eqn_list : EQUATION varname ':'",
	"eqn_list : EQUATION varname ':' equation",
	"dep_list : varname",
	"dep_list : dep_list ',' varname",
	"equation : lhs EQNEQ",
	"equation : EQNEQ rhs",
	"equation : ':'",
	"equation : ':' lhs EQNEQ rhs",
	"lhs : /* empty */",
	"lhs : expr",
	"rhs : /* empty */",
	"rhs : expr",
	"local : /* empty */",
	"local : local1",
	"local1 : LOCAL anyname",
	"local1 : local1 ',' anyname",
	"ckvar : VAR",
	"anyname : STRING",
	"anyname : VAR",
	"anyname : UNDEF",
	"anyname : FUNCTION",
	"anyname : PROCEDURE",
	"anyname : FUN_BLTIN",
	"anyname : SECTION",
	"anyname : RANGEVAR",
	"anyname : NRNPNTVAR",
	"anyname : OBJECTVAR",
	"anyname : TEMPLATE",
	"anyname : OBFUNCTION",
	"anyname : AUTO",
	"anyname : SECTIONREF",
	"anyname : MECHANISM",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{  return(0); }
#define YYABORT		{  return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
if (!yyv) {

	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
}

	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 432 "parse.y"
{ ntab = 0;} break;
case 2:
# line 433 "parse.y"
{ return '\n';} break;
case 3:
# line 434 "parse.y"
{ return '\n';} break;
case 4:
# line 436 "parse.y"
{ hoc_ob_check(-1); code2(nopop, STOP); return 1; } break;
case 5:
# line 438 "parse.y"
{ codein(STOP); return 1; } break;
case 6:
# line 440 "parse.y"
{ hoc_ob_check(-1); code2(print, STOP); return 1; } break;
case 7:
# line 442 "parse.y"
{ debug(); return '\n';} break;
case 8:
# line 444 "parse.y"
{ return 'e';} break;
case 9:
# line 446 "parse.y"
{ return '\n';} break;
case 10:
# line 449 "parse.y"
{ plt(-3,0.,0.); return '\n';} break;
case 11:
# line 450 "parse.y"
{hoc_help();} break;
case 12:
# line 450 "parse.y"
{ return '\n'; } break;
case 13:
# line 452 "parse.y"
{clean_err(); hoc_execerror("parse error", (char*)0);
#if LINT
if (0) {
if(yydebug);
goto yynewstate;
}
#endif
		} break;
case 14:
# line 462 "parse.y"
{Symbol *s; TPD; s = spop();
		hoc_obvar_declare(s, VAR, 1);
		code3(varpush, s, assign); PN;} break;
case 15:
# line 466 "parse.y"
{  TPD; defnonly("$"); code(argassign); codei(yypvt[-2].narg); yyval.inst=yypvt[-0].inst; PN;} break;
case 16:
# line 469 "parse.y"
{ TPD; code(range_const); codesym(spop()); PN;} break;
case 17:
# line 473 "parse.y"
{extern Symbol* hoc_which_template();
		 code(hoc_newobj); codesym(hoc_which_template(yypvt[-3].sym)); codei(yypvt[-1].narg);} break;
case 18:
# line 476 "parse.y"
{TPDYNAM; code(hoc_object_asgn); pushi(OBJECTVAR);} break;
case 19:
# line 478 "parse.y"
{myerr("assignment to variable, make sure right side is a number");} break;
case 20:
# line 482 "parse.y"
{pushi(OBJECTVAR);pushs(yypvt[-0].sym); pushi(CHECK);} break;
case 21:
# line 483 "parse.y"
{yyval.inst = yypvt[-0].inst; code(hoc_objectvar); spop(); codesym(yypvt[-2].sym);} break;
case 22:
# line 485 "parse.y"
{defnonly("$o"); yyval.inst = code(hoc_objectarg); codei(yypvt[-0].narg); pushi(OBJECTVAR);} break;
case 23:
# line 487 "parse.y"
{TPD; yyval.inst = yypvt[-1].inst; code(hoc_constobject); codesym(yypvt[-3].sym); pushi(OBJECTVAR);} break;
case 25:
# line 490 "parse.y"
{pushs(yypvt[-0].sym);pushi(NOCHECK);} break;
case 26:
# line 491 "parse.y"
{code(hoc_object_component); codesym(spop()); codei(ipop());
		 codei(yypvt[-0].narg);
		 codei(0); codesym(0);
		} break;
case 27:
# line 495 "parse.y"
{myerr("object syntax is o1.o2.o3.");} break;
case 28:
# line 498 "parse.y"
{yyval.narg = 0;} break;
case 29:
# line 500 "parse.y"
{yyval.narg = yypvt[-1].narg;} break;
case 30:
# line 502 "parse.y"
{hoc_begintemplate(yypvt[-0].sym);} break;
case 33:
# line 505 "parse.y"
{hoc_endtemplate(yypvt[-0].sym);} break;
case 34:
# line 506 "parse.y"
{myerr("begintemplate Name\npublic namelist\nexternal namelist\n...\nendtemplate Name");} break;
case 35:
# line 509 "parse.y"
{yyval.inst = yypvt[-1].inst;} break;
case 36:
# line 512 "parse.y"
{code(hoc_objvardecl); codesym(yypvt[-0].sym); codei(0);} break;
case 37:
# line 514 "parse.y"
{code(hoc_objvardecl); codesym(yypvt[-1].sym); codei(yypvt[-0].narg);} break;
case 38:
# line 516 "parse.y"
{code(hoc_objvardecl); codesym(yypvt[-0].sym); codei(0);} break;
case 39:
# line 518 "parse.y"
{code(hoc_objvardecl); codesym(yypvt[-1].sym); codei(yypvt[-0].narg);} break;
case 40:
# line 521 "parse.y"
{
		  Symbol* s;
		  s = hoc_decl(yypvt[-0].sym);
		  if (s->type != UNDEF && s->type != OBJECTVAR) {
			acterror(s->name, " already declared");
		  }
		  yyval.sym = s;
		} break;
case 41:
# line 531 "parse.y"
{hoc_add_publiclist(yypvt[-0].sym);} break;
case 42:
# line 533 "parse.y"
{hoc_add_publiclist(yypvt[-0].sym);} break;
case 43:
# line 536 "parse.y"
{hoc_external_var(yypvt[-0].sym);} break;
case 44:
# line 538 "parse.y"
{hoc_external_var(yypvt[-0].sym);} break;
case 45:
# line 543 "parse.y"
{code(assstr);} break;
case 46:
# line 545 "parse.y"
{pushi(STRING); TPDYNAM; code(hoc_object_asgn);
		 hoc_ob_check(-1); code(nopop);
		} break;
case 47:
# line 549 "parse.y"
{code(hoc_asgn_obj_to_str);} break;
case 48:
# line 550 "parse.y"
{myerr("string assignment: both sides need to be a string");} break;
case 50:
# line 555 "parse.y"
{yyval.inst = code(hoc_push_string); codesym(yypvt[-0].sym);} break;
case 51:
# line 559 "parse.y"
{yyval.inst = code(hoc_push_string); codesym(yypvt[-0].sym);} break;
case 52:
# line 561 "parse.y"
{defnonly("$s"); yyval.inst = code(hoc_stringarg); codei(yypvt[-0].narg);} break;
case 53:
# line 565 "parse.y"
{ yyval.inst = yypvt[-1].inst; } break;
case 55:
# line 569 "parse.y"
{
			Symbol* s = hoc_decl(yypvt[-0].sym);
			if (s->type == UNDEF) {
				hoc_obvar_declare(s, STRING, 0);
				OPSTR(s) = (char**)emalloc(sizeof(char*));
				*OPSTR(s) = 0;
			}else if (s->type != STRING) {
				acterror(s->name, " already declared");
			}
			hoc_assign_str(OPSTR(s), "");
		} break;
case 56:
# line 582 "parse.y"
{ code(nopop); hoc_ob_check(-1); /*don't check*/} break;
case 61:
# line 590 "parse.y"
{ yyval.inst = yypvt[-0].inst;} break;
case 62:
# line 592 "parse.y"
{ defnonly("return"); yyval.inst=yypvt[-0].inst; code(procret); } break;
case 63:
# line 594 "parse.y"
{  TPD; defnonly("return"); yyval.inst=yypvt[-0].inst; code(funcret);} break;
case 64:
# line 596 "parse.y"
{ code(Break); yyval.inst = yypvt[-0].inst; } break;
case 65:
# line 598 "parse.y"
{ code(Stop); yyval.inst = yypvt[-0].inst; } break;
case 66:
# line 600 "parse.y"
{ code(Continue); yyval.inst = yypvt[-0].inst; } break;
case 67:
# line 602 "parse.y"
{ yyval.inst = yypvt[-3].inst; code(call); codesym(yypvt[-4].sym); codei(yypvt[-1].narg); code(nopop); } break;
case 68:
# line 604 "parse.y"
{ yyval.inst = yypvt[-0].inst; code(hoc_newline); } break;
case 69:
# line 606 "parse.y"
{
			(yypvt[-4].inst)[1].i =relative(yypvt[-1].inst, yypvt[-4].inst, 1);	/* body */
			(yypvt[-4].inst)[2].i =relative(yypvt[-0].inst, yypvt[-4].inst, 2); /* exit from the for */
			(yypvt[-4].inst)[3].i  =relative(yypvt[-2].inst, yypvt[-4].inst, 3);	/* increment */
			yyval.inst = yypvt[-5].inst;
#if LINT
if (0){YYERROR;}
#endif
			} break;
case 70:
# line 616 "parse.y"
{ Symbol *s; yyval.inst = Code(varpush); codesym(s = spop());
			hoc_obvar_declare(s, VAR, 1);
		  } break;
case 71:
# line 620 "parse.y"
{yyval.inst = code(shortfor); codei(0); codei(0); TPD; TPD;} break;
case 72:
# line 622 "parse.y"
{ yyval.inst = yypvt[-8].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			   (yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		  } break;
case 73:
# line 626 "parse.y"
{ Symbol *s; yyval.inst = Code(varpush); codesym(s = spop());
			hoc_obvar_declare(s, VAR, 1);
		  } break;
case 74:
# line 630 "parse.y"
{  code(hoc_parallel_begin);
		     yyval.inst = code(shortfor); codei(0); codei(0); TPD; TPD;} break;
case 75:
# line 633 "parse.y"
{ yyval.inst = yypvt[-8].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			   (yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
			code(hoc_parallel_end);
		  } break;
case 76:
# line 638 "parse.y"
{
		(yypvt[-3].inst)[1].i = relative(yypvt[-1].inst, yypvt[-3].inst, 1);	/* body of loop */
		(yypvt[-3].inst)[2].i = relative(yypvt[-0].inst, yypvt[-3].inst, 2); } break;
case 77:
# line 642 "parse.y"
{
		(yypvt[-3].inst)[1].i = relative(yypvt[-1].inst, yypvt[-3].inst, 1);	/* thenpart */
		(yypvt[-3].inst)[3].i = relative(yypvt[-0].inst, yypvt[-3].inst, 3); } break;
case 78:
# line 646 "parse.y"
{
		(yypvt[-6].inst)[1].i = relative(yypvt[-4].inst, yypvt[-6].inst, 1);	/* thenpart */
		(yypvt[-6].inst)[2].i = relative(yypvt[-1].inst, yypvt[-6].inst, 2);	/* elsepart */
		(yypvt[-6].inst)[3].i = relative(yypvt[-0].inst, yypvt[-6].inst, 3); } break;
case 79:
# line 651 "parse.y"
{ ntab++;} break;
case 80:
# line 653 "parse.y"
{
		ntab--; yyval.inst = yypvt[-1].inst;
		} break;
case 82:
# line 659 "parse.y"
{ yyval.inst = yypvt[-1].inst; } break;
case 83:
# line 661 "parse.y"
{ TPD; TPD; yyval.inst = yypvt[-5].inst; code(connectsection);} break;
case 84:
# line 663 "parse.y"
{ TPD; TPD; yyval.inst = yypvt[-8].inst; code(simpleconnectsection);} break;
case 85:
# line 665 "parse.y"
{ TPD; yyval.inst = yypvt[-5].inst; code(connectpointer); codesym(spop());} break;
case 86:
# line 666 "parse.y"
{code(nrn_cppp);} break;
case 87:
# line 667 "parse.y"
{ yyval.inst = yypvt[-4].inst; code(connect_point_process_pointer);
			 hoc_ob_check(-1);} break;
case 88:
# line 670 "parse.y"
{ yyval.inst = yypvt[-0].inst; code(sec_access);} break;
case 89:
# line 672 "parse.y"
{ yyval.inst = yypvt[-0].inst; code(sec_access_object);} break;
case 90:
# line 674 "parse.y"
{ yyval.inst = Code(mech_access); codesym(yypvt[-0].sym);} break;
case 91:
# line 676 "parse.y"
{ yyval.inst = Code(mech_uninsert); codesym(yypvt[-0].sym);} break;
case 92:
# line 678 "parse.y"
{ code(sec_access_pop);} break;
case 93:
# line 680 "parse.y"
{ code(sec_access_pop); hoc_ob_check(-1);
			insertcode(yypvt[-1].inst, yypvt[-0].inst, ob_sec_access);} break;
case 94:
# line 683 "parse.y"
{ TPD; TPD; TPD; TPD; code(range_interpolate); codesym(spop());} break;
case 95:
# line 685 "parse.y"
{ TPD; TPD; code(range_interpolate_single); codesym(spop());} break;
case 96:
# line 687 "parse.y"
{Symbol *s; code(varpush); codesym(s = spop());
		 hoc_obvar_declare(s, VAR, 1);
		 yyval.inst = code(for_segment); codei(0); codei(0);} break;
case 97:
# line 691 "parse.y"
{ yyval.inst = yypvt[-4].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			(yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		} break;
case 98:
# line 695 "parse.y"
{	code(hoc_push_string); codesym((Symbol*)0);
			yyval.inst = code(forall_section); codei(0); codei(0);} break;
case 99:
# line 698 "parse.y"
{ yyval.inst = yypvt[-3].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			(yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		} break;
case 100:
# line 702 "parse.y"
{ yyval.inst = code(forall_section); codei(0); codei(0);} break;
case 101:
# line 704 "parse.y"
{ yyval.inst = yypvt[-4].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			(yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		} break;
case 102:
# line 708 "parse.y"
{ yyval.inst = code(hoc_ifsec); codei(0); codei(0);} break;
case 103:
# line 710 "parse.y"
{ yyval.inst = yypvt[-4].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			(yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		} break;
case 104:
# line 714 "parse.y"
{hoc_ob_check(-1);
		yyval.inst = code(forall_sectionlist); codei(0); codei(0); } break;
case 105:
# line 717 "parse.y"
{ yyval.inst = yypvt[-4].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			(yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		} break;
case 106:
# line 721 "parse.y"
{ hoc_ob_check(-1);
		 yyval.inst = code(hoc_ifseclist); codei(0); codei(0);
		} break;
case 107:
# line 726 "parse.y"
{ yyval.inst = yypvt[-4].inst; (yypvt[-2].inst)[1].i = relative(yypvt[-1].inst, yypvt[-2].inst, 1); /* body */
			(yypvt[-2].inst)[2].i = relative(yypvt[-0].inst, yypvt[-2].inst, 2); /* exit */
		} break;
case 108:
# line 733 "parse.y"
{pushs(yypvt[-0].sym); pushi(CHECK);} break;
case 109:
# line 734 "parse.y"
{code(sec_access_push); codesym(spop()); yyval.inst = yypvt[-0].inst;} break;
case 111:
# line 739 "parse.y"
{hoc_ob_check(SECTION); code(ob_sec_access);} break;
case 112:
# line 743 "parse.y"
{ code(add_section); codesym(yypvt[-0].sym); codei(0);} break;
case 113:
# line 745 "parse.y"
{ code(add_section); codesym(yypvt[-1].sym); codei(yypvt[-0].narg);} break;
case 114:
# line 747 "parse.y"
{code(add_section); codesym(yypvt[-0].sym); codei(0);} break;
case 115:
# line 749 "parse.y"
{ code(add_section); codesym(yypvt[-1].sym); codei(yypvt[-0].narg);} break;
case 116:
# line 752 "parse.y"
{
			Symbol* s;
			s = hoc_decl(yypvt[-0].sym);
			if (s->type != UNDEF && s->type != SECTION)
				acterror(s->name, " already declared");
		} break;
case 117:
# line 760 "parse.y"
{ code(sec_access_push); codesym((Symbol *)0);} break;
case 119:
# line 763 "parse.y"
{pushs(yypvt[-0].sym); pushi(CHECK);} break;
case 120:
# line 764 "parse.y"
{yyval.inst = yypvt[-0].inst;} break;
case 121:
# line 767 "parse.y"
{ code3(varpush, spop(), hoc_evalpointer);} break;
case 122:
# line 769 "parse.y"
{ TPD; code(rangevarevalpointer); codesym(spop());} break;
case 123:
# line 771 "parse.y"
{hoc_ipop(); code(hoc_ob_pointer);} break;
case 124:
# line 772 "parse.y"
{myerr("rangevariable needs explicit arc position,eg. v(.5)");} break;
case 125:
# line 778 "parse.y"
{ TPD; yyval.inst = yypvt[-0].inst; code(nopop);} break;
case 126:
# line 781 "parse.y"
{ yyval.inst = code(forcode); codei(0); codei(0); codei(0); } break;
case 127:
# line 784 "parse.y"
{ TPD; yyval.inst = yypvt[-0].inst; codein(STOP);} break;
case 128:
# line 787 "parse.y"
{ TPD; yyval.inst = yypvt[-1].inst; code2(nopop, STOP);} break;
case 129:
# line 790 "parse.y"
{ TPD; codein(STOP); yyval.inst = yypvt[-1].inst;} break;
case 130:
# line 793 "parse.y"
{ yyval.inst = yypvt[-0].inst; } break;
case 131:
# line 796 "parse.y"
{ yyval.inst=code(ifcode); codei(0); codei(0); codei(0); } break;
case 132:
# line 799 "parse.y"
{ yyval.inst = progp; } break;
case 133:
# line 802 "parse.y"
{ codein(STOP); yyval.inst = progp; } break;
case 134:
# line 805 "parse.y"
{ yyval.inst = progp; prog_error = yyval.inst; } break;
case 135:
# line 807 "parse.y"
{
			prog_parse_recover = progp;
			prog_error = yyval.inst;
			if (fin == stdin && !pipeflag)
			{	int i;
				Printf(">");
				for (i = 0; i < ntab; i++)
					Printf("	");
			}
		} break;
case 137:
# line 819 "parse.y"
{myerr("syntax error in compound statement");} break;
case 138:
# line 824 "parse.y"
{ yyval.inst = code(constpush); codesym(yypvt[-0].sym); PN;} break;
case 139:
# line 826 "parse.y"
{ yyval.inst = code(pushzero); PN;} break;
case 140:
# line 828 "parse.y"
{ code3(varpush, spop(), eval); PN;} break;
case 141:
# line 830 "parse.y"
{ defnonly("$"); yyval.inst = code(arg); codei(yypvt[-0].narg); PN;} break;
case 142:
# line 833 "parse.y"
{code(rangepoint); codesym(spop()); PN;} break;
case 143:
# line 835 "parse.y"
{ TPD; code(rangevareval); codesym(spop()); PN;} break;
case 144:
# line 839 "parse.y"
{code(hoc_object_eval);} break;
case 146:
# line 843 "parse.y"
{ yyval.inst = yypvt[-3].inst; code(call); codesym(yypvt[-4].sym); codei(yypvt[-1].narg); PN;} break;
case 147:
# line 845 "parse.y"
{ code(call); codesym(spop()); codei(yypvt[-1].narg); PN;} break;
case 148:
# line 847 "parse.y"
{ yyval.inst=yypvt[-1].inst; code(varread); codesym(spop()); PN;} break;
case 149:
# line 849 "parse.y"
{ TPD; yyval.inst = yypvt[-1].inst; code(bltin); codesym(yypvt[-3].sym); PN;} break;
case 150:
# line 851 "parse.y"
{ yyval.inst = yypvt[-1].inst; } break;
case 151:
# line 853 "parse.y"
{myerr("syntax error in expression");} break;
case 152:
# line 855 "parse.y"
{ TPD; TPD; code(add); PN; } break;
case 153:
# line 857 "parse.y"
{ TPD; TPD;code(sub); PN;} break;
case 154:
# line 859 "parse.y"
{ TPD; TPD; code(mul); PN;} break;
case 155:
# line 861 "parse.y"
{ TPD; TPD; code(hoc_div); PN;} break;
case 156:
# line 863 "parse.y"
{ TPD; TPD; code(hoc_cyclic); PN;} break;
case 157:
# line 865 "parse.y"
{ TPD; TPD; code(power); PN;} break;
case 158:
# line 867 "parse.y"
{ TPD; yyval.inst = yypvt[-0].inst; code(negate); PN;} break;
case 159:
# line 869 "parse.y"
{ TPD; TPD; code(gt); PN;} break;
case 160:
# line 871 "parse.y"
{ TPD; TPD; code(ge); PN;} break;
case 161:
# line 873 "parse.y"
{ TPD; TPD; code(lt); PN;} break;
case 162:
# line 875 "parse.y"
{ TPD; TPD; code(le); PN;} break;
case 163:
# line 877 "parse.y"
{ TPD; TPD; code(eq); PN;} break;
case 164:
# line 879 "parse.y"
{ TPD; TPD; code(ne); PN;} break;
case 165:
# line 881 "parse.y"
{ TPD; TPD; code(and); PN;} break;
case 166:
# line 883 "parse.y"
{ TPD; TPD; code(or); PN;} break;
case 167:
# line 885 "parse.y"
{ TPD; yyval.inst = yypvt[-0].inst; code(not); PN;} break;
case 171:
# line 892 "parse.y"
{Symbol *s; code(varpush); codesym(s=spop()); yyval.inst = yypvt[-1].inst;
		code(arayinstal); codei(yypvt[-0].narg); hoc_obvar_declare(s, VAR, 0);} break;
case 172:
# line 895 "parse.y"
{Symbol *s; code(varpush); codesym(s = spop());
		code(arayinstal); codei(yypvt[-0].narg); hoc_obvar_declare(s, VAR, 0);} break;
case 173:
# line 900 "parse.y"
{pushs(yypvt[-1].sym); yyval.narg = yypvt[-0].narg;} break;
case 174:
# line 903 "parse.y"
{  TPD; yyval.narg = 1; } break;
case 175:
# line 905 "parse.y"
{  TPD;yyval.narg = yyval.narg + 1; } break;
case 177:
# line 911 "parse.y"
{ pushs(yypvt[-1].sym); yyval.inst = yypvt[-0].inst; } break;
case 178:
# line 913 "parse.y"
{ if (yypvt[-1].sym->subtype == USERPROPERTY) {
			code(sec_access_push); codesym((Symbol *)0);
		  }
		pushs(yypvt[-1].sym); pushi(CHECK);
		} break;
case 179:
# line 918 "parse.y"
{yyval.inst = yypvt[-2].inst;} break;
case 180:
# line 920 "parse.y"
{ if (yypvt[-0].sym->subtype != USERPROPERTY) {
			acterror(yypvt[-0].sym->name, "not a section variable");
		  }
		yyval.inst = yypvt[-2].inst; pushs(yypvt[-0].sym);
		} break;
case 181:
# line 934 "parse.y"
{
		int d1, chk;
		Symbol *sym;
		d1 = ipop();
		chk = ipop();
		sym = spop();
   if (chk) {
	if (!ISARRAY(sym)) {
		if (d1)
			acterror(sym->name, "not an array variable");
	}else{
		if ( d1 == 0 ) { /*fake index list with all 0's*/
			int i;
			for (i=0; i<sym->arayinfo->nsub; i++) {
				code(pushzero);
			}
		}			
		else if ( d1 != sym->arayinfo->nsub) {
			acterror("wrong # of subscripts",sym->name);
		}
	}
   }else {
	pushi(d1); /* must check dynamically */
   }
		pushs(sym);
		} break;
case 182:
# line 963 "parse.y"
{ pushi(0); } break;
case 183:
# line 965 "parse.y"
{  TPD;pushi(ipop() + 1); } break;
case 184:
# line 969 "parse.y"
{ TPDYNAM; code(prexpr);} break;
case 185:
# line 971 "parse.y"
{ code(prstr); } break;
case 186:
# line 973 "parse.y"
{ TPDYNAM; code(prexpr);} break;
case 187:
# line 975 "parse.y"
{ code(prstr); } break;
case 188:
# line 978 "parse.y"
{ yyval.inst = code(hoc_delete_symbol); codesym(yypvt[-0].sym); } break;
case 189:
# line 982 "parse.y"
{yypvt[-0].sym->type=FUNCTION; indef=1; } break;
case 190:
# line 984 "parse.y"
{ code(procret); hoc_define(yypvt[-4].sym);
		 yypvt[-4].sym->u.u_proc->nauto=yypvt[-0].narg; indef=0; } break;
case 191:
# line 987 "parse.y"
{ yypvt[-0].sym->type=PROCEDURE; indef=1; } break;
case 192:
# line 989 "parse.y"
{ code(procret); hoc_define(yypvt[-4].sym);
		 yypvt[-4].sym->u.u_proc->nauto=yypvt[-0].narg; indef=0; } break;
case 193:
# line 993 "parse.y"
{ Symbol *s; s=yylval.sym;
		if(s->type != UNDEF) acterror(s->name, "already defined");
		s->u.u_proc = (Proc *)emalloc(sizeof(Proc));
		s->u.u_proc->defn.in = STOP;
		s->u.u_proc->list = (Symlist *)0; } break;
case 196:
# line 1001 "parse.y"
{ntab++;} break;
case 197:
# line 1002 "parse.y"
{
		ntab--;
		yyval.narg = yypvt[-3].narg;
		} break;
case 198:
# line 1007 "parse.y"
{ yyval.narg = 0; } break;
case 200:
# line 1011 "parse.y"
{yyval.narg = 1;} break;
case 201:
# line 1013 "parse.y"
{yyval.narg = yypvt[-2].narg + 1;} break;
case 202:
# line 1016 "parse.y"
{} break;
case 203:
# line 1018 "parse.y"
{ hoc_ob_check(-1);} break;
case 205:
# line 1022 "parse.y"
{ yyval.inst = yypvt[-0].inst; } break;
case 206:
# line 1024 "parse.y"
{code3(varpush, spop(), eqn_name);
		do_equation = 1; } break;
case 207:
# line 1027 "parse.y"
{ yyval.inst = yypvt[-3].inst; do_equation = 0; } break;
case 208:
# line 1030 "parse.y"
{Symbol *s; yyval.inst = code3(varpush,s= spop(), dep_make); hoc_obvar_declare(s, VAR, 0);} break;
case 209:
# line 1032 "parse.y"
{Symbol *s; code3(varpush, s=spop(), dep_make); hoc_obvar_declare(s, VAR, 0);} break;
case 212:
# line 1037 "parse.y"
{ code(eqn_init); } break;
case 214:
# line 1041 "parse.y"
{ code(eqn_lhs); } break;
case 215:
# line 1043 "parse.y"
{ codein(STOP); TPD; } break;
case 216:
# line 1046 "parse.y"
{ code(eqn_rhs); } break;
case 217:
# line 1048 "parse.y"
{ codein(STOP); TPD; } break;
case 218:
# line 1051 "parse.y"
{ yyval.narg = 0; } break;
case 220:
# line 1055 "parse.y"
{
		Symbol *sp;
		yyval.narg = 1;
		sp = install(yypvt[-0].sym->name, AUTO, 0.0, &p_symlist);
		sp->u.u_auto = yyval.narg;
		} break;
case 221:
# line 1062 "parse.y"
{
		Symbol *sp;
		yyval.narg = yypvt[-2].narg + 1;
		sp = install(yypvt[-0].sym->name, AUTO, 0.0, &p_symlist);
		sp->u.u_auto = yyval.narg;
		} break;
case 222:
# line 1070 "parse.y"
{  Symbol* s;
	   s = hoc_decl(yypvt[-0].sym);
	   if (s->subtype != NOTUSER)
		acterror("can't redeclare user variable", s->name);
	   yyval.sym = s;
	} break;
	}
	goto yystack;		/* reset registers in driver code */
}
