#include <stdio.h>
#include <math.h>

#define TRUE 1         /* Boolean true variable */
#define FALSE 0        /* Boolean false variable */
#define then           /*To make if-then-else blocks more legible */
#define begin {        /* To make statement blocks more legible */
#define end   }        /*To make statement blocks more legible */

/* Declare external variables */

static double fx,ldt, dmin, nf, nl;
static double v[20][20], q0[20], q1[20], qa, qb, qc, qd0, qd1, qf1;
static double d[20];
static int praxstep = 0; /* if 1 returns after one iteration of main loop */

double praxis_pval(i) int i; { return d[i];}
double* praxis_paxis(i) int i; {return v[i];}
static double         random1(),ranval;
static quad1(); 

double praxis(pt0,pmachep,ph0,n,pprin,x,pf,pfmin)
	double *pt0, *pmachep, *ph0, (*pf)(),*pfmin,x[];
	int    *pprin;
	int n;
{


/***************************************************************************/
/*      								   */
/* Andrew Scheman							   */
/* C.P.S. 193 - Independent study for Dr. Kootsey			   */
/* Date submitted: 4/23/84					           */
/* 									   */
/* The purpose of this project was to translate the fortran version of the */
/* function praxis, which is used to find the minimum of a function using  */
/* the principal axis method.  The language translated into is C for the   */
/* the CI-C86 compiler, version 1.32, on the IBM personal computer.        */
/* All arrays that began subscripting from 1 in Fortran were changed to    */
/* subsript from 0 in the C version.  Thus, in comparing the two programs  */
/* certain key variables and conditions will operate from different numbers*/
/* but this is invisible to the user of the program.  In addition, all GOTO*/
/* statements have been replaced by WHILE or DO-WHILE constructs in C to   */
/* allow for a more structured program.				           */
/* In translating this program I took the liberty of breaking the one large*/
/*
	And I put them back together and made most things static so there
	is less chance of name conflicts when this is part of a larger program.
	The additional functions to access principal values and principal
	axes are
		double praxis_pval(int i)
		double* praxis_paxis(int i)
	Michael Hines 7/29/93
*/
/* module of all the procedures into 3 smaller modules called PRAX.C, MIN.C*/
/* and SORT.C.  However, this is also invisible to the user, unless he     */
/* wishes to alter the program.  All external variables are declared in a  */
/* file called XTRN.H, which is # included at the beginning of every file. */
/* Another group of statements, DEF.H, is also # included in every module. */
/* These statements include definitions of constructs like BEGIN, END, TRUE*/
/* and FALSE in order to make the program more readable and less cryptic.  */
/* Finally, to avoid errors make sure the following modules are on the     */
/* floppy disk being used: PRAX.C, MIN.C, SORT.C, ERROR.C, TRIG.ARC, XTRN.H*/
/* and DEF.H.  Good luck and find those minima!!!			   */
/*								    	   */
/***************************************************************************/


/****************************************************************************/
/* praxis returns the minimum of the function f(x,n) of n variables using   */
/* the principal axis method.  The gradient of the function i is not req-   */
/* uired.                                                                   */
/****************************************************************************/


/****************************************************************************/
/*									    */
/* for a description of the algorithm, see chapter 7 of "Algorithms for     */
/* Finding the Zeros and Extrema of Functions Without Calculating 	    */
/* Derivatives" by Richard P. Brent...					    */
/*									    */
/****************************************************************************/
    

/****************************************************************************/
/*									    */
/* the parameters are:							    */
/* t0       is a tolerance.  Praxis attempts to return praxis = f(x) such   */
/*	    that if x0 is the true local minimum near x, then 		    */
/*          norm(x-x0) < t0 + squareroot(machep)*norm(x).		    */
/* machep   is the machine precision, the smallest number such that         */
/*          1 + machep > 1.  This will vary for different machines.         */
/* h0       is the maximum step size.  h0 should be set to about the        */
/*  	    maximum distance from the initial guess to the minimum. ( if h0 */
/*          is set too large or too small, the initial rate of convergence  */
/*          will be slow.)						    */
/* n	    (at least two) is the number of variables on which the function */
/*	    depends.							    */
/* prin     controls the printing of intermediate results.		    */
/*          if prin=0, nothing is printed.				    */
/*	    if prin=1, f is printed after every n+1 or n+2 linear           */
/*	    minimizations.  Final x is printed, but intermediate x is       */
/*          printed only if n is at most 4.				    */
/*          if prin=2, the scale factors and the principal values of the    */
/*	    approximating quadratic form are also printed.	            */
/*          if prin=3, x is also printed after every few linear 	    */
/*	    minimizations.						    */
/*          if prin=4, the principal vectors of the approximating quadratic */
/*          form are also printed.					    */
/* x        is an array containing on entry a guess of the point of minimum */
/*          on return the estimated point of minimu.			    */
/*pf(x,n)   is the function to be minimized.  f should be a double precision*/
/*          function, declared external in the calling program.		    */
/* pfmin    is an estimate of the minimum, used only in printing inter-     */
/*          mediate reults.					            */
/*									    */
/* The approximating quadratic form is:					    */
/*         q(x') = f(x,n) + 1/2 * (x' - x)-transpose * a * (x'-x)           */
/* where x is the best estimate of the minimum and a is			    */
/*         inverse (v-transpose)*d* inverse(v)				    */
/* (v(*,*) is the matrix of search directions.				    */
/* d(*) is the array of second differences.  If f() has continuous second   */
/* derivatives near x0, a will tend to the hessian of f at x0 as x approachs*/
/* x0.									    */
/*									    */
/* It is assumed that on floating-point underflow the result is set to 0.   */
/* The user should observe the comment on heuristic numbers after the init- */
/* ialization of machine dependent numbers.				    */
/*									    */
/****************************************************************************/



/* Local variables */

static int      tester1, tester2;
static int            kl, kt, ktm, powval, illc, pk2;
static double         s, sl, dn, f1, lds, t, h, sf, df, machep;
static double         m2, m4, small, vsmall, large, vlarge, scbd, ldfac,t2,dni;      
static double         z[20], prin, y[20], value, dpowval;
static int            idim, i, j, k, k2, km1, km, klmk, ii,im1;
static double	*ps, *pvalue, *pd0;


/****************************************************************************/
/*                      						    */
/* If n > 20 or if n < 20 and you need more space, change '20' to the       */
/* largest value of n in the next card, in the card 'idim=20', and in the   */
/* dimension statements in subroutines minfit, min, flin, and quad.         */
/*									    */
/****************************************************************************/

/* Begin execution */

/*machine dependent numbers*/

*pmachep = 1e-9;
small = (*pmachep)*(*pmachep);
vsmall = (small)*(small);
large = 1.0/small;
vlarge = 1.0/vsmall;
m2 =sqrt(*pmachep);
m4 = sqrt(m2);

/****************************************************************************/
/*									    */
/* HEURISTIC NUMBERS:                                                       */
/*									    */
/* if the axes may be badly scaled (which is to be avoided if possible),    */
/* then set scbd=10.  Otherwise, set scbd=1.                                */
/* If the problem is known to be ill-conditioned, set illc = TRUE.          */
/* Otherwise, set illc = FALSE.                                             */
/* KTM is the number of iterations without improvement before the algorithm */
/* terminates.  KTM = 4 is very cautious and KTM = 1 is usually quite       */
/* satisfactory. 							    */
/*									    */
/****************************************************************************/


scbd = 1.0;
illc = 0;    
ktm = 1;
ldfac = 0.01;
if (illc) then
    ldfac = 0.1;
kt = 0;
nl = 0;
nf = 1;


fx = (*pf)(x,n);

qf1 = fx;
t = small + fabs(*pt0);
t2 = t;
dmin = small;
h = *ph0;
if (h < (100*t)) then
   h = 100*t;
 ldt = h;

/* the first set of search directions v is the identity matrix */

for (i = 0; i < n; i++)
    begin
	for (j = 0; j < n; j++)
	    v[i][j] = 0.0;
	v[i][i] = 1.0;
    end


d[0] = 0.0;
qd0 = 0.0;
for (i = 0; i < n; i++)
    begin
	q0[i] = x[i];
	q1[i] = x[i];
    end

if (*pprin > 0) then
      print(n,x,pprin,pfmin);

/* The MAIN LOOP starts here */

do {
   tester1 = 1;
   sf = d[0];
   d[0] = 0.0;
   s = 0.0;
   ps = &s;
/* minimize along the first direction v(*,1) */
/* fx will be passed by value.                */

    pd0 = &d[0];
    value = fx;
    pvalue = &value;
/*vcprnt(1,d,2);*/
    min(n,1,2,pd0,ps,pvalue,FALSE,pf,x,pt0,pmachep,ph0);
/*vcprnt(1,d,2);*/

    if (s <= 0.0)
      for (i = 0; i < n; i++)
        v[i][0] = -v[i][0];

/*    if  (!(sf > (0.9 * d[0])) && ((0.9 * sf) < d[0]))   */
    if  ((sf <= (0.9 * d[0])) || ((0.9 * sf) >= d[0]))   
       for (i = 1; i < n; i++)
           d[i] = 0.0;
    /* the INNER LOOP starts here*/
    for (k = 1; k < n; k++)
        begin
        for (i = 0; i < n; i++)
            y[i] = x[i];
        sf = fx;

        if (kt > 0) then
           illc = 1;

     /* the INNER LOOP restarts here */

        do {
           tester2 = TRUE;
           kl = k;
           df = 0.0;
           
       /*****************************************************************/
       /* A random step follows ( to avoid resolution valleys). praxis  */
       /* assumes that RANDOM returns a random number uniformly distrib-*/
       /* uted in (0,1)						        */
       /*****************************************************************/

           if (illc == 1) then
              for (i = 0; i < n; i++)
                begin
                  ranval = random1(n);
                  ranval = ranval - 0.5;
                  powval = pow(10.,(double)kt);
                  dpowval = 0.1*ldt + t2*powval;
                  s = ranval*dpowval;
                  z[i] = s;
                  for (j = 0; j < n; j++)
                        x[j] = x[j] + s * v[j][i];
                  fx = (*pf)(x,n);
                  nf = nf + 1;
               end
          /*minimize along the "non-conjugate directions v(*,k),...,v(*,n)*/

           for (k2 = k; k2 < n; k2++)
             begin
               sl = fx;
               s = 0.0;
              pd0 = &d[k2];
              value = fx;
              pvalue = &value;
/*vcprnt(1,d,2);*/
              min(n,k2+1,2,pd0,&s,pvalue,FALSE,pf,x,pt0,pmachep,ph0);
/*vcprnt(1,d,2);*/
              if (illc == 0)     
                 s = sl - fx;
               else 
                 s = d[k2] * ((s + z[k2]) * (s + z[k2]));
               if (df <= s)     
                 begin
                   df = s;
                   kl = k2;
                 end
             end
           if ((illc == 1) || (df >= fabs(100 * (*pmachep) * fx)))         
               tester2 = FALSE;
          /* if there was not much improvement on the first try set illc */
          /* to true and start the inner loop again.                     */

           else
             begin
               tester2 = TRUE;
               illc = 1;
             end 
   
           } while (tester2 == TRUE);   /*RESTART INNER LOOP */
                 
        if ((k == 1) && (*pprin > 1)) then
              vcprnt(1,d,n);

        /*minimize along the conjugate directions v(*,1),...,v(*,k-1)*/
                            
        km1 = k -1;
        for (k2 = 0; k2 <= km1; k2++)
          begin
            s = 0;
            pd0 = &d[k2];
            value = fx;
            pvalue = &value;
            pk2 = k2 + 1; 
            min(n,pk2,2,pd0,&s,pvalue,FALSE,pf,x,pt0,pmachep,ph0);
          end
        f1 = fx;
        fx = sf;
        lds = 0;
        for (i = 0; i < n; i++)
          begin
	    sl = x[i];
	    x[i] = y[i];
 	    sl = sl - y[i];
 	    y[i] = sl;
    	    lds = lds + (sl*sl);
          end
        lds = sqrt(lds);
       /*********************************************************************/
       /*								    */
       /* Discard direction v(*,kl). 					    */
       /* if no random step was taken, v(*,kl) is the "non-conjugate"       */
       /* direction along which the greatest improvement was made...        */
       /*								    */
       /*********************************************************************/

       if (lds > small) then
          begin
            klmk = kl - k;
            if (klmk >= 1) then
              begin
                for (ii = 0; ii < klmk; ii++)
                  begin
                    i = kl - ii - 1;
                    for (j = 0; j < n; j++)
                      v[j][i+1] = v[j][i];
                    d[i+1] = d[i];
                end
              end
            d[k] = 0;
            for ( i = 0; i < n; i++)
                v[i][k] = y[i]/lds;
            pd0 = &d[k];

    /* minimize along the new "conjugate" direction v(*,k),which is the */
    /* normalized vector: new(x) - old(x).....				*/

            value = f1;
            pvalue = &value;
            pk2 = k + 1;
            min(n,pk2,4,pd0,&lds,pvalue,TRUE,pf,x,pt0,pmachep,ph0);
            if (lds <= 0.0) 
              begin
                lds = -lds;
                for (i = 0; i < n; i++)
                   v[i][k] = - v[i][k];
              end
            end
            ldt = ldfac*ldt;
            if (ldt < lds) then
               ldt = lds;
            if (*pprin > 0) then
               print(n,x,pprin,pfmin);
            t2 = 0.0;
            for (i = 0; i < n; i++)
              t2 = t2 + (x[i]*x[i]);
            t2 = m2 * sqrt(t2) + t;

        /* see whether the length of the step taken since the starting */
        /* of the inner loop exceeds half the tolerance...             */

            if (ldt > (0.5 * t2)) then
              kt = -1;
            kt++;
            if (kt > ktm) then
               begin
                 tester1 = FALSE;
               end
        end  /* of inner loop */
        
        /* try quadratic extrapolation in case we are in a curved valley*/


            quad1(n,pf,x,pt0,pmachep,ph0);
            dn = 0.0;
            for (i = 0; i < n; i++)
	      begin
		d[i] = 1.0/sqrt(d[i]);
                if (dn < d[i]) then
                   dn = d[i];
              end
            if (*pprin > 3) then
                maprnt(1,v,idim,n);
  
            for (j = 0; j < n; j++) 
              begin
		s = d[j]/dn;
		for ( i = 0; i < n; i++)
                   v[i][j] = s * v[i][j];
              end


   /* scale the axes to try to reduce the condition number... */

           if (scbd > 1.0) then
              begin
         	s = vlarge;
		for ( i = 0; i < n; i++)
                   begin
		     sl = 0.0;
		     for ( j = 0; j < n; j++)
 			sl = sl + (v[i][j] * v[i][j]);
		     z[i] = sqrt(sl);
		     if (z[i] < m4) then
			z[i] = m4;
		     if (s > z[i]) then
			s = z[i];
	  	   end
		for (i = 0; i < n; i++)
		   begin
		     sl = s/z[i];
		     z[i] = 1.0/sl;
		     if (z[i] > scbd) then
   			begin
			  sl = 1.0/scbd;
			  z[i] = scbd;
			end
		     for (j = 0; j < n; j++)
                        v[i][j] = sl * v[i][j];
                   end
               end
               /* calculate a new set of orthogonal directions */
	       /* before repeating the main loop.              */
	       /* first transpose v for minfit...              */

		for (i = 1; i < n; i++)
                   begin
		     im1 = i - 1;
                     for (j = 0; j <= im1; j++)
                        begin
			  s = v[i][j];
			  v[i][j] = v[j][i];
			  v[j][i] = s;
			end
		  end


           /*****************************************************************/
	   /*								    */
	   /* Call MINFIT to find the singular value decomposition of v.    */
	   /* This gives the principal values and principal directions of   */
	   /* the approximating quadratic form without squaring the cond-   */
  	   /* ition number... 						    */
	   /*****************************************************************/


	    minfit(idim,n,pmachep,&vsmall,v,d);

           /* unscale the axes */

	    if (scbd > 1.0) then
	      begin
		for (i = 0; i < n; i++)
                   begin
		     s = z[i];
		     for (j = 0; j < n; j++)
			v[i][j] = s * v[i][j];
		  end
	    for (i = 0; i < n; i++)
	       begin
		 s = 0.0;
		 for (j = 0; j < n; j++)
		    s = s + (v[j][i] * v[j][i]);
		 s = sqrt(s);
		 d[i] = s * d[i];
		 s = 1/s;
		 for ( j = 0; j < n; j++)
		    v[j][i] = s * v[j][i];
	       end
            end
            for (i = 0; i < n; i++)
               begin
		 dni = dn * d[i];
                 if (dni > large) then
		    d[i] = vsmall;
		 else if (dni < small) then
		        d[i] = vlarge;
		 else
	              d[i] = 1/(dni*dni);
	       end
	   /* sort the eigenvalues and eigenvectors */
	    sort(idim,n,d,v);
            dmin = d[n-1];
	    if (dmin < small) then
		dmin = small;
	    illc = 0;
	    if ((m2 * d[0]) > dmin) then
		illc = 1;
	    if ((*pprin >1) && (scbd > 1.0)) then
		vcprnt(2,z,n);
	    if (*pprin > 1) then
		vcprnt(3,d,n);
	    if (*pprin > 3) then
		maprnt(2,v,idim,n);
	    if (praxstep ==1)	/* allows analysis of approach to fit by */
		tester1 = FALSE;/* controlling routine */
        } while (tester1 == TRUE);

      if (*pprin != 0) then
	{
		vcprnt(3,d,n);
		maprnt(2,v,idim,n);	
		vcprnt(4,x,n);
	}
      return(fx);
   }


sort(m,n,d,vv)

int n, m;
double vv[20][20];
double d[20]; 
{
double s;
int i, j, k, nm1, ip1;

/* sorts the elements of d[n] into descending order and moves the */
/* corresponding columns of vv[n][n].                              */

/*m is the row precision of vv as declared in the calling program */


if (n != 1) then
   begin
     nm1 = n - 1;
     for (i = 0; i < nm1; i++)
  	begin
	  k = i;
	  s = d[i];
	  ip1 = i + 1;
          for (j = ip1; j < n; j++)
	     begin
		if (d[j] > s) then
		  begin
		    k = j;
		    s = d[j];
                  end
	     end
	  if (k > i) then
	     begin
		d[k] = d[i];
		d[i] = s;
		for (j = 0; j < n; j++)
		    begin
			s = vv[j][i];
			vv[j][i] = vv[j][k];
			vv[j][k] = s;
		    end
	     end
          end
    end
  return;
  }

	     

static quad1(n,pf,x,pt0,pmachep,ph0) 

int n; 
double (*pf)(), x[], *pt0, *pmachep, *ph0;
{

/* quad looks for the minimum of f along a curve defined by q0,q1 */


double s,l,value;
int i;
double	*ps, *pvalue, *pl;

s = fx;
fx = qf1;
qf1 = s;
qd1 = 0.0;
for (i = 0; i < n; i++)
    begin
      s = x[i];
      l = q1[i];
      x[i] = l;
      q1[i] = s;
      qd1 = (qd1 + ((s - l)*(s - l)));
    end
qd1 = sqrt(qd1);
l = qd1;
s = 0.0;
if (!((qd0<=0.0)||(qd1<=0.0)||(nl<(3*n*n)))) then
    begin
      value = qf1;
      pvalue = &value;
      ps = &s;
      pl = &l;
      min(n,0,2,ps,pl,pvalue,TRUE,pf,x,pt0,pmachep,ph0);
      qa = (l*(l-qd1))/(qd0*(qd0+qd1));
      qb = ((l+qd0)*(qd1-l))/(qd0*qd1);
      qc = (l*(l+qd0))/(qd1*(qd0+qd1));
   end
else
    begin
      fx = qf1;
      qa = 0.0;
      qb = qa;
      qc = 1.0;
    end
   qd0=qd1;
for (i = 0; i < n; i++)
    begin
      s = q0[i];
      q0[i] = x[i];
      x[i] = ((qa*s + qb*x[i]) + (qc*q1[i]));
    end
return;
}
			



vcprnt(option,vv,n) 
double vv[];
int option, n;
{

int i;
if (option == 1) then
  begin
    printf("The second difference array d[*] is :\n");
    for (i= 0; i < n; i++)
        printf("%g\n",vv[i]);
  end
else if (option == 2) then
  begin
    printf("The scale factors are:\n");
    for (i = 0; i < n; i++)
        printf("%g\n",vv[i]);
  end
else if (option == 3) then
  begin
    printf("The approximating quadratic form has the principal values:\n");
    for (i = 0; i < n; i++)
        printf("%g\n",vv[i]);
  end
else if (option == 4) then
  begin
    printf("x is:\n");
    for (i = 0; i < n; i++)
       printf("%g\n",vv[i]);
  end
return;
}




print(n,x,pprin,pfmin)
int *pprin, n;
double x[],*pfmin;
{
double ln;
int i;

printf("After ");
printf("%g",nl);
printf(" linear searches, the function has been evaluated ");
printf("%g times.\n",nf);
printf("The smallest value found is f(x) = ");
printf("%g\n",fx);


if (fx > *pfmin) then
   begin
     ln = log10(fx-(*pfmin));
     printf("log (f(x)) - ");
     printf("%g",*pfmin);
     printf(" = ");
     printf("%g\n",ln);
   end
else
    begin
      printf("log (f(x)) -- ");
      printf("%g",*pfmin);
      printf(" is undefined\n");
    end
if (!((n > 4)&&(*pprin <=2))) then
   begin
     printf("x is:");
     printf("%g\n",x[0]);
     for (i = 1; i < n; i++)
        begin
          printf("x is:");
          printf("%g\n",x[i]);
        end
   end
printf("  \n");
return;
}



maprnt(option,vv,m,n)
double vv[20][20];
int m, n, option;
{

int low, upp, tester6, i, j;

low = 1;
upp = 5;
if (option == 1) then
   printf("The new directions are:\n");
else if (option == 2) then
   printf("and the principal axes:\n");

	for (i=0; i< n; i++)
	{
		printf("%3d", i+1);
		for (j=0; j < n; j++)
		{
			printf("  %12g", vv[i][j]);
			if (j%5 == 4 && (j != n-1))
				printf("\n   ");
		}
		printf("\n");
	}
return;
}


static double random1(pnaught)

int pnaught;
{
static double ran1, half, ran3[127];
static int ran2, i, j, q, r;
static int init = FALSE;
static double temp;
static int constnt,iptr,val;

if (init == FALSE) then
   begin
     r = (pnaught % 8190) + 1;
     ran2 = 127;
     for (i = 0; i < 127; i++)
         begin
  	   ran2 = ran2 - 1;
	   ran1 = pow(2.,55.);
           ran1 = -(ran1);
           for (j = 0; j < 7; j++)
               begin
                val = 1756 * r;
                r = val % 8191;    
                q = r/32;
                ran1 = (ran1+q) * (1./256.);
               end
           ran3[ran2] = ran1;
         end
      init = TRUE;
    end
if (ran2 == 0) then
     ran2 = 127;
ran2 = ran2 - 1;
ran1 = ran1 + ran3[ran2];
half = 0.5;
if (ran1 >= 0.0) then
   ran1 = ran1 - half;
else 
   ran1 = ran1 + half;
ran3[ran2] = ran1;
return(ran1 + half);
}


/**************************************************************************/
/*                                                                        */
/* These are the subroutines min, minfit and flin that are used by praxis */
/* Andrew Scheman C.P.S. 193... 4/23/84					  */
/*									  */
/* An improved version of minfit (see Golub and Reinsch, 1969)		  */
/* restricted to m = n, p = 0.						  */
/*									  */
/* The singular values of the array ab are returned in q and ab is over-  */
/* written with the orthoganol matrix v such that u.diag(q) = ab, where   */
/* u is another orthoganol matrix.					  */
/*									  */
/**************************************************************************/

minfit(m,n,pmachep,tol,ab,q)

double *pmachep,*tol,ab[20][20],q[20];
int n,m;
{

double e[20], eps, g, x1, s, f, h, y, c, temp, z;
int    i, j, k, kk, kt, ll2, lp1, ii, l2,l;
int     tester3, absflag;

/* householders reduction to bidiagnol form */
if (n != 1) then
   begin
     eps = *pmachep;
     g   = 0.0;
     x1  = 0.0;
     for (i = 1; i <= n; i++)
       begin
	e[i-1] = g;
	s = 0.0;
	l = i + 1;
	for (j =i; j <=n; j++)
           s = s + (ab[j-1][i-1] * ab[j-1][i-1]);
	g = 0.0;
        if (s >= *tol) then
	  begin
	    f = ab[i-1][i-1];
	    g = sqrt(s);
	    if (f >= 0) then
		g = -g;
	    h = f*g - s;
	    ab[i-1][i-1] = f - g;
            if (l <= n) then
              begin
		for (j =l; j <=n; j++)
		  begin
		    f = 0.0;
		    for (k = i; k <= n; k++)
			f = f + ab[k-1][i-1] * ab[k-1][j-1];
		    f = f/h;
		    for (k = i; k <= n; k++)
  			ab[k-1][j-1] = ab[k-1][j-1] + f*ab[k-1][i-1];
		  end
	      end
	   end

    q[i-1] = g;
    s = 0.0;
    if (i != n) then
       for (j = l; j <= n; j++)
           s = s + (ab[i-1][j-1] * ab[i-1][j-1]);
    g = 0.0;
    if (s >= *tol) then
       begin
         if (i != n) then
            f = ab[i-1][i];
         g = sqrt(s);
         if (f >= 0.0) then
            g = -g;
         h = f*g - s;
         if ( i != n) then
            begin
              ab[i-1][i] = f - g;
              for (j = l; j <= n; j++)
                  e[j-1] = ab[i-1][j-1]/h;
              for (j = l; j <= n; j++)
                  begin
                     s = 0.0;
                     for (k = l; k <= n; k++)
                         s = s + (ab[j-1][k-1] * ab[i-1][k-1]);
                     for (k = l; k <= n; k++)
                         ab[j-1][k-1] = ab[j-1][k-1] + s*e[k-1];
                  end
            end
        end

	y = fabs(q[i-1]) + fabs(e[i-1]);
	if ( y > x1) then
	    x1 = y;
	end
/* accumulation of right hand transformations */

        ab[n-1][n-1] = 1.0;
	g = e[n-1];
	l = n;
	for (ii = 2; ii <= n; ii++)
	   begin
	     i = n - ii+1;
	     if (g != 0.0) then
		begin
		  h = ab[i-1][i] * g;
		  for (j = l; j <= n; j++)
		      ab[j-1][i-1] = ab[i-1][j-1]/h;
		  for (j = l; j <= n; j++)
		      begin
			s = 0.0;
			for (k = l; k <= n; k++)
			   s = s + (ab[i-1][k-1] * ab[k-1][j-1]);
			for (k = l; k <= n; k++)
			   ab[k-1][j-1] = ab[k-1][j-1] + s*ab[k-1][i-1];
		      end
		end
		for (j = l; j <= n; j++)
		   begin
		     ab[i-1][j-1] = 0.0;
		     ab[j-1][i-1] = 0.0;
		   end;
		ab[i-1][i-1] = 1.0;
		g = e[i-1];
                l = i;
	     end
	/* diagonalization of the bidiagnol form */
	     eps = eps * x1;
	     for ( kk = 1; kk <= n; kk++)
		begin
		  k = n - kk+1;
		  kt = 0;
		  tester3 = TRUE;

		  do {
                  kt = kt + 1;
		  if ( kt > 30) then
		     begin
			e[k-1] =  0.0;
			printf("qr failed\n");
		     end
		     absflag = FALSE;
		  for (ll2 = 1; ll2 <=k; ll2++)
		     begin
			l2 = k - ll2+1;
			l  = l2;
			if (fabs(e[l-1]) <= eps) then
			   begin
			      absflag = TRUE;
                              break;
			   end
                       if (l != 1.0) then
			  if (fabs(q[l-2]) <= eps) then
				break;
		     end
/* cancellation of e(l) if l > 0... */

		  if (absflag == FALSE) then
		     begin
			c = 0.0;
			s = 1.0;
			for (i = l; i <= k; i++)
			   begin
			     f = s * e[i-1];
			     e[i-1] = c * e[i-1];
			     if (fabs(f) <= eps) then
				break;
			     g = q[i-1];
			     if (fabs(f) < fabs(g)) then
				h = fabs(g) * sqrt(1+((f/g)*(f/g)));
			     else
				begin
				  if (f == 0.0) then
				     h = 0.0;
				  else
				     h = fabs(f) * sqrt(1+((g/f)*(g/f)));
				end
			     q[i-1] = h;
			     if (h == 0.0) then
				begin
				  g = 1.0;
				  h = 1.0;
				end
			     c = g/h;
			     s = (-f)/h;
			   end
			end
	/* test for convergence */

			z = q[k-1];
			if (l != k) then
			   begin
			     x1 = q[l-1];
			     y = q[k-2];
			     g = e[k-2];
			     h = e[k-1];
			     f = ((y -z) * (y + z) + (g -h)*(g+h))/(2*h*y);
			     g = sqrt(f * f + 1.0);
                             temp = f - g;
			     if (f >= 0.0) then
				temp = f + g;
			     f = ((x1 -z)*(x1 + z)+h*(y/temp - h))/x1;
       /* next qr transformation */
			     c = 1.0;
			     s = 1.0;
			     lp1 = l + 1;
			     if (lp1 <= k) then
				for (i = lp1; i <= k; i++)
				  begin
				    g = e[i-1];
				    y = q[i-1];
			            h = s * g;
				    g = g * c;
				    if (fabs(f) >= fabs(h)) then
				      begin
					if (f == 0.0) then
					   z = 0.0;
					else
					   z = fabs(f)*sqrt(1+(h/f)*(h/f));
				      end
				    else
                                           z = fabs(h)*sqrt(1+(f/h)*(f/h));
			            e[i-2] = z;
                                   if (z == 0.0) then
					begin
					  f = 1.0;
					  z = 1.0;
					end
				    c = f/z;
				    s = h/z;
				    f = x1*c + g*s;
			            g = (-x1)*s + g*c;
				    h = y * s;
				    y = y * c;
				    for ( j= 1; j <= n; j++)
				      begin
					x1 = ab[j-1][i-2];
					z = ab[j-1][i-1];
					ab[j-1][i-2] = x1*c + z*s;
					ab[j-1][i-1] = (-x1)*s + z*c;
				      end
				    if (fabs(f) >= fabs(h)) then
				      begin
					if (f == 0.0) then
					  z = 0.0;
					else   
					  z = fabs(f)*sqrt(1+((h/f)*(h/f)));
				      end
				    else
					z = fabs(h)*sqrt(1+((f/h)*(f/h)));
            			    q[i-2] = z;
				    if (z == 0.0) then
					begin
					  f = 1.0;
					  z = 1.0;
					end
				    c = f/z;
				    s = h/z;
			            f = c*g + s*y;
			            x1 = (-s)*g + c*y;
			         end;
                             e[l-1] = 0.0;
			     e[k-1] = f;
			     q[k-1] = x1;
			   end
			else
			     tester3 = FALSE;
			}while (tester3 == TRUE);

			if (z < 0.0) then
			   begin
			     q[k-1] = -z;
			     for (j= 1; j <= n; j++)
				ab[j-1][k-1] = -ab[j-1][k-1];
			   end
			end
		   end
                   else
		      begin
			q[0] = ab[0][0];
			ab[0][0] = 1.0;
                       end
}

min(n,j,nits,pd2,px1,pf1,fk,pf,x,pt,pmachep,ph)

double   *pmachep, *pd2, *px1,(*pf)(), *pt, *ph, x[],*pf1;
int      fk, n;
int      j, nits;
{

/****************************************************************************/
/*									    */
/* The subroutine min minimizes f from x in the direction v(*,j)            */
/* J is less than 1, when a quadratic search is made in the plane defined   */
/* by q0, q1,x.								    */
/* D2 is either 0 or an approximation to 1/2 f''.			    */
/* On entry x1 is an estimate of the distance from x to the minimum along   */
/* v(*,j) (or if j = 0, a curve).  On return, x1 is the distance found.     */
/* If fk = TRUE, then f1 = flin(x1).  Otherwise x1 and f1 are ignored on    */
/* entry unless final fx is greater than f1.				    */
/* Nits controls the number of times an attempt will be made to halve the   */
/* interval.								    */
/*									    */
/****************************************************************************/

typedef  int logical;
logical  dz, tester4, tester5;
double   temp, m2, m4, sf1, sx1, fm, f0, s, t2, h, t, xm, d2, x2, d1, f2;
double   small, flin();           
/* int      px2, pj;    */
double *px2; int *pj;
int      n1, k, i;


small = (*pmachep) * (*pmachep);
m2    = sqrt(*pmachep);
m4    = sqrt(m2);
sf1   = *pf1;
sx1   = *px1;
k     = 0;
xm    = 0.0;
fm    = fx;
f0    = fx;

if (*pd2 < *pmachep) then
    dz = TRUE;
else
    dz = FALSE;
/* find the step size */

s = 0.0;
for (i = 0; i < n; i++)
    s = s + (x[i]*x[i]);
s = sqrt(s);
temp = *pd2;
if (dz == TRUE) then
   temp = dmin;

t2 = m4 * (sqrt(fabs(fx)/temp + s*ldt)) + m2 * ldt;
s = m4 * s +(*pt);
if ((dz == TRUE) && (t2 > s)) then
    t2 = s;
if (t2 < small) then
    t2 = small;
if (t2 > (.01 * (*ph))) then
    t2 = 0.01*(*ph);
if (!((fk == FALSE) || (*pf1 > fm))) then
    begin
      xm = *px1;
      fm = *pf1;
    end
if (!((fk == TRUE) && (fabs(*px1)>=t2))) then
    begin
      temp = 1.0;
      if (*px1 < 0.0) then
	 temp = -1.0;
      *px1 = temp * t2;
      pj = &j;
      *pf1 = flin(n,pj,px1,pf,x);
    end
if (*pf1 < fm) then
    begin
      xm = *px1;
      fm = *pf1;
    end

/* evaluate flin at another point and estimate the 2nd derivative */

tester4 = TRUE;
while (tester4 == TRUE) {
   if (dz == TRUE) then
      begin
	x2 = -(*px1);
	if (f0 > *pf1) then
	   x2 = 2.0 * (*px1);
        pj = &j;
        px2 = &x2;
	f2 = flin(n,pj,px2,pf,x);
	if (f2 < fm) then
	   begin
 	      xm = x2;
	      fm = f2;
	   end
	*pd2 = (x2*(*pf1-f0)-(*px1)*(f2-f0))/((*px1*x2)*(*px1-x2));
/*printf("%10.6lf %10.6lf %10.6lf %10.6lf %10.6lf %10.6lf\n",*pd2,x2,*pf1,f0,
			*px1,f2);*/
      end

/* estimate the first derivative at 0 */       
        d1 = (*pf1 - f0)/(*px1) - (*px1 *(*pd2));
        dz = TRUE;
        
        if (*pd2 <= small) then
           begin
             x2 = *ph;
             if (d1 >= 0.0) then
                x2 = -x2;
           end
        else
           x2 = (-0.5 * d1)/(*pd2);
        if (fabs(x2) > *ph) then
           if (x2 <= 0.0) then
              x2 = -(*ph);
           else
              x2 = *ph;
  
        tester5 = TRUE;
        while (tester5 == TRUE) {
        tester5 = FALSE;
        pj = &j;
        px2 = &x2;
	f2 = flin(n,pj,px2,pf,x);
	if ((k >= nits) || (f2 <= f0)) then
	   tester4 = FALSE;
	else
	   begin
	     k++;
	     if (!((f0 < *pf1) && ((*px1 * x2) > 0))) then
		begin
		  tester5 = TRUE;
		  x2 = 0.5 * x2;
		end
             else
		begin
		  tester4 = TRUE;
		  tester5 = FALSE;
		end
	   end
	} 
    }                        
  nl = nl + 1;
  if (f2 >= fm) then
        x2 = xm;
  else
	fm = f2;
  if (fabs(x2*(x2 - (*px1))) > small) then
{
	*pd2 = (x2*(*pf1 - f0)- *px1 * (fm - f0))/((*px1*x2)*(*px1-x2));
/*printf("  %10.6lf %10.6lf %10.6lf %10.6lf %10.6lf %10.6lf\n",*pd2,x2,*pf1,f0,
			*px1,fm);*/
}
  else
	if (k > 0) then
	   *pd2 = 0.0;
  if (*pd2 <= small) then
	*pd2 = small;
  *px1 = x2;
  fx = fm;
  if (sf1 < fx) then
     begin
	fx = sf1;
	*px1 = sx1;
     end

  if (j != 0) then
     for (i = 0; i < n; i++)
       begin
         x[i] = x[i] + ((*px1) * v[i][j-1]);
       end
}

double flin(n,pj,px2,pf,x)

int *pj,n;
double *px2, (*pf)(), x[];
{

/* Flin is the function of one real variable px2 that is minimized by min. */


double t[20],errterm;
int i;

/* The search is linear */
if (*pj != 0) then
   for (i = 0; i < n; i++)
         t[i] = x[i] + *px2 * v[i][*pj-1];
else
  /* The search is along a parabolic space curve */
   begin
     qa = (*px2*(*px2-qd1))/(qd0*(qd0+qd1));
     qb = ((*px2+qd0)*(qd1-*px2))/(qd0*qd1);
     qc = (*px2*(*px2+qd0))/(qd1*(qd0+qd1));
     for (i = 0; i < n; i++)
         t[i] = (qa*q0[i]+qb*x[i])+(qc*q1[i]);
   end
nf = nf + 1;  /* increment the function evaluation counter */
errterm = (*pf)(t,n);
return(errterm);
}
