
/******************************************************************************
 *
 * File: random.c
 *
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990
 *   Duke University
 *
 ******************************************************************************/

#ifndef LINT
static char RCSid[] =
    "$Id: random.c,v 1.1.1.1 1994/10/12 17:22:23 hines Exp $" ;
#endif

#include "scopenv.h"
static unsigned long value = 1;


/*-----------------------------------------------------------------------------
 *
 *  RANDOM()
 *
 *	Selects a random number from the uniform distribution on
 *	the interval [0,1].  A seed number can be specified by a
 *	call to the function set_seed(seed).  Otherwise, a seed
 *	of 1 will be used.
 *
 *  Calling sequence:
 *	scop_random()
 *
 *  Arguments:
 *	none for random; for set_seed
 *	Input:	seed, int	value of the seed
 *
 *	Output:	argument unchanged
 *
 *
 *  Returns:
 *	Double precision value of the random number
 *
 *  Functions called:
 *	none
 *
 *  Files accessed:
 *	none
 *
 *--------------------------------------------------------------------------- */

double 
scop_random()
{
    extern double fabs();
    unsigned long a = 2147437301, c = 453816981,
    /* m = 2^32 - 1, the largest long int value that can be represented */
    m = 0xFFFFFFFF;

    value = a * value + c;
    return (fabs((double) value / (double) m));
}

/*-----------------------------------------------------------------------------
 *
 *  SET_SEED()
 *
 *	Set random number seed
 *
 *  Calling sequence:
 *	set_seed(seed)
 *
 *  Arguments:
 *	seed - integer random number seed
 *
 *  Returns:
 *	nothing
 *
 *  Functions called:
 *	none
 *
 *  Files accessed:
 *	none
 *
 */

set_seed(seed)
double seed;
{
    value = seed;
}

