
/******************************************************************************
 *
 * File: sigmoid.c
 *
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990
 *   Duke University
 *
 ******************************************************************************/

#ifndef LINT
static char RCSid[] = "$Id: sigmoid.c,v 1.1.1.1 1994/10/12 17:22:24 hines Exp $" ;
#endif
/****************************************************************/
/*								*/
/*  Abstract: sigmoid						*/
/*								*/
/*    Calculates the value of a sigmoidal function of one	*/
/*    variable given the values of three constants in the	*/
/*    function.							*/
/*								*/
/*  Calling sequence: sigmoid(x, max, K, n)			*/
/*								*/
/*  Arguments							*/
/*    Input:	x, double	the independent variable	*/
/*								*/
/*		max, double	maximum value the sigmoidal	*/
/*				function can attain		*/
/*								*/
/*		K, double	the value for x at which the	*/
/*				function value is max/2		*/
/*								*/
/*		n, double	parameter controlling the	*/
/*				steepness of the sigmoid curve.	*/
/*				It is the power to which x and	*/
/*				K are raised.			*/
/*								*/
/*    Output:	arguments are unchanged				*/
/*								*/
/*  Returns: Double precision value of the sigmoidal function	*/
/*								*/
/*  Functions called: none					*/
/*								*/
/*  Files accessed: none					*/
/*								*/
/****************************************************************/

double 
sigmoid(x, max, K, n)
double x, max, K, n;
{
    double value, temp;
    extern double pow();

    temp = pow(x, n);
    value = (max * temp) / (temp + pow(K, n));
    return (value);
}
